/* EqualizerPreset.c generated by valac 0.52.4, the Vala compiler
 * generated from EqualizerPreset.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 *              Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>

enum  {
	MUSIC_EQUALIZER_PRESET_0_PROPERTY,
	MUSIC_EQUALIZER_PRESET_NAME_PROPERTY,
	MUSIC_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY,
	MUSIC_EQUALIZER_PRESET_NUM_PROPERTIES
};
static GParamSpec* music_equalizer_preset_properties[MUSIC_EQUALIZER_PRESET_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MusicEqualizerPresetPrivate {
	gchar* _name;
	gboolean _is_default;
};

static gint MusicEqualizerPreset_private_offset;
static gpointer music_equalizer_preset_parent_class = NULL;

static void music_equalizer_preset_finalize (GObject * obj);
static GType music_equalizer_preset_get_type_once (void);
static void _vala_music_equalizer_preset_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_music_equalizer_preset_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
music_equalizer_preset_get_instance_private (MusicEqualizerPreset* self)
{
	return G_STRUCT_MEMBER_P (self, MusicEqualizerPreset_private_offset);
}

MusicEqualizerPreset*
music_equalizer_preset_construct_basic (GType object_type,
                                        const gchar* name)
{
	MusicEqualizerPreset * self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (MusicEqualizerPreset*) g_object_new (object_type, "name", name, NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GeeArrayList* _tmp2_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < 10)) {
					break;
				}
				_tmp2_ = self->gains;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, (gpointer) ((gintptr) 0));
			}
		}
	}
	return self;
}

MusicEqualizerPreset*
music_equalizer_preset_new_basic (const gchar* name)
{
	return music_equalizer_preset_construct_basic (MUSIC_TYPE_EQUALIZER_PRESET, name);
}

MusicEqualizerPreset*
music_equalizer_preset_construct_with_gains (GType object_type,
                                             const gchar* name,
                                             gint* items,
                                             gint items_length1)
{
	MusicEqualizerPreset * self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (MusicEqualizerPreset*) g_object_new (object_type, "name", name, NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GeeArrayList* _tmp2_;
				gint _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < 10)) {
					break;
				}
				_tmp2_ = self->gains;
				_tmp3_ = items[i];
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, (gpointer) ((gintptr) _tmp3_));
			}
		}
	}
	return self;
}

MusicEqualizerPreset*
music_equalizer_preset_new_with_gains (const gchar* name,
                                       gint* items,
                                       gint items_length1)
{
	return music_equalizer_preset_construct_with_gains (MUSIC_TYPE_EQUALIZER_PRESET, name, items, items_length1);
}

MusicEqualizerPreset*
music_equalizer_preset_construct_from_string (GType object_type,
                                              const gchar* data)
{
	MusicEqualizerPreset * self = NULL;
	gchar** vals = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint vals_length1;
	gint _vals_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	const gchar* _tmp3_;
	g_return_val_if_fail (data != NULL, NULL);
	_tmp1_ = _tmp0_ = g_strsplit (data, "/", 0);
	vals = _tmp1_;
	vals_length1 = _vala_array_length (_tmp0_);
	_vals_size_ = vals_length1;
	_tmp2_ = vals;
	_tmp2__length1 = vals_length1;
	_tmp3_ = _tmp2_[0];
	self = (MusicEqualizerPreset*) g_object_new (object_type, "name", _tmp3_, NULL);
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				gchar** _tmp6_;
				gint _tmp6__length1;
				GeeArrayList* _tmp7_;
				gchar** _tmp8_;
				gint _tmp8__length1;
				const gchar* _tmp9_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = vals;
				_tmp6__length1 = vals_length1;
				if (!(i < _tmp6__length1)) {
					break;
				}
				_tmp7_ = self->gains;
				_tmp8_ = vals;
				_tmp8__length1 = vals_length1;
				_tmp9_ = _tmp8_[i];
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, (gpointer) ((gintptr) atoi (_tmp9_)));
			}
		}
	}
	vals = (_vala_array_free (vals, vals_length1, (GDestroyNotify) g_free), NULL);
	return self;
}

MusicEqualizerPreset*
music_equalizer_preset_new_from_string (const gchar* data)
{
	return music_equalizer_preset_construct_from_string (MUSIC_TYPE_EQUALIZER_PRESET, data);
}

gchar*
music_equalizer_preset_to_string (MusicEqualizerPreset* self)
{
	gchar* str_preset = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup ("");
	str_preset = _tmp0_;
	_tmp2_ = self->priv->_name;
	if (_tmp2_ != NULL) {
		const gchar* _tmp3_;
		_tmp3_ = self->priv->_name;
		_tmp1_ = g_strcmp0 (_tmp3_, "") != 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		const gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp4_ = self->priv->_name;
		_tmp5_ = g_strdup (_tmp4_);
		_g_free0 (str_preset);
		str_preset = _tmp5_;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp6_ = FALSE;
				_tmp6_ = TRUE;
				while (TRUE) {
					const gchar* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					if (!_tmp6_) {
						gint _tmp7_;
						_tmp7_ = i;
						i = _tmp7_ + 1;
					}
					_tmp6_ = FALSE;
					if (!(i < 10)) {
						break;
					}
					_tmp8_ = str_preset;
					_tmp9_ = g_strdup_printf ("%i", music_equalizer_preset_get_gain (self, i));
					_tmp10_ = _tmp9_;
					_tmp11_ = g_strconcat ("/", _tmp10_, NULL);
					_tmp12_ = _tmp11_;
					_tmp13_ = g_strconcat (_tmp8_, _tmp12_, NULL);
					_g_free0 (str_preset);
					str_preset = _tmp13_;
					_g_free0 (_tmp12_);
					_g_free0 (_tmp10_);
				}
			}
		}
	}
	result = str_preset;
	return result;
}

void
music_equalizer_preset_set_gain (MusicEqualizerPreset* self,
                                 gint index,
                                 gint val)
{
	GeeArrayList* _tmp0_;
	g_return_if_fail (self != NULL);
	if (index > 9) {
		return;
	}
	_tmp0_ = self->gains;
	gee_abstract_list_set ((GeeAbstractList*) _tmp0_, index, (gpointer) ((gintptr) val));
}

gint
music_equalizer_preset_get_gain (MusicEqualizerPreset* self,
                                 gint index)
{
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->gains;
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, index);
	result = (gint) ((gintptr) _tmp1_);
	return result;
}

MusicEqualizerPreset*
music_equalizer_preset_construct (GType object_type)
{
	MusicEqualizerPreset * self = NULL;
	self = (MusicEqualizerPreset*) g_object_new (object_type, NULL);
	return self;
}

MusicEqualizerPreset*
music_equalizer_preset_new (void)
{
	return music_equalizer_preset_construct (MUSIC_TYPE_EQUALIZER_PRESET);
}

const gchar*
music_equalizer_preset_get_name (MusicEqualizerPreset* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

void
music_equalizer_preset_set_name (MusicEqualizerPreset* self,
                                 const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_equalizer_preset_get_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_equalizer_preset_properties[MUSIC_EQUALIZER_PRESET_NAME_PROPERTY]);
	}
}

gboolean
music_equalizer_preset_get_is_default (MusicEqualizerPreset* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_default;
	return result;
}

void
music_equalizer_preset_set_is_default (MusicEqualizerPreset* self,
                                       gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = music_equalizer_preset_get_is_default (self);
	if (old_value != value) {
		self->priv->_is_default = value;
		g_object_notify_by_pspec ((GObject *) self, music_equalizer_preset_properties[MUSIC_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY]);
	}
}

static void
music_equalizer_preset_class_init (MusicEqualizerPresetClass * klass,
                                   gpointer klass_data)
{
	music_equalizer_preset_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicEqualizerPreset_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_equalizer_preset_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_equalizer_preset_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_equalizer_preset_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_EQUALIZER_PRESET_NAME_PROPERTY, music_equalizer_preset_properties[MUSIC_EQUALIZER_PRESET_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY, music_equalizer_preset_properties[MUSIC_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY] = g_param_spec_boolean ("is-default", "is-default", "is-default", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
music_equalizer_preset_instance_init (MusicEqualizerPreset * self,
                                      gpointer klass)
{
	GeeArrayList* _tmp0_;
	self->priv = music_equalizer_preset_get_instance_private (self);
	_tmp0_ = gee_array_list_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL);
	self->gains = _tmp0_;
	self->priv->_is_default = FALSE;
}

static void
music_equalizer_preset_finalize (GObject * obj)
{
	MusicEqualizerPreset * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_EQUALIZER_PRESET, MusicEqualizerPreset);
	_g_free0 (self->priv->_name);
	_g_object_unref0 (self->gains);
	G_OBJECT_CLASS (music_equalizer_preset_parent_class)->finalize (obj);
}

static GType
music_equalizer_preset_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicEqualizerPresetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_equalizer_preset_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicEqualizerPreset), 0, (GInstanceInitFunc) music_equalizer_preset_instance_init, NULL };
	GType music_equalizer_preset_type_id;
	music_equalizer_preset_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicEqualizerPreset", &g_define_type_info, 0);
	MusicEqualizerPreset_private_offset = g_type_add_instance_private (music_equalizer_preset_type_id, sizeof (MusicEqualizerPresetPrivate));
	return music_equalizer_preset_type_id;
}

GType
music_equalizer_preset_get_type (void)
{
	static volatile gsize music_equalizer_preset_type_id__volatile = 0;
	if (g_once_init_enter (&music_equalizer_preset_type_id__volatile)) {
		GType music_equalizer_preset_type_id;
		music_equalizer_preset_type_id = music_equalizer_preset_get_type_once ();
		g_once_init_leave (&music_equalizer_preset_type_id__volatile, music_equalizer_preset_type_id);
	}
	return music_equalizer_preset_type_id__volatile;
}

static void
_vala_music_equalizer_preset_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	MusicEqualizerPreset * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_EQUALIZER_PRESET, MusicEqualizerPreset);
	switch (property_id) {
		case MUSIC_EQUALIZER_PRESET_NAME_PROPERTY:
		g_value_set_string (value, music_equalizer_preset_get_name (self));
		break;
		case MUSIC_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY:
		g_value_set_boolean (value, music_equalizer_preset_get_is_default (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_equalizer_preset_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	MusicEqualizerPreset * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_EQUALIZER_PRESET, MusicEqualizerPreset);
	switch (property_id) {
		case MUSIC_EQUALIZER_PRESET_NAME_PROPERTY:
		music_equalizer_preset_set_name (self, g_value_get_string (value));
		break;
		case MUSIC_EQUALIZER_PRESET_IS_DEFAULT_PROPERTY:
		music_equalizer_preset_set_is_default (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

