/* Equalizer.c generated by valac 0.52.4, the Vala compiler
 * generated from Equalizer.vala, do not modify */

/*-
 * Copyright (c) 2012-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */

#include "io.elementary.music-core.h"
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gst/gst.h>
#include <glib/gi18n-lib.h>

enum  {
	MUSIC_EQUALIZER_0_PROPERTY,
	MUSIC_EQUALIZER_NUM_PROPERTIES
};
static GParamSpec* music_equalizer_properties[MUSIC_EQUALIZER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static gpointer music_equalizer_parent_class = NULL;
static GeeTreeSet* music_equalizer_default_presets;
static GeeTreeSet* music_equalizer_default_presets = NULL;

static GObject * music_equalizer_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void music_equalizer_finalize (GObject * obj);
static GType music_equalizer_get_type_once (void);

void
music_equalizer_set_gain (MusicEqualizer* self,
                          gint index,
                          gdouble gain)
{
	GObject* band = NULL;
	GstElement* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->element;
	_tmp1_ = gst_child_proxy_get_child_by_index (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gst_child_proxy_get_type (), GstChildProxy), (guint) index);
	band = _tmp1_;
	if (gain < ((gdouble) 0)) {
		gain = gain * 0.24f;
	} else {
		gain = gain * 0.12f;
	}
	_tmp2_ = band;
	g_object_set (_tmp2_, "gain", gain, NULL);
	_g_object_unref0 (band);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GeeCollection*
music_equalizer_get_default_presets (void)
{
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp3_;
	GeeTreeSet* _tmp4_;
	gint* _tmp5_;
	gint* _tmp6_;
	gint _tmp6__length1;
	MusicEqualizerPreset* _tmp7_;
	MusicEqualizerPreset* _tmp8_;
	GeeTreeSet* _tmp9_;
	gint* _tmp10_;
	gint* _tmp11_;
	gint _tmp11__length1;
	MusicEqualizerPreset* _tmp12_;
	MusicEqualizerPreset* _tmp13_;
	GeeTreeSet* _tmp14_;
	gint* _tmp15_;
	gint* _tmp16_;
	gint _tmp16__length1;
	MusicEqualizerPreset* _tmp17_;
	MusicEqualizerPreset* _tmp18_;
	GeeTreeSet* _tmp19_;
	gint* _tmp20_;
	gint* _tmp21_;
	gint _tmp21__length1;
	MusicEqualizerPreset* _tmp22_;
	MusicEqualizerPreset* _tmp23_;
	GeeTreeSet* _tmp24_;
	gint* _tmp25_;
	gint* _tmp26_;
	gint _tmp26__length1;
	MusicEqualizerPreset* _tmp27_;
	MusicEqualizerPreset* _tmp28_;
	GeeTreeSet* _tmp29_;
	gint* _tmp30_;
	gint* _tmp31_;
	gint _tmp31__length1;
	MusicEqualizerPreset* _tmp32_;
	MusicEqualizerPreset* _tmp33_;
	GeeTreeSet* _tmp34_;
	gint* _tmp35_;
	gint* _tmp36_;
	gint _tmp36__length1;
	MusicEqualizerPreset* _tmp37_;
	MusicEqualizerPreset* _tmp38_;
	GeeTreeSet* _tmp39_;
	gint* _tmp40_;
	gint* _tmp41_;
	gint _tmp41__length1;
	MusicEqualizerPreset* _tmp42_;
	MusicEqualizerPreset* _tmp43_;
	GeeTreeSet* _tmp44_;
	gint* _tmp45_;
	gint* _tmp46_;
	gint _tmp46__length1;
	MusicEqualizerPreset* _tmp47_;
	MusicEqualizerPreset* _tmp48_;
	GeeTreeSet* _tmp49_;
	gint* _tmp50_;
	gint* _tmp51_;
	gint _tmp51__length1;
	MusicEqualizerPreset* _tmp52_;
	MusicEqualizerPreset* _tmp53_;
	GeeTreeSet* _tmp54_;
	gint* _tmp55_;
	gint* _tmp56_;
	gint _tmp56__length1;
	MusicEqualizerPreset* _tmp57_;
	MusicEqualizerPreset* _tmp58_;
	GeeTreeSet* _tmp59_;
	gint* _tmp60_;
	gint* _tmp61_;
	gint _tmp61__length1;
	MusicEqualizerPreset* _tmp62_;
	MusicEqualizerPreset* _tmp63_;
	GeeTreeSet* _tmp64_;
	gint* _tmp65_;
	gint* _tmp66_;
	gint _tmp66__length1;
	MusicEqualizerPreset* _tmp67_;
	MusicEqualizerPreset* _tmp68_;
	GeeTreeSet* _tmp69_;
	gint* _tmp70_;
	gint* _tmp71_;
	gint _tmp71__length1;
	MusicEqualizerPreset* _tmp72_;
	MusicEqualizerPreset* _tmp73_;
	GeeTreeSet* _tmp74_;
	gint* _tmp75_;
	gint* _tmp76_;
	gint _tmp76__length1;
	MusicEqualizerPreset* _tmp77_;
	MusicEqualizerPreset* _tmp78_;
	GeeTreeSet* _tmp79_;
	gint* _tmp80_;
	gint* _tmp81_;
	gint _tmp81__length1;
	MusicEqualizerPreset* _tmp82_;
	MusicEqualizerPreset* _tmp83_;
	GeeTreeSet* _tmp84_;
	gint* _tmp85_;
	gint* _tmp86_;
	gint _tmp86__length1;
	MusicEqualizerPreset* _tmp87_;
	MusicEqualizerPreset* _tmp88_;
	GeeTreeSet* _tmp89_;
	gint* _tmp90_;
	gint* _tmp91_;
	gint _tmp91__length1;
	MusicEqualizerPreset* _tmp92_;
	MusicEqualizerPreset* _tmp93_;
	GeeTreeSet* _tmp94_;
	GeeBidirSortedSet* _tmp95_;
	GeeBidirSortedSet* _tmp96_;
	GeeCollection* result = NULL;
	_tmp0_ = music_equalizer_default_presets;
	if (_tmp0_ != NULL) {
		GeeTreeSet* _tmp1_;
		GeeCollection* _tmp2_;
		_tmp1_ = music_equalizer_default_presets;
		_tmp2_ = _g_object_ref0 ((GeeCollection*) _tmp1_);
		result = _tmp2_;
		return result;
	}
	_tmp3_ = gee_tree_set_new (MUSIC_TYPE_EQUALIZER_PRESET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (music_equalizer_default_presets);
	music_equalizer_default_presets = _tmp3_;
	_tmp4_ = music_equalizer_default_presets;
	_tmp5_ = g_new0 (gint, 10);
	_tmp5_[0] = 0;
	_tmp5_[1] = 0;
	_tmp5_[2] = 0;
	_tmp5_[3] = 0;
	_tmp5_[4] = 0;
	_tmp5_[5] = 0;
	_tmp5_[6] = 0;
	_tmp5_[7] = 0;
	_tmp5_[8] = 0;
	_tmp5_[9] = 0;
	_tmp6_ = _tmp5_;
	_tmp6__length1 = 10;
	_tmp7_ = music_equalizer_preset_new_with_gains (_ ("Flat"), _tmp6_, 10);
	_tmp8_ = _tmp7_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, _tmp8_);
	_g_object_unref0 (_tmp8_);
	_tmp6_ = (g_free (_tmp6_), NULL);
	_tmp9_ = music_equalizer_default_presets;
	_tmp10_ = g_new0 (gint, 10);
	_tmp10_[0] = 0;
	_tmp10_[1] = 0;
	_tmp10_[2] = 0;
	_tmp10_[3] = 0;
	_tmp10_[4] = 0;
	_tmp10_[5] = 0;
	_tmp10_[6] = -40;
	_tmp10_[7] = -40;
	_tmp10_[8] = -40;
	_tmp10_[9] = -50;
	_tmp11_ = _tmp10_;
	_tmp11__length1 = 10;
	_tmp12_ = music_equalizer_preset_new_with_gains (_ ("Classical"), _tmp11_, 10);
	_tmp13_ = _tmp12_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp13_);
	_g_object_unref0 (_tmp13_);
	_tmp11_ = (g_free (_tmp11_), NULL);
	_tmp14_ = music_equalizer_default_presets;
	_tmp15_ = g_new0 (gint, 10);
	_tmp15_[0] = 0;
	_tmp15_[1] = 0;
	_tmp15_[2] = 20;
	_tmp15_[3] = 30;
	_tmp15_[4] = 30;
	_tmp15_[5] = 30;
	_tmp15_[6] = 20;
	_tmp15_[7] = 0;
	_tmp15_[8] = 0;
	_tmp15_[9] = 0;
	_tmp16_ = _tmp15_;
	_tmp16__length1 = 10;
	_tmp17_ = music_equalizer_preset_new_with_gains (_ ("Club"), _tmp16_, 10);
	_tmp18_ = _tmp17_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp18_);
	_g_object_unref0 (_tmp18_);
	_tmp16_ = (g_free (_tmp16_), NULL);
	_tmp19_ = music_equalizer_default_presets;
	_tmp20_ = g_new0 (gint, 10);
	_tmp20_[0] = 50;
	_tmp20_[1] = 35;
	_tmp20_[2] = 10;
	_tmp20_[3] = 0;
	_tmp20_[4] = 0;
	_tmp20_[5] = -30;
	_tmp20_[6] = -40;
	_tmp20_[7] = -40;
	_tmp20_[8] = 0;
	_tmp20_[9] = 0;
	_tmp21_ = _tmp20_;
	_tmp21__length1 = 10;
	_tmp22_ = music_equalizer_preset_new_with_gains (_ ("Dance"), _tmp21_, 10);
	_tmp23_ = _tmp22_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp23_);
	_g_object_unref0 (_tmp23_);
	_tmp21_ = (g_free (_tmp21_), NULL);
	_tmp24_ = music_equalizer_default_presets;
	_tmp25_ = g_new0 (gint, 10);
	_tmp25_[0] = 70;
	_tmp25_[1] = 70;
	_tmp25_[2] = 70;
	_tmp25_[3] = 40;
	_tmp25_[4] = 20;
	_tmp25_[5] = -45;
	_tmp25_[6] = -50;
	_tmp25_[7] = -55;
	_tmp25_[8] = -55;
	_tmp25_[9] = -55;
	_tmp26_ = _tmp25_;
	_tmp26__length1 = 10;
	_tmp27_ = music_equalizer_preset_new_with_gains (_ ("Full Bass"), _tmp26_, 10);
	_tmp28_ = _tmp27_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp24_, _tmp28_);
	_g_object_unref0 (_tmp28_);
	_tmp26_ = (g_free (_tmp26_), NULL);
	_tmp29_ = music_equalizer_default_presets;
	_tmp30_ = g_new0 (gint, 10);
	_tmp30_[0] = -50;
	_tmp30_[1] = -50;
	_tmp30_[2] = -50;
	_tmp30_[3] = -25;
	_tmp30_[4] = 15;
	_tmp30_[5] = 55;
	_tmp30_[6] = 80;
	_tmp30_[7] = 80;
	_tmp30_[8] = 80;
	_tmp30_[9] = 80;
	_tmp31_ = _tmp30_;
	_tmp31__length1 = 10;
	_tmp32_ = music_equalizer_preset_new_with_gains (_ ("Full Treble"), _tmp31_, 10);
	_tmp33_ = _tmp32_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, _tmp33_);
	_g_object_unref0 (_tmp33_);
	_tmp31_ = (g_free (_tmp31_), NULL);
	_tmp34_ = music_equalizer_default_presets;
	_tmp35_ = g_new0 (gint, 10);
	_tmp35_[0] = 35;
	_tmp35_[1] = 30;
	_tmp35_[2] = 0;
	_tmp35_[3] = -40;
	_tmp35_[4] = -25;
	_tmp35_[5] = 10;
	_tmp35_[6] = 45;
	_tmp35_[7] = 55;
	_tmp35_[8] = 60;
	_tmp35_[9] = 60;
	_tmp36_ = _tmp35_;
	_tmp36__length1 = 10;
	_tmp37_ = music_equalizer_preset_new_with_gains (_ ("Full Bass + Treble"), _tmp36_, 10);
	_tmp38_ = _tmp37_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp34_, _tmp38_);
	_g_object_unref0 (_tmp38_);
	_tmp36_ = (g_free (_tmp36_), NULL);
	_tmp39_ = music_equalizer_default_presets;
	_tmp40_ = g_new0 (gint, 10);
	_tmp40_[0] = 25;
	_tmp40_[1] = 50;
	_tmp40_[2] = 25;
	_tmp40_[3] = -20;
	_tmp40_[4] = 0;
	_tmp40_[5] = -30;
	_tmp40_[6] = -40;
	_tmp40_[7] = -40;
	_tmp40_[8] = 0;
	_tmp40_[9] = 0;
	_tmp41_ = _tmp40_;
	_tmp41__length1 = 10;
	_tmp42_ = music_equalizer_preset_new_with_gains (_ ("Headphones"), _tmp41_, 10);
	_tmp43_ = _tmp42_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp39_, _tmp43_);
	_g_object_unref0 (_tmp43_);
	_tmp41_ = (g_free (_tmp41_), NULL);
	_tmp44_ = music_equalizer_default_presets;
	_tmp45_ = g_new0 (gint, 10);
	_tmp45_[0] = 50;
	_tmp45_[1] = 50;
	_tmp45_[2] = 30;
	_tmp45_[3] = 30;
	_tmp45_[4] = 0;
	_tmp45_[5] = -25;
	_tmp45_[6] = -25;
	_tmp45_[7] = -25;
	_tmp45_[8] = 0;
	_tmp45_[9] = 0;
	_tmp46_ = _tmp45_;
	_tmp46__length1 = 10;
	_tmp47_ = music_equalizer_preset_new_with_gains (_ ("Large Hall"), _tmp46_, 10);
	_tmp48_ = _tmp47_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp44_, _tmp48_);
	_g_object_unref0 (_tmp48_);
	_tmp46_ = (g_free (_tmp46_), NULL);
	_tmp49_ = music_equalizer_default_presets;
	_tmp50_ = g_new0 (gint, 10);
	_tmp50_[0] = -25;
	_tmp50_[1] = 0;
	_tmp50_[2] = 20;
	_tmp50_[3] = 25;
	_tmp50_[4] = 30;
	_tmp50_[5] = 30;
	_tmp50_[6] = 20;
	_tmp50_[7] = 15;
	_tmp50_[8] = 15;
	_tmp50_[9] = 10;
	_tmp51_ = _tmp50_;
	_tmp51__length1 = 10;
	_tmp52_ = music_equalizer_preset_new_with_gains (_ ("Live"), _tmp51_, 10);
	_tmp53_ = _tmp52_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp49_, _tmp53_);
	_g_object_unref0 (_tmp53_);
	_tmp51_ = (g_free (_tmp51_), NULL);
	_tmp54_ = music_equalizer_default_presets;
	_tmp55_ = g_new0 (gint, 10);
	_tmp55_[0] = 35;
	_tmp55_[1] = 35;
	_tmp55_[2] = 0;
	_tmp55_[3] = 0;
	_tmp55_[4] = 0;
	_tmp55_[5] = 0;
	_tmp55_[6] = 0;
	_tmp55_[7] = 0;
	_tmp55_[8] = 35;
	_tmp55_[9] = 35;
	_tmp56_ = _tmp55_;
	_tmp56__length1 = 10;
	_tmp57_ = music_equalizer_preset_new_with_gains (_ ("Party"), _tmp56_, 10);
	_tmp58_ = _tmp57_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp54_, _tmp58_);
	_g_object_unref0 (_tmp58_);
	_tmp56_ = (g_free (_tmp56_), NULL);
	_tmp59_ = music_equalizer_default_presets;
	_tmp60_ = g_new0 (gint, 10);
	_tmp60_[0] = -10;
	_tmp60_[1] = 25;
	_tmp60_[2] = 35;
	_tmp60_[3] = 40;
	_tmp60_[4] = 25;
	_tmp60_[5] = -5;
	_tmp60_[6] = -15;
	_tmp60_[7] = -15;
	_tmp60_[8] = -10;
	_tmp60_[9] = -10;
	_tmp61_ = _tmp60_;
	_tmp61__length1 = 10;
	_tmp62_ = music_equalizer_preset_new_with_gains (_ ("Pop"), _tmp61_, 10);
	_tmp63_ = _tmp62_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp59_, _tmp63_);
	_g_object_unref0 (_tmp63_);
	_tmp61_ = (g_free (_tmp61_), NULL);
	_tmp64_ = music_equalizer_default_presets;
	_tmp65_ = g_new0 (gint, 10);
	_tmp65_[0] = 0;
	_tmp65_[1] = 0;
	_tmp65_[2] = -5;
	_tmp65_[3] = -30;
	_tmp65_[4] = 0;
	_tmp65_[5] = -35;
	_tmp65_[6] = -35;
	_tmp65_[7] = 0;
	_tmp65_[8] = 0;
	_tmp65_[9] = 0;
	_tmp66_ = _tmp65_;
	_tmp66__length1 = 10;
	_tmp67_ = music_equalizer_preset_new_with_gains (_ ("Reggae"), _tmp66_, 10);
	_tmp68_ = _tmp67_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp64_, _tmp68_);
	_g_object_unref0 (_tmp68_);
	_tmp66_ = (g_free (_tmp66_), NULL);
	_tmp69_ = music_equalizer_default_presets;
	_tmp70_ = g_new0 (gint, 10);
	_tmp70_[0] = 40;
	_tmp70_[1] = 25;
	_tmp70_[2] = -30;
	_tmp70_[3] = -40;
	_tmp70_[4] = -20;
	_tmp70_[5] = 20;
	_tmp70_[6] = 45;
	_tmp70_[7] = 55;
	_tmp70_[8] = 55;
	_tmp70_[9] = 55;
	_tmp71_ = _tmp70_;
	_tmp71__length1 = 10;
	_tmp72_ = music_equalizer_preset_new_with_gains (_ ("Rock"), _tmp71_, 10);
	_tmp73_ = _tmp72_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp69_, _tmp73_);
	_g_object_unref0 (_tmp73_);
	_tmp71_ = (g_free (_tmp71_), NULL);
	_tmp74_ = music_equalizer_default_presets;
	_tmp75_ = g_new0 (gint, 10);
	_tmp75_[0] = 25;
	_tmp75_[1] = 10;
	_tmp75_[2] = -5;
	_tmp75_[3] = -15;
	_tmp75_[4] = -5;
	_tmp75_[5] = 20;
	_tmp75_[6] = 45;
	_tmp75_[7] = 50;
	_tmp75_[8] = 55;
	_tmp75_[9] = 60;
	_tmp76_ = _tmp75_;
	_tmp76__length1 = 10;
	_tmp77_ = music_equalizer_preset_new_with_gains (_ ("Soft"), _tmp76_, 10);
	_tmp78_ = _tmp77_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp74_, _tmp78_);
	_g_object_unref0 (_tmp78_);
	_tmp76_ = (g_free (_tmp76_), NULL);
	_tmp79_ = music_equalizer_default_presets;
	_tmp80_ = g_new0 (gint, 10);
	_tmp80_[0] = -15;
	_tmp80_[1] = -25;
	_tmp80_[2] = -25;
	_tmp80_[3] = -5;
	_tmp80_[4] = 20;
	_tmp80_[5] = 30;
	_tmp80_[6] = 45;
	_tmp80_[7] = 50;
	_tmp80_[8] = 55;
	_tmp80_[9] = 50;
	_tmp81_ = _tmp80_;
	_tmp81__length1 = 10;
	_tmp82_ = music_equalizer_preset_new_with_gains (_ ("Ska"), _tmp81_, 10);
	_tmp83_ = _tmp82_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp79_, _tmp83_);
	_g_object_unref0 (_tmp83_);
	_tmp81_ = (g_free (_tmp81_), NULL);
	_tmp84_ = music_equalizer_default_presets;
	_tmp85_ = g_new0 (gint, 10);
	_tmp85_[0] = 20;
	_tmp85_[1] = 20;
	_tmp85_[2] = 10;
	_tmp85_[3] = -5;
	_tmp85_[4] = -25;
	_tmp85_[5] = -30;
	_tmp85_[6] = -20;
	_tmp85_[7] = -5;
	_tmp85_[8] = 15;
	_tmp85_[9] = 45;
	_tmp86_ = _tmp85_;
	_tmp86__length1 = 10;
	_tmp87_ = music_equalizer_preset_new_with_gains (_ ("Soft Rock"), _tmp86_, 10);
	_tmp88_ = _tmp87_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp84_, _tmp88_);
	_g_object_unref0 (_tmp88_);
	_tmp86_ = (g_free (_tmp86_), NULL);
	_tmp89_ = music_equalizer_default_presets;
	_tmp90_ = g_new0 (gint, 10);
	_tmp90_[0] = 40;
	_tmp90_[1] = 30;
	_tmp90_[2] = 0;
	_tmp90_[3] = -30;
	_tmp90_[4] = -25;
	_tmp90_[5] = 0;
	_tmp90_[6] = 40;
	_tmp90_[7] = 50;
	_tmp90_[8] = 50;
	_tmp90_[9] = 45;
	_tmp91_ = _tmp90_;
	_tmp91__length1 = 10;
	_tmp92_ = music_equalizer_preset_new_with_gains (_ ("Techno"), _tmp91_, 10);
	_tmp93_ = _tmp92_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp89_, _tmp93_);
	_g_object_unref0 (_tmp93_);
	_tmp91_ = (g_free (_tmp91_), NULL);
	_tmp94_ = music_equalizer_default_presets;
	_tmp95_ = gee_abstract_bidir_sorted_set_get_read_only_view ((GeeAbstractBidirSortedSet*) _tmp94_);
	_tmp96_ = _tmp95_;
	result = (GeeCollection*) _tmp96_;
	return result;
}

MusicEqualizer*
music_equalizer_construct (GType object_type)
{
	MusicEqualizer * self = NULL;
	self = (MusicEqualizer*) g_object_new (object_type, NULL);
	return self;
}

MusicEqualizer*
music_equalizer_new (void)
{
	return music_equalizer_construct (MUSIC_TYPE_EQUALIZER);
}

static GObject *
music_equalizer_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicEqualizer * self;
	GstElement* _tmp0_;
	gint* freqs = NULL;
	gint* _tmp1_;
	gint freqs_length1;
	gint _freqs_size_;
	gfloat last_freq = 0.0F;
	parent_class = G_OBJECT_CLASS (music_equalizer_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_EQUALIZER, MusicEqualizer);
	_tmp0_ = gst_element_factory_make ("equalizer-10bands", "equalizer");
	if (_tmp0_ != NULL) {
		g_object_ref_sink (_tmp0_);
	}
	_g_object_unref0 (self->element);
	self->element = _tmp0_;
	_tmp1_ = g_new0 (gint, 10);
	_tmp1_[0] = 60;
	_tmp1_[1] = 170;
	_tmp1_[2] = 310;
	_tmp1_[3] = 600;
	_tmp1_[4] = 1000;
	_tmp1_[5] = 3000;
	_tmp1_[6] = 6000;
	_tmp1_[7] = 12000;
	_tmp1_[8] = 14000;
	_tmp1_[9] = 16000;
	freqs = _tmp1_;
	freqs_length1 = 10;
	_freqs_size_ = freqs_length1;
	last_freq = (gfloat) 0;
	{
		gint index = 0;
		index = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				GObject* band = NULL;
				GstElement* _tmp4_;
				GObject* _tmp5_;
				gfloat freq = 0.0F;
				gint* _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				gfloat bandwidth = 0.0F;
				GObject* _tmp8_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = index;
					index = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				if (!(index < 10)) {
					break;
				}
				_tmp4_ = self->element;
				_tmp5_ = gst_child_proxy_get_child_by_index (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gst_child_proxy_get_type (), GstChildProxy), (guint) index);
				band = _tmp5_;
				_tmp6_ = freqs;
				_tmp6__length1 = freqs_length1;
				_tmp7_ = _tmp6_[index];
				freq = (gfloat) _tmp7_;
				bandwidth = freq - last_freq;
				last_freq = freq;
				_tmp8_ = band;
				g_object_set (_tmp8_, "freq", freq, "bandwidth", bandwidth, "gain", 0.0f, NULL);
				_g_object_unref0 (band);
			}
		}
	}
	freqs = (g_free (freqs), NULL);
	return obj;
}

static void
music_equalizer_class_init (MusicEqualizerClass * klass,
                            gpointer klass_data)
{
	music_equalizer_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = music_equalizer_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_equalizer_finalize;
}

static void
music_equalizer_instance_init (MusicEqualizer * self,
                               gpointer klass)
{
}

static void
music_equalizer_finalize (GObject * obj)
{
	MusicEqualizer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_EQUALIZER, MusicEqualizer);
	_g_object_unref0 (self->element);
	G_OBJECT_CLASS (music_equalizer_parent_class)->finalize (obj);
}

static GType
music_equalizer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicEqualizerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_equalizer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicEqualizer), 0, (GInstanceInitFunc) music_equalizer_instance_init, NULL };
	GType music_equalizer_type_id;
	music_equalizer_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicEqualizer", &g_define_type_info, 0);
	return music_equalizer_type_id;
}

GType
music_equalizer_get_type (void)
{
	static volatile gsize music_equalizer_type_id__volatile = 0;
	if (g_once_init_enter (&music_equalizer_type_id__volatile)) {
		GType music_equalizer_type_id;
		music_equalizer_type_id = music_equalizer_get_type_once ();
		g_once_init_leave (&music_equalizer_type_id__volatile, music_equalizer_type_id);
	}
	return music_equalizer_type_id__volatile;
}

