/* LibrariesManager.c generated by valac 0.52.4, the Vala compiler
 * generated from LibrariesManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <time.h>
#include <glib/gi18n-lib.h>

enum  {
	MUSIC_LIBRARIES_MANAGER_0_PROPERTY,
	MUSIC_LIBRARIES_MANAGER_NUM_PROPERTIES
};
static GParamSpec* music_libraries_manager_properties[MUSIC_LIBRARIES_MANAGER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _MusicLibrariesManagerTransferMediasAsyncData MusicLibrariesManagerTransferMediasAsyncData;
enum  {
	MUSIC_LIBRARIES_MANAGER_ADD_HEADLESS_PLAYLIST_SIGNAL,
	MUSIC_LIBRARIES_MANAGER_LIBRARY_REMOVED_SIGNAL,
	MUSIC_LIBRARIES_MANAGER_LIBRARY_ADDED_SIGNAL,
	MUSIC_LIBRARIES_MANAGER_CANCEL_TRANSFER_SIGNAL,
	MUSIC_LIBRARIES_MANAGER_OPERATION_TERMINATED_SIGNAL,
	MUSIC_LIBRARIES_MANAGER_NUM_SIGNALS
};
static guint music_libraries_manager_signals[MUSIC_LIBRARIES_MANAGER_NUM_SIGNALS] = {0};

struct _MusicLibrariesManagerPrivate {
	gchar* old_search;
	GeeHashMap* libraries;
	gint current_index;
};

struct _Block6Data {
	int _ref_count_;
	MusicLibrariesManager* self;
	GeeTreeSet* copied_list;
	gpointer _async_data_;
};

struct _MusicLibrariesManagerTransferMediasAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MusicLibrariesManager* self;
	GeeCollection* list;
	Block6Data* _data6_;
	gboolean _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint index;
	gint total;
	gint _tmp3_;
	gint _tmp4_;
	GeeTreeSet* _tmp5_;
	GeeIterator* _m_it;
	GeeIterator* _tmp6_;
	GeeIterator* _tmp7_;
	MusicMedia* m;
	GeeIterator* _tmp8_;
	gpointer _tmp9_;
	MusicMedia* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	gboolean _tmp16_;
	GFile* dest;
	MusicMedia* _tmp17_;
	GFile* _tmp18_;
	GFile* _tmp19_;
	gboolean success;
	gboolean _tmp20_;
	MusicMedia* _tmp21_;
	GFile* _tmp22_;
	GFile* _tmp23_;
	GFile* _tmp24_;
	MusicMedia* copy;
	MusicMedia* _tmp25_;
	MusicMedia* _tmp26_;
	MusicMedia* _tmp27_;
	GFile* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	MusicMedia* _tmp31_;
	MusicMedia* _tmp32_;
	MusicMedia* _tmp33_;
	time_t _tmp34_;
	GeeTreeSet* _tmp35_;
	MusicMedia* _tmp36_;
	MusicMedia* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	GFile* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	GError* err;
	MusicMedia* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	GError* _tmp48_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	const gchar* _tmp51_;
	MusicMedia* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	const gchar* _tmp56_;
	MusicMedia* _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	MusicMedia* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	gint _tmp64_;
	GError* _inner_error0_;
};

static gint MusicLibrariesManager_private_offset;
static gpointer music_libraries_manager_parent_class = NULL;

static void music_libraries_manager_transfer_medias_async_data_free (gpointer _data);
static gboolean music_libraries_manager_transfer_medias_async_co (MusicLibrariesManagerTransferMediasAsyncData* _data_);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gboolean _music_libraries_manager_do_progress_notification_with_timeout_gsource_func (gpointer self);
static gboolean __lambda15_ (Block6Data* _data6_);
static gboolean ___lambda15__gsource_func (gpointer self);
static void music_libraries_manager_finalize (GObject * obj);
static GType music_libraries_manager_get_type_once (void);

static inline gpointer
music_libraries_manager_get_instance_private (MusicLibrariesManager* self)
{
	return G_STRUCT_MEMBER_P (self, MusicLibrariesManager_private_offset);
}

MusicLibrariesManager*
music_libraries_manager_construct (GType object_type)
{
	MusicLibrariesManager * self = NULL;
	GeeHashMap* _tmp0_;
	self = (MusicLibrariesManager*) g_object_new (object_type, NULL);
	_tmp0_ = gee_hash_map_new (MUSIC_TYPE_LIBRARY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->libraries);
	self->priv->libraries = _tmp0_;
	return self;
}

MusicLibrariesManager*
music_libraries_manager_new (void)
{
	return music_libraries_manager_construct (MUSIC_TYPE_LIBRARIES_MANAGER);
}

void
music_libraries_manager_add_library (MusicLibrariesManager* self,
                                     MusicLibrary* library)
{
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (library != NULL);
	_tmp0_ = self->priv->libraries;
	_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp4_ = !gee_collection_contains ((GeeCollection*) _tmp3_, library);
	_g_object_unref0 (_tmp3_);
	if (_tmp4_) {
		GeeHashMap* _tmp5_;
		_tmp5_ = self->priv->libraries;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, library, (gpointer) ((gintptr) self->priv->current_index));
		g_signal_emit (self, music_libraries_manager_signals[MUSIC_LIBRARIES_MANAGER_LIBRARY_ADDED_SIGNAL], 0, library);
	}
}

void
music_libraries_manager_remove_library (MusicLibrariesManager* self,
                                        MusicLibrary* library)
{
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (library != NULL);
	_tmp0_ = self->priv->libraries;
	_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_collection_contains ((GeeCollection*) _tmp3_, library);
	_g_object_unref0 (_tmp3_);
	if (_tmp4_) {
		GeeHashMap* _tmp5_;
		g_signal_emit (self, music_libraries_manager_signals[MUSIC_LIBRARIES_MANAGER_LIBRARY_REMOVED_SIGNAL], 0, library);
		_tmp5_ = self->priv->libraries;
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp5_, library, NULL);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

MusicLibrary*
music_libraries_manager_get_library_from_index (MusicLibrariesManager* self,
                                                gint index)
{
	MusicLibrary* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->libraries;
		_tmp1_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_entry_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeMapEntry* _tmp9_;
			gconstpointer _tmp10_;
			gconstpointer _tmp11_;
			_tmp6_ = _entry_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _entry_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			entry = (GeeMapEntry*) _tmp8_;
			_tmp9_ = entry;
			_tmp10_ = gee_map_entry_get_value (_tmp9_);
			_tmp11_ = _tmp10_;
			if (((gint) ((gintptr) _tmp11_)) == index) {
				GeeMapEntry* _tmp12_;
				gconstpointer _tmp13_;
				gconstpointer _tmp14_;
				MusicLibrary* _tmp15_;
				_tmp12_ = entry;
				_tmp13_ = gee_map_entry_get_key (_tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = _g_object_ref0 ((MusicLibrary*) _tmp14_);
				result = _tmp15_;
				_g_object_unref0 (entry);
				_g_object_unref0 (_entry_it);
				return result;
			}
			_g_object_unref0 (entry);
		}
		_g_object_unref0 (_entry_it);
	}
	result = NULL;
	return result;
}

void
music_libraries_manager_search_for_string (MusicLibrariesManager* self,
                                           const gchar* search)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (search != NULL);
	_tmp0_ = self->priv->old_search;
	if (g_strcmp0 (_tmp0_, search) == 0) {
		return;
	}
	_tmp1_ = g_strdup (search);
	_g_free0 (self->priv->old_search);
	self->priv->old_search = _tmp1_;
	{
		GeeIterator* _library_it = NULL;
		GeeHashMap* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeIterator* _tmp6_;
		GeeIterator* _tmp7_;
		_tmp2_ = self->priv->libraries;
		_tmp3_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = _tmp4_;
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
		_tmp7_ = _tmp6_;
		_g_object_unref0 (_tmp5_);
		_library_it = _tmp7_;
		while (TRUE) {
			GeeIterator* _tmp8_;
			MusicLibrary* library = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			MusicLibrary* _tmp11_;
			_tmp8_ = _library_it;
			if (!gee_iterator_next (_tmp8_)) {
				break;
			}
			_tmp9_ = _library_it;
			_tmp10_ = gee_iterator_get (_tmp9_);
			library = (MusicLibrary*) _tmp10_;
			_tmp11_ = library;
			music_library_search_medias (_tmp11_, search);
			_g_object_unref0 (library);
		}
		_g_object_unref0 (_library_it);
	}
}

void
music_libraries_manager_transfer_to_local_library (MusicLibrariesManager* self,
                                                   GeeCollection* to_transfer)
{
	MusicLibrary* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gint _tmp4_;
	gint _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_transfer != NULL);
	_tmp0_ = self->local_library;
	if (_tmp0_ == NULL) {
		return;
	}
	if (to_transfer == NULL) {
		_tmp1_ = TRUE;
	} else {
		gint _tmp2_;
		gint _tmp3_;
		_tmp2_ = gee_collection_get_size (to_transfer);
		_tmp3_ = _tmp2_;
		_tmp1_ = _tmp3_ == 0;
	}
	if (_tmp1_) {
		g_warning ("LibrariesManager.vala:93: No songs in transfer list\n");
		return;
	}
	_tmp4_ = gee_collection_get_size (to_transfer);
	_tmp5_ = _tmp4_;
	g_debug ("LibrariesManager.vala:97: Found %d medias to import.", _tmp5_);
	music_libraries_manager_transfer_medias_async (self, to_transfer, NULL, NULL);
	return;
}

static void
music_libraries_manager_transfer_medias_async_data_free (gpointer _data)
{
	MusicLibrariesManagerTransferMediasAsyncData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->list);
	_g_object_unref0 (_data_->self);
	g_slice_free (MusicLibrariesManagerTransferMediasAsyncData, _data_);
}

void
music_libraries_manager_transfer_medias_async (MusicLibrariesManager* self,
                                               GeeCollection* list,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	MusicLibrariesManagerTransferMediasAsyncData* _data_;
	MusicLibrariesManager* _tmp0_;
	GeeCollection* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (list != NULL);
	_data_ = g_slice_new0 (MusicLibrariesManagerTransferMediasAsyncData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, music_libraries_manager_transfer_medias_async_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (list);
	_g_object_unref0 (_data_->list);
	_data_->list = _tmp1_;
	music_libraries_manager_transfer_medias_async_co (_data_);
}

void
music_libraries_manager_transfer_medias_finish (MusicLibrariesManager* self,
                                                GAsyncResult* _res_)
{
	MusicLibrariesManagerTransferMediasAsyncData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		MusicLibrariesManager* self;
		self = _data6_->self;
		_g_object_unref0 (_data6_->copied_list);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static gboolean
_music_libraries_manager_do_progress_notification_with_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = music_libraries_manager_do_progress_notification_with_timeout ((MusicLibrariesManager*) self);
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static gboolean
__lambda15_ (Block6Data* _data6_)
{
	MusicLibrariesManager* self;
	MusicLibrary* _tmp0_;
	GeeTreeSet* _tmp1_;
	gboolean result = FALSE;
	self = _data6_->self;
	_tmp0_ = self->local_library;
	_tmp1_ = _data6_->copied_list;
	music_library_add_medias (_tmp0_, (GeeCollection*) _tmp1_);
	result = FALSE;
	return result;
}

static gboolean
___lambda15__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda15_ (self);
	return result;
}

static gboolean
music_libraries_manager_transfer_medias_async_co (MusicLibrariesManagerTransferMediasAsyncData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data6_ = g_slice_new0 (Block6Data);
	_data_->_data6_->_ref_count_ = 1;
	_data_->_data6_->self = g_object_ref (_data_->self);
	_data_->_data6_->_async_data_ = _data_;
	if (_data_->list == NULL) {
		_data_->_tmp0_ = TRUE;
	} else {
		_data_->_tmp1_ = gee_collection_get_size (_data_->list);
		_data_->_tmp2_ = _data_->_tmp1_;
		_data_->_tmp0_ = _data_->_tmp2_ == 0;
	}
	if (_data_->_tmp0_) {
		block6_data_unref (_data_->_data6_);
		_data_->_data6_ = NULL;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->index = 0;
	_data_->self->progress = (gdouble) 0;
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _music_libraries_manager_do_progress_notification_with_timeout_gsource_func, g_object_ref (_data_->self), g_object_unref);
	_data_->_tmp3_ = gee_collection_get_size (_data_->list);
	_data_->_tmp4_ = _data_->_tmp3_;
	_data_->total = _data_->_tmp4_;
	_data_->_tmp5_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_data_->_data6_->copied_list = _data_->_tmp5_;
	{
		_data_->_tmp6_ = gee_iterable_iterator ((GeeIterable*) _data_->list);
		_data_->_m_it = _data_->_tmp6_;
		while (TRUE) {
			_data_->_tmp7_ = _data_->_m_it;
			if (!gee_iterator_next (_data_->_tmp7_)) {
				break;
			}
			_data_->_tmp8_ = _data_->_m_it;
			_data_->_tmp9_ = gee_iterator_get (_data_->_tmp8_);
			_data_->m = (MusicMedia*) _data_->_tmp9_;
			_data_->_tmp10_ = _data_->m;
			_data_->_tmp11_ = music_media_get_uri (_data_->_tmp10_);
			_data_->_tmp12_ = _data_->_tmp11_;
			_data_->_tmp13_ = _data_->_tmp12_;
			_data_->_tmp14_ = g_file_new_for_uri (_data_->_tmp13_);
			_data_->_tmp15_ = _data_->_tmp14_;
			_data_->_tmp16_ = g_file_query_exists (_data_->_tmp15_, NULL);
			_g_object_unref0 (_data_->_tmp15_);
			_g_free0 (_data_->_tmp13_);
			if (_data_->_tmp16_) {
				{
					_data_->_tmp17_ = _data_->m;
					_data_->_tmp18_ = music_file_utils_get_new_destination (_data_->_tmp17_);
					_data_->dest = _data_->_tmp18_;
					_data_->_tmp19_ = _data_->dest;
					if (_data_->_tmp19_ == NULL) {
						_g_object_unref0 (_data_->dest);
						_g_object_unref0 (_data_->m);
						break;
					}
					_data_->success = FALSE;
					_data_->_tmp21_ = _data_->m;
					_data_->_tmp22_ = music_media_get_file (_data_->_tmp21_);
					_data_->_tmp23_ = _data_->_tmp22_;
					_data_->_tmp24_ = _data_->dest;
					_data_->_tmp20_ = g_file_copy (_data_->_tmp23_, _data_->_tmp24_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_data_->_inner_error0_);
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
						_g_object_unref0 (_data_->dest);
						goto __catch0_g_error;
					}
					_data_->success = _data_->_tmp20_;
					if (_data_->success) {
						_data_->_tmp25_ = _data_->m;
						_data_->_tmp26_ = music_media_copy (_data_->_tmp25_);
						_data_->copy = _data_->_tmp26_;
						g_debug ("LibrariesManager.vala:131: success copying file\n");
						_data_->_tmp27_ = _data_->copy;
						_data_->_tmp28_ = _data_->dest;
						_data_->_tmp29_ = g_file_get_uri (_data_->_tmp28_);
						_data_->_tmp30_ = _data_->_tmp29_;
						music_media_set_uri (_data_->_tmp27_, _data_->_tmp30_);
						_g_free0 (_data_->_tmp30_);
						_data_->_tmp31_ = _data_->copy;
						music_media_set_rowid (_data_->_tmp31_, (gint64) 0);
						_data_->_tmp32_ = _data_->copy;
						music_media_set_is_temporary (_data_->_tmp32_, FALSE);
						_data_->_tmp33_ = _data_->copy;
						_data_->_tmp34_ = time (NULL);
						music_media_set_date_added (_data_->_tmp33_, (guint) ((gint) _data_->_tmp34_));
						_data_->_tmp35_ = _data_->_data6_->copied_list;
						_data_->_tmp36_ = _data_->copy;
						gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp35_, _data_->_tmp36_);
						_g_object_unref0 (_data_->copy);
					} else {
						_data_->_tmp37_ = _data_->m;
						_data_->_tmp38_ = music_media_get_uri (_data_->_tmp37_);
						_data_->_tmp39_ = _data_->_tmp38_;
						_data_->_tmp40_ = _data_->_tmp39_;
						_data_->_tmp41_ = _data_->dest;
						_data_->_tmp42_ = g_file_get_path (_data_->_tmp41_);
						_data_->_tmp43_ = _data_->_tmp42_;
						g_warning ("LibrariesManager.vala:138: Failure: Could not copy imported media %s t" \
"o media folder %s", _data_->_tmp40_, _data_->_tmp43_);
						_g_free0 (_data_->_tmp43_);
						_g_free0 (_data_->_tmp40_);
						_g_object_unref0 (_data_->dest);
						_g_object_unref0 (_data_->m);
						break;
					}
					_g_object_unref0 (_data_->dest);
				}
				goto __finally0;
				__catch0_g_error:
				{
					_data_->err = _data_->_inner_error0_;
					_data_->_inner_error0_ = NULL;
					_data_->_tmp44_ = _data_->m;
					_data_->_tmp45_ = music_media_get_uri (_data_->_tmp44_);
					_data_->_tmp46_ = _data_->_tmp45_;
					_data_->_tmp47_ = _data_->_tmp46_;
					_data_->_tmp48_ = _data_->err;
					_data_->_tmp49_ = _data_->_tmp48_->message;
					g_warning ("LibrariesManager.vala:142: Could not copy imported media %s to media f" \
"older: %s\n", _data_->_tmp47_, _data_->_tmp49_);
					_g_free0 (_data_->_tmp47_);
					_g_error_free0 (_data_->err);
					_g_object_unref0 (_data_->m);
					break;
				}
				__finally0:
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
					_g_object_unref0 (_data_->m);
					_g_object_unref0 (_data_->_m_it);
					block6_data_unref (_data_->_data6_);
					_data_->_data6_ = NULL;
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
					g_clear_error (&_data_->_inner_error0_);
					g_object_unref (_data_->_async_result);
					return FALSE;
				}
				_data_->_tmp50_ = g_strdup (_ ("Importing <b>$NAME</b> by <b>$ARTIST</b> to library…"));
				_g_free0 (_data_->self->current_operation);
				_data_->self->current_operation = _data_->_tmp50_;
				_data_->_tmp51_ = _data_->self->current_operation;
				_data_->_tmp52_ = _data_->m;
				_data_->_tmp53_ = music_media_get_display_title (_data_->_tmp52_);
				_data_->_tmp54_ = _data_->_tmp53_;
				_data_->_tmp55_ = string_replace (_data_->_tmp51_, "$NAME", _data_->_tmp54_);
				_g_free0 (_data_->self->current_operation);
				_data_->self->current_operation = _data_->_tmp55_;
				_g_free0 (_data_->_tmp54_);
				_data_->_tmp56_ = _data_->self->current_operation;
				_data_->_tmp57_ = _data_->m;
				_data_->_tmp58_ = music_media_get_display_artist (_data_->_tmp57_);
				_data_->_tmp59_ = _data_->_tmp58_;
				_data_->_tmp60_ = string_replace (_data_->_tmp56_, "$ARTIST", _data_->_tmp59_);
				_g_free0 (_data_->self->current_operation);
				_data_->self->current_operation = _data_->_tmp60_;
				_g_free0 (_data_->_tmp59_);
			} else {
				_data_->_tmp61_ = _data_->m;
				_data_->_tmp62_ = music_media_get_display_title (_data_->_tmp61_);
				_data_->_tmp63_ = _data_->_tmp62_;
				g_message ("LibrariesManager.vala:150: Skipped transferring media %s. Either alrea" \
"dy in library, or has invalid file path.\n", _data_->_tmp63_);
				_g_free0 (_data_->_tmp63_);
			}
			_data_->_tmp64_ = _data_->index;
			_data_->index = _data_->_tmp64_ + 1;
			_data_->self->progress = ((gdouble) _data_->index) / _data_->total;
			_g_object_unref0 (_data_->m);
		}
		_g_object_unref0 (_data_->_m_it);
	}
	_data_->self->progress = (gdouble) 1;
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda15__gsource_func, block6_data_ref (_data_->_data6_), block6_data_unref);
	block6_data_unref (_data_->_data6_);
	_data_->_data6_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

gboolean
music_libraries_manager_do_progress_notification_with_timeout (MusicLibrariesManager* self)
{
	MusicNotificationManager* _tmp0_;
	MusicNotificationManager* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = music_notification_manager_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = self->current_operation;
	_tmp3_ = string_replace (_tmp2_, "&", "&amp;");
	_tmp4_ = _tmp3_;
	g_signal_emit_by_name (_tmp1_, "update-progress", _tmp4_, self->progress);
	_g_free0 (_tmp4_);
	_g_object_unref0 (_tmp1_);
	if (self->progress < ((gdouble) 1)) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static void
music_libraries_manager_class_init (MusicLibrariesManagerClass * klass,
                                    gpointer klass_data)
{
	music_libraries_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicLibrariesManager_private_offset);
	G_OBJECT_CLASS (klass)->finalize = music_libraries_manager_finalize;
	/**
	     * Headless playlists are playlists that are not linked to a library.
	     */
	music_libraries_manager_signals[MUSIC_LIBRARIES_MANAGER_ADD_HEADLESS_PLAYLIST_SIGNAL] = g_signal_new ("add-headless-playlist", MUSIC_TYPE_LIBRARIES_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_STATIC_PLAYLIST);
	music_libraries_manager_signals[MUSIC_LIBRARIES_MANAGER_LIBRARY_REMOVED_SIGNAL] = g_signal_new ("library-removed", MUSIC_TYPE_LIBRARIES_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_LIBRARY);
	music_libraries_manager_signals[MUSIC_LIBRARIES_MANAGER_LIBRARY_ADDED_SIGNAL] = g_signal_new ("library-added", MUSIC_TYPE_LIBRARIES_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_LIBRARY);
	music_libraries_manager_signals[MUSIC_LIBRARIES_MANAGER_CANCEL_TRANSFER_SIGNAL] = g_signal_new ("cancel-transfer", MUSIC_TYPE_LIBRARIES_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_libraries_manager_signals[MUSIC_LIBRARIES_MANAGER_OPERATION_TERMINATED_SIGNAL] = g_signal_new ("operation-terminated", MUSIC_TYPE_LIBRARIES_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
music_libraries_manager_instance_init (MusicLibrariesManager * self,
                                       gpointer klass)
{
	self->priv = music_libraries_manager_get_instance_private (self);
	self->priv->old_search = NULL;
	self->priv->current_index = 0;
}

static void
music_libraries_manager_finalize (GObject * obj)
{
	MusicLibrariesManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_LIBRARIES_MANAGER, MusicLibrariesManager);
	_g_free0 (self->current_operation);
	_g_free0 (self->priv->old_search);
	_g_object_unref0 (self->priv->libraries);
	_g_object_unref0 (self->local_library);
	G_OBJECT_CLASS (music_libraries_manager_parent_class)->finalize (obj);
}

static GType
music_libraries_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicLibrariesManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_libraries_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicLibrariesManager), 0, (GInstanceInitFunc) music_libraries_manager_instance_init, NULL };
	GType music_libraries_manager_type_id;
	music_libraries_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicLibrariesManager", &g_define_type_info, 0);
	MusicLibrariesManager_private_offset = g_type_add_instance_private (music_libraries_manager_type_id, sizeof (MusicLibrariesManagerPrivate));
	return music_libraries_manager_type_id;
}

GType
music_libraries_manager_get_type (void)
{
	static volatile gsize music_libraries_manager_type_id__volatile = 0;
	if (g_once_init_enter (&music_libraries_manager_type_id__volatile)) {
		GType music_libraries_manager_type_id;
		music_libraries_manager_type_id = music_libraries_manager_get_type_once ();
		g_once_init_leave (&music_libraries_manager_type_id__volatile, music_libraries_manager_type_id);
	}
	return music_libraries_manager_type_id__volatile;
}

