/* Library.c generated by valac 0.52.4, the Vala compiler
 * generated from Library.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>

enum  {
	MUSIC_LIBRARY_0_PROPERTY,
	MUSIC_LIBRARY_NUM_PROPERTIES
};
static GParamSpec* music_library_properties[MUSIC_LIBRARY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	MUSIC_LIBRARY_FILE_OPERATIONS_STARTED_SIGNAL,
	MUSIC_LIBRARY_FILE_OPERATIONS_DONE_SIGNAL,
	MUSIC_LIBRARY_MEDIA_ADDED_SIGNAL,
	MUSIC_LIBRARY_MEDIA_UPDATED_SIGNAL,
	MUSIC_LIBRARY_MEDIA_REMOVED_SIGNAL,
	MUSIC_LIBRARY_MEDIA_IMPORTED_SIGNAL,
	MUSIC_LIBRARY_SEARCH_FINISHED_SIGNAL,
	MUSIC_LIBRARY_PLAYLIST_ADDED_SIGNAL,
	MUSIC_LIBRARY_PLAYLIST_NAME_UPDATED_SIGNAL,
	MUSIC_LIBRARY_PLAYLIST_REMOVED_SIGNAL,
	MUSIC_LIBRARY_SMARTPLAYLIST_ADDED_SIGNAL,
	MUSIC_LIBRARY_SMARTPLAYLIST_NAME_UPDATED_SIGNAL,
	MUSIC_LIBRARY_SMARTPLAYLIST_REMOVED_SIGNAL,
	MUSIC_LIBRARY_NUM_SIGNALS
};
static guint music_library_signals[MUSIC_LIBRARY_NUM_SIGNALS] = {0};

static gpointer music_library_parent_class = NULL;

static void music_library_real_initialize_library (MusicLibrary* self);
static void music_library_real_add_files_to_library (MusicLibrary* self,
                                              GeeCollection* files);
static GeeCollection* music_library_real_get_medias (MusicLibrary* self);
static GeeCollection* music_library_real_get_playlists (MusicLibrary* self);
static GeeCollection* music_library_real_get_smart_playlists (MusicLibrary* self);
static void music_library_real_search_medias (MusicLibrary* self,
                                       const gchar* search);
static GeeCollection* music_library_real_get_search_result (MusicLibrary* self);
static void music_library_real_add_media (MusicLibrary* self,
                                   MusicMedia* s);
static void music_library_real_add_medias (MusicLibrary* self,
                                    GeeCollection* new_media);
static MusicMedia* music_library_real_find_media (MusicLibrary* self,
                                           MusicMedia* to_find);
static MusicMedia* music_library_real_media_from_file (MusicLibrary* self,
                                                GFile* file);
static MusicMedia* music_library_real_media_from_uri (MusicLibrary* self,
                                               const gchar* uri);
static MusicMedia* music_library_real_media_from_id (MusicLibrary* self,
                                              gint64 id);
static GeeCollection* music_library_real_medias_from_uris (MusicLibrary* self,
                                                    GeeCollection* uris);
static GeeCollection* music_library_real_medias_from_ids (MusicLibrary* self,
                                                   GeeCollection* ids);
static void music_library_real_update_media (MusicLibrary* self,
                                      MusicMedia* s,
                                      gboolean update_meta,
                                      gboolean record_time);
static void music_library_real_update_medias (MusicLibrary* self,
                                       GeeCollection* updates,
                                       gboolean update_meta,
                                       gboolean record_time);
static void music_library_real_remove_media (MusicLibrary* self,
                                      MusicMedia* s,
                                      gboolean trash);
static void music_library_real_remove_medias (MusicLibrary* self,
                                       GeeCollection* to_remove,
                                       gboolean trash);
static gboolean music_library_real_support_smart_playlists (MusicLibrary* self);
static void music_library_real_add_smart_playlist (MusicLibrary* self,
                                            MusicSmartPlaylist* p);
static void music_library_real_remove_smart_playlist (MusicLibrary* self,
                                               gint64 id);
static MusicSmartPlaylist* music_library_real_smart_playlist_from_id (MusicLibrary* self,
                                                               gint64 id);
static MusicSmartPlaylist* music_library_real_smart_playlist_from_name (MusicLibrary* self,
                                                                 const gchar* name);
static gboolean music_library_real_support_playlists (MusicLibrary* self);
static void music_library_real_add_playlist (MusicLibrary* self,
                                      MusicStaticPlaylist* p);
static void music_library_real_remove_playlist (MusicLibrary* self,
                                         gint64 id);
static MusicStaticPlaylist* music_library_real_playlist_from_id (MusicLibrary* self,
                                                          gint64 id);
static MusicStaticPlaylist* music_library_real_playlist_from_name (MusicLibrary* self,
                                                            const gchar* name);
static gboolean music_library_real_start_file_operations (MusicLibrary* self,
                                                   const gchar* message);
static gboolean music_library_real_doing_file_operations (MusicLibrary* self);
static void music_library_real_finish_file_operations (MusicLibrary* self);
static GType music_library_get_type_once (void);

static void
music_library_real_initialize_library (MusicLibrary* self)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_initialize_library'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_library_initialize_library (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->initialize_library) {
		_klass_->initialize_library (self);
	}
}

static void
music_library_real_add_files_to_library (MusicLibrary* self,
                                         GeeCollection* files)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_add_files_to_library'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_library_add_files_to_library (MusicLibrary* self,
                                    GeeCollection* files)
{
	MusicLibraryClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->add_files_to_library) {
		_klass_->add_files_to_library (self, files);
	}
}

static GeeCollection*
music_library_real_get_medias (MusicLibrary* self)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_get_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

GeeCollection*
music_library_get_medias (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->get_medias) {
		return _klass_->get_medias (self);
	}
	return NULL;
}

static GeeCollection*
music_library_real_get_playlists (MusicLibrary* self)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_get_playlists'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

GeeCollection*
music_library_get_playlists (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->get_playlists) {
		return _klass_->get_playlists (self);
	}
	return NULL;
}

static GeeCollection*
music_library_real_get_smart_playlists (MusicLibrary* self)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_get_smart_playlists'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

GeeCollection*
music_library_get_smart_playlists (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->get_smart_playlists) {
		return _klass_->get_smart_playlists (self);
	}
	return NULL;
}

static void
music_library_real_search_medias (MusicLibrary* self,
                                  const gchar* search)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_search_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_library_search_medias (MusicLibrary* self,
                             const gchar* search)
{
	MusicLibraryClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->search_medias) {
		_klass_->search_medias (self, search);
	}
}

static GeeCollection*
music_library_real_get_search_result (MusicLibrary* self)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_get_search_result'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

GeeCollection*
music_library_get_search_result (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->get_search_result) {
		return _klass_->get_search_result (self);
	}
	return NULL;
}

static void
music_library_real_add_media (MusicLibrary* self,
                              MusicMedia* s)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_add_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_library_add_media (MusicLibrary* self,
                         MusicMedia* s)
{
	MusicLibraryClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->add_media) {
		_klass_->add_media (self, s);
	}
}

static void
music_library_real_add_medias (MusicLibrary* self,
                               GeeCollection* new_media)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_add_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_library_add_medias (MusicLibrary* self,
                          GeeCollection* new_media)
{
	MusicLibraryClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->add_medias) {
		_klass_->add_medias (self, new_media);
	}
}

static MusicMedia*
music_library_real_find_media (MusicLibrary* self,
                               MusicMedia* to_find)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_find_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

MusicMedia*
music_library_find_media (MusicLibrary* self,
                          MusicMedia* to_find)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->find_media) {
		return _klass_->find_media (self, to_find);
	}
	return NULL;
}

static MusicMedia*
music_library_real_media_from_file (MusicLibrary* self,
                                    GFile* file)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_media_from_file'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

MusicMedia*
music_library_media_from_file (MusicLibrary* self,
                               GFile* file)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->media_from_file) {
		return _klass_->media_from_file (self, file);
	}
	return NULL;
}

static MusicMedia*
music_library_real_media_from_uri (MusicLibrary* self,
                                   const gchar* uri)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_media_from_uri'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

MusicMedia*
music_library_media_from_uri (MusicLibrary* self,
                              const gchar* uri)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->media_from_uri) {
		return _klass_->media_from_uri (self, uri);
	}
	return NULL;
}

static MusicMedia*
music_library_real_media_from_id (MusicLibrary* self,
                                  gint64 id)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_media_from_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

MusicMedia*
music_library_media_from_id (MusicLibrary* self,
                             gint64 id)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->media_from_id) {
		return _klass_->media_from_id (self, id);
	}
	return NULL;
}

static GeeCollection*
music_library_real_medias_from_uris (MusicLibrary* self,
                                     GeeCollection* uris)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_medias_from_uris'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

GeeCollection*
music_library_medias_from_uris (MusicLibrary* self,
                                GeeCollection* uris)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->medias_from_uris) {
		return _klass_->medias_from_uris (self, uris);
	}
	return NULL;
}

static GeeCollection*
music_library_real_medias_from_ids (MusicLibrary* self,
                                    GeeCollection* ids)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_medias_from_ids'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

GeeCollection*
music_library_medias_from_ids (MusicLibrary* self,
                               GeeCollection* ids)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->medias_from_ids) {
		return _klass_->medias_from_ids (self, ids);
	}
	return NULL;
}

static void
music_library_real_update_media (MusicLibrary* self,
                                 MusicMedia* s,
                                 gboolean update_meta,
                                 gboolean record_time)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_update_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_library_update_media (MusicLibrary* self,
                            MusicMedia* s,
                            gboolean update_meta,
                            gboolean record_time)
{
	MusicLibraryClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->update_media) {
		_klass_->update_media (self, s, update_meta, record_time);
	}
}

static void
music_library_real_update_medias (MusicLibrary* self,
                                  GeeCollection* updates,
                                  gboolean update_meta,
                                  gboolean record_time)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_update_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_library_update_medias (MusicLibrary* self,
                             GeeCollection* updates,
                             gboolean update_meta,
                             gboolean record_time)
{
	MusicLibraryClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->update_medias) {
		_klass_->update_medias (self, updates, update_meta, record_time);
	}
}

static void
music_library_real_remove_media (MusicLibrary* self,
                                 MusicMedia* s,
                                 gboolean trash)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_remove_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_library_remove_media (MusicLibrary* self,
                            MusicMedia* s,
                            gboolean trash)
{
	MusicLibraryClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->remove_media) {
		_klass_->remove_media (self, s, trash);
	}
}

static void
music_library_real_remove_medias (MusicLibrary* self,
                                  GeeCollection* to_remove,
                                  gboolean trash)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_remove_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_library_remove_medias (MusicLibrary* self,
                             GeeCollection* to_remove,
                             gboolean trash)
{
	MusicLibraryClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->remove_medias) {
		_klass_->remove_medias (self, to_remove, trash);
	}
}

static gboolean
music_library_real_support_smart_playlists (MusicLibrary* self)
{
	gboolean _tmp0_ = FALSE;
	g_critical ("Type `%s' does not implement abstract method `music_library_support_smart_playlists'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}

gboolean
music_library_support_smart_playlists (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->support_smart_playlists) {
		return _klass_->support_smart_playlists (self);
	}
	return FALSE;
}

static void
music_library_real_add_smart_playlist (MusicLibrary* self,
                                       MusicSmartPlaylist* p)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_add_smart_playlist'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_library_add_smart_playlist (MusicLibrary* self,
                                  MusicSmartPlaylist* p)
{
	MusicLibraryClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->add_smart_playlist) {
		_klass_->add_smart_playlist (self, p);
	}
}

static void
music_library_real_remove_smart_playlist (MusicLibrary* self,
                                          gint64 id)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_remove_smart_playlist'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_library_remove_smart_playlist (MusicLibrary* self,
                                     gint64 id)
{
	MusicLibraryClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->remove_smart_playlist) {
		_klass_->remove_smart_playlist (self, id);
	}
}

static MusicSmartPlaylist*
music_library_real_smart_playlist_from_id (MusicLibrary* self,
                                           gint64 id)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_smart_playlist_from_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

MusicSmartPlaylist*
music_library_smart_playlist_from_id (MusicLibrary* self,
                                      gint64 id)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->smart_playlist_from_id) {
		return _klass_->smart_playlist_from_id (self, id);
	}
	return NULL;
}

static MusicSmartPlaylist*
music_library_real_smart_playlist_from_name (MusicLibrary* self,
                                             const gchar* name)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_smart_playlist_from_name'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

MusicSmartPlaylist*
music_library_smart_playlist_from_name (MusicLibrary* self,
                                        const gchar* name)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->smart_playlist_from_name) {
		return _klass_->smart_playlist_from_name (self, name);
	}
	return NULL;
}

static gboolean
music_library_real_support_playlists (MusicLibrary* self)
{
	gboolean _tmp0_ = FALSE;
	g_critical ("Type `%s' does not implement abstract method `music_library_support_playlists'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}

gboolean
music_library_support_playlists (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->support_playlists) {
		return _klass_->support_playlists (self);
	}
	return FALSE;
}

static void
music_library_real_add_playlist (MusicLibrary* self,
                                 MusicStaticPlaylist* p)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_add_playlist'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_library_add_playlist (MusicLibrary* self,
                            MusicStaticPlaylist* p)
{
	MusicLibraryClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->add_playlist) {
		_klass_->add_playlist (self, p);
	}
}

static void
music_library_real_remove_playlist (MusicLibrary* self,
                                    gint64 id)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_remove_playlist'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_library_remove_playlist (MusicLibrary* self,
                               gint64 id)
{
	MusicLibraryClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->remove_playlist) {
		_klass_->remove_playlist (self, id);
	}
}

static MusicStaticPlaylist*
music_library_real_playlist_from_id (MusicLibrary* self,
                                     gint64 id)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_playlist_from_id'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

MusicStaticPlaylist*
music_library_playlist_from_id (MusicLibrary* self,
                                gint64 id)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->playlist_from_id) {
		return _klass_->playlist_from_id (self, id);
	}
	return NULL;
}

static MusicStaticPlaylist*
music_library_real_playlist_from_name (MusicLibrary* self,
                                       const gchar* name)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_playlist_from_name'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

MusicStaticPlaylist*
music_library_playlist_from_name (MusicLibrary* self,
                                  const gchar* name)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->playlist_from_name) {
		return _klass_->playlist_from_name (self, name);
	}
	return NULL;
}

static gboolean
music_library_real_start_file_operations (MusicLibrary* self,
                                          const gchar* message)
{
	gboolean _tmp0_ = FALSE;
	g_critical ("Type `%s' does not implement abstract method `music_library_start_file_operations'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}

gboolean
music_library_start_file_operations (MusicLibrary* self,
                                     const gchar* message)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->start_file_operations) {
		return _klass_->start_file_operations (self, message);
	}
	return FALSE;
}

static gboolean
music_library_real_doing_file_operations (MusicLibrary* self)
{
	gboolean _tmp0_ = FALSE;
	g_critical ("Type `%s' does not implement abstract method `music_library_doing_file_operations'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return _tmp0_;
}

gboolean
music_library_doing_file_operations (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->doing_file_operations) {
		return _klass_->doing_file_operations (self);
	}
	return FALSE;
}

static void
music_library_real_finish_file_operations (MusicLibrary* self)
{
	g_critical ("Type `%s' does not implement abstract method `music_library_finish_file_operations'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_library_finish_file_operations (MusicLibrary* self)
{
	MusicLibraryClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_LIBRARY_GET_CLASS (self);
	if (_klass_->finish_file_operations) {
		_klass_->finish_file_operations (self);
	}
}

gint
music_library_playlist_count_without_read_only (MusicLibrary* self)
{
	gint i = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	i = 0;
	{
		GeeIterator* _p_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
		_tmp0_ = music_library_get_playlists (self);
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_p_it = _tmp3_;
		while (TRUE) {
			GeeIterator* _tmp4_;
			MusicStaticPlaylist* p = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			MusicStaticPlaylist* _tmp7_;
			gboolean _tmp8_;
			gboolean _tmp9_;
			_tmp4_ = _p_it;
			if (!gee_iterator_next (_tmp4_)) {
				break;
			}
			_tmp5_ = _p_it;
			_tmp6_ = gee_iterator_get (_tmp5_);
			p = (MusicStaticPlaylist*) _tmp6_;
			_tmp7_ = p;
			_tmp8_ = music_static_playlist_get_read_only (_tmp7_);
			_tmp9_ = _tmp8_;
			if (_tmp9_ == FALSE) {
				gint _tmp10_;
				_tmp10_ = i;
				i = _tmp10_ + 1;
			}
			_g_object_unref0 (p);
		}
		_g_object_unref0 (_p_it);
	}
	result = i;
	return result;
}

void
music_library_media_from_name (MusicLibrary* self,
                               GeeCollection* tests,
                               GeeCollection* found,
                               GeeCollection* not_found)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (tests != NULL);
	g_return_if_fail (found != NULL);
	g_return_if_fail (not_found != NULL);
	{
		GeeIterator* _test_it = NULL;
		GeeIterator* _tmp0_;
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) tests);
		_test_it = _tmp0_;
		while (TRUE) {
			GeeIterator* _tmp1_;
			MusicMedia* test = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			MusicMedia* media_found = NULL;
			MusicMedia* _tmp4_;
			MusicMedia* _tmp5_;
			MusicMedia* _tmp6_;
			_tmp1_ = _test_it;
			if (!gee_iterator_next (_tmp1_)) {
				break;
			}
			_tmp2_ = _test_it;
			_tmp3_ = gee_iterator_get (_tmp2_);
			test = (MusicMedia*) _tmp3_;
			_tmp4_ = test;
			_tmp5_ = music_library_find_media (self, _tmp4_);
			media_found = _tmp5_;
			_tmp6_ = media_found;
			if (_tmp6_ != NULL) {
				MusicMedia* _tmp7_;
				gint64 _tmp8_;
				gint64 _tmp9_;
				_tmp7_ = media_found;
				_tmp8_ = music_media_get_rowid (_tmp7_);
				_tmp9_ = _tmp8_;
				gee_collection_add (found, &_tmp9_);
			} else {
				MusicMedia* _tmp10_;
				_tmp10_ = test;
				gee_collection_add (not_found, _tmp10_);
			}
			_g_object_unref0 (media_found);
			_g_object_unref0 (test);
		}
		_g_object_unref0 (_test_it);
	}
}

MusicLibrary*
music_library_construct (GType object_type)
{
	MusicLibrary * self = NULL;
	self = (MusicLibrary*) g_object_new (object_type, NULL);
	return self;
}

static void
music_library_class_init (MusicLibraryClass * klass,
                          gpointer klass_data)
{
	music_library_parent_class = g_type_class_peek_parent (klass);
	((MusicLibraryClass *) klass)->initialize_library = (void (*) (MusicLibrary*)) music_library_real_initialize_library;
	((MusicLibraryClass *) klass)->add_files_to_library = (void (*) (MusicLibrary*, GeeCollection*)) music_library_real_add_files_to_library;
	((MusicLibraryClass *) klass)->get_medias = (GeeCollection* (*) (MusicLibrary*)) music_library_real_get_medias;
	((MusicLibraryClass *) klass)->get_playlists = (GeeCollection* (*) (MusicLibrary*)) music_library_real_get_playlists;
	((MusicLibraryClass *) klass)->get_smart_playlists = (GeeCollection* (*) (MusicLibrary*)) music_library_real_get_smart_playlists;
	((MusicLibraryClass *) klass)->search_medias = (void (*) (MusicLibrary*, const gchar*)) music_library_real_search_medias;
	((MusicLibraryClass *) klass)->get_search_result = (GeeCollection* (*) (MusicLibrary*)) music_library_real_get_search_result;
	((MusicLibraryClass *) klass)->add_media = (void (*) (MusicLibrary*, MusicMedia*)) music_library_real_add_media;
	((MusicLibraryClass *) klass)->add_medias = (void (*) (MusicLibrary*, GeeCollection*)) music_library_real_add_medias;
	((MusicLibraryClass *) klass)->find_media = (MusicMedia* (*) (MusicLibrary*, MusicMedia*)) music_library_real_find_media;
	((MusicLibraryClass *) klass)->media_from_file = (MusicMedia* (*) (MusicLibrary*, GFile*)) music_library_real_media_from_file;
	((MusicLibraryClass *) klass)->media_from_uri = (MusicMedia* (*) (MusicLibrary*, const gchar*)) music_library_real_media_from_uri;
	((MusicLibraryClass *) klass)->media_from_id = (MusicMedia* (*) (MusicLibrary*, gint64)) music_library_real_media_from_id;
	((MusicLibraryClass *) klass)->medias_from_uris = (GeeCollection* (*) (MusicLibrary*, GeeCollection*)) music_library_real_medias_from_uris;
	((MusicLibraryClass *) klass)->medias_from_ids = (GeeCollection* (*) (MusicLibrary*, GeeCollection*)) music_library_real_medias_from_ids;
	((MusicLibraryClass *) klass)->update_media = (void (*) (MusicLibrary*, MusicMedia*, gboolean, gboolean)) music_library_real_update_media;
	((MusicLibraryClass *) klass)->update_medias = (void (*) (MusicLibrary*, GeeCollection*, gboolean, gboolean)) music_library_real_update_medias;
	((MusicLibraryClass *) klass)->remove_media = (void (*) (MusicLibrary*, MusicMedia*, gboolean)) music_library_real_remove_media;
	((MusicLibraryClass *) klass)->remove_medias = (void (*) (MusicLibrary*, GeeCollection*, gboolean)) music_library_real_remove_medias;
	((MusicLibraryClass *) klass)->support_smart_playlists = (gboolean (*) (MusicLibrary*)) music_library_real_support_smart_playlists;
	((MusicLibraryClass *) klass)->add_smart_playlist = (void (*) (MusicLibrary*, MusicSmartPlaylist*)) music_library_real_add_smart_playlist;
	((MusicLibraryClass *) klass)->remove_smart_playlist = (void (*) (MusicLibrary*, gint64)) music_library_real_remove_smart_playlist;
	((MusicLibraryClass *) klass)->smart_playlist_from_id = (MusicSmartPlaylist* (*) (MusicLibrary*, gint64)) music_library_real_smart_playlist_from_id;
	((MusicLibraryClass *) klass)->smart_playlist_from_name = (MusicSmartPlaylist* (*) (MusicLibrary*, const gchar*)) music_library_real_smart_playlist_from_name;
	((MusicLibraryClass *) klass)->support_playlists = (gboolean (*) (MusicLibrary*)) music_library_real_support_playlists;
	((MusicLibraryClass *) klass)->add_playlist = (void (*) (MusicLibrary*, MusicStaticPlaylist*)) music_library_real_add_playlist;
	((MusicLibraryClass *) klass)->remove_playlist = (void (*) (MusicLibrary*, gint64)) music_library_real_remove_playlist;
	((MusicLibraryClass *) klass)->playlist_from_id = (MusicStaticPlaylist* (*) (MusicLibrary*, gint64)) music_library_real_playlist_from_id;
	((MusicLibraryClass *) klass)->playlist_from_name = (MusicStaticPlaylist* (*) (MusicLibrary*, const gchar*)) music_library_real_playlist_from_name;
	((MusicLibraryClass *) klass)->start_file_operations = (gboolean (*) (MusicLibrary*, const gchar*)) music_library_real_start_file_operations;
	((MusicLibraryClass *) klass)->doing_file_operations = (gboolean (*) (MusicLibrary*)) music_library_real_doing_file_operations;
	((MusicLibraryClass *) klass)->finish_file_operations = (void (*) (MusicLibrary*)) music_library_real_finish_file_operations;
	music_library_signals[MUSIC_LIBRARY_FILE_OPERATIONS_STARTED_SIGNAL] = g_signal_new ("file-operations-started", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_library_signals[MUSIC_LIBRARY_FILE_OPERATIONS_DONE_SIGNAL] = g_signal_new ("file-operations-done", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_library_signals[MUSIC_LIBRARY_MEDIA_ADDED_SIGNAL] = g_signal_new ("media-added", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	music_library_signals[MUSIC_LIBRARY_MEDIA_UPDATED_SIGNAL] = g_signal_new ("media-updated", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	music_library_signals[MUSIC_LIBRARY_MEDIA_REMOVED_SIGNAL] = g_signal_new ("media-removed", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	music_library_signals[MUSIC_LIBRARY_MEDIA_IMPORTED_SIGNAL] = g_signal_new ("media-imported", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	music_library_signals[MUSIC_LIBRARY_SEARCH_FINISHED_SIGNAL] = g_signal_new ("search-finished", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_library_signals[MUSIC_LIBRARY_PLAYLIST_ADDED_SIGNAL] = g_signal_new ("playlist-added", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_STATIC_PLAYLIST);
	music_library_signals[MUSIC_LIBRARY_PLAYLIST_NAME_UPDATED_SIGNAL] = g_signal_new ("playlist-name-updated", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_STATIC_PLAYLIST);
	music_library_signals[MUSIC_LIBRARY_PLAYLIST_REMOVED_SIGNAL] = g_signal_new ("playlist-removed", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_STATIC_PLAYLIST);
	music_library_signals[MUSIC_LIBRARY_SMARTPLAYLIST_ADDED_SIGNAL] = g_signal_new ("smartplaylist-added", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_SMART_PLAYLIST);
	music_library_signals[MUSIC_LIBRARY_SMARTPLAYLIST_NAME_UPDATED_SIGNAL] = g_signal_new ("smartplaylist-name-updated", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_SMART_PLAYLIST);
	music_library_signals[MUSIC_LIBRARY_SMARTPLAYLIST_REMOVED_SIGNAL] = g_signal_new ("smartplaylist-removed", MUSIC_TYPE_LIBRARY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_SMART_PLAYLIST);
}

static void
music_library_instance_init (MusicLibrary * self,
                             gpointer klass)
{
}

static GType
music_library_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicLibraryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_library_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicLibrary), 0, (GInstanceInitFunc) music_library_instance_init, NULL };
	GType music_library_type_id;
	music_library_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicLibrary", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return music_library_type_id;
}

GType
music_library_get_type (void)
{
	static volatile gsize music_library_type_id__volatile = 0;
	if (g_once_init_enter (&music_library_type_id__volatile)) {
		GType music_library_type_id;
		music_library_type_id = music_library_get_type_once ();
		g_once_init_leave (&music_library_type_id__volatile, music_library_type_id);
	}
	return music_library_type_id__volatile;
}

