/* LibraryWindowInterface.c generated by valac 0.52.4, the Vala compiler
 * generated from LibraryWindowInterface.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <gio/gio.h>
#include <glib-object.h>
#include <glib.h>

enum  {
	MUSIC_LIBRARY_WINDOW_INTERFACE_SOURCE_LIST_ADDED_SIGNAL,
	MUSIC_LIBRARY_WINDOW_INTERFACE_MEDIA_HALF_PLAYED_SIGNAL,
	MUSIC_LIBRARY_WINDOW_INTERFACE_UPDATE_MEDIA_INFO_SIGNAL,
	MUSIC_LIBRARY_WINDOW_INTERFACE_NUM_SIGNALS
};
static guint music_library_window_interface_signals[MUSIC_LIBRARY_WINDOW_INTERFACE_NUM_SIGNALS] = {0};

static void g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data);
static GType music_library_window_interface_get_type_once (void);

void
music_library_window_interface_update_sensitivities (MusicLibraryWindowInterface* self,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	MusicLibraryWindowInterfaceIface* _iface_;
	_iface_ = MUSIC_LIBRARY_WINDOW_INTERFACE_GET_INTERFACE (self);
	if (_iface_->update_sensitivities) {
		_iface_->update_sensitivities (self, _callback_, _user_data_);
	}
}

void
music_library_window_interface_update_sensitivities_finish (MusicLibraryWindowInterface* self,
                                                            GAsyncResult* _res_)
{
	MusicLibraryWindowInterfaceIface* _iface_;
	_iface_ = MUSIC_LIBRARY_WINDOW_INTERFACE_GET_INTERFACE (self);
	if (_iface_->update_sensitivities_finish) {
		_iface_->update_sensitivities_finish (self, _res_);
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), data2);
}

static void
music_library_window_interface_default_init (MusicLibraryWindowInterfaceIface * iface,
                                             gpointer iface_data)
{
	music_library_window_interface_signals[MUSIC_LIBRARY_WINDOW_INTERFACE_SOURCE_LIST_ADDED_SIGNAL] = g_signal_new ("source-list-added", MUSIC_TYPE_LIBRARY_WINDOW_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT, G_TYPE_NONE, 2, G_TYPE_OBJECT, G_TYPE_INT);
	music_library_window_interface_signals[MUSIC_LIBRARY_WINDOW_INTERFACE_MEDIA_HALF_PLAYED_SIGNAL] = g_signal_new ("media-half-played", MUSIC_TYPE_LIBRARY_WINDOW_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_MEDIA);
	music_library_window_interface_signals[MUSIC_LIBRARY_WINDOW_INTERFACE_UPDATE_MEDIA_INFO_SIGNAL] = g_signal_new ("update-media-info", MUSIC_TYPE_LIBRARY_WINDOW_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, MUSIC_TYPE_MEDIA);
}

static GType
music_library_window_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicLibraryWindowInterfaceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_library_window_interface_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType music_library_window_interface_type_id;
	music_library_window_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "MusicLibraryWindowInterface", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (music_library_window_interface_type_id, G_TYPE_OBJECT);
	return music_library_window_interface_type_id;
}

GType
music_library_window_interface_get_type (void)
{
	static volatile gsize music_library_window_interface_type_id__volatile = 0;
	if (g_once_init_enter (&music_library_window_interface_type_id__volatile)) {
		GType music_library_window_interface_type_id;
		music_library_window_interface_type_id = music_library_window_interface_get_type_once ();
		g_once_init_leave (&music_library_window_interface_type_id__volatile, music_library_window_interface_type_id);
	}
	return music_library_window_interface_type_id__volatile;
}

