/* Media.c generated by valac 0.52.4, the Vala compiler
 * generated from Media.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include "io.elementary.music-core.h"
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>

enum  {
	MUSIC_MEDIA_0_PROPERTY,
	MUSIC_MEDIA_ROWID_PROPERTY,
	MUSIC_MEDIA_URI_PROPERTY,
	MUSIC_MEDIA_FILE_SIZE_PROPERTY,
	MUSIC_MEDIA_FILE_EXISTS_PROPERTY,
	MUSIC_MEDIA_FILE_PROPERTY,
	MUSIC_MEDIA_IS_PREVIEW_PROPERTY,
	MUSIC_MEDIA_IS_TEMPORARY_PROPERTY,
	MUSIC_MEDIA_LOCATION_UNKNOWN_PROPERTY,
	MUSIC_MEDIA_HAS_EMBEDDED_PROPERTY,
	MUSIC_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY,
	MUSIC_MEDIA_SHOW_INDICATOR_PROPERTY,
	MUSIC_MEDIA_TITLE_PROPERTY,
	MUSIC_MEDIA_TRACK_PROPERTY,
	MUSIC_MEDIA_TRACK_COUNT_PROPERTY,
	MUSIC_MEDIA_COMPOSER_PROPERTY,
	MUSIC_MEDIA_ARTIST_PROPERTY,
	MUSIC_MEDIA_ALBUM_ARTIST_PROPERTY,
	MUSIC_MEDIA_ALBUM_PROPERTY,
	MUSIC_MEDIA_ALBUM_NUMBER_PROPERTY,
	MUSIC_MEDIA_ALBUM_COUNT_PROPERTY,
	MUSIC_MEDIA_ALBUM_INFO_PROPERTY,
	MUSIC_MEDIA_GROUPING_PROPERTY,
	MUSIC_MEDIA_GENRE_PROPERTY,
	MUSIC_MEDIA_COMMENT_PROPERTY,
	MUSIC_MEDIA_LYRICS_PROPERTY,
	MUSIC_MEDIA_YEAR_PROPERTY,
	MUSIC_MEDIA_BITRATE_PROPERTY,
	MUSIC_MEDIA_BPM_PROPERTY,
	MUSIC_MEDIA_SAMPLERATE_PROPERTY,
	MUSIC_MEDIA_LENGTH_PROPERTY,
	MUSIC_MEDIA_RATING_PROPERTY,
	MUSIC_MEDIA_PLAY_COUNT_PROPERTY,
	MUSIC_MEDIA_SKIP_COUNT_PROPERTY,
	MUSIC_MEDIA_DATE_ADDED_PROPERTY,
	MUSIC_MEDIA_LAST_PLAYED_PROPERTY,
	MUSIC_MEDIA_LAST_MODIFIED_PROPERTY,
	MUSIC_MEDIA_RESUME_POS_PROPERTY,
	MUSIC_MEDIA_SHOW_PROPERTY,
	MUSIC_MEDIA_NUM_PROPERTIES
};
static GParamSpec* music_media_properties[MUSIC_MEDIA_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _MusicMediaPrivate {
	gint64 _rowid;
	guint64 _file_size;
	GFile* _file;
	gboolean _is_preview;
	gboolean _is_temporary;
	gboolean _location_unknown;
	gboolean _has_embedded;
	GIcon* _unique_status_image;
	gboolean _show_indicator;
	gchar* _title;
	guint _track;
	guint _track_count;
	gchar* _composer;
	gchar* _artist;
	gchar* _album_artist;
	gchar* _album;
	guint _album_number;
	guint _album_count;
	MusicAlbum* _album_info;
	gchar* _grouping;
	gchar* _genre;
	gchar* _comment;
	gchar* _lyrics;
	guint _year;
	guint _bitrate;
	guint _bpm;
	guint _samplerate;
	guint _length;
	guint _play_count;
	guint _skip_count;
	guint _date_added;
	guint _last_played;
	guint _last_modified;
	gint _resume_pos;
	gboolean _show;
};

static gint MusicMedia_private_offset;
static gpointer music_media_parent_class = NULL;
gchar* music_media_UNKNOWN = NULL;

gchar* music_string_locale_to_utf8 (const gchar* string_locale);
gchar* music_media_get_simple_display_text (const gchar* text);
static void music_media_finalize (GObject * obj);
static GType music_media_get_type_once (void);
static void _vala_music_media_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_music_media_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
music_media_get_instance_private (MusicMedia* self)
{
	return G_STRUCT_MEMBER_P (self, MusicMedia_private_offset);
}

inline gchar*
music_media_get_display_filename (MusicMedia* self)
{
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* filename = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_;
	gchar* _tmp11_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = music_media_get_file (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_file_get_basename (_tmp2_);
	_tmp0_ = _tmp3_;
	if (_tmp0_ == NULL) {
		const gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp4_ = music_media_UNKNOWN;
		_tmp5_ = g_strdup (_tmp4_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp5_;
	}
	_tmp6_ = music_string_locale_to_utf8 (_tmp0_);
	filename = _tmp6_;
	_tmp8_ = filename;
	if (music_media_is_valid_string_field (_tmp8_)) {
		const gchar* _tmp9_;
		_tmp9_ = filename;
		_tmp7_ = _tmp9_;
	} else {
		const gchar* _tmp10_;
		_tmp10_ = music_media_UNKNOWN;
		_tmp7_ = _tmp10_;
	}
	_tmp11_ = g_strdup (_tmp7_);
	result = _tmp11_;
	_g_free0 (filename);
	_g_free0 (_tmp0_);
	return result;
}

inline gchar*
music_media_get_display_location (MusicMedia* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gchar* filename = NULL;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_media_get_is_temporary (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup ("");
		result = _tmp2_;
		return result;
	}
	_tmp3_ = music_media_get_file (self);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_file_get_path (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = music_string_locale_to_utf8 (_tmp6_);
	_tmp8_ = _tmp7_;
	_g_free0 (_tmp6_);
	filename = _tmp8_;
	_tmp9_ = filename;
	if (music_media_is_valid_string_field (_tmp9_)) {
		GFile* _tmp10_;
		GFile* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		_tmp10_ = music_media_get_file (self);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_file_get_uri_scheme (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = filename;
		_tmp15_ = g_strdup_printf ("%s:/%s", _tmp13_, _tmp14_);
		_tmp16_ = _tmp15_;
		_g_free0 (_tmp13_);
		result = _tmp16_;
		_g_free0 (filename);
		return result;
	}
	_tmp17_ = music_media_UNKNOWN;
	_tmp18_ = g_strdup (_tmp17_);
	result = _tmp18_;
	_g_free0 (filename);
	return result;
}

inline gchar*
music_media_get_display_title (MusicMedia* self)
{
	gchar* title = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_media_get_title (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup (_tmp1_);
	title = _tmp2_;
	_tmp4_ = title;
	if (music_media_is_valid_string_field (_tmp4_)) {
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = title;
		_tmp6_ = g_strdup (_tmp5_);
		_g_free0 (_tmp3_);
		_tmp3_ = _tmp6_;
	} else {
		gchar* _tmp7_;
		_tmp7_ = music_media_get_display_filename (self);
		_g_free0 (_tmp3_);
		_tmp3_ = _tmp7_;
	}
	result = _tmp3_;
	_g_free0 (title);
	return result;
}

inline gchar*
music_media_get_display_composer (MusicMedia* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_media_get_composer (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_media_get_simple_display_text (_tmp1_);
	result = _tmp2_;
	return result;
}

inline gchar*
music_media_get_display_artist (MusicMedia* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_media_get_artist (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_media_get_simple_display_text (_tmp1_);
	result = _tmp2_;
	return result;
}

inline gchar*
music_media_get_display_album_artist (MusicMedia* self,
                                      gboolean use_artist_fallback)
{
	gchar* album_artist = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_media_get_album_artist (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup (_tmp1_);
	album_artist = _tmp2_;
	_tmp3_ = album_artist;
	if (music_media_is_valid_string_field (_tmp3_)) {
		result = album_artist;
		return result;
	}
	if (use_artist_fallback) {
		gchar* _tmp4_;
		_tmp4_ = music_media_get_display_artist (self);
		result = _tmp4_;
		_g_free0 (album_artist);
		return result;
	}
	_tmp5_ = music_media_UNKNOWN;
	_tmp6_ = g_strdup (_tmp5_);
	result = _tmp6_;
	_g_free0 (album_artist);
	return result;
}

inline gchar*
music_media_get_display_album (MusicMedia* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_media_get_album (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_media_get_simple_display_text (_tmp1_);
	result = _tmp2_;
	return result;
}

inline gchar*
music_media_get_display_genre (MusicMedia* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_media_get_genre (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_media_get_simple_display_text (_tmp1_);
	result = _tmp2_;
	return result;
}

inline gboolean
music_media_is_valid_string_field (const gchar* text)
{
	gboolean result = FALSE;
	result = !music_string_is_empty (text, TRUE);
	return result;
}

guint
music_media_get_album_hashkey (MusicMedia* self)
{
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GString* _tmp12_;
	const gchar* _tmp13_;
	guint result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = g_string_new ("");
	builder = _tmp0_;
	_tmp1_ = builder;
	_tmp2_ = music_media_get_album (self);
	_tmp3_ = _tmp2_;
	g_string_append (_tmp1_, _tmp3_);
	_tmp4_ = music_media_get_album_artist (self);
	_tmp5_ = _tmp4_;
	if (music_media_is_valid_string_field (_tmp5_)) {
		GString* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		_tmp6_ = builder;
		_tmp7_ = music_media_get_album_artist (self);
		_tmp8_ = _tmp7_;
		g_string_append (_tmp6_, _tmp8_);
	} else {
		GString* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		_tmp9_ = builder;
		_tmp10_ = music_media_get_artist (self);
		_tmp11_ = _tmp10_;
		g_string_append (_tmp9_, _tmp11_);
	}
	_tmp12_ = builder;
	_tmp13_ = _tmp12_->str;
	result = g_str_hash (_tmp13_);
	_g_string_free0 (builder);
	return result;
}

/**
     * It's called simple because it simply checks if the string is empty,
     * and returns UNKNOWN if it is.
     */
inline gchar*
music_media_get_simple_display_text (const gchar* text)
{
	const gchar* _tmp0_ = NULL;
	gchar* _tmp2_;
	gchar* result = NULL;
	if (music_media_is_valid_string_field (text)) {
		_tmp0_ = text;
	} else {
		const gchar* _tmp1_;
		_tmp1_ = music_media_UNKNOWN;
		_tmp0_ = _tmp1_;
	}
	_tmp2_ = g_strdup (_tmp0_);
	result = _tmp2_;
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

gchar*
music_media_get_title_markup (MusicMedia* self)
{
	gboolean is_valid_artist = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean is_valid_album = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_media_get_artist (self);
	_tmp1_ = _tmp0_;
	is_valid_artist = music_media_is_valid_string_field (_tmp1_);
	_tmp2_ = music_media_get_album (self);
	_tmp3_ = _tmp2_;
	is_valid_album = music_media_is_valid_string_field (_tmp3_);
	if (!is_valid_artist) {
		_tmp4_ = is_valid_album;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		_tmp5_ = music_media_get_album (self);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_markup_escape_text (_tmp6_, (gssize) -1);
		_tmp8_ = _tmp7_;
		_tmp9_ = g_strconcat ("<b>", _tmp8_, NULL);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strconcat (_tmp10_, "</b>", NULL);
		_tmp12_ = _tmp11_;
		_tmp13_ = string_replace (_ ("$NAME on $ALBUM"), "$ALBUM", _tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = music_media_get_display_title (self);
		_tmp16_ = _tmp15_;
		_tmp17_ = g_markup_escape_text (_tmp16_, (gssize) -1);
		_tmp18_ = _tmp17_;
		_tmp19_ = g_strconcat ("<b>", _tmp18_, NULL);
		_tmp20_ = _tmp19_;
		_tmp21_ = g_strconcat (_tmp20_, "</b>", NULL);
		_tmp22_ = _tmp21_;
		_tmp23_ = string_replace (_tmp14_, "$NAME", _tmp22_);
		_tmp24_ = _tmp23_;
		_g_free0 (_tmp22_);
		_g_free0 (_tmp20_);
		_g_free0 (_tmp18_);
		_g_free0 (_tmp16_);
		_g_free0 (_tmp14_);
		_g_free0 (_tmp12_);
		_g_free0 (_tmp10_);
		_g_free0 (_tmp8_);
		result = _tmp24_;
		return result;
	} else {
		gboolean _tmp25_ = FALSE;
		if (is_valid_artist) {
			_tmp25_ = !is_valid_album;
		} else {
			_tmp25_ = FALSE;
		}
		if (_tmp25_) {
			const gchar* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			_tmp26_ = music_media_get_artist (self);
			_tmp27_ = _tmp26_;
			_tmp28_ = g_markup_escape_text (_tmp27_, (gssize) -1);
			_tmp29_ = _tmp28_;
			_tmp30_ = g_strconcat ("<b>", _tmp29_, NULL);
			_tmp31_ = _tmp30_;
			_tmp32_ = g_strconcat (_tmp31_, "</b>", NULL);
			_tmp33_ = _tmp32_;
			_tmp34_ = string_replace (_ ("$NAME by $ARTIST"), "$ARTIST", _tmp33_);
			_tmp35_ = _tmp34_;
			_tmp36_ = music_media_get_display_title (self);
			_tmp37_ = _tmp36_;
			_tmp38_ = g_markup_escape_text (_tmp37_, (gssize) -1);
			_tmp39_ = _tmp38_;
			_tmp40_ = g_strconcat ("<b>", _tmp39_, NULL);
			_tmp41_ = _tmp40_;
			_tmp42_ = g_strconcat (_tmp41_, "</b>", NULL);
			_tmp43_ = _tmp42_;
			_tmp44_ = string_replace (_tmp35_, "$NAME", _tmp43_);
			_tmp45_ = _tmp44_;
			_g_free0 (_tmp43_);
			_g_free0 (_tmp41_);
			_g_free0 (_tmp39_);
			_g_free0 (_tmp37_);
			_g_free0 (_tmp35_);
			_g_free0 (_tmp33_);
			_g_free0 (_tmp31_);
			_g_free0 (_tmp29_);
			result = _tmp45_;
			return result;
		} else {
			gboolean _tmp46_ = FALSE;
			if (!is_valid_artist) {
				_tmp46_ = !is_valid_album;
			} else {
				_tmp46_ = FALSE;
			}
			if (_tmp46_) {
				gchar* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
				gchar* _tmp50_;
				gchar* _tmp51_;
				gchar* _tmp52_;
				gchar* _tmp53_;
				gchar* _tmp54_;
				_tmp47_ = music_media_get_display_title (self);
				_tmp48_ = _tmp47_;
				_tmp49_ = g_markup_escape_text (_tmp48_, (gssize) -1);
				_tmp50_ = _tmp49_;
				_tmp51_ = g_strconcat ("<b>", _tmp50_, NULL);
				_tmp52_ = _tmp51_;
				_tmp53_ = g_strconcat (_tmp52_, "</b>", NULL);
				_tmp54_ = _tmp53_;
				_g_free0 (_tmp52_);
				_g_free0 (_tmp50_);
				_g_free0 (_tmp48_);
				result = _tmp54_;
				return result;
			} else {
				const gchar* _tmp55_;
				const gchar* _tmp56_;
				gchar* _tmp57_;
				gchar* _tmp58_;
				gchar* _tmp59_;
				gchar* _tmp60_;
				gchar* _tmp61_;
				gchar* _tmp62_;
				gchar* _tmp63_;
				gchar* _tmp64_;
				gchar* _tmp65_;
				gchar* _tmp66_;
				gchar* _tmp67_;
				gchar* _tmp68_;
				gchar* _tmp69_;
				gchar* _tmp70_;
				gchar* _tmp71_;
				gchar* _tmp72_;
				gchar* _tmp73_;
				gchar* _tmp74_;
				const gchar* _tmp75_;
				const gchar* _tmp76_;
				gchar* _tmp77_;
				gchar* _tmp78_;
				gchar* _tmp79_;
				gchar* _tmp80_;
				gchar* _tmp81_;
				gchar* _tmp82_;
				gchar* _tmp83_;
				gchar* _tmp84_;
				_tmp55_ = music_media_get_artist (self);
				_tmp56_ = _tmp55_;
				_tmp57_ = g_markup_escape_text (_tmp56_, (gssize) -1);
				_tmp58_ = _tmp57_;
				_tmp59_ = g_strconcat ("<b>", _tmp58_, NULL);
				_tmp60_ = _tmp59_;
				_tmp61_ = g_strconcat (_tmp60_, "</b>", NULL);
				_tmp62_ = _tmp61_;
				_tmp63_ = string_replace (_ ("$NAME by $ARTIST on $ALBUM"), "$ARTIST", _tmp62_);
				_tmp64_ = _tmp63_;
				_tmp65_ = music_media_get_display_title (self);
				_tmp66_ = _tmp65_;
				_tmp67_ = g_markup_escape_text (_tmp66_, (gssize) -1);
				_tmp68_ = _tmp67_;
				_tmp69_ = g_strconcat ("<b>", _tmp68_, NULL);
				_tmp70_ = _tmp69_;
				_tmp71_ = g_strconcat (_tmp70_, "</b>", NULL);
				_tmp72_ = _tmp71_;
				_tmp73_ = string_replace (_tmp64_, "$NAME", _tmp72_);
				_tmp74_ = _tmp73_;
				_tmp75_ = music_media_get_album (self);
				_tmp76_ = _tmp75_;
				_tmp77_ = g_markup_escape_text (_tmp76_, (gssize) -1);
				_tmp78_ = _tmp77_;
				_tmp79_ = g_strconcat ("<b>", _tmp78_, NULL);
				_tmp80_ = _tmp79_;
				_tmp81_ = g_strconcat (_tmp80_, "</b>", NULL);
				_tmp82_ = _tmp81_;
				_tmp83_ = string_replace (_tmp74_, "$ALBUM", _tmp82_);
				_tmp84_ = _tmp83_;
				_g_free0 (_tmp82_);
				_g_free0 (_tmp80_);
				_g_free0 (_tmp78_);
				_g_free0 (_tmp74_);
				_g_free0 (_tmp72_);
				_g_free0 (_tmp70_);
				_g_free0 (_tmp68_);
				_g_free0 (_tmp66_);
				_g_free0 (_tmp64_);
				_g_free0 (_tmp62_);
				_g_free0 (_tmp60_);
				_g_free0 (_tmp58_);
				result = _tmp84_;
				return result;
			}
		}
	}
}

MusicMedia*
music_media_construct (GType object_type,
                       const gchar* uri)
{
	MusicMedia * self = NULL;
	g_return_val_if_fail (uri != NULL, NULL);
	self = (MusicMedia*) g_object_new (object_type, NULL);
	music_media_set_uri (self, uri);
	return self;
}

MusicMedia*
music_media_new (const gchar* uri)
{
	return music_media_construct (MUSIC_TYPE_MEDIA, uri);
}

MusicMedia*
music_media_construct_from_file (GType object_type,
                                 GFile* file)
{
	MusicMedia * self = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	self = (MusicMedia*) g_object_new (object_type, NULL);
	music_media_set_file (self, file);
	return self;
}

MusicMedia*
music_media_new_from_file (GFile* file)
{
	return music_media_construct_from_file (MUSIC_TYPE_MEDIA, file);
}

MusicMedia*
music_media_copy (MusicMedia* self)
{
	MusicMedia* rv = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	MusicMedia* _tmp3_;
	MusicMedia* _tmp4_;
	guint64 _tmp5_;
	guint64 _tmp6_;
	guint _tmp7_;
	guint _tmp8_;
	guint _tmp9_;
	guint _tmp10_;
	guint _tmp11_;
	guint _tmp12_;
	guint _tmp13_;
	guint _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	guint _tmp31_;
	guint _tmp32_;
	guint _tmp33_;
	guint _tmp34_;
	guint _tmp35_;
	guint _tmp36_;
	guint _tmp37_;
	guint _tmp38_;
	guint _tmp39_;
	guint _tmp40_;
	guint _tmp41_;
	guint _tmp42_;
	guint _tmp43_;
	guint _tmp44_;
	guint _tmp45_;
	guint _tmp46_;
	guint _tmp47_;
	guint _tmp48_;
	guint _tmp49_;
	guint _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	gboolean _tmp53_;
	gboolean _tmp54_;
	gboolean _tmp55_;
	gboolean _tmp56_;
	guint _tmp57_;
	guint _tmp58_;
	gboolean _tmp59_;
	gboolean _tmp60_;
	gboolean _tmp61_;
	gboolean _tmp62_;
	GIcon* _tmp63_;
	GIcon* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
	MusicMedia* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_media_get_uri (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	_tmp3_ = music_media_new (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	rv = _tmp4_;
	_tmp5_ = music_media_get_file_size (self);
	_tmp6_ = _tmp5_;
	music_media_set_file_size (rv, _tmp6_);
	_tmp7_ = music_media_get_track (self);
	_tmp8_ = _tmp7_;
	music_media_set_track (rv, _tmp8_);
	_tmp9_ = music_media_get_track_count (self);
	_tmp10_ = _tmp9_;
	music_media_set_track_count (rv, _tmp10_);
	_tmp11_ = music_media_get_album_number (self);
	_tmp12_ = _tmp11_;
	music_media_set_album_number (rv, _tmp12_);
	_tmp13_ = music_media_get_album_count (self);
	_tmp14_ = _tmp13_;
	music_media_set_album_count (rv, _tmp14_);
	_tmp15_ = music_media_get_title (self);
	_tmp16_ = _tmp15_;
	music_media_set_title (rv, _tmp16_);
	_tmp17_ = music_media_get_artist (self);
	_tmp18_ = _tmp17_;
	music_media_set_artist (rv, _tmp18_);
	_tmp19_ = music_media_get_composer (self);
	_tmp20_ = _tmp19_;
	music_media_set_composer (rv, _tmp20_);
	_tmp21_ = music_media_get_album_artist (self);
	_tmp22_ = _tmp21_;
	music_media_set_album_artist (rv, _tmp22_);
	_tmp23_ = music_media_get_album (self);
	_tmp24_ = _tmp23_;
	music_media_set_album (rv, _tmp24_);
	_tmp25_ = music_media_get_genre (self);
	_tmp26_ = _tmp25_;
	music_media_set_genre (rv, _tmp26_);
	_tmp27_ = music_media_get_grouping (self);
	_tmp28_ = _tmp27_;
	music_media_set_grouping (rv, _tmp28_);
	_tmp29_ = music_media_get_comment (self);
	_tmp30_ = _tmp29_;
	music_media_set_comment (rv, _tmp30_);
	_tmp31_ = music_media_get_year (self);
	_tmp32_ = _tmp31_;
	music_media_set_year (rv, _tmp32_);
	_tmp33_ = music_media_get_bitrate (self);
	_tmp34_ = _tmp33_;
	music_media_set_bitrate (rv, _tmp34_);
	_tmp35_ = music_media_get_length (self);
	_tmp36_ = _tmp35_;
	music_media_set_length (rv, _tmp36_);
	_tmp37_ = music_media_get_samplerate (self);
	_tmp38_ = _tmp37_;
	music_media_set_samplerate (rv, _tmp38_);
	_tmp39_ = music_media_get_bpm (self);
	_tmp40_ = _tmp39_;
	music_media_set_bpm (rv, _tmp40_);
	_tmp41_ = music_media_get_rating (self);
	_tmp42_ = _tmp41_;
	music_media_set_rating (rv, _tmp42_);
	_tmp43_ = music_media_get_play_count (self);
	_tmp44_ = _tmp43_;
	music_media_set_play_count (rv, _tmp44_);
	_tmp45_ = music_media_get_skip_count (self);
	_tmp46_ = _tmp45_;
	music_media_set_skip_count (rv, _tmp46_);
	_tmp47_ = music_media_get_date_added (self);
	_tmp48_ = _tmp47_;
	music_media_set_date_added (rv, _tmp48_);
	_tmp49_ = music_media_get_last_played (self);
	_tmp50_ = _tmp49_;
	music_media_set_last_played (rv, _tmp50_);
	_tmp51_ = music_media_get_lyrics (self);
	_tmp52_ = _tmp51_;
	music_media_set_lyrics (rv, _tmp52_);
	_tmp53_ = music_media_get_is_preview (self);
	_tmp54_ = _tmp53_;
	music_media_set_is_preview (rv, _tmp54_);
	_tmp55_ = music_media_get_is_temporary (self);
	_tmp56_ = _tmp55_;
	music_media_set_is_temporary (rv, _tmp56_);
	_tmp57_ = music_media_get_last_modified (self);
	_tmp58_ = _tmp57_;
	music_media_set_last_modified (rv, _tmp58_);
	_tmp59_ = music_media_get_show (self);
	_tmp60_ = _tmp59_;
	music_media_set_show (rv, _tmp60_);
	_tmp61_ = music_media_get_show_indicator (self);
	_tmp62_ = _tmp61_;
	music_media_set_show_indicator (rv, _tmp62_);
	_tmp63_ = music_media_get_unique_status_image (self);
	_tmp64_ = _tmp63_;
	music_media_set_unique_status_image (rv, _tmp64_);
	_tmp65_ = music_media_get_location_unknown (self);
	_tmp66_ = _tmp65_;
	music_media_set_location_unknown (rv, _tmp66_);
	result = rv;
	return result;
}

gint64
music_media_get_rowid (MusicMedia* self)
{
	gint64 result;
	g_return_val_if_fail (self != NULL, 0LL);
	result = self->priv->_rowid;
	return result;
}

void
music_media_set_rowid (MusicMedia* self,
                       gint64 value)
{
	gint64 old_value;
	g_return_if_fail (self != NULL);
	old_value = music_media_get_rowid (self);
	if (old_value != value) {
		self->priv->_rowid = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_ROWID_PROPERTY]);
	}
}

gchar*
music_media_get_uri (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_uri) {
		return _klass_->get_uri (self);
	}
	return NULL;
}

static gchar*
music_media_real_get_uri (MusicMedia* base)
{
	gchar* result;
	MusicMedia* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	self = base;
	_tmp0_ = music_media_get_file (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_file_get_uri (_tmp1_);
	result = _tmp2_;
	return result;
}

void
music_media_set_uri (MusicMedia* self,
                     const gchar* value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_uri) {
		_klass_->set_uri (self, value);
	}
}

static void
music_media_real_set_uri (MusicMedia* base,
                          const gchar* value)
{
	MusicMedia* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	self = base;
	_tmp0_ = g_file_new_for_uri (value);
	_tmp1_ = _tmp0_;
	music_media_set_file (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
	g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_URI_PROPERTY]);
}

guint64
music_media_get_file_size (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0ULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_file_size) {
		return _klass_->get_file_size (self);
	}
	return 0ULL;
}

static guint64
music_media_real_get_file_size (MusicMedia* base)
{
	guint64 result;
	MusicMedia* self;
	self = base;
	result = self->priv->_file_size;
	return result;
}

void
music_media_set_file_size (MusicMedia* self,
                           guint64 value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_file_size) {
		_klass_->set_file_size (self, value);
	}
}

static void
music_media_real_set_file_size (MusicMedia* base,
                                guint64 value)
{
	MusicMedia* self;
	guint64 old_value;
	self = base;
	old_value = music_media_real_get_file_size (base);
	if (old_value != value) {
		self->priv->_file_size = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_FILE_SIZE_PROPERTY]);
	}
}

gboolean
music_media_get_file_exists (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_file_exists) {
		return _klass_->get_file_exists (self);
	}
	return FALSE;
}

static gboolean
music_media_real_get_file_exists (MusicMedia* base)
{
	gboolean result;
	MusicMedia* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	self = base;
	_tmp0_ = music_media_get_file (self);
	_tmp1_ = _tmp0_;
	result = g_file_query_exists (_tmp1_, NULL);
	return result;
}

GFile*
music_media_get_file (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_file) {
		return _klass_->get_file (self);
	}
	return NULL;
}

static GFile*
music_media_real_get_file (MusicMedia* base)
{
	GFile* result;
	MusicMedia* self;
	GFile* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_file;
	result = _tmp0_;
	return result;
}

void
music_media_set_file (MusicMedia* self,
                      GFile* value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_file) {
		_klass_->set_file (self, value);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
music_media_real_set_file (MusicMedia* base,
                           GFile* value)
{
	MusicMedia* self;
	GFile* old_value;
	self = base;
	old_value = music_media_real_get_file (base);
	if (old_value != value) {
		GFile* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_file);
		self->priv->_file = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_FILE_PROPERTY]);
	}
}

gboolean
music_media_get_is_preview (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_is_preview) {
		return _klass_->get_is_preview (self);
	}
	return FALSE;
}

static gboolean
music_media_real_get_is_preview (MusicMedia* base)
{
	gboolean result;
	MusicMedia* self;
	self = base;
	result = self->priv->_is_preview;
	return result;
}

void
music_media_set_is_preview (MusicMedia* self,
                            gboolean value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_is_preview) {
		_klass_->set_is_preview (self, value);
	}
}

static void
music_media_real_set_is_preview (MusicMedia* base,
                                 gboolean value)
{
	MusicMedia* self;
	gboolean old_value;
	self = base;
	old_value = music_media_real_get_is_preview (base);
	if (old_value != value) {
		self->priv->_is_preview = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_IS_PREVIEW_PROPERTY]);
	}
}

gboolean
music_media_get_is_temporary (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_is_temporary) {
		return _klass_->get_is_temporary (self);
	}
	return FALSE;
}

static gboolean
music_media_real_get_is_temporary (MusicMedia* base)
{
	gboolean result;
	MusicMedia* self;
	self = base;
	result = self->priv->_is_temporary;
	return result;
}

void
music_media_set_is_temporary (MusicMedia* self,
                              gboolean value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_is_temporary) {
		_klass_->set_is_temporary (self, value);
	}
}

static void
music_media_real_set_is_temporary (MusicMedia* base,
                                   gboolean value)
{
	MusicMedia* self;
	gboolean old_value;
	self = base;
	old_value = music_media_real_get_is_temporary (base);
	if (old_value != value) {
		self->priv->_is_temporary = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_IS_TEMPORARY_PROPERTY]);
	}
}

gboolean
music_media_get_location_unknown (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_location_unknown) {
		return _klass_->get_location_unknown (self);
	}
	return FALSE;
}

static gboolean
music_media_real_get_location_unknown (MusicMedia* base)
{
	gboolean result;
	MusicMedia* self;
	self = base;
	result = self->priv->_location_unknown;
	return result;
}

void
music_media_set_location_unknown (MusicMedia* self,
                                  gboolean value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_location_unknown) {
		_klass_->set_location_unknown (self, value);
	}
}

static void
music_media_real_set_location_unknown (MusicMedia* base,
                                       gboolean value)
{
	MusicMedia* self;
	gboolean old_value;
	self = base;
	old_value = music_media_real_get_location_unknown (base);
	if (old_value != value) {
		self->priv->_location_unknown = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_LOCATION_UNKNOWN_PROPERTY]);
	}
}

gboolean
music_media_get_has_embedded (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_has_embedded) {
		return _klass_->get_has_embedded (self);
	}
	return FALSE;
}

static gboolean
music_media_real_get_has_embedded (MusicMedia* base)
{
	gboolean result;
	MusicMedia* self;
	self = base;
	result = self->priv->_has_embedded;
	return result;
}

void
music_media_set_has_embedded (MusicMedia* self,
                              gboolean value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_has_embedded) {
		_klass_->set_has_embedded (self, value);
	}
}

static void
music_media_real_set_has_embedded (MusicMedia* base,
                                   gboolean value)
{
	MusicMedia* self;
	gboolean old_value;
	self = base;
	old_value = music_media_real_get_has_embedded (base);
	if (old_value != value) {
		self->priv->_has_embedded = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_HAS_EMBEDDED_PROPERTY]);
	}
}

GIcon*
music_media_get_unique_status_image (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_unique_status_image) {
		return _klass_->get_unique_status_image (self);
	}
	return NULL;
}

static GIcon*
music_media_real_get_unique_status_image (MusicMedia* base)
{
	GIcon* result;
	MusicMedia* self;
	GIcon* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_unique_status_image;
	result = _tmp0_;
	return result;
}

void
music_media_set_unique_status_image (MusicMedia* self,
                                     GIcon* value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_unique_status_image) {
		_klass_->set_unique_status_image (self, value);
	}
}

static void
music_media_real_set_unique_status_image (MusicMedia* base,
                                          GIcon* value)
{
	MusicMedia* self;
	GIcon* old_value;
	self = base;
	old_value = music_media_real_get_unique_status_image (base);
	if (old_value != value) {
		GIcon* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_unique_status_image);
		self->priv->_unique_status_image = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY]);
	}
}

gboolean
music_media_get_show_indicator (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_show_indicator) {
		return _klass_->get_show_indicator (self);
	}
	return FALSE;
}

static gboolean
music_media_real_get_show_indicator (MusicMedia* base)
{
	gboolean result;
	MusicMedia* self;
	self = base;
	result = self->priv->_show_indicator;
	return result;
}

void
music_media_set_show_indicator (MusicMedia* self,
                                gboolean value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_show_indicator) {
		_klass_->set_show_indicator (self, value);
	}
}

static void
music_media_real_set_show_indicator (MusicMedia* base,
                                     gboolean value)
{
	MusicMedia* self;
	gboolean old_value;
	self = base;
	old_value = music_media_real_get_show_indicator (base);
	if (old_value != value) {
		self->priv->_show_indicator = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_SHOW_INDICATOR_PROPERTY]);
	}
}

const gchar*
music_media_get_title (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_title) {
		return _klass_->get_title (self);
	}
	return NULL;
}

static const gchar*
music_media_real_get_title (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_title;
	result = _tmp0_;
	return result;
}

void
music_media_set_title (MusicMedia* self,
                       const gchar* value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_title) {
		_klass_->set_title (self, value);
	}
}

static void
music_media_real_set_title (MusicMedia* base,
                            const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
	self = base;
	old_value = music_media_real_get_title (base);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_title);
		self->priv->_title = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_TITLE_PROPERTY]);
	}
}

guint
music_media_get_track (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_track) {
		return _klass_->get_track (self);
	}
	return 0U;
}

static guint
music_media_real_get_track (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
	self = base;
	result = self->priv->_track;
	return result;
}

void
music_media_set_track (MusicMedia* self,
                       guint value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_track) {
		_klass_->set_track (self, value);
	}
}

static void
music_media_real_set_track (MusicMedia* base,
                            guint value)
{
	MusicMedia* self;
	guint old_value;
	self = base;
	old_value = music_media_real_get_track (base);
	if (old_value != value) {
		self->priv->_track = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_TRACK_PROPERTY]);
	}
}

guint
music_media_get_track_count (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_track_count) {
		return _klass_->get_track_count (self);
	}
	return 0U;
}

static guint
music_media_real_get_track_count (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
	self = base;
	result = self->priv->_track_count;
	return result;
}

void
music_media_set_track_count (MusicMedia* self,
                             guint value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_track_count) {
		_klass_->set_track_count (self, value);
	}
}

static void
music_media_real_set_track_count (MusicMedia* base,
                                  guint value)
{
	MusicMedia* self;
	guint old_value;
	self = base;
	old_value = music_media_real_get_track_count (base);
	if (old_value != value) {
		self->priv->_track_count = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_TRACK_COUNT_PROPERTY]);
	}
}

const gchar*
music_media_get_composer (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_composer) {
		return _klass_->get_composer (self);
	}
	return NULL;
}

static const gchar*
music_media_real_get_composer (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_composer;
	result = _tmp0_;
	return result;
}

void
music_media_set_composer (MusicMedia* self,
                          const gchar* value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_composer) {
		_klass_->set_composer (self, value);
	}
}

static void
music_media_real_set_composer (MusicMedia* base,
                               const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
	self = base;
	old_value = music_media_real_get_composer (base);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_composer);
		self->priv->_composer = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_COMPOSER_PROPERTY]);
	}
}

const gchar*
music_media_get_artist (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_artist) {
		return _klass_->get_artist (self);
	}
	return NULL;
}

static const gchar*
music_media_real_get_artist (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_artist;
	result = _tmp0_;
	return result;
}

void
music_media_set_artist (MusicMedia* self,
                        const gchar* value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_artist) {
		_klass_->set_artist (self, value);
	}
}

static void
music_media_real_set_artist (MusicMedia* base,
                             const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
	self = base;
	old_value = music_media_real_get_artist (base);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_artist);
		self->priv->_artist = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_ARTIST_PROPERTY]);
	}
}

const gchar*
music_media_get_album_artist (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_album_artist) {
		return _klass_->get_album_artist (self);
	}
	return NULL;
}

static const gchar*
music_media_real_get_album_artist (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_album_artist;
	result = _tmp0_;
	return result;
}

void
music_media_set_album_artist (MusicMedia* self,
                              const gchar* value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_album_artist) {
		_klass_->set_album_artist (self, value);
	}
}

static void
music_media_real_set_album_artist (MusicMedia* base,
                                   const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
	self = base;
	old_value = music_media_real_get_album_artist (base);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_album_artist);
		self->priv->_album_artist = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_ALBUM_ARTIST_PROPERTY]);
	}
}

const gchar*
music_media_get_album (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_album) {
		return _klass_->get_album (self);
	}
	return NULL;
}

static const gchar*
music_media_real_get_album (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_album;
	result = _tmp0_;
	return result;
}

void
music_media_set_album (MusicMedia* self,
                       const gchar* value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_album) {
		_klass_->set_album (self, value);
	}
}

static void
music_media_real_set_album (MusicMedia* base,
                            const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
	self = base;
	old_value = music_media_real_get_album (base);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_album);
		self->priv->_album = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_ALBUM_PROPERTY]);
	}
}

guint
music_media_get_album_number (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_album_number) {
		return _klass_->get_album_number (self);
	}
	return 0U;
}

static guint
music_media_real_get_album_number (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
	self = base;
	result = self->priv->_album_number;
	return result;
}

void
music_media_set_album_number (MusicMedia* self,
                              guint value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_album_number) {
		_klass_->set_album_number (self, value);
	}
}

static void
music_media_real_set_album_number (MusicMedia* base,
                                   guint value)
{
	MusicMedia* self;
	guint old_value;
	self = base;
	old_value = music_media_real_get_album_number (base);
	if (old_value != value) {
		self->priv->_album_number = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_ALBUM_NUMBER_PROPERTY]);
	}
}

guint
music_media_get_album_count (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_album_count) {
		return _klass_->get_album_count (self);
	}
	return 0U;
}

static guint
music_media_real_get_album_count (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
	self = base;
	result = self->priv->_album_count;
	return result;
}

void
music_media_set_album_count (MusicMedia* self,
                             guint value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_album_count) {
		_klass_->set_album_count (self, value);
	}
}

static void
music_media_real_set_album_count (MusicMedia* base,
                                  guint value)
{
	MusicMedia* self;
	guint old_value;
	self = base;
	old_value = music_media_real_get_album_count (base);
	if (old_value != value) {
		self->priv->_album_count = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_ALBUM_COUNT_PROPERTY]);
	}
}

MusicAlbum*
music_media_get_album_info (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_album_info) {
		return _klass_->get_album_info (self);
	}
	return NULL;
}

static MusicAlbum*
music_media_real_get_album_info (MusicMedia* base)
{
	MusicAlbum* result;
	MusicMedia* self;
	MusicAlbum* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_album_info;
	result = _tmp0_;
	return result;
}

void
music_media_set_album_info (MusicMedia* self,
                            MusicAlbum* value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_album_info) {
		_klass_->set_album_info (self, value);
	}
}

static void
music_media_real_set_album_info (MusicMedia* base,
                                 MusicAlbum* value)
{
	MusicMedia* self;
	MusicAlbum* old_value;
	self = base;
	old_value = music_media_real_get_album_info (base);
	if (old_value != value) {
		self->priv->_album_info = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_ALBUM_INFO_PROPERTY]);
	}
}

const gchar*
music_media_get_grouping (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_grouping) {
		return _klass_->get_grouping (self);
	}
	return NULL;
}

static const gchar*
music_media_real_get_grouping (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_grouping;
	result = _tmp0_;
	return result;
}

void
music_media_set_grouping (MusicMedia* self,
                          const gchar* value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_grouping) {
		_klass_->set_grouping (self, value);
	}
}

static void
music_media_real_set_grouping (MusicMedia* base,
                               const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
	self = base;
	old_value = music_media_real_get_grouping (base);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_grouping);
		self->priv->_grouping = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_GROUPING_PROPERTY]);
	}
}

const gchar*
music_media_get_genre (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_genre) {
		return _klass_->get_genre (self);
	}
	return NULL;
}

static const gchar*
music_media_real_get_genre (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_genre;
	result = _tmp0_;
	return result;
}

void
music_media_set_genre (MusicMedia* self,
                       const gchar* value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_genre) {
		_klass_->set_genre (self, value);
	}
}

static void
music_media_real_set_genre (MusicMedia* base,
                            const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
	self = base;
	old_value = music_media_real_get_genre (base);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_genre);
		self->priv->_genre = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_GENRE_PROPERTY]);
	}
}

const gchar*
music_media_get_comment (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_comment) {
		return _klass_->get_comment (self);
	}
	return NULL;
}

static const gchar*
music_media_real_get_comment (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_comment;
	result = _tmp0_;
	return result;
}

void
music_media_set_comment (MusicMedia* self,
                         const gchar* value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_comment) {
		_klass_->set_comment (self, value);
	}
}

static void
music_media_real_set_comment (MusicMedia* base,
                              const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
	self = base;
	old_value = music_media_real_get_comment (base);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_comment);
		self->priv->_comment = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_COMMENT_PROPERTY]);
	}
}

const gchar*
music_media_get_lyrics (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_lyrics) {
		return _klass_->get_lyrics (self);
	}
	return NULL;
}

static const gchar*
music_media_real_get_lyrics (MusicMedia* base)
{
	const gchar* result;
	MusicMedia* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_lyrics;
	result = _tmp0_;
	return result;
}

void
music_media_set_lyrics (MusicMedia* self,
                        const gchar* value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_lyrics) {
		_klass_->set_lyrics (self, value);
	}
}

static void
music_media_real_set_lyrics (MusicMedia* base,
                             const gchar* value)
{
	MusicMedia* self;
	gchar* old_value;
	self = base;
	old_value = music_media_real_get_lyrics (base);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_lyrics);
		self->priv->_lyrics = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_LYRICS_PROPERTY]);
	}
}

guint
music_media_get_year (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_year) {
		return _klass_->get_year (self);
	}
	return 0U;
}

static guint
music_media_real_get_year (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
	self = base;
	result = self->priv->_year;
	return result;
}

void
music_media_set_year (MusicMedia* self,
                      guint value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_year) {
		_klass_->set_year (self, value);
	}
}

static void
music_media_real_set_year (MusicMedia* base,
                           guint value)
{
	MusicMedia* self;
	guint old_value;
	self = base;
	old_value = music_media_real_get_year (base);
	if (old_value != value) {
		self->priv->_year = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_YEAR_PROPERTY]);
	}
}

guint
music_media_get_bitrate (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_bitrate) {
		return _klass_->get_bitrate (self);
	}
	return 0U;
}

static guint
music_media_real_get_bitrate (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
	self = base;
	result = self->priv->_bitrate;
	return result;
}

void
music_media_set_bitrate (MusicMedia* self,
                         guint value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_bitrate) {
		_klass_->set_bitrate (self, value);
	}
}

static void
music_media_real_set_bitrate (MusicMedia* base,
                              guint value)
{
	MusicMedia* self;
	guint old_value;
	self = base;
	old_value = music_media_real_get_bitrate (base);
	if (old_value != value) {
		self->priv->_bitrate = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_BITRATE_PROPERTY]);
	}
}

guint
music_media_get_bpm (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_bpm) {
		return _klass_->get_bpm (self);
	}
	return 0U;
}

static guint
music_media_real_get_bpm (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
	self = base;
	result = self->priv->_bpm;
	return result;
}

void
music_media_set_bpm (MusicMedia* self,
                     guint value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_bpm) {
		_klass_->set_bpm (self, value);
	}
}

static void
music_media_real_set_bpm (MusicMedia* base,
                          guint value)
{
	MusicMedia* self;
	guint old_value;
	self = base;
	old_value = music_media_real_get_bpm (base);
	if (old_value != value) {
		self->priv->_bpm = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_BPM_PROPERTY]);
	}
}

guint
music_media_get_samplerate (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_samplerate) {
		return _klass_->get_samplerate (self);
	}
	return 0U;
}

static guint
music_media_real_get_samplerate (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
	self = base;
	result = self->priv->_samplerate;
	return result;
}

void
music_media_set_samplerate (MusicMedia* self,
                            guint value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_samplerate) {
		_klass_->set_samplerate (self, value);
	}
}

static void
music_media_real_set_samplerate (MusicMedia* base,
                                 guint value)
{
	MusicMedia* self;
	guint old_value;
	self = base;
	old_value = music_media_real_get_samplerate (base);
	if (old_value != value) {
		self->priv->_samplerate = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_SAMPLERATE_PROPERTY]);
	}
}

guint
music_media_get_length (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_length) {
		return _klass_->get_length (self);
	}
	return 0U;
}

static guint
music_media_real_get_length (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
	self = base;
	result = self->priv->_length;
	return result;
}

void
music_media_set_length (MusicMedia* self,
                        guint value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_length) {
		_klass_->set_length (self, value);
	}
}

static void
music_media_real_set_length (MusicMedia* base,
                             guint value)
{
	MusicMedia* self;
	guint old_value;
	self = base;
	old_value = music_media_real_get_length (base);
	if (old_value != value) {
		self->priv->_length = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_LENGTH_PROPERTY]);
	}
}

guint
music_media_get_rating (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_rating) {
		return _klass_->get_rating (self);
	}
	return 0U;
}

static guint
music_media_real_get_rating (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
	self = base;
	result = self->_rating;
	return result;
}

void
music_media_set_rating (MusicMedia* self,
                        guint value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_rating) {
		_klass_->set_rating (self, value);
	}
}

static void
music_media_real_set_rating (MusicMedia* base,
                             guint value)
{
	MusicMedia* self;
	self = base;
	self->_rating = CLAMP (value, (guint) 0, (guint) 5);
	g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_RATING_PROPERTY]);
}

guint
music_media_get_play_count (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_play_count) {
		return _klass_->get_play_count (self);
	}
	return 0U;
}

static guint
music_media_real_get_play_count (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
	self = base;
	result = self->priv->_play_count;
	return result;
}

void
music_media_set_play_count (MusicMedia* self,
                            guint value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_play_count) {
		_klass_->set_play_count (self, value);
	}
}

static void
music_media_real_set_play_count (MusicMedia* base,
                                 guint value)
{
	MusicMedia* self;
	guint old_value;
	self = base;
	old_value = music_media_real_get_play_count (base);
	if (old_value != value) {
		self->priv->_play_count = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_PLAY_COUNT_PROPERTY]);
	}
}

guint
music_media_get_skip_count (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_skip_count) {
		return _klass_->get_skip_count (self);
	}
	return 0U;
}

static guint
music_media_real_get_skip_count (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
	self = base;
	result = self->priv->_skip_count;
	return result;
}

void
music_media_set_skip_count (MusicMedia* self,
                            guint value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_skip_count) {
		_klass_->set_skip_count (self, value);
	}
}

static void
music_media_real_set_skip_count (MusicMedia* base,
                                 guint value)
{
	MusicMedia* self;
	guint old_value;
	self = base;
	old_value = music_media_real_get_skip_count (base);
	if (old_value != value) {
		self->priv->_skip_count = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_SKIP_COUNT_PROPERTY]);
	}
}

guint
music_media_get_date_added (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_date_added) {
		return _klass_->get_date_added (self);
	}
	return 0U;
}

static guint
music_media_real_get_date_added (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
	self = base;
	result = self->priv->_date_added;
	return result;
}

void
music_media_set_date_added (MusicMedia* self,
                            guint value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_date_added) {
		_klass_->set_date_added (self, value);
	}
}

static void
music_media_real_set_date_added (MusicMedia* base,
                                 guint value)
{
	MusicMedia* self;
	guint old_value;
	self = base;
	old_value = music_media_real_get_date_added (base);
	if (old_value != value) {
		self->priv->_date_added = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_DATE_ADDED_PROPERTY]);
	}
}

guint
music_media_get_last_played (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_last_played) {
		return _klass_->get_last_played (self);
	}
	return 0U;
}

static guint
music_media_real_get_last_played (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
	self = base;
	result = self->priv->_last_played;
	return result;
}

void
music_media_set_last_played (MusicMedia* self,
                             guint value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_last_played) {
		_klass_->set_last_played (self, value);
	}
}

static void
music_media_real_set_last_played (MusicMedia* base,
                                  guint value)
{
	MusicMedia* self;
	guint old_value;
	self = base;
	old_value = music_media_real_get_last_played (base);
	if (old_value != value) {
		self->priv->_last_played = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_LAST_PLAYED_PROPERTY]);
	}
}

guint
music_media_get_last_modified (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_last_modified) {
		return _klass_->get_last_modified (self);
	}
	return 0U;
}

static guint
music_media_real_get_last_modified (MusicMedia* base)
{
	guint result;
	MusicMedia* self;
	self = base;
	result = self->priv->_last_modified;
	return result;
}

void
music_media_set_last_modified (MusicMedia* self,
                               guint value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_last_modified) {
		_klass_->set_last_modified (self, value);
	}
}

static void
music_media_real_set_last_modified (MusicMedia* base,
                                    guint value)
{
	MusicMedia* self;
	guint old_value;
	self = base;
	old_value = music_media_real_get_last_modified (base);
	if (old_value != value) {
		self->priv->_last_modified = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_LAST_MODIFIED_PROPERTY]);
	}
}

gint
music_media_get_resume_pos (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, 0);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_resume_pos) {
		return _klass_->get_resume_pos (self);
	}
	return -1;
}

static gint
music_media_real_get_resume_pos (MusicMedia* base)
{
	gint result;
	MusicMedia* self;
	self = base;
	result = self->priv->_resume_pos;
	return result;
}

void
music_media_set_resume_pos (MusicMedia* self,
                            gint value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_resume_pos) {
		_klass_->set_resume_pos (self, value);
	}
}

static void
music_media_real_set_resume_pos (MusicMedia* base,
                                 gint value)
{
	MusicMedia* self;
	gint old_value;
	self = base;
	old_value = music_media_real_get_resume_pos (base);
	if (old_value != value) {
		self->priv->_resume_pos = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_RESUME_POS_PROPERTY]);
	}
}

gboolean
music_media_get_show (MusicMedia* self)
{
	MusicMediaClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->get_show) {
		return _klass_->get_show (self);
	}
	return FALSE;
}

static gboolean
music_media_real_get_show (MusicMedia* base)
{
	gboolean result;
	MusicMedia* self;
	self = base;
	result = self->priv->_show;
	return result;
}

void
music_media_set_show (MusicMedia* self,
                      gboolean value)
{
	MusicMediaClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_MEDIA_GET_CLASS (self);
	if (_klass_->set_show) {
		_klass_->set_show (self, value);
	}
}

static void
music_media_real_set_show (MusicMedia* base,
                           gboolean value)
{
	MusicMedia* self;
	gboolean old_value;
	self = base;
	old_value = music_media_real_get_show (base);
	if (old_value != value) {
		self->priv->_show = value;
		g_object_notify_by_pspec ((GObject *) self, music_media_properties[MUSIC_MEDIA_SHOW_PROPERTY]);
	}
}

static void
music_media_class_init (MusicMediaClass * klass,
                        gpointer klass_data)
{
	gchar* _tmp0_;
	music_media_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicMedia_private_offset);
	MUSIC_MEDIA_CLASS (klass)->get_uri = music_media_real_get_uri;
	MUSIC_MEDIA_CLASS (klass)->set_uri = music_media_real_set_uri;
	MUSIC_MEDIA_CLASS (klass)->get_file_size = music_media_real_get_file_size;
	MUSIC_MEDIA_CLASS (klass)->set_file_size = music_media_real_set_file_size;
	MUSIC_MEDIA_CLASS (klass)->get_file_exists = music_media_real_get_file_exists;
	MUSIC_MEDIA_CLASS (klass)->get_file = music_media_real_get_file;
	MUSIC_MEDIA_CLASS (klass)->set_file = music_media_real_set_file;
	MUSIC_MEDIA_CLASS (klass)->get_is_preview = music_media_real_get_is_preview;
	MUSIC_MEDIA_CLASS (klass)->set_is_preview = music_media_real_set_is_preview;
	MUSIC_MEDIA_CLASS (klass)->get_is_temporary = music_media_real_get_is_temporary;
	MUSIC_MEDIA_CLASS (klass)->set_is_temporary = music_media_real_set_is_temporary;
	MUSIC_MEDIA_CLASS (klass)->get_location_unknown = music_media_real_get_location_unknown;
	MUSIC_MEDIA_CLASS (klass)->set_location_unknown = music_media_real_set_location_unknown;
	MUSIC_MEDIA_CLASS (klass)->get_has_embedded = music_media_real_get_has_embedded;
	MUSIC_MEDIA_CLASS (klass)->set_has_embedded = music_media_real_set_has_embedded;
	MUSIC_MEDIA_CLASS (klass)->get_unique_status_image = music_media_real_get_unique_status_image;
	MUSIC_MEDIA_CLASS (klass)->set_unique_status_image = music_media_real_set_unique_status_image;
	MUSIC_MEDIA_CLASS (klass)->get_show_indicator = music_media_real_get_show_indicator;
	MUSIC_MEDIA_CLASS (klass)->set_show_indicator = music_media_real_set_show_indicator;
	MUSIC_MEDIA_CLASS (klass)->get_title = music_media_real_get_title;
	MUSIC_MEDIA_CLASS (klass)->set_title = music_media_real_set_title;
	MUSIC_MEDIA_CLASS (klass)->get_track = music_media_real_get_track;
	MUSIC_MEDIA_CLASS (klass)->set_track = music_media_real_set_track;
	MUSIC_MEDIA_CLASS (klass)->get_track_count = music_media_real_get_track_count;
	MUSIC_MEDIA_CLASS (klass)->set_track_count = music_media_real_set_track_count;
	MUSIC_MEDIA_CLASS (klass)->get_composer = music_media_real_get_composer;
	MUSIC_MEDIA_CLASS (klass)->set_composer = music_media_real_set_composer;
	MUSIC_MEDIA_CLASS (klass)->get_artist = music_media_real_get_artist;
	MUSIC_MEDIA_CLASS (klass)->set_artist = music_media_real_set_artist;
	MUSIC_MEDIA_CLASS (klass)->get_album_artist = music_media_real_get_album_artist;
	MUSIC_MEDIA_CLASS (klass)->set_album_artist = music_media_real_set_album_artist;
	MUSIC_MEDIA_CLASS (klass)->get_album = music_media_real_get_album;
	MUSIC_MEDIA_CLASS (klass)->set_album = music_media_real_set_album;
	MUSIC_MEDIA_CLASS (klass)->get_album_number = music_media_real_get_album_number;
	MUSIC_MEDIA_CLASS (klass)->set_album_number = music_media_real_set_album_number;
	MUSIC_MEDIA_CLASS (klass)->get_album_count = music_media_real_get_album_count;
	MUSIC_MEDIA_CLASS (klass)->set_album_count = music_media_real_set_album_count;
	MUSIC_MEDIA_CLASS (klass)->get_album_info = music_media_real_get_album_info;
	MUSIC_MEDIA_CLASS (klass)->set_album_info = music_media_real_set_album_info;
	MUSIC_MEDIA_CLASS (klass)->get_grouping = music_media_real_get_grouping;
	MUSIC_MEDIA_CLASS (klass)->set_grouping = music_media_real_set_grouping;
	MUSIC_MEDIA_CLASS (klass)->get_genre = music_media_real_get_genre;
	MUSIC_MEDIA_CLASS (klass)->set_genre = music_media_real_set_genre;
	MUSIC_MEDIA_CLASS (klass)->get_comment = music_media_real_get_comment;
	MUSIC_MEDIA_CLASS (klass)->set_comment = music_media_real_set_comment;
	MUSIC_MEDIA_CLASS (klass)->get_lyrics = music_media_real_get_lyrics;
	MUSIC_MEDIA_CLASS (klass)->set_lyrics = music_media_real_set_lyrics;
	MUSIC_MEDIA_CLASS (klass)->get_year = music_media_real_get_year;
	MUSIC_MEDIA_CLASS (klass)->set_year = music_media_real_set_year;
	MUSIC_MEDIA_CLASS (klass)->get_bitrate = music_media_real_get_bitrate;
	MUSIC_MEDIA_CLASS (klass)->set_bitrate = music_media_real_set_bitrate;
	MUSIC_MEDIA_CLASS (klass)->get_bpm = music_media_real_get_bpm;
	MUSIC_MEDIA_CLASS (klass)->set_bpm = music_media_real_set_bpm;
	MUSIC_MEDIA_CLASS (klass)->get_samplerate = music_media_real_get_samplerate;
	MUSIC_MEDIA_CLASS (klass)->set_samplerate = music_media_real_set_samplerate;
	MUSIC_MEDIA_CLASS (klass)->get_length = music_media_real_get_length;
	MUSIC_MEDIA_CLASS (klass)->set_length = music_media_real_set_length;
	MUSIC_MEDIA_CLASS (klass)->get_rating = music_media_real_get_rating;
	MUSIC_MEDIA_CLASS (klass)->set_rating = music_media_real_set_rating;
	MUSIC_MEDIA_CLASS (klass)->get_play_count = music_media_real_get_play_count;
	MUSIC_MEDIA_CLASS (klass)->set_play_count = music_media_real_set_play_count;
	MUSIC_MEDIA_CLASS (klass)->get_skip_count = music_media_real_get_skip_count;
	MUSIC_MEDIA_CLASS (klass)->set_skip_count = music_media_real_set_skip_count;
	MUSIC_MEDIA_CLASS (klass)->get_date_added = music_media_real_get_date_added;
	MUSIC_MEDIA_CLASS (klass)->set_date_added = music_media_real_set_date_added;
	MUSIC_MEDIA_CLASS (klass)->get_last_played = music_media_real_get_last_played;
	MUSIC_MEDIA_CLASS (klass)->set_last_played = music_media_real_set_last_played;
	MUSIC_MEDIA_CLASS (klass)->get_last_modified = music_media_real_get_last_modified;
	MUSIC_MEDIA_CLASS (klass)->set_last_modified = music_media_real_set_last_modified;
	MUSIC_MEDIA_CLASS (klass)->get_resume_pos = music_media_real_get_resume_pos;
	MUSIC_MEDIA_CLASS (klass)->set_resume_pos = music_media_real_set_resume_pos;
	MUSIC_MEDIA_CLASS (klass)->get_show = music_media_real_get_show;
	MUSIC_MEDIA_CLASS (klass)->set_show = music_media_real_set_show;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_media_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_media_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_media_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_ROWID_PROPERTY, music_media_properties[MUSIC_MEDIA_ROWID_PROPERTY] = g_param_spec_int64 ("rowid", "rowid", "rowid", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_URI_PROPERTY, music_media_properties[MUSIC_MEDIA_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_FILE_SIZE_PROPERTY, music_media_properties[MUSIC_MEDIA_FILE_SIZE_PROPERTY] = g_param_spec_uint64 ("file-size", "file-size", "file-size", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_FILE_EXISTS_PROPERTY, music_media_properties[MUSIC_MEDIA_FILE_EXISTS_PROPERTY] = g_param_spec_boolean ("file-exists", "file-exists", "file-exists", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_FILE_PROPERTY, music_media_properties[MUSIC_MEDIA_FILE_PROPERTY] = g_param_spec_object ("file", "file", "file", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_IS_PREVIEW_PROPERTY, music_media_properties[MUSIC_MEDIA_IS_PREVIEW_PROPERTY] = g_param_spec_boolean ("is-preview", "is-preview", "is-preview", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_IS_TEMPORARY_PROPERTY, music_media_properties[MUSIC_MEDIA_IS_TEMPORARY_PROPERTY] = g_param_spec_boolean ("is-temporary", "is-temporary", "is-temporary", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_LOCATION_UNKNOWN_PROPERTY, music_media_properties[MUSIC_MEDIA_LOCATION_UNKNOWN_PROPERTY] = g_param_spec_boolean ("location-unknown", "location-unknown", "location-unknown", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_HAS_EMBEDDED_PROPERTY, music_media_properties[MUSIC_MEDIA_HAS_EMBEDDED_PROPERTY] = g_param_spec_boolean ("has-embedded", "has-embedded", "has-embedded", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY, music_media_properties[MUSIC_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY] = g_param_spec_object ("unique-status-image", "unique-status-image", "unique-status-image", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_SHOW_INDICATOR_PROPERTY, music_media_properties[MUSIC_MEDIA_SHOW_INDICATOR_PROPERTY] = g_param_spec_boolean ("show-indicator", "show-indicator", "show-indicator", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Metadata Fields
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_TITLE_PROPERTY, music_media_properties[MUSIC_MEDIA_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_TRACK_PROPERTY, music_media_properties[MUSIC_MEDIA_TRACK_PROPERTY] = g_param_spec_uint ("track", "track", "track", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_TRACK_COUNT_PROPERTY, music_media_properties[MUSIC_MEDIA_TRACK_COUNT_PROPERTY] = g_param_spec_uint ("track-count", "track-count", "track-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_COMPOSER_PROPERTY, music_media_properties[MUSIC_MEDIA_COMPOSER_PROPERTY] = g_param_spec_string ("composer", "composer", "composer", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_ARTIST_PROPERTY, music_media_properties[MUSIC_MEDIA_ARTIST_PROPERTY] = g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_ALBUM_ARTIST_PROPERTY, music_media_properties[MUSIC_MEDIA_ALBUM_ARTIST_PROPERTY] = g_param_spec_string ("album-artist", "album-artist", "album-artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_ALBUM_PROPERTY, music_media_properties[MUSIC_MEDIA_ALBUM_PROPERTY] = g_param_spec_string ("album", "album", "album", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_ALBUM_NUMBER_PROPERTY, music_media_properties[MUSIC_MEDIA_ALBUM_NUMBER_PROPERTY] = g_param_spec_uint ("album-number", "album-number", "album-number", 0, G_MAXUINT, (guint) 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_ALBUM_COUNT_PROPERTY, music_media_properties[MUSIC_MEDIA_ALBUM_COUNT_PROPERTY] = g_param_spec_uint ("album-count", "album-count", "album-count", 0, G_MAXUINT, (guint) 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_ALBUM_INFO_PROPERTY, music_media_properties[MUSIC_MEDIA_ALBUM_INFO_PROPERTY] = g_param_spec_object ("album-info", "album-info", "album-info", MUSIC_TYPE_ALBUM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_GROUPING_PROPERTY, music_media_properties[MUSIC_MEDIA_GROUPING_PROPERTY] = g_param_spec_string ("grouping", "grouping", "grouping", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_GENRE_PROPERTY, music_media_properties[MUSIC_MEDIA_GENRE_PROPERTY] = g_param_spec_string ("genre", "genre", "genre", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_COMMENT_PROPERTY, music_media_properties[MUSIC_MEDIA_COMMENT_PROPERTY] = g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_LYRICS_PROPERTY, music_media_properties[MUSIC_MEDIA_LYRICS_PROPERTY] = g_param_spec_string ("lyrics", "lyrics", "lyrics", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_YEAR_PROPERTY, music_media_properties[MUSIC_MEDIA_YEAR_PROPERTY] = g_param_spec_uint ("year", "year", "year", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_BITRATE_PROPERTY, music_media_properties[MUSIC_MEDIA_BITRATE_PROPERTY] = g_param_spec_uint ("bitrate", "bitrate", "bitrate", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_BPM_PROPERTY, music_media_properties[MUSIC_MEDIA_BPM_PROPERTY] = g_param_spec_uint ("bpm", "bpm", "bpm", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_SAMPLERATE_PROPERTY, music_media_properties[MUSIC_MEDIA_SAMPLERATE_PROPERTY] = g_param_spec_uint ("samplerate", "samplerate", "samplerate", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_LENGTH_PROPERTY, music_media_properties[MUSIC_MEDIA_LENGTH_PROPERTY] = g_param_spec_uint ("length", "length", "length", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_RATING_PROPERTY, music_media_properties[MUSIC_MEDIA_RATING_PROPERTY] = g_param_spec_uint ("rating", "rating", "rating", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * Internal stats
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_PLAY_COUNT_PROPERTY, music_media_properties[MUSIC_MEDIA_PLAY_COUNT_PROPERTY] = g_param_spec_uint ("play-count", "play-count", "play-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_SKIP_COUNT_PROPERTY, music_media_properties[MUSIC_MEDIA_SKIP_COUNT_PROPERTY] = g_param_spec_uint ("skip-count", "skip-count", "skip-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_DATE_ADDED_PROPERTY, music_media_properties[MUSIC_MEDIA_DATE_ADDED_PROPERTY] = g_param_spec_uint ("date-added", "date-added", "date-added", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_LAST_PLAYED_PROPERTY, music_media_properties[MUSIC_MEDIA_LAST_PLAYED_PROPERTY] = g_param_spec_uint ("last-played", "last-played", "last-played", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_LAST_MODIFIED_PROPERTY, music_media_properties[MUSIC_MEDIA_LAST_MODIFIED_PROPERTY] = g_param_spec_uint ("last-modified", "last-modified", "last-modified", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_RESUME_POS_PROPERTY, music_media_properties[MUSIC_MEDIA_RESUME_POS_PROPERTY] = g_param_spec_int ("resume-pos", "resume-pos", "resume-pos", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_MEDIA_SHOW_PROPERTY, music_media_properties[MUSIC_MEDIA_SHOW_PROPERTY] = g_param_spec_boolean ("show", "show", "show", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	_tmp0_ = g_strdup (_ ("Unknown"));
	music_media_UNKNOWN = _tmp0_;
}

static void
music_media_instance_init (MusicMedia * self,
                           gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	self->priv = music_media_get_instance_private (self);
	self->priv->_file_size = (guint64) 0;
	self->priv->_is_preview = FALSE;
	self->priv->_is_temporary = FALSE;
	self->priv->_location_unknown = FALSE;
	self->priv->_has_embedded = FALSE;
	self->priv->_show_indicator = FALSE;
	_tmp0_ = g_strdup ("");
	self->priv->_title = _tmp0_;
	self->priv->_track = (guint) 0;
	self->priv->_track_count = (guint) 0;
	_tmp1_ = g_strdup ("");
	self->priv->_composer = _tmp1_;
	_tmp2_ = g_strdup ("");
	self->priv->_artist = _tmp2_;
	_tmp3_ = g_strdup ("");
	self->priv->_album_artist = _tmp3_;
	_tmp4_ = g_strdup ("");
	self->priv->_album = _tmp4_;
	self->priv->_album_number = (guint) 1;
	self->priv->_album_count = (guint) 1;
	self->priv->_album_info = NULL;
	_tmp5_ = g_strdup ("");
	self->priv->_grouping = _tmp5_;
	_tmp6_ = g_strdup ("");
	self->priv->_genre = _tmp6_;
	_tmp7_ = g_strdup ("");
	self->priv->_comment = _tmp7_;
	_tmp8_ = g_strdup ("");
	self->priv->_lyrics = _tmp8_;
	self->priv->_year = (guint) 0;
	self->priv->_bitrate = (guint) 0;
	self->priv->_bpm = (guint) 0;
	self->priv->_samplerate = (guint) 0;
	self->priv->_length = (guint) 0;
	self->priv->_play_count = (guint) 0;
	self->priv->_skip_count = (guint) 0;
	self->priv->_date_added = (guint) 0;
	self->priv->_last_played = (guint) 0;
	self->priv->_last_modified = (guint) 0;
	self->priv->_resume_pos = 0;
	self->priv->_show = TRUE;
}

static void
music_media_finalize (GObject * obj)
{
	MusicMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_MEDIA, MusicMedia);
	_g_object_unref0 (self->priv->_file);
	_g_object_unref0 (self->priv->_unique_status_image);
	_g_free0 (self->priv->_title);
	_g_free0 (self->priv->_composer);
	_g_free0 (self->priv->_artist);
	_g_free0 (self->priv->_album_artist);
	_g_free0 (self->priv->_album);
	_g_free0 (self->priv->_grouping);
	_g_free0 (self->priv->_genre);
	_g_free0 (self->priv->_comment);
	_g_free0 (self->priv->_lyrics);
	G_OBJECT_CLASS (music_media_parent_class)->finalize (obj);
}

static GType
music_media_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicMediaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_media_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicMedia), 0, (GInstanceInitFunc) music_media_instance_init, NULL };
	GType music_media_type_id;
	music_media_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicMedia", &g_define_type_info, 0);
	MusicMedia_private_offset = g_type_add_instance_private (music_media_type_id, sizeof (MusicMediaPrivate));
	return music_media_type_id;
}

GType
music_media_get_type (void)
{
	static volatile gsize music_media_type_id__volatile = 0;
	if (g_once_init_enter (&music_media_type_id__volatile)) {
		GType music_media_type_id;
		music_media_type_id = music_media_get_type_once ();
		g_once_init_leave (&music_media_type_id__volatile, music_media_type_id);
	}
	return music_media_type_id__volatile;
}

static void
_vala_music_media_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	MusicMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_MEDIA, MusicMedia);
	switch (property_id) {
		case MUSIC_MEDIA_ROWID_PROPERTY:
		g_value_set_int64 (value, music_media_get_rowid (self));
		break;
		case MUSIC_MEDIA_URI_PROPERTY:
		g_value_take_string (value, music_media_get_uri (self));
		break;
		case MUSIC_MEDIA_FILE_SIZE_PROPERTY:
		g_value_set_uint64 (value, music_media_get_file_size (self));
		break;
		case MUSIC_MEDIA_FILE_EXISTS_PROPERTY:
		g_value_set_boolean (value, music_media_get_file_exists (self));
		break;
		case MUSIC_MEDIA_FILE_PROPERTY:
		g_value_set_object (value, music_media_get_file (self));
		break;
		case MUSIC_MEDIA_IS_PREVIEW_PROPERTY:
		g_value_set_boolean (value, music_media_get_is_preview (self));
		break;
		case MUSIC_MEDIA_IS_TEMPORARY_PROPERTY:
		g_value_set_boolean (value, music_media_get_is_temporary (self));
		break;
		case MUSIC_MEDIA_LOCATION_UNKNOWN_PROPERTY:
		g_value_set_boolean (value, music_media_get_location_unknown (self));
		break;
		case MUSIC_MEDIA_HAS_EMBEDDED_PROPERTY:
		g_value_set_boolean (value, music_media_get_has_embedded (self));
		break;
		case MUSIC_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY:
		g_value_set_object (value, music_media_get_unique_status_image (self));
		break;
		case MUSIC_MEDIA_SHOW_INDICATOR_PROPERTY:
		g_value_set_boolean (value, music_media_get_show_indicator (self));
		break;
		case MUSIC_MEDIA_TITLE_PROPERTY:
		g_value_set_string (value, music_media_get_title (self));
		break;
		case MUSIC_MEDIA_TRACK_PROPERTY:
		g_value_set_uint (value, music_media_get_track (self));
		break;
		case MUSIC_MEDIA_TRACK_COUNT_PROPERTY:
		g_value_set_uint (value, music_media_get_track_count (self));
		break;
		case MUSIC_MEDIA_COMPOSER_PROPERTY:
		g_value_set_string (value, music_media_get_composer (self));
		break;
		case MUSIC_MEDIA_ARTIST_PROPERTY:
		g_value_set_string (value, music_media_get_artist (self));
		break;
		case MUSIC_MEDIA_ALBUM_ARTIST_PROPERTY:
		g_value_set_string (value, music_media_get_album_artist (self));
		break;
		case MUSIC_MEDIA_ALBUM_PROPERTY:
		g_value_set_string (value, music_media_get_album (self));
		break;
		case MUSIC_MEDIA_ALBUM_NUMBER_PROPERTY:
		g_value_set_uint (value, music_media_get_album_number (self));
		break;
		case MUSIC_MEDIA_ALBUM_COUNT_PROPERTY:
		g_value_set_uint (value, music_media_get_album_count (self));
		break;
		case MUSIC_MEDIA_ALBUM_INFO_PROPERTY:
		g_value_set_object (value, music_media_get_album_info (self));
		break;
		case MUSIC_MEDIA_GROUPING_PROPERTY:
		g_value_set_string (value, music_media_get_grouping (self));
		break;
		case MUSIC_MEDIA_GENRE_PROPERTY:
		g_value_set_string (value, music_media_get_genre (self));
		break;
		case MUSIC_MEDIA_COMMENT_PROPERTY:
		g_value_set_string (value, music_media_get_comment (self));
		break;
		case MUSIC_MEDIA_LYRICS_PROPERTY:
		g_value_set_string (value, music_media_get_lyrics (self));
		break;
		case MUSIC_MEDIA_YEAR_PROPERTY:
		g_value_set_uint (value, music_media_get_year (self));
		break;
		case MUSIC_MEDIA_BITRATE_PROPERTY:
		g_value_set_uint (value, music_media_get_bitrate (self));
		break;
		case MUSIC_MEDIA_BPM_PROPERTY:
		g_value_set_uint (value, music_media_get_bpm (self));
		break;
		case MUSIC_MEDIA_SAMPLERATE_PROPERTY:
		g_value_set_uint (value, music_media_get_samplerate (self));
		break;
		case MUSIC_MEDIA_LENGTH_PROPERTY:
		g_value_set_uint (value, music_media_get_length (self));
		break;
		case MUSIC_MEDIA_RATING_PROPERTY:
		g_value_set_uint (value, music_media_get_rating (self));
		break;
		case MUSIC_MEDIA_PLAY_COUNT_PROPERTY:
		g_value_set_uint (value, music_media_get_play_count (self));
		break;
		case MUSIC_MEDIA_SKIP_COUNT_PROPERTY:
		g_value_set_uint (value, music_media_get_skip_count (self));
		break;
		case MUSIC_MEDIA_DATE_ADDED_PROPERTY:
		g_value_set_uint (value, music_media_get_date_added (self));
		break;
		case MUSIC_MEDIA_LAST_PLAYED_PROPERTY:
		g_value_set_uint (value, music_media_get_last_played (self));
		break;
		case MUSIC_MEDIA_LAST_MODIFIED_PROPERTY:
		g_value_set_uint (value, music_media_get_last_modified (self));
		break;
		case MUSIC_MEDIA_RESUME_POS_PROPERTY:
		g_value_set_int (value, music_media_get_resume_pos (self));
		break;
		case MUSIC_MEDIA_SHOW_PROPERTY:
		g_value_set_boolean (value, music_media_get_show (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_media_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	MusicMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_MEDIA, MusicMedia);
	switch (property_id) {
		case MUSIC_MEDIA_ROWID_PROPERTY:
		music_media_set_rowid (self, g_value_get_int64 (value));
		break;
		case MUSIC_MEDIA_URI_PROPERTY:
		music_media_set_uri (self, g_value_get_string (value));
		break;
		case MUSIC_MEDIA_FILE_SIZE_PROPERTY:
		music_media_set_file_size (self, g_value_get_uint64 (value));
		break;
		case MUSIC_MEDIA_FILE_PROPERTY:
		music_media_set_file (self, g_value_get_object (value));
		break;
		case MUSIC_MEDIA_IS_PREVIEW_PROPERTY:
		music_media_set_is_preview (self, g_value_get_boolean (value));
		break;
		case MUSIC_MEDIA_IS_TEMPORARY_PROPERTY:
		music_media_set_is_temporary (self, g_value_get_boolean (value));
		break;
		case MUSIC_MEDIA_LOCATION_UNKNOWN_PROPERTY:
		music_media_set_location_unknown (self, g_value_get_boolean (value));
		break;
		case MUSIC_MEDIA_HAS_EMBEDDED_PROPERTY:
		music_media_set_has_embedded (self, g_value_get_boolean (value));
		break;
		case MUSIC_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY:
		music_media_set_unique_status_image (self, g_value_get_object (value));
		break;
		case MUSIC_MEDIA_SHOW_INDICATOR_PROPERTY:
		music_media_set_show_indicator (self, g_value_get_boolean (value));
		break;
		case MUSIC_MEDIA_TITLE_PROPERTY:
		music_media_set_title (self, g_value_get_string (value));
		break;
		case MUSIC_MEDIA_TRACK_PROPERTY:
		music_media_set_track (self, g_value_get_uint (value));
		break;
		case MUSIC_MEDIA_TRACK_COUNT_PROPERTY:
		music_media_set_track_count (self, g_value_get_uint (value));
		break;
		case MUSIC_MEDIA_COMPOSER_PROPERTY:
		music_media_set_composer (self, g_value_get_string (value));
		break;
		case MUSIC_MEDIA_ARTIST_PROPERTY:
		music_media_set_artist (self, g_value_get_string (value));
		break;
		case MUSIC_MEDIA_ALBUM_ARTIST_PROPERTY:
		music_media_set_album_artist (self, g_value_get_string (value));
		break;
		case MUSIC_MEDIA_ALBUM_PROPERTY:
		music_media_set_album (self, g_value_get_string (value));
		break;
		case MUSIC_MEDIA_ALBUM_NUMBER_PROPERTY:
		music_media_set_album_number (self, g_value_get_uint (value));
		break;
		case MUSIC_MEDIA_ALBUM_COUNT_PROPERTY:
		music_media_set_album_count (self, g_value_get_uint (value));
		break;
		case MUSIC_MEDIA_ALBUM_INFO_PROPERTY:
		music_media_set_album_info (self, g_value_get_object (value));
		break;
		case MUSIC_MEDIA_GROUPING_PROPERTY:
		music_media_set_grouping (self, g_value_get_string (value));
		break;
		case MUSIC_MEDIA_GENRE_PROPERTY:
		music_media_set_genre (self, g_value_get_string (value));
		break;
		case MUSIC_MEDIA_COMMENT_PROPERTY:
		music_media_set_comment (self, g_value_get_string (value));
		break;
		case MUSIC_MEDIA_LYRICS_PROPERTY:
		music_media_set_lyrics (self, g_value_get_string (value));
		break;
		case MUSIC_MEDIA_YEAR_PROPERTY:
		music_media_set_year (self, g_value_get_uint (value));
		break;
		case MUSIC_MEDIA_BITRATE_PROPERTY:
		music_media_set_bitrate (self, g_value_get_uint (value));
		break;
		case MUSIC_MEDIA_BPM_PROPERTY:
		music_media_set_bpm (self, g_value_get_uint (value));
		break;
		case MUSIC_MEDIA_SAMPLERATE_PROPERTY:
		music_media_set_samplerate (self, g_value_get_uint (value));
		break;
		case MUSIC_MEDIA_LENGTH_PROPERTY:
		music_media_set_length (self, g_value_get_uint (value));
		break;
		case MUSIC_MEDIA_RATING_PROPERTY:
		music_media_set_rating (self, g_value_get_uint (value));
		break;
		case MUSIC_MEDIA_PLAY_COUNT_PROPERTY:
		music_media_set_play_count (self, g_value_get_uint (value));
		break;
		case MUSIC_MEDIA_SKIP_COUNT_PROPERTY:
		music_media_set_skip_count (self, g_value_get_uint (value));
		break;
		case MUSIC_MEDIA_DATE_ADDED_PROPERTY:
		music_media_set_date_added (self, g_value_get_uint (value));
		break;
		case MUSIC_MEDIA_LAST_PLAYED_PROPERTY:
		music_media_set_last_played (self, g_value_get_uint (value));
		break;
		case MUSIC_MEDIA_LAST_MODIFIED_PROPERTY:
		music_media_set_last_modified (self, g_value_get_uint (value));
		break;
		case MUSIC_MEDIA_RESUME_POS_PROPERTY:
		music_media_set_resume_pos (self, g_value_get_int (value));
		break;
		case MUSIC_MEDIA_SHOW_PROPERTY:
		music_media_set_show (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

