/* Playlist.c generated by valac 0.52.4, the Vala compiler
 * generated from Playlist.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <gee.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

enum  {
	MUSIC_PLAYLIST_0_PROPERTY,
	MUSIC_PLAYLIST_MEDIAS_PROPERTY,
	MUSIC_PLAYLIST_ROWID_PROPERTY,
	MUSIC_PLAYLIST_NAME_PROPERTY,
	MUSIC_PLAYLIST_NUM_PROPERTIES
};
static GParamSpec* music_playlist_properties[MUSIC_PLAYLIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	MUSIC_PLAYLIST_REQUEST_PLAY_SIGNAL,
	MUSIC_PLAYLIST_MEDIA_ADDED_SIGNAL,
	MUSIC_PLAYLIST_MEDIA_REMOVED_SIGNAL,
	MUSIC_PLAYLIST_UPDATED_SIGNAL,
	MUSIC_PLAYLIST_CLEARED_SIGNAL,
	MUSIC_PLAYLIST_NUM_SIGNALS
};
static guint music_playlist_signals[MUSIC_PLAYLIST_NUM_SIGNALS] = {0};

struct _MusicPlaylistPrivate {
	GeeArrayList* _medias;
	gint64 _rowid;
};

static gint MusicPlaylist_private_offset;
static gpointer music_playlist_parent_class = NULL;

void music_playlist_set_medias (MusicPlaylist* self,
                                GeeArrayList* value);
static void music_playlist_real_add_media (MusicPlaylist* self,
                                    MusicMedia* to_remove);
static void music_playlist_real_add_medias (MusicPlaylist* self,
                                     GeeCollection* to_add);
static void music_playlist_real_remove_media (MusicPlaylist* self,
                                       MusicMedia* to_remove);
static void music_playlist_real_remove_medias (MusicPlaylist* self,
                                        GeeCollection* to_remove);
static void music_playlist_real_clear (MusicPlaylist* self);
static void music_playlist_finalize (GObject * obj);
static GType music_playlist_get_type_once (void);
static void _vala_music_playlist_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_music_playlist_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);

static inline gpointer
music_playlist_get_instance_private (MusicPlaylist* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPlaylist_private_offset);
}

static void
music_playlist_real_add_media (MusicPlaylist* self,
                               MusicMedia* to_remove)
{
	g_critical ("Type `%s' does not implement abstract method `music_playlist_add_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_playlist_add_media (MusicPlaylist* self,
                          MusicMedia* to_remove)
{
	MusicPlaylistClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
	if (_klass_->add_media) {
		_klass_->add_media (self, to_remove);
	}
}

static void
music_playlist_real_add_medias (MusicPlaylist* self,
                                GeeCollection* to_add)
{
	g_critical ("Type `%s' does not implement abstract method `music_playlist_add_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_playlist_add_medias (MusicPlaylist* self,
                           GeeCollection* to_add)
{
	MusicPlaylistClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
	if (_klass_->add_medias) {
		_klass_->add_medias (self, to_add);
	}
}

static void
music_playlist_real_remove_media (MusicPlaylist* self,
                                  MusicMedia* to_remove)
{
	g_critical ("Type `%s' does not implement abstract method `music_playlist_remove_media'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_playlist_remove_media (MusicPlaylist* self,
                             MusicMedia* to_remove)
{
	MusicPlaylistClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
	if (_klass_->remove_media) {
		_klass_->remove_media (self, to_remove);
	}
}

static void
music_playlist_real_remove_medias (MusicPlaylist* self,
                                   GeeCollection* to_remove)
{
	g_critical ("Type `%s' does not implement abstract method `music_playlist_remove_medias'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_playlist_remove_medias (MusicPlaylist* self,
                              GeeCollection* to_remove)
{
	MusicPlaylistClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
	if (_klass_->remove_medias) {
		_klass_->remove_medias (self, to_remove);
	}
}

static void
music_playlist_real_clear (MusicPlaylist* self)
{
	g_critical ("Type `%s' does not implement abstract method `music_playlist_clear'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
music_playlist_clear (MusicPlaylist* self)
{
	MusicPlaylistClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
	if (_klass_->clear) {
		_klass_->clear (self);
	}
}

gboolean
music_playlist_is_empty (MusicPlaylist* self)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = music_playlist_get_medias (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	result = _tmp3_ <= 0;
	return result;
}

/**
    * Retrives a Media at an index in this playlist
    */
MusicMedia*
music_playlist_get (MusicPlaylist* self,
                    gint index)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gpointer _tmp2_;
	MusicMedia* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_playlist_get_medias (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _tmp1_, index);
	result = (MusicMedia*) _tmp2_;
	return result;
}

void
music_playlist_set (MusicPlaylist* self,
                    gint index,
                    MusicMedia* m)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	_tmp0_ = music_playlist_get_medias (self);
	_tmp1_ = _tmp0_;
	gee_abstract_list_set ((GeeAbstractList*) _tmp1_, index, m);
}

GeeIterator*
music_playlist_iterator (MusicPlaylist* self)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeIterator* _tmp2_;
	GeeIterator* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_playlist_get_medias (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
	result = _tmp2_;
	return result;
}

MusicPlaylist*
music_playlist_construct (GType object_type)
{
	MusicPlaylist * self = NULL;
	self = (MusicPlaylist*) g_object_new (object_type, NULL);
	return self;
}

GeeArrayList*
music_playlist_get_medias (MusicPlaylist* self)
{
	MusicPlaylistClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
	if (_klass_->get_medias) {
		return _klass_->get_medias (self);
	}
	return NULL;
}

static GeeArrayList*
music_playlist_real_get_medias (MusicPlaylist* base)
{
	GeeArrayList* result;
	MusicPlaylist* self;
	GeeArrayList* _tmp0_;
	self = base;
	_tmp0_ = self->priv->_medias;
	result = _tmp0_;
	return result;
}

void
music_playlist_set_medias (MusicPlaylist* self,
                           GeeArrayList* value)
{
	MusicPlaylistClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
	if (_klass_->set_medias) {
		_klass_->set_medias (self, value);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
music_playlist_real_set_medias (MusicPlaylist* base,
                                GeeArrayList* value)
{
	MusicPlaylist* self;
	GeeArrayList* old_value;
	self = base;
	old_value = music_playlist_real_get_medias (base);
	if (old_value != value) {
		GeeArrayList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_medias);
		self->priv->_medias = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_playlist_properties[MUSIC_PLAYLIST_MEDIAS_PROPERTY]);
	}
}

gint64
music_playlist_get_rowid (MusicPlaylist* self)
{
	gint64 result;
	g_return_val_if_fail (self != NULL, 0LL);
	result = self->priv->_rowid;
	return result;
}

void
music_playlist_set_rowid (MusicPlaylist* self,
                          gint64 value)
{
	gint64 old_value;
	g_return_if_fail (self != NULL);
	old_value = music_playlist_get_rowid (self);
	if (old_value != value) {
		self->priv->_rowid = value;
		g_object_notify_by_pspec ((GObject *) self, music_playlist_properties[MUSIC_PLAYLIST_ROWID_PROPERTY]);
	}
}

const gchar*
music_playlist_get_name (MusicPlaylist* self)
{
	MusicPlaylistClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
	if (_klass_->get_name) {
		return _klass_->get_name (self);
	}
	return NULL;
}

static const gchar*
music_playlist_real_get_name (MusicPlaylist* base)
{
	const gchar* result;
	MusicPlaylist* self;
	const gchar* _tmp0_;
	self = base;
	_tmp0_ = self->_name;
	result = _tmp0_;
	return result;
}

void
music_playlist_set_name (MusicPlaylist* self,
                         const gchar* value)
{
	MusicPlaylistClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_PLAYLIST_GET_CLASS (self);
	if (_klass_->set_name) {
		_klass_->set_name (self, value);
	}
}

static void
music_playlist_real_set_name (MusicPlaylist* base,
                              const gchar* value)
{
	MusicPlaylist* self;
	gchar* old_name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	self = base;
	_tmp0_ = self->_name;
	_tmp1_ = g_strdup (_tmp0_);
	old_name = _tmp1_;
	_tmp2_ = g_strdup (value);
	_g_free0 (self->_name);
	self->_name = _tmp2_;
	g_signal_emit (self, music_playlist_signals[MUSIC_PLAYLIST_UPDATED_SIGNAL], 0, old_name);
	_g_free0 (old_name);
	g_object_notify_by_pspec ((GObject *) self, music_playlist_properties[MUSIC_PLAYLIST_NAME_PROPERTY]);
}

static void
music_playlist_class_init (MusicPlaylistClass * klass,
                           gpointer klass_data)
{
	music_playlist_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicPlaylist_private_offset);
	((MusicPlaylistClass *) klass)->add_media = (void (*) (MusicPlaylist*, MusicMedia*)) music_playlist_real_add_media;
	((MusicPlaylistClass *) klass)->add_medias = (void (*) (MusicPlaylist*, GeeCollection*)) music_playlist_real_add_medias;
	((MusicPlaylistClass *) klass)->remove_media = (void (*) (MusicPlaylist*, MusicMedia*)) music_playlist_real_remove_media;
	((MusicPlaylistClass *) klass)->remove_medias = (void (*) (MusicPlaylist*, GeeCollection*)) music_playlist_real_remove_medias;
	((MusicPlaylistClass *) klass)->clear = (void (*) (MusicPlaylist*)) music_playlist_real_clear;
	MUSIC_PLAYLIST_CLASS (klass)->get_medias = music_playlist_real_get_medias;
	MUSIC_PLAYLIST_CLASS (klass)->set_medias = music_playlist_real_set_medias;
	MUSIC_PLAYLIST_CLASS (klass)->get_name = music_playlist_real_get_name;
	MUSIC_PLAYLIST_CLASS (klass)->set_name = music_playlist_real_set_name;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_playlist_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_playlist_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_playlist_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYLIST_MEDIAS_PROPERTY, music_playlist_properties[MUSIC_PLAYLIST_MEDIAS_PROPERTY] = g_param_spec_object ("medias", "medias", "medias", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYLIST_ROWID_PROPERTY, music_playlist_properties[MUSIC_PLAYLIST_ROWID_PROPERTY] = g_param_spec_int64 ("rowid", "rowid", "rowid", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLAYLIST_NAME_PROPERTY, music_playlist_properties[MUSIC_PLAYLIST_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	music_playlist_signals[MUSIC_PLAYLIST_REQUEST_PLAY_SIGNAL] = g_signal_new ("request-play", MUSIC_TYPE_PLAYLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_playlist_signals[MUSIC_PLAYLIST_MEDIA_ADDED_SIGNAL] = g_signal_new ("media-added", MUSIC_TYPE_PLAYLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	music_playlist_signals[MUSIC_PLAYLIST_MEDIA_REMOVED_SIGNAL] = g_signal_new ("media-removed", MUSIC_TYPE_PLAYLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	music_playlist_signals[MUSIC_PLAYLIST_UPDATED_SIGNAL] = g_signal_new ("updated", MUSIC_TYPE_PLAYLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	music_playlist_signals[MUSIC_PLAYLIST_CLEARED_SIGNAL] = g_signal_new ("cleared", MUSIC_TYPE_PLAYLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
music_playlist_instance_init (MusicPlaylist * self,
                              gpointer klass)
{
	GeeArrayList* _tmp0_;
	gchar* _tmp1_;
	self->priv = music_playlist_get_instance_private (self);
	_tmp0_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->priv->_medias = _tmp0_;
	_tmp1_ = g_strdup ("");
	self->_name = _tmp1_;
}

static void
music_playlist_finalize (GObject * obj)
{
	MusicPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_PLAYLIST, MusicPlaylist);
	_g_object_unref0 (self->priv->_medias);
	_g_object_unref0 (self->icon);
	_g_free0 (self->_name);
	G_OBJECT_CLASS (music_playlist_parent_class)->finalize (obj);
}

static GType
music_playlist_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPlaylist), 0, (GInstanceInitFunc) music_playlist_instance_init, NULL };
	GType music_playlist_type_id;
	music_playlist_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicPlaylist", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	MusicPlaylist_private_offset = g_type_add_instance_private (music_playlist_type_id, sizeof (MusicPlaylistPrivate));
	return music_playlist_type_id;
}

GType
music_playlist_get_type (void)
{
	static volatile gsize music_playlist_type_id__volatile = 0;
	if (g_once_init_enter (&music_playlist_type_id__volatile)) {
		GType music_playlist_type_id;
		music_playlist_type_id = music_playlist_get_type_once ();
		g_once_init_leave (&music_playlist_type_id__volatile, music_playlist_type_id);
	}
	return music_playlist_type_id__volatile;
}

static void
_vala_music_playlist_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	MusicPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PLAYLIST, MusicPlaylist);
	switch (property_id) {
		case MUSIC_PLAYLIST_MEDIAS_PROPERTY:
		g_value_set_object (value, music_playlist_get_medias (self));
		break;
		case MUSIC_PLAYLIST_ROWID_PROPERTY:
		g_value_set_int64 (value, music_playlist_get_rowid (self));
		break;
		case MUSIC_PLAYLIST_NAME_PROPERTY:
		g_value_set_string (value, music_playlist_get_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_playlist_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	MusicPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_PLAYLIST, MusicPlaylist);
	switch (property_id) {
		case MUSIC_PLAYLIST_MEDIAS_PROPERTY:
		music_playlist_set_medias (self, g_value_get_object (value));
		break;
		case MUSIC_PLAYLIST_ROWID_PROPERTY:
		music_playlist_set_rowid (self, g_value_get_int64 (value));
		break;
		case MUSIC_PLAYLIST_NAME_PROPERTY:
		music_playlist_set_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

