/* SmartPlaylist.c generated by valac 0.52.4, the Vala compiler
 * generated from SmartPlaylist.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

enum  {
	MUSIC_SMART_PLAYLIST_0_PROPERTY,
	MUSIC_SMART_PLAYLIST_CONDITIONAL_PROPERTY,
	MUSIC_SMART_PLAYLIST_QUERY_COUNT_PROPERTY,
	MUSIC_SMART_PLAYLIST_LIMIT_PROPERTY,
	MUSIC_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY,
	MUSIC_SMART_PLAYLIST_LIBRARY_PROPERTY,
	MUSIC_SMART_PLAYLIST_NUM_PROPERTIES
};
static GParamSpec* music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block10Data Block10Data;
typedef struct _Block11Data Block11Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))

struct _MusicSmartPlaylistPrivate {
	MusicSmartPlaylistConditionalType _conditional;
	gint _query_count;
	gboolean _limit;
	guint _limit_amount;
	MusicLibrary* _library;
};

struct _Block10Data {
	int _ref_count_;
	MusicSmartPlaylist* self;
	GeeCollection* given_library;
};

struct _Block11Data {
	int _ref_count_;
	Block10Data * _data10_;
	GeeTreeSet* added;
	GeeTreeSet* removed;
};

static gint MusicSmartPlaylist_private_offset;
static gpointer music_smart_playlist_parent_class = NULL;

static void music_smart_playlist_real_add_media (MusicPlaylist* base,
                                          MusicMedia* m);
static void music_smart_playlist_real_add_medias (MusicPlaylist* base,
                                           GeeCollection* to_add);
static void music_smart_playlist_real_remove_media (MusicPlaylist* base,
                                             MusicMedia* to_remove);
static void music_smart_playlist_real_remove_medias (MusicPlaylist* base,
                                              GeeCollection* to_remove);
static void music_smart_playlist_real_analyse_all (MusicSmartPlaylist* self);
static void music_smart_playlist_analyse_list (MusicSmartPlaylist* self,
                                        GeeCollection* given_library);
static void music_smart_playlist_real_clear_queries (MusicSmartPlaylist* self);
static GeeCollection* music_smart_playlist_real_get_queries (MusicSmartPlaylist* self);
static void music_smart_playlist_real_add_query (MusicSmartPlaylist* self,
                                          MusicSmartQuery* s);
static void music_smart_playlist_real_add_queries (MusicSmartPlaylist* self,
                                            GeeCollection* queries);
static void music_smart_playlist_real_clear (MusicPlaylist* base);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void* __lambda10_ (Block10Data* _data10_);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static gboolean __lambda11_ (Block11Data* _data11_);
static gboolean ___lambda11__gsource_func (gpointer self);
static gpointer ___lambda10__gthread_func (gpointer self);
static GObject * music_smart_playlist_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void _music_smart_playlist___lambda12_ (MusicSmartPlaylist* self,
                                        GeeCollection* medias);
static void __music_smart_playlist___lambda12__music_library_media_added (MusicLibrary* _sender,
                                                                   GeeCollection* medias,
                                                                   gpointer self);
static void _music_smart_playlist___lambda13_ (MusicSmartPlaylist* self,
                                        GeeCollection* medias);
static void __music_smart_playlist___lambda13__music_library_media_updated (MusicLibrary* _sender,
                                                                     GeeCollection* medias,
                                                                     gpointer self);
static void _music_smart_playlist___lambda14_ (MusicSmartPlaylist* self,
                                        GeeCollection* medias);
static void __music_smart_playlist___lambda14__music_library_media_removed (MusicLibrary* _sender,
                                                                     GeeCollection* medias,
                                                                     gpointer self);
static void music_smart_playlist_finalize (GObject * obj);
static GType music_smart_playlist_get_type_once (void);
static void _vala_music_smart_playlist_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_music_smart_playlist_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
music_smart_playlist_get_instance_private (MusicSmartPlaylist* self)
{
	return G_STRUCT_MEMBER_P (self, MusicSmartPlaylist_private_offset);
}

static GType
music_smart_playlist_conditional_type_get_type_once (void)
{
	static const GEnumValue values[] = {{MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ALL, "MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ALL", "all"}, {MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ANY, "MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ANY", "any"}, {0, NULL, NULL}};
	GType music_smart_playlist_conditional_type_type_id;
	music_smart_playlist_conditional_type_type_id = g_enum_register_static ("MusicSmartPlaylistConditionalType", values);
	return music_smart_playlist_conditional_type_type_id;
}

GType
music_smart_playlist_conditional_type_get_type (void)
{
	static volatile gsize music_smart_playlist_conditional_type_type_id__volatile = 0;
	if (g_once_init_enter (&music_smart_playlist_conditional_type_type_id__volatile)) {
		GType music_smart_playlist_conditional_type_type_id;
		music_smart_playlist_conditional_type_type_id = music_smart_playlist_conditional_type_get_type_once ();
		g_once_init_leave (&music_smart_playlist_conditional_type_type_id__volatile, music_smart_playlist_conditional_type_type_id);
	}
	return music_smart_playlist_conditional_type_type_id__volatile;
}

MusicSmartPlaylist*
music_smart_playlist_construct (GType object_type,
                                MusicLibrary* library)
{
	MusicSmartPlaylist * self = NULL;
	g_return_val_if_fail (library != NULL, NULL);
	self = (MusicSmartPlaylist*) g_object_new (object_type, "library", library, NULL);
	return self;
}

MusicSmartPlaylist*
music_smart_playlist_new (MusicLibrary* library)
{
	return music_smart_playlist_construct (MUSIC_TYPE_SMART_PLAYLIST, library);
}

static void
music_smart_playlist_real_add_media (MusicPlaylist* base,
                                     MusicMedia* m)
{
	MusicSmartPlaylist * self;
	self = (MusicSmartPlaylist*) base;
	g_return_if_fail (m != NULL);
	g_warning ("SmartPlaylist.vala:82: Trying to force the media addition to a smart p" \
"laylist!");
}

static void
music_smart_playlist_real_add_medias (MusicPlaylist* base,
                                      GeeCollection* to_add)
{
	MusicSmartPlaylist * self;
	self = (MusicSmartPlaylist*) base;
	g_return_if_fail (to_add != NULL);
	g_warning ("SmartPlaylist.vala:86: Trying to force the media addition to a smart p" \
"laylist!");
}

static void
music_smart_playlist_real_remove_media (MusicPlaylist* base,
                                        MusicMedia* to_remove)
{
	MusicSmartPlaylist * self;
	self = (MusicSmartPlaylist*) base;
	g_return_if_fail (to_remove != NULL);
	g_warning ("SmartPlaylist.vala:90: Trying to force the media removal from a smart " \
"playlist!");
}

static void
music_smart_playlist_real_remove_medias (MusicPlaylist* base,
                                         GeeCollection* to_remove)
{
	MusicSmartPlaylist * self;
	self = (MusicSmartPlaylist*) base;
	g_return_if_fail (to_remove != NULL);
	g_warning ("SmartPlaylist.vala:94: Trying to force the media removal from a smart " \
"playlist!");
}

static void
music_smart_playlist_real_analyse_all (MusicSmartPlaylist* self)
{
	MusicLibrary* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	_tmp0_ = self->priv->_library;
	_tmp1_ = music_library_get_medias (_tmp0_);
	_tmp2_ = _tmp1_;
	music_smart_playlist_analyse_list (self, _tmp2_);
	_g_object_unref0 (_tmp2_);
}

void
music_smart_playlist_analyse_all (MusicSmartPlaylist* self)
{
	MusicSmartPlaylistClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
	if (_klass_->analyse_all) {
		_klass_->analyse_all (self);
	}
}

static void
music_smart_playlist_real_clear_queries (MusicSmartPlaylist* self)
{
	GeeTreeSet* _tmp0_;
	music_smart_playlist_set_query_count (self, 0);
	_tmp0_ = self->queries;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	g_signal_emit_by_name ((MusicPlaylist*) self, "updated", NULL);
}

void
music_smart_playlist_clear_queries (MusicSmartPlaylist* self)
{
	MusicSmartPlaylistClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
	if (_klass_->clear_queries) {
		_klass_->clear_queries (self);
	}
}

static GeeCollection*
music_smart_playlist_real_get_queries (MusicSmartPlaylist* self)
{
	GeeTreeSet* _tmp0_;
	GeeBidirSortedSet* _tmp1_;
	GeeBidirSortedSet* _tmp2_;
	GeeCollection* result = NULL;
	_tmp0_ = self->queries;
	_tmp1_ = gee_abstract_bidir_sorted_set_get_read_only_view ((GeeAbstractBidirSortedSet*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = (GeeCollection*) _tmp2_;
	return result;
}

GeeCollection*
music_smart_playlist_get_queries (MusicSmartPlaylist* self)
{
	MusicSmartPlaylistClass* _klass_;
	g_return_val_if_fail (self != NULL, NULL);
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
	if (_klass_->get_queries) {
		return _klass_->get_queries (self);
	}
	return NULL;
}

static void
music_smart_playlist_real_add_query (MusicSmartPlaylist* self,
                                     MusicSmartQuery* s)
{
	gint _tmp0_;
	GeeTreeSet* _tmp1_;
	g_return_if_fail (s != NULL);
	_tmp0_ = self->priv->_query_count;
	music_smart_playlist_set_query_count (self, _tmp0_ + 1);
	_tmp1_ = self->queries;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, s);
	music_smart_playlist_analyse_all (self);
	g_signal_emit_by_name ((MusicPlaylist*) self, "updated", NULL);
}

void
music_smart_playlist_add_query (MusicSmartPlaylist* self,
                                MusicSmartQuery* s)
{
	MusicSmartPlaylistClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
	if (_klass_->add_query) {
		_klass_->add_query (self, s);
	}
}

static void
music_smart_playlist_real_add_queries (MusicSmartPlaylist* self,
                                       GeeCollection* queries)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeTreeSet* _tmp3_;
	g_return_if_fail (queries != NULL);
	_tmp0_ = self->priv->_query_count;
	_tmp1_ = gee_collection_get_size (queries);
	_tmp2_ = _tmp1_;
	music_smart_playlist_set_query_count (self, _tmp0_ + _tmp2_);
	_tmp3_ = self->queries;
	gee_collection_add_all ((GeeCollection*) _tmp3_, queries);
	music_smart_playlist_analyse_all (self);
	g_signal_emit_by_name ((MusicPlaylist*) self, "updated", NULL);
}

void
music_smart_playlist_add_queries (MusicSmartPlaylist* self,
                                  GeeCollection* queries)
{
	MusicSmartPlaylistClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
	if (_klass_->add_queries) {
		_klass_->add_queries (self, queries);
	}
}

static void
music_smart_playlist_real_clear (MusicPlaylist* base)
{
	MusicSmartPlaylist * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	self = (MusicSmartPlaylist*) base;
	_tmp0_ = music_playlist_get_medias ((MusicPlaylist*) self);
	_tmp1_ = _tmp0_;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
	g_signal_emit_by_name ((MusicPlaylist*) self, "cleared");
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

gboolean
music_smart_playlist_media_matches_query (MusicSmartQuery* q,
                                          MusicMedia* s)
{
	MusicSmartQueryFieldType _tmp0_;
	MusicSmartQueryFieldType _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (q != NULL, FALSE);
	g_return_val_if_fail (s != NULL, FALSE);
	_tmp0_ = music_smart_query_get_field (q);
	_tmp1_ = _tmp0_;
	switch (_tmp1_) {
		case MUSIC_SMART_QUERY_FIELD_TYPE_URI:
		{
			MusicSmartQueryComparatorType _tmp2_;
			MusicSmartQueryComparatorType _tmp3_;
			_tmp2_ = music_smart_query_get_comparator (q);
			_tmp3_ = _tmp2_;
			if (_tmp3_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS) {
				GValue _tmp4_ = {0};
				GValue _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gboolean _tmp14_;
				music_smart_query_get_value (q, &_tmp4_);
				_tmp5_ = _tmp4_;
				_tmp6_ = g_value_get_string (&_tmp5_);
				_tmp7_ = g_utf8_strdown (_tmp6_, (gssize) -1);
				_tmp8_ = _tmp7_;
				_tmp9_ = music_media_get_uri (s);
				_tmp10_ = _tmp9_;
				_tmp11_ = _tmp10_;
				_tmp12_ = g_utf8_strdown (_tmp11_, (gssize) -1);
				_tmp13_ = _tmp12_;
				_tmp14_ = g_strcmp0 (_tmp8_, _tmp13_) == 0;
				_g_free0 (_tmp13_);
				_g_free0 (_tmp11_);
				_g_free0 (_tmp8_);
				result = _tmp14_;
				return result;
			} else {
				MusicSmartQueryComparatorType _tmp15_;
				MusicSmartQueryComparatorType _tmp16_;
				_tmp15_ = music_smart_query_get_comparator (q);
				_tmp16_ = _tmp15_;
				if (_tmp16_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS) {
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					GValue _tmp22_ = {0};
					GValue _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					gboolean _tmp27_;
					_tmp17_ = music_media_get_uri (s);
					_tmp18_ = _tmp17_;
					_tmp19_ = _tmp18_;
					_tmp20_ = g_utf8_strdown (_tmp19_, (gssize) -1);
					_tmp21_ = _tmp20_;
					music_smart_query_get_value (q, &_tmp22_);
					_tmp23_ = _tmp22_;
					_tmp24_ = g_value_get_string (&_tmp23_);
					_tmp25_ = g_utf8_strdown (_tmp24_, (gssize) -1);
					_tmp26_ = _tmp25_;
					_tmp27_ = string_contains (_tmp21_, _tmp26_);
					_g_free0 (_tmp26_);
					_g_free0 (_tmp21_);
					_g_free0 (_tmp19_);
					result = _tmp27_;
					return result;
				} else {
					MusicSmartQueryComparatorType _tmp28_;
					MusicSmartQueryComparatorType _tmp29_;
					_tmp28_ = music_smart_query_get_comparator (q);
					_tmp29_ = _tmp28_;
					if (_tmp29_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
						gchar* _tmp30_;
						gchar* _tmp31_;
						gchar* _tmp32_;
						gchar* _tmp33_;
						gchar* _tmp34_;
						GValue _tmp35_ = {0};
						GValue _tmp36_;
						const gchar* _tmp37_;
						gchar* _tmp38_;
						gchar* _tmp39_;
						gboolean _tmp40_;
						_tmp30_ = music_media_get_uri (s);
						_tmp31_ = _tmp30_;
						_tmp32_ = _tmp31_;
						_tmp33_ = g_utf8_strdown (_tmp32_, (gssize) -1);
						_tmp34_ = _tmp33_;
						music_smart_query_get_value (q, &_tmp35_);
						_tmp36_ = _tmp35_;
						_tmp37_ = g_value_get_string (&_tmp36_);
						_tmp38_ = g_utf8_strdown (_tmp37_, (gssize) -1);
						_tmp39_ = _tmp38_;
						_tmp40_ = !string_contains (_tmp34_, _tmp39_);
						_g_free0 (_tmp39_);
						_g_free0 (_tmp34_);
						_g_free0 (_tmp32_);
						result = _tmp40_;
						return result;
					}
				}
			}
			break;
		}
		case MUSIC_SMART_QUERY_FIELD_TYPE_ALBUM:
		{
			MusicSmartQueryComparatorType _tmp41_;
			MusicSmartQueryComparatorType _tmp42_;
			_tmp41_ = music_smart_query_get_comparator (q);
			_tmp42_ = _tmp41_;
			if (_tmp42_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS) {
				GValue _tmp43_ = {0};
				GValue _tmp44_;
				const gchar* _tmp45_;
				gchar* _tmp46_;
				gchar* _tmp47_;
				const gchar* _tmp48_;
				const gchar* _tmp49_;
				gchar* _tmp50_;
				gchar* _tmp51_;
				gboolean _tmp52_;
				music_smart_query_get_value (q, &_tmp43_);
				_tmp44_ = _tmp43_;
				_tmp45_ = g_value_get_string (&_tmp44_);
				_tmp46_ = g_utf8_strdown (_tmp45_, (gssize) -1);
				_tmp47_ = _tmp46_;
				_tmp48_ = music_media_get_album (s);
				_tmp49_ = _tmp48_;
				_tmp50_ = g_utf8_strdown (_tmp49_, (gssize) -1);
				_tmp51_ = _tmp50_;
				_tmp52_ = g_strcmp0 (_tmp47_, _tmp51_) == 0;
				_g_free0 (_tmp51_);
				_g_free0 (_tmp47_);
				result = _tmp52_;
				return result;
			} else {
				MusicSmartQueryComparatorType _tmp53_;
				MusicSmartQueryComparatorType _tmp54_;
				_tmp53_ = music_smart_query_get_comparator (q);
				_tmp54_ = _tmp53_;
				if (_tmp54_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS) {
					const gchar* _tmp55_;
					const gchar* _tmp56_;
					gchar* _tmp57_;
					gchar* _tmp58_;
					GValue _tmp59_ = {0};
					GValue _tmp60_;
					const gchar* _tmp61_;
					gchar* _tmp62_;
					gchar* _tmp63_;
					gboolean _tmp64_;
					_tmp55_ = music_media_get_album (s);
					_tmp56_ = _tmp55_;
					_tmp57_ = g_utf8_strdown (_tmp56_, (gssize) -1);
					_tmp58_ = _tmp57_;
					music_smart_query_get_value (q, &_tmp59_);
					_tmp60_ = _tmp59_;
					_tmp61_ = g_value_get_string (&_tmp60_);
					_tmp62_ = g_utf8_strdown (_tmp61_, (gssize) -1);
					_tmp63_ = _tmp62_;
					_tmp64_ = string_contains (_tmp58_, _tmp63_);
					_g_free0 (_tmp63_);
					_g_free0 (_tmp58_);
					result = _tmp64_;
					return result;
				} else {
					MusicSmartQueryComparatorType _tmp65_;
					MusicSmartQueryComparatorType _tmp66_;
					_tmp65_ = music_smart_query_get_comparator (q);
					_tmp66_ = _tmp65_;
					if (_tmp66_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
						const gchar* _tmp67_;
						const gchar* _tmp68_;
						gchar* _tmp69_;
						gchar* _tmp70_;
						GValue _tmp71_ = {0};
						GValue _tmp72_;
						const gchar* _tmp73_;
						gchar* _tmp74_;
						gchar* _tmp75_;
						gboolean _tmp76_;
						_tmp67_ = music_media_get_album (s);
						_tmp68_ = _tmp67_;
						_tmp69_ = g_utf8_strdown (_tmp68_, (gssize) -1);
						_tmp70_ = _tmp69_;
						music_smart_query_get_value (q, &_tmp71_);
						_tmp72_ = _tmp71_;
						_tmp73_ = g_value_get_string (&_tmp72_);
						_tmp74_ = g_utf8_strdown (_tmp73_, (gssize) -1);
						_tmp75_ = _tmp74_;
						_tmp76_ = !string_contains (_tmp70_, _tmp75_);
						_g_free0 (_tmp75_);
						_g_free0 (_tmp70_);
						result = _tmp76_;
						return result;
					}
				}
			}
			break;
		}
		case MUSIC_SMART_QUERY_FIELD_TYPE_ARTIST:
		{
			MusicSmartQueryComparatorType _tmp77_;
			MusicSmartQueryComparatorType _tmp78_;
			_tmp77_ = music_smart_query_get_comparator (q);
			_tmp78_ = _tmp77_;
			if (_tmp78_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS) {
				GValue _tmp79_ = {0};
				GValue _tmp80_;
				const gchar* _tmp81_;
				gchar* _tmp82_;
				gchar* _tmp83_;
				const gchar* _tmp84_;
				const gchar* _tmp85_;
				gchar* _tmp86_;
				gchar* _tmp87_;
				gboolean _tmp88_;
				music_smart_query_get_value (q, &_tmp79_);
				_tmp80_ = _tmp79_;
				_tmp81_ = g_value_get_string (&_tmp80_);
				_tmp82_ = g_utf8_strdown (_tmp81_, (gssize) -1);
				_tmp83_ = _tmp82_;
				_tmp84_ = music_media_get_artist (s);
				_tmp85_ = _tmp84_;
				_tmp86_ = g_utf8_strdown (_tmp85_, (gssize) -1);
				_tmp87_ = _tmp86_;
				_tmp88_ = g_strcmp0 (_tmp83_, _tmp87_) == 0;
				_g_free0 (_tmp87_);
				_g_free0 (_tmp83_);
				result = _tmp88_;
				return result;
			} else {
				MusicSmartQueryComparatorType _tmp89_;
				MusicSmartQueryComparatorType _tmp90_;
				_tmp89_ = music_smart_query_get_comparator (q);
				_tmp90_ = _tmp89_;
				if (_tmp90_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS) {
					const gchar* _tmp91_;
					const gchar* _tmp92_;
					gchar* _tmp93_;
					gchar* _tmp94_;
					GValue _tmp95_ = {0};
					GValue _tmp96_;
					const gchar* _tmp97_;
					gchar* _tmp98_;
					gchar* _tmp99_;
					gboolean _tmp100_;
					_tmp91_ = music_media_get_artist (s);
					_tmp92_ = _tmp91_;
					_tmp93_ = g_utf8_strdown (_tmp92_, (gssize) -1);
					_tmp94_ = _tmp93_;
					music_smart_query_get_value (q, &_tmp95_);
					_tmp96_ = _tmp95_;
					_tmp97_ = g_value_get_string (&_tmp96_);
					_tmp98_ = g_utf8_strdown (_tmp97_, (gssize) -1);
					_tmp99_ = _tmp98_;
					_tmp100_ = string_contains (_tmp94_, _tmp99_);
					_g_free0 (_tmp99_);
					_g_free0 (_tmp94_);
					result = _tmp100_;
					return result;
				} else {
					MusicSmartQueryComparatorType _tmp101_;
					MusicSmartQueryComparatorType _tmp102_;
					_tmp101_ = music_smart_query_get_comparator (q);
					_tmp102_ = _tmp101_;
					if (_tmp102_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
						const gchar* _tmp103_;
						const gchar* _tmp104_;
						gchar* _tmp105_;
						gchar* _tmp106_;
						GValue _tmp107_ = {0};
						GValue _tmp108_;
						const gchar* _tmp109_;
						gchar* _tmp110_;
						gchar* _tmp111_;
						gboolean _tmp112_;
						_tmp103_ = music_media_get_artist (s);
						_tmp104_ = _tmp103_;
						_tmp105_ = g_utf8_strdown (_tmp104_, (gssize) -1);
						_tmp106_ = _tmp105_;
						music_smart_query_get_value (q, &_tmp107_);
						_tmp108_ = _tmp107_;
						_tmp109_ = g_value_get_string (&_tmp108_);
						_tmp110_ = g_utf8_strdown (_tmp109_, (gssize) -1);
						_tmp111_ = _tmp110_;
						_tmp112_ = !string_contains (_tmp106_, _tmp111_);
						_g_free0 (_tmp111_);
						_g_free0 (_tmp106_);
						result = _tmp112_;
						return result;
					}
				}
			}
			break;
		}
		case MUSIC_SMART_QUERY_FIELD_TYPE_COMPOSER:
		{
			MusicSmartQueryComparatorType _tmp113_;
			MusicSmartQueryComparatorType _tmp114_;
			_tmp113_ = music_smart_query_get_comparator (q);
			_tmp114_ = _tmp113_;
			if (_tmp114_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS) {
				GValue _tmp115_ = {0};
				GValue _tmp116_;
				const gchar* _tmp117_;
				gchar* _tmp118_;
				gchar* _tmp119_;
				const gchar* _tmp120_;
				const gchar* _tmp121_;
				gchar* _tmp122_;
				gchar* _tmp123_;
				gboolean _tmp124_;
				music_smart_query_get_value (q, &_tmp115_);
				_tmp116_ = _tmp115_;
				_tmp117_ = g_value_get_string (&_tmp116_);
				_tmp118_ = g_utf8_strdown (_tmp117_, (gssize) -1);
				_tmp119_ = _tmp118_;
				_tmp120_ = music_media_get_composer (s);
				_tmp121_ = _tmp120_;
				_tmp122_ = g_utf8_strdown (_tmp121_, (gssize) -1);
				_tmp123_ = _tmp122_;
				_tmp124_ = g_strcmp0 (_tmp119_, _tmp123_) == 0;
				_g_free0 (_tmp123_);
				_g_free0 (_tmp119_);
				result = _tmp124_;
				return result;
			} else {
				MusicSmartQueryComparatorType _tmp125_;
				MusicSmartQueryComparatorType _tmp126_;
				_tmp125_ = music_smart_query_get_comparator (q);
				_tmp126_ = _tmp125_;
				if (_tmp126_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS) {
					const gchar* _tmp127_;
					const gchar* _tmp128_;
					gchar* _tmp129_;
					gchar* _tmp130_;
					GValue _tmp131_ = {0};
					GValue _tmp132_;
					const gchar* _tmp133_;
					gchar* _tmp134_;
					gchar* _tmp135_;
					gboolean _tmp136_;
					_tmp127_ = music_media_get_composer (s);
					_tmp128_ = _tmp127_;
					_tmp129_ = g_utf8_strdown (_tmp128_, (gssize) -1);
					_tmp130_ = _tmp129_;
					music_smart_query_get_value (q, &_tmp131_);
					_tmp132_ = _tmp131_;
					_tmp133_ = g_value_get_string (&_tmp132_);
					_tmp134_ = g_utf8_strdown (_tmp133_, (gssize) -1);
					_tmp135_ = _tmp134_;
					_tmp136_ = string_contains (_tmp130_, _tmp135_);
					_g_free0 (_tmp135_);
					_g_free0 (_tmp130_);
					result = _tmp136_;
					return result;
				} else {
					MusicSmartQueryComparatorType _tmp137_;
					MusicSmartQueryComparatorType _tmp138_;
					_tmp137_ = music_smart_query_get_comparator (q);
					_tmp138_ = _tmp137_;
					if (_tmp138_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
						const gchar* _tmp139_;
						const gchar* _tmp140_;
						gchar* _tmp141_;
						gchar* _tmp142_;
						GValue _tmp143_ = {0};
						GValue _tmp144_;
						const gchar* _tmp145_;
						gchar* _tmp146_;
						gchar* _tmp147_;
						gboolean _tmp148_;
						_tmp139_ = music_media_get_composer (s);
						_tmp140_ = _tmp139_;
						_tmp141_ = g_utf8_strdown (_tmp140_, (gssize) -1);
						_tmp142_ = _tmp141_;
						music_smart_query_get_value (q, &_tmp143_);
						_tmp144_ = _tmp143_;
						_tmp145_ = g_value_get_string (&_tmp144_);
						_tmp146_ = g_utf8_strdown (_tmp145_, (gssize) -1);
						_tmp147_ = _tmp146_;
						_tmp148_ = !string_contains (_tmp142_, _tmp147_);
						_g_free0 (_tmp147_);
						_g_free0 (_tmp142_);
						result = _tmp148_;
						return result;
					}
				}
			}
			break;
		}
		case MUSIC_SMART_QUERY_FIELD_TYPE_COMMENT:
		{
			MusicSmartQueryComparatorType _tmp149_;
			MusicSmartQueryComparatorType _tmp150_;
			_tmp149_ = music_smart_query_get_comparator (q);
			_tmp150_ = _tmp149_;
			if (_tmp150_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS) {
				GValue _tmp151_ = {0};
				GValue _tmp152_;
				const gchar* _tmp153_;
				gchar* _tmp154_;
				gchar* _tmp155_;
				const gchar* _tmp156_;
				const gchar* _tmp157_;
				gchar* _tmp158_;
				gchar* _tmp159_;
				gboolean _tmp160_;
				music_smart_query_get_value (q, &_tmp151_);
				_tmp152_ = _tmp151_;
				_tmp153_ = g_value_get_string (&_tmp152_);
				_tmp154_ = g_utf8_strdown (_tmp153_, (gssize) -1);
				_tmp155_ = _tmp154_;
				_tmp156_ = music_media_get_comment (s);
				_tmp157_ = _tmp156_;
				_tmp158_ = g_utf8_strdown (_tmp157_, (gssize) -1);
				_tmp159_ = _tmp158_;
				_tmp160_ = g_strcmp0 (_tmp155_, _tmp159_) == 0;
				_g_free0 (_tmp159_);
				_g_free0 (_tmp155_);
				result = _tmp160_;
				return result;
			} else {
				MusicSmartQueryComparatorType _tmp161_;
				MusicSmartQueryComparatorType _tmp162_;
				_tmp161_ = music_smart_query_get_comparator (q);
				_tmp162_ = _tmp161_;
				if (_tmp162_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS) {
					const gchar* _tmp163_;
					const gchar* _tmp164_;
					gchar* _tmp165_;
					gchar* _tmp166_;
					GValue _tmp167_ = {0};
					GValue _tmp168_;
					const gchar* _tmp169_;
					gchar* _tmp170_;
					gchar* _tmp171_;
					gboolean _tmp172_;
					_tmp163_ = music_media_get_comment (s);
					_tmp164_ = _tmp163_;
					_tmp165_ = g_utf8_strdown (_tmp164_, (gssize) -1);
					_tmp166_ = _tmp165_;
					music_smart_query_get_value (q, &_tmp167_);
					_tmp168_ = _tmp167_;
					_tmp169_ = g_value_get_string (&_tmp168_);
					_tmp170_ = g_utf8_strdown (_tmp169_, (gssize) -1);
					_tmp171_ = _tmp170_;
					_tmp172_ = string_contains (_tmp166_, _tmp171_);
					_g_free0 (_tmp171_);
					_g_free0 (_tmp166_);
					result = _tmp172_;
					return result;
				} else {
					MusicSmartQueryComparatorType _tmp173_;
					MusicSmartQueryComparatorType _tmp174_;
					_tmp173_ = music_smart_query_get_comparator (q);
					_tmp174_ = _tmp173_;
					if (_tmp174_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
						const gchar* _tmp175_;
						const gchar* _tmp176_;
						gchar* _tmp177_;
						gchar* _tmp178_;
						GValue _tmp179_ = {0};
						GValue _tmp180_;
						const gchar* _tmp181_;
						gchar* _tmp182_;
						gchar* _tmp183_;
						gboolean _tmp184_;
						_tmp175_ = music_media_get_comment (s);
						_tmp176_ = _tmp175_;
						_tmp177_ = g_utf8_strdown (_tmp176_, (gssize) -1);
						_tmp178_ = _tmp177_;
						music_smart_query_get_value (q, &_tmp179_);
						_tmp180_ = _tmp179_;
						_tmp181_ = g_value_get_string (&_tmp180_);
						_tmp182_ = g_utf8_strdown (_tmp181_, (gssize) -1);
						_tmp183_ = _tmp182_;
						_tmp184_ = !string_contains (_tmp178_, _tmp183_);
						_g_free0 (_tmp183_);
						_g_free0 (_tmp178_);
						result = _tmp184_;
						return result;
					}
				}
			}
			break;
		}
		case MUSIC_SMART_QUERY_FIELD_TYPE_GENRE:
		{
			MusicSmartQueryComparatorType _tmp185_;
			MusicSmartQueryComparatorType _tmp186_;
			_tmp185_ = music_smart_query_get_comparator (q);
			_tmp186_ = _tmp185_;
			if (_tmp186_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS) {
				GValue _tmp187_ = {0};
				GValue _tmp188_;
				const gchar* _tmp189_;
				gchar* _tmp190_;
				gchar* _tmp191_;
				const gchar* _tmp192_;
				const gchar* _tmp193_;
				gchar* _tmp194_;
				gchar* _tmp195_;
				gboolean _tmp196_;
				music_smart_query_get_value (q, &_tmp187_);
				_tmp188_ = _tmp187_;
				_tmp189_ = g_value_get_string (&_tmp188_);
				_tmp190_ = g_utf8_strdown (_tmp189_, (gssize) -1);
				_tmp191_ = _tmp190_;
				_tmp192_ = music_media_get_genre (s);
				_tmp193_ = _tmp192_;
				_tmp194_ = g_utf8_strdown (_tmp193_, (gssize) -1);
				_tmp195_ = _tmp194_;
				_tmp196_ = g_strcmp0 (_tmp191_, _tmp195_) == 0;
				_g_free0 (_tmp195_);
				_g_free0 (_tmp191_);
				result = _tmp196_;
				return result;
			} else {
				MusicSmartQueryComparatorType _tmp197_;
				MusicSmartQueryComparatorType _tmp198_;
				_tmp197_ = music_smart_query_get_comparator (q);
				_tmp198_ = _tmp197_;
				if (_tmp198_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS) {
					const gchar* _tmp199_;
					const gchar* _tmp200_;
					gchar* _tmp201_;
					gchar* _tmp202_;
					GValue _tmp203_ = {0};
					GValue _tmp204_;
					const gchar* _tmp205_;
					gchar* _tmp206_;
					gchar* _tmp207_;
					gboolean _tmp208_;
					_tmp199_ = music_media_get_genre (s);
					_tmp200_ = _tmp199_;
					_tmp201_ = g_utf8_strdown (_tmp200_, (gssize) -1);
					_tmp202_ = _tmp201_;
					music_smart_query_get_value (q, &_tmp203_);
					_tmp204_ = _tmp203_;
					_tmp205_ = g_value_get_string (&_tmp204_);
					_tmp206_ = g_utf8_strdown (_tmp205_, (gssize) -1);
					_tmp207_ = _tmp206_;
					_tmp208_ = string_contains (_tmp202_, _tmp207_);
					_g_free0 (_tmp207_);
					_g_free0 (_tmp202_);
					result = _tmp208_;
					return result;
				} else {
					MusicSmartQueryComparatorType _tmp209_;
					MusicSmartQueryComparatorType _tmp210_;
					_tmp209_ = music_smart_query_get_comparator (q);
					_tmp210_ = _tmp209_;
					if (_tmp210_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
						const gchar* _tmp211_;
						const gchar* _tmp212_;
						gchar* _tmp213_;
						gchar* _tmp214_;
						GValue _tmp215_ = {0};
						GValue _tmp216_;
						const gchar* _tmp217_;
						gchar* _tmp218_;
						gchar* _tmp219_;
						gboolean _tmp220_;
						_tmp211_ = music_media_get_genre (s);
						_tmp212_ = _tmp211_;
						_tmp213_ = g_utf8_strdown (_tmp212_, (gssize) -1);
						_tmp214_ = _tmp213_;
						music_smart_query_get_value (q, &_tmp215_);
						_tmp216_ = _tmp215_;
						_tmp217_ = g_value_get_string (&_tmp216_);
						_tmp218_ = g_utf8_strdown (_tmp217_, (gssize) -1);
						_tmp219_ = _tmp218_;
						_tmp220_ = !string_contains (_tmp214_, _tmp219_);
						_g_free0 (_tmp219_);
						_g_free0 (_tmp214_);
						result = _tmp220_;
						return result;
					}
				}
			}
			break;
		}
		case MUSIC_SMART_QUERY_FIELD_TYPE_GROUPING:
		{
			MusicSmartQueryComparatorType _tmp221_;
			MusicSmartQueryComparatorType _tmp222_;
			_tmp221_ = music_smart_query_get_comparator (q);
			_tmp222_ = _tmp221_;
			if (_tmp222_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS) {
				GValue _tmp223_ = {0};
				GValue _tmp224_;
				const gchar* _tmp225_;
				gchar* _tmp226_;
				gchar* _tmp227_;
				const gchar* _tmp228_;
				const gchar* _tmp229_;
				gchar* _tmp230_;
				gchar* _tmp231_;
				gboolean _tmp232_;
				music_smart_query_get_value (q, &_tmp223_);
				_tmp224_ = _tmp223_;
				_tmp225_ = g_value_get_string (&_tmp224_);
				_tmp226_ = g_utf8_strdown (_tmp225_, (gssize) -1);
				_tmp227_ = _tmp226_;
				_tmp228_ = music_media_get_grouping (s);
				_tmp229_ = _tmp228_;
				_tmp230_ = g_utf8_strdown (_tmp229_, (gssize) -1);
				_tmp231_ = _tmp230_;
				_tmp232_ = g_strcmp0 (_tmp227_, _tmp231_) == 0;
				_g_free0 (_tmp231_);
				_g_free0 (_tmp227_);
				result = _tmp232_;
				return result;
			} else {
				MusicSmartQueryComparatorType _tmp233_;
				MusicSmartQueryComparatorType _tmp234_;
				_tmp233_ = music_smart_query_get_comparator (q);
				_tmp234_ = _tmp233_;
				if (_tmp234_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS) {
					const gchar* _tmp235_;
					const gchar* _tmp236_;
					gchar* _tmp237_;
					gchar* _tmp238_;
					GValue _tmp239_ = {0};
					GValue _tmp240_;
					const gchar* _tmp241_;
					gchar* _tmp242_;
					gchar* _tmp243_;
					gboolean _tmp244_;
					_tmp235_ = music_media_get_grouping (s);
					_tmp236_ = _tmp235_;
					_tmp237_ = g_utf8_strdown (_tmp236_, (gssize) -1);
					_tmp238_ = _tmp237_;
					music_smart_query_get_value (q, &_tmp239_);
					_tmp240_ = _tmp239_;
					_tmp241_ = g_value_get_string (&_tmp240_);
					_tmp242_ = g_utf8_strdown (_tmp241_, (gssize) -1);
					_tmp243_ = _tmp242_;
					_tmp244_ = string_contains (_tmp238_, _tmp243_);
					_g_free0 (_tmp243_);
					_g_free0 (_tmp238_);
					result = _tmp244_;
					return result;
				} else {
					MusicSmartQueryComparatorType _tmp245_;
					MusicSmartQueryComparatorType _tmp246_;
					_tmp245_ = music_smart_query_get_comparator (q);
					_tmp246_ = _tmp245_;
					if (_tmp246_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
						const gchar* _tmp247_;
						const gchar* _tmp248_;
						gchar* _tmp249_;
						gchar* _tmp250_;
						GValue _tmp251_ = {0};
						GValue _tmp252_;
						const gchar* _tmp253_;
						gchar* _tmp254_;
						gchar* _tmp255_;
						gboolean _tmp256_;
						_tmp247_ = music_media_get_grouping (s);
						_tmp248_ = _tmp247_;
						_tmp249_ = g_utf8_strdown (_tmp248_, (gssize) -1);
						_tmp250_ = _tmp249_;
						music_smart_query_get_value (q, &_tmp251_);
						_tmp252_ = _tmp251_;
						_tmp253_ = g_value_get_string (&_tmp252_);
						_tmp254_ = g_utf8_strdown (_tmp253_, (gssize) -1);
						_tmp255_ = _tmp254_;
						_tmp256_ = !string_contains (_tmp250_, _tmp255_);
						_g_free0 (_tmp255_);
						_g_free0 (_tmp250_);
						result = _tmp256_;
						return result;
					}
				}
			}
			break;
		}
		case MUSIC_SMART_QUERY_FIELD_TYPE_TITLE:
		{
			MusicSmartQueryComparatorType _tmp257_;
			MusicSmartQueryComparatorType _tmp258_;
			_tmp257_ = music_smart_query_get_comparator (q);
			_tmp258_ = _tmp257_;
			if (_tmp258_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS) {
				GValue _tmp259_ = {0};
				GValue _tmp260_;
				const gchar* _tmp261_;
				gchar* _tmp262_;
				gchar* _tmp263_;
				const gchar* _tmp264_;
				const gchar* _tmp265_;
				gchar* _tmp266_;
				gchar* _tmp267_;
				gboolean _tmp268_;
				music_smart_query_get_value (q, &_tmp259_);
				_tmp260_ = _tmp259_;
				_tmp261_ = g_value_get_string (&_tmp260_);
				_tmp262_ = g_utf8_strdown (_tmp261_, (gssize) -1);
				_tmp263_ = _tmp262_;
				_tmp264_ = music_media_get_title (s);
				_tmp265_ = _tmp264_;
				_tmp266_ = g_utf8_strdown (_tmp265_, (gssize) -1);
				_tmp267_ = _tmp266_;
				_tmp268_ = g_strcmp0 (_tmp263_, _tmp267_) == 0;
				_g_free0 (_tmp267_);
				_g_free0 (_tmp263_);
				result = _tmp268_;
				return result;
			} else {
				MusicSmartQueryComparatorType _tmp269_;
				MusicSmartQueryComparatorType _tmp270_;
				_tmp269_ = music_smart_query_get_comparator (q);
				_tmp270_ = _tmp269_;
				if (_tmp270_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_CONTAINS) {
					const gchar* _tmp271_;
					const gchar* _tmp272_;
					gchar* _tmp273_;
					gchar* _tmp274_;
					GValue _tmp275_ = {0};
					GValue _tmp276_;
					const gchar* _tmp277_;
					gchar* _tmp278_;
					gchar* _tmp279_;
					gboolean _tmp280_;
					_tmp271_ = music_media_get_title (s);
					_tmp272_ = _tmp271_;
					_tmp273_ = g_utf8_strdown (_tmp272_, (gssize) -1);
					_tmp274_ = _tmp273_;
					music_smart_query_get_value (q, &_tmp275_);
					_tmp276_ = _tmp275_;
					_tmp277_ = g_value_get_string (&_tmp276_);
					_tmp278_ = g_utf8_strdown (_tmp277_, (gssize) -1);
					_tmp279_ = _tmp278_;
					_tmp280_ = string_contains (_tmp274_, _tmp279_);
					_g_free0 (_tmp279_);
					_g_free0 (_tmp274_);
					result = _tmp280_;
					return result;
				} else {
					MusicSmartQueryComparatorType _tmp281_;
					MusicSmartQueryComparatorType _tmp282_;
					_tmp281_ = music_smart_query_get_comparator (q);
					_tmp282_ = _tmp281_;
					if (_tmp282_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_NOT_CONTAINS) {
						const gchar* _tmp283_;
						const gchar* _tmp284_;
						gchar* _tmp285_;
						gchar* _tmp286_;
						GValue _tmp287_ = {0};
						GValue _tmp288_;
						const gchar* _tmp289_;
						gchar* _tmp290_;
						gchar* _tmp291_;
						gboolean _tmp292_;
						_tmp283_ = music_media_get_title (s);
						_tmp284_ = _tmp283_;
						_tmp285_ = g_utf8_strdown (_tmp284_, (gssize) -1);
						_tmp286_ = _tmp285_;
						music_smart_query_get_value (q, &_tmp287_);
						_tmp288_ = _tmp287_;
						_tmp289_ = g_value_get_string (&_tmp288_);
						_tmp290_ = g_utf8_strdown (_tmp289_, (gssize) -1);
						_tmp291_ = _tmp290_;
						_tmp292_ = !string_contains (_tmp286_, _tmp291_);
						_g_free0 (_tmp291_);
						_g_free0 (_tmp286_);
						result = _tmp292_;
						return result;
					}
				}
			}
			break;
		}
		case MUSIC_SMART_QUERY_FIELD_TYPE_BITRATE:
		{
			MusicSmartQueryComparatorType _tmp293_;
			MusicSmartQueryComparatorType _tmp294_;
			_tmp293_ = music_smart_query_get_comparator (q);
			_tmp294_ = _tmp293_;
			if (_tmp294_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY) {
				GValue _tmp295_ = {0};
				GValue _tmp296_;
				guint _tmp297_;
				guint _tmp298_;
				music_smart_query_get_value (q, &_tmp295_);
				_tmp296_ = _tmp295_;
				_tmp297_ = music_media_get_bitrate (s);
				_tmp298_ = _tmp297_;
				result = ((guint) g_value_get_int (&_tmp296_)) == _tmp298_;
				return result;
			} else {
				MusicSmartQueryComparatorType _tmp299_;
				MusicSmartQueryComparatorType _tmp300_;
				_tmp299_ = music_smart_query_get_comparator (q);
				_tmp300_ = _tmp299_;
				if (_tmp300_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST) {
					guint _tmp301_;
					guint _tmp302_;
					GValue _tmp303_ = {0};
					GValue _tmp304_;
					_tmp301_ = music_media_get_bitrate (s);
					_tmp302_ = _tmp301_;
					music_smart_query_get_value (q, &_tmp303_);
					_tmp304_ = _tmp303_;
					result = _tmp302_ <= ((guint) g_value_get_int (&_tmp304_));
					return result;
				} else {
					MusicSmartQueryComparatorType _tmp305_;
					MusicSmartQueryComparatorType _tmp306_;
					_tmp305_ = music_smart_query_get_comparator (q);
					_tmp306_ = _tmp305_;
					if (_tmp306_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST) {
						guint _tmp307_;
						guint _tmp308_;
						GValue _tmp309_ = {0};
						GValue _tmp310_;
						_tmp307_ = music_media_get_bitrate (s);
						_tmp308_ = _tmp307_;
						music_smart_query_get_value (q, &_tmp309_);
						_tmp310_ = _tmp309_;
						result = _tmp308_ >= ((guint) g_value_get_int (&_tmp310_));
						return result;
					}
				}
			}
			break;
		}
		case MUSIC_SMART_QUERY_FIELD_TYPE_PLAYCOUNT:
		{
			MusicSmartQueryComparatorType _tmp311_;
			MusicSmartQueryComparatorType _tmp312_;
			_tmp311_ = music_smart_query_get_comparator (q);
			_tmp312_ = _tmp311_;
			if (_tmp312_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY) {
				GValue _tmp313_ = {0};
				GValue _tmp314_;
				guint _tmp315_;
				guint _tmp316_;
				music_smart_query_get_value (q, &_tmp313_);
				_tmp314_ = _tmp313_;
				_tmp315_ = music_media_get_play_count (s);
				_tmp316_ = _tmp315_;
				result = ((guint) g_value_get_int (&_tmp314_)) == _tmp316_;
				return result;
			} else {
				MusicSmartQueryComparatorType _tmp317_;
				MusicSmartQueryComparatorType _tmp318_;
				_tmp317_ = music_smart_query_get_comparator (q);
				_tmp318_ = _tmp317_;
				if (_tmp318_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST) {
					guint _tmp319_;
					guint _tmp320_;
					GValue _tmp321_ = {0};
					GValue _tmp322_;
					_tmp319_ = music_media_get_play_count (s);
					_tmp320_ = _tmp319_;
					music_smart_query_get_value (q, &_tmp321_);
					_tmp322_ = _tmp321_;
					result = _tmp320_ <= ((guint) g_value_get_int (&_tmp322_));
					return result;
				} else {
					MusicSmartQueryComparatorType _tmp323_;
					MusicSmartQueryComparatorType _tmp324_;
					_tmp323_ = music_smart_query_get_comparator (q);
					_tmp324_ = _tmp323_;
					if (_tmp324_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST) {
						guint _tmp325_;
						guint _tmp326_;
						GValue _tmp327_ = {0};
						GValue _tmp328_;
						_tmp325_ = music_media_get_play_count (s);
						_tmp326_ = _tmp325_;
						music_smart_query_get_value (q, &_tmp327_);
						_tmp328_ = _tmp327_;
						result = _tmp326_ >= ((guint) g_value_get_int (&_tmp328_));
						return result;
					}
				}
			}
			break;
		}
		case MUSIC_SMART_QUERY_FIELD_TYPE_SKIPCOUNT:
		{
			MusicSmartQueryComparatorType _tmp329_;
			MusicSmartQueryComparatorType _tmp330_;
			_tmp329_ = music_smart_query_get_comparator (q);
			_tmp330_ = _tmp329_;
			if (_tmp330_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY) {
				GValue _tmp331_ = {0};
				GValue _tmp332_;
				guint _tmp333_;
				guint _tmp334_;
				music_smart_query_get_value (q, &_tmp331_);
				_tmp332_ = _tmp331_;
				_tmp333_ = music_media_get_skip_count (s);
				_tmp334_ = _tmp333_;
				result = ((guint) g_value_get_int (&_tmp332_)) == _tmp334_;
				return result;
			} else {
				MusicSmartQueryComparatorType _tmp335_;
				MusicSmartQueryComparatorType _tmp336_;
				_tmp335_ = music_smart_query_get_comparator (q);
				_tmp336_ = _tmp335_;
				if (_tmp336_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST) {
					guint _tmp337_;
					guint _tmp338_;
					GValue _tmp339_ = {0};
					GValue _tmp340_;
					_tmp337_ = music_media_get_skip_count (s);
					_tmp338_ = _tmp337_;
					music_smart_query_get_value (q, &_tmp339_);
					_tmp340_ = _tmp339_;
					result = _tmp338_ <= ((guint) g_value_get_int (&_tmp340_));
					return result;
				} else {
					MusicSmartQueryComparatorType _tmp341_;
					MusicSmartQueryComparatorType _tmp342_;
					_tmp341_ = music_smart_query_get_comparator (q);
					_tmp342_ = _tmp341_;
					if (_tmp342_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST) {
						guint _tmp343_;
						guint _tmp344_;
						GValue _tmp345_ = {0};
						GValue _tmp346_;
						_tmp343_ = music_media_get_skip_count (s);
						_tmp344_ = _tmp343_;
						music_smart_query_get_value (q, &_tmp345_);
						_tmp346_ = _tmp345_;
						result = _tmp344_ >= ((guint) g_value_get_int (&_tmp346_));
						return result;
					}
				}
			}
			break;
		}
		case MUSIC_SMART_QUERY_FIELD_TYPE_YEAR:
		{
			MusicSmartQueryComparatorType _tmp347_;
			MusicSmartQueryComparatorType _tmp348_;
			_tmp347_ = music_smart_query_get_comparator (q);
			_tmp348_ = _tmp347_;
			if (_tmp348_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY) {
				GValue _tmp349_ = {0};
				GValue _tmp350_;
				guint _tmp351_;
				guint _tmp352_;
				music_smart_query_get_value (q, &_tmp349_);
				_tmp350_ = _tmp349_;
				_tmp351_ = music_media_get_year (s);
				_tmp352_ = _tmp351_;
				result = ((guint) g_value_get_int (&_tmp350_)) == _tmp352_;
				return result;
			} else {
				MusicSmartQueryComparatorType _tmp353_;
				MusicSmartQueryComparatorType _tmp354_;
				_tmp353_ = music_smart_query_get_comparator (q);
				_tmp354_ = _tmp353_;
				if (_tmp354_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST) {
					guint _tmp355_;
					guint _tmp356_;
					GValue _tmp357_ = {0};
					GValue _tmp358_;
					_tmp355_ = music_media_get_year (s);
					_tmp356_ = _tmp355_;
					music_smart_query_get_value (q, &_tmp357_);
					_tmp358_ = _tmp357_;
					result = _tmp356_ <= ((guint) g_value_get_int (&_tmp358_));
					return result;
				} else {
					MusicSmartQueryComparatorType _tmp359_;
					MusicSmartQueryComparatorType _tmp360_;
					_tmp359_ = music_smart_query_get_comparator (q);
					_tmp360_ = _tmp359_;
					if (_tmp360_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST) {
						guint _tmp361_;
						guint _tmp362_;
						GValue _tmp363_ = {0};
						GValue _tmp364_;
						_tmp361_ = music_media_get_year (s);
						_tmp362_ = _tmp361_;
						music_smart_query_get_value (q, &_tmp363_);
						_tmp364_ = _tmp363_;
						result = _tmp362_ >= ((guint) g_value_get_int (&_tmp364_));
						return result;
					}
				}
			}
			break;
		}
		case MUSIC_SMART_QUERY_FIELD_TYPE_LENGTH:
		{
			MusicSmartQueryComparatorType _tmp365_;
			MusicSmartQueryComparatorType _tmp366_;
			_tmp365_ = music_smart_query_get_comparator (q);
			_tmp366_ = _tmp365_;
			if (_tmp366_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY) {
				GValue _tmp367_ = {0};
				GValue _tmp368_;
				guint _tmp369_;
				guint _tmp370_;
				music_smart_query_get_value (q, &_tmp367_);
				_tmp368_ = _tmp367_;
				_tmp369_ = music_media_get_length (s);
				_tmp370_ = _tmp369_;
				result = ((guint) g_value_get_int (&_tmp368_)) == _tmp370_;
				return result;
			} else {
				MusicSmartQueryComparatorType _tmp371_;
				MusicSmartQueryComparatorType _tmp372_;
				_tmp371_ = music_smart_query_get_comparator (q);
				_tmp372_ = _tmp371_;
				if (_tmp372_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST) {
					guint _tmp373_;
					guint _tmp374_;
					GValue _tmp375_ = {0};
					GValue _tmp376_;
					_tmp373_ = music_media_get_length (s);
					_tmp374_ = _tmp373_;
					music_smart_query_get_value (q, &_tmp375_);
					_tmp376_ = _tmp375_;
					result = _tmp374_ <= ((guint) g_value_get_int (&_tmp376_));
					return result;
				} else {
					MusicSmartQueryComparatorType _tmp377_;
					MusicSmartQueryComparatorType _tmp378_;
					_tmp377_ = music_smart_query_get_comparator (q);
					_tmp378_ = _tmp377_;
					if (_tmp378_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST) {
						guint _tmp379_;
						guint _tmp380_;
						GValue _tmp381_ = {0};
						GValue _tmp382_;
						_tmp379_ = music_media_get_length (s);
						_tmp380_ = _tmp379_;
						music_smart_query_get_value (q, &_tmp381_);
						_tmp382_ = _tmp381_;
						result = _tmp380_ >= ((guint) g_value_get_int (&_tmp382_));
						return result;
					}
				}
			}
			break;
		}
		case MUSIC_SMART_QUERY_FIELD_TYPE_RATING:
		{
			MusicSmartQueryComparatorType _tmp383_;
			MusicSmartQueryComparatorType _tmp384_;
			_tmp383_ = music_smart_query_get_comparator (q);
			_tmp384_ = _tmp383_;
			if (_tmp384_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY) {
				GValue _tmp385_ = {0};
				GValue _tmp386_;
				guint _tmp387_;
				guint _tmp388_;
				music_smart_query_get_value (q, &_tmp385_);
				_tmp386_ = _tmp385_;
				_tmp387_ = music_media_get_rating (s);
				_tmp388_ = _tmp387_;
				result = ((guint) g_value_get_int (&_tmp386_)) == _tmp388_;
				return result;
			} else {
				MusicSmartQueryComparatorType _tmp389_;
				MusicSmartQueryComparatorType _tmp390_;
				_tmp389_ = music_smart_query_get_comparator (q);
				_tmp390_ = _tmp389_;
				if (_tmp390_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_MOST) {
					guint _tmp391_;
					guint _tmp392_;
					GValue _tmp393_ = {0};
					GValue _tmp394_;
					_tmp391_ = music_media_get_rating (s);
					_tmp392_ = _tmp391_;
					music_smart_query_get_value (q, &_tmp393_);
					_tmp394_ = _tmp393_;
					result = _tmp392_ <= ((guint) g_value_get_int (&_tmp394_));
					return result;
				} else {
					MusicSmartQueryComparatorType _tmp395_;
					MusicSmartQueryComparatorType _tmp396_;
					_tmp395_ = music_smart_query_get_comparator (q);
					_tmp396_ = _tmp395_;
					if (_tmp396_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_AT_LEAST) {
						guint _tmp397_;
						guint _tmp398_;
						GValue _tmp399_ = {0};
						GValue _tmp400_;
						_tmp397_ = music_media_get_rating (s);
						_tmp398_ = _tmp397_;
						music_smart_query_get_value (q, &_tmp399_);
						_tmp400_ = _tmp399_;
						result = _tmp398_ >= ((guint) g_value_get_int (&_tmp400_));
						return result;
					}
				}
			}
			break;
		}
		case MUSIC_SMART_QUERY_FIELD_TYPE_DATE_ADDED:
		{
			GDateTime* now = NULL;
			GDateTime* _tmp401_;
			GDateTime* played = NULL;
			guint _tmp402_;
			guint _tmp403_;
			GDateTime* _tmp404_;
			GDateTime* _tmp405_;
			GValue _tmp406_ = {0};
			GValue _tmp407_;
			GDateTime* _tmp408_;
			MusicSmartQueryComparatorType _tmp409_;
			MusicSmartQueryComparatorType _tmp410_;
			_tmp401_ = g_date_time_new_now_local ();
			now = _tmp401_;
			_tmp402_ = music_media_get_date_added (s);
			_tmp403_ = _tmp402_;
			_tmp404_ = g_date_time_new_from_unix_local ((gint64) _tmp403_);
			played = _tmp404_;
			_tmp405_ = played;
			music_smart_query_get_value (q, &_tmp406_);
			_tmp407_ = _tmp406_;
			_tmp408_ = g_date_time_add_days (_tmp405_, g_value_get_int (&_tmp407_));
			_g_date_time_unref0 (played);
			played = _tmp408_;
			_tmp409_ = music_smart_query_get_comparator (q);
			_tmp410_ = _tmp409_;
			if (_tmp410_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY) {
				gboolean _tmp411_ = FALSE;
				GDateTime* _tmp412_;
				GDateTime* _tmp413_;
				_tmp412_ = now;
				_tmp413_ = played;
				if (g_date_time_get_day_of_year (_tmp412_) == g_date_time_get_day_of_year (_tmp413_)) {
					GDateTime* _tmp414_;
					GDateTime* _tmp415_;
					_tmp414_ = now;
					_tmp415_ = played;
					_tmp411_ = g_date_time_get_year (_tmp414_) == g_date_time_get_year (_tmp415_);
				} else {
					_tmp411_ = FALSE;
				}
				result = _tmp411_;
				_g_date_time_unref0 (played);
				_g_date_time_unref0 (now);
				return result;
			} else {
				MusicSmartQueryComparatorType _tmp416_;
				MusicSmartQueryComparatorType _tmp417_;
				_tmp416_ = music_smart_query_get_comparator (q);
				_tmp417_ = _tmp416_;
				if (_tmp417_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_WITHIN) {
					GDateTime* _tmp418_;
					GDateTime* _tmp419_;
					_tmp418_ = played;
					_tmp419_ = now;
					result = g_date_time_compare (_tmp418_, _tmp419_) > 0;
					_g_date_time_unref0 (played);
					_g_date_time_unref0 (now);
					return result;
				} else {
					MusicSmartQueryComparatorType _tmp420_;
					MusicSmartQueryComparatorType _tmp421_;
					_tmp420_ = music_smart_query_get_comparator (q);
					_tmp421_ = _tmp420_;
					if (_tmp421_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_BEFORE) {
						GDateTime* _tmp422_;
						GDateTime* _tmp423_;
						_tmp422_ = now;
						_tmp423_ = played;
						result = g_date_time_compare (_tmp422_, _tmp423_) > 0;
						_g_date_time_unref0 (played);
						_g_date_time_unref0 (now);
						return result;
					}
				}
			}
			_g_date_time_unref0 (played);
			_g_date_time_unref0 (now);
			break;
		}
		case MUSIC_SMART_QUERY_FIELD_TYPE_LAST_PLAYED:
		{
			guint _tmp424_;
			guint _tmp425_;
			GDateTime* now = NULL;
			GDateTime* _tmp426_;
			GDateTime* played = NULL;
			guint _tmp427_;
			guint _tmp428_;
			GDateTime* _tmp429_;
			GDateTime* _tmp430_;
			GValue _tmp431_ = {0};
			GValue _tmp432_;
			GDateTime* _tmp433_;
			MusicSmartQueryComparatorType _tmp434_;
			MusicSmartQueryComparatorType _tmp435_;
			_tmp424_ = music_media_get_last_played (s);
			_tmp425_ = _tmp424_;
			if (_tmp425_ == ((guint) 0)) {
				result = FALSE;
				return result;
			}
			_tmp426_ = g_date_time_new_now_local ();
			now = _tmp426_;
			_tmp427_ = music_media_get_last_played (s);
			_tmp428_ = _tmp427_;
			_tmp429_ = g_date_time_new_from_unix_local ((gint64) _tmp428_);
			played = _tmp429_;
			_tmp430_ = played;
			music_smart_query_get_value (q, &_tmp431_);
			_tmp432_ = _tmp431_;
			_tmp433_ = g_date_time_add_days (_tmp430_, g_value_get_int (&_tmp432_));
			_g_date_time_unref0 (played);
			played = _tmp433_;
			_tmp434_ = music_smart_query_get_comparator (q);
			_tmp435_ = _tmp434_;
			if (_tmp435_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_EXACTLY) {
				gboolean _tmp436_ = FALSE;
				GDateTime* _tmp437_;
				GDateTime* _tmp438_;
				_tmp437_ = now;
				_tmp438_ = played;
				if (g_date_time_get_day_of_year (_tmp437_) == g_date_time_get_day_of_year (_tmp438_)) {
					GDateTime* _tmp439_;
					GDateTime* _tmp440_;
					_tmp439_ = now;
					_tmp440_ = played;
					_tmp436_ = g_date_time_get_year (_tmp439_) == g_date_time_get_year (_tmp440_);
				} else {
					_tmp436_ = FALSE;
				}
				result = _tmp436_;
				_g_date_time_unref0 (played);
				_g_date_time_unref0 (now);
				return result;
			} else {
				MusicSmartQueryComparatorType _tmp441_;
				MusicSmartQueryComparatorType _tmp442_;
				_tmp441_ = music_smart_query_get_comparator (q);
				_tmp442_ = _tmp441_;
				if (_tmp442_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_WITHIN) {
					GDateTime* _tmp443_;
					GDateTime* _tmp444_;
					_tmp443_ = played;
					_tmp444_ = now;
					result = g_date_time_compare (_tmp443_, _tmp444_) > 0;
					_g_date_time_unref0 (played);
					_g_date_time_unref0 (now);
					return result;
				} else {
					MusicSmartQueryComparatorType _tmp445_;
					MusicSmartQueryComparatorType _tmp446_;
					_tmp445_ = music_smart_query_get_comparator (q);
					_tmp446_ = _tmp445_;
					if (_tmp446_ == MUSIC_SMART_QUERY_COMPARATOR_TYPE_IS_BEFORE) {
						GDateTime* _tmp447_;
						GDateTime* _tmp448_;
						_tmp447_ = now;
						_tmp448_ = played;
						result = g_date_time_compare (_tmp447_, _tmp448_) > 0;
						_g_date_time_unref0 (played);
						_g_date_time_unref0 (now);
						return result;
					}
				}
			}
			_g_date_time_unref0 (played);
			_g_date_time_unref0 (now);
			break;
		}
		default:
		break;
	}
	result = FALSE;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		MusicSmartPlaylist* self;
		self = _data10_->self;
		_g_object_unref0 (_data10_->given_library);
		_g_object_unref0 (self);
		g_slice_free (Block10Data, _data10_);
	}
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
	g_atomic_int_inc (&_data11_->_ref_count_);
	return _data11_;
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
		MusicSmartPlaylist* self;
		self = _data11_->_data10_->self;
		_g_object_unref0 (_data11_->removed);
		_g_object_unref0 (_data11_->added);
		block10_data_unref (_data11_->_data10_);
		_data11_->_data10_ = NULL;
		g_slice_free (Block11Data, _data11_);
	}
}

static gboolean
__lambda11_ (Block11Data* _data11_)
{
	Block10Data* _data10_;
	MusicSmartPlaylist* self;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	gboolean result = FALSE;
	_data10_ = _data11_->_data10_;
	self = _data10_->self;
	_tmp0_ = _data11_->added;
	g_signal_emit_by_name ((MusicPlaylist*) self, "media-added", (GeeCollection*) _tmp0_);
	_tmp1_ = _data11_->removed;
	g_signal_emit_by_name ((MusicPlaylist*) self, "media-removed", (GeeCollection*) _tmp1_);
	result = FALSE;
	return result;
}

static gboolean
___lambda11__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda11_ (self);
	return result;
}

static void*
__lambda10_ (Block10Data* _data10_)
{
	MusicSmartPlaylist* self;
	Block11Data* _data11_;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	void* result = NULL;
	self = _data10_->self;
	_data11_ = g_slice_new0 (Block11Data);
	_data11_->_ref_count_ = 1;
	_data11_->_data10_ = block10_data_ref (_data10_);
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_data11_->added = _tmp0_;
	_tmp1_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_data11_->removed = _tmp1_;
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp2_;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _data10_->given_library);
		_m_it = _tmp2_;
		while (TRUE) {
			GeeIterator* _tmp3_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			MusicMedia* _tmp6_;
			gint match_count = 0;
			gboolean _tmp15_ = FALSE;
			gboolean _tmp16_ = FALSE;
			gboolean _tmp17_ = FALSE;
			MusicSmartPlaylistConditionalType _tmp18_;
			MusicSmartPlaylistConditionalType _tmp19_;
			gboolean _tmp45_ = FALSE;
			gboolean _tmp46_;
			gboolean _tmp47_;
			_tmp3_ = _m_it;
			if (!gee_iterator_next (_tmp3_)) {
				break;
			}
			_tmp4_ = _m_it;
			_tmp5_ = gee_iterator_get (_tmp4_);
			m = (MusicMedia*) _tmp5_;
			_tmp6_ = m;
			if (_tmp6_ == NULL) {
				_g_object_unref0 (m);
				continue;
			}
			match_count = 0;
			{
				GeeIterator* _q_it = NULL;
				GeeTreeSet* _tmp7_;
				GeeIterator* _tmp8_;
				_tmp7_ = self->queries;
				_tmp8_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp7_);
				_q_it = _tmp8_;
				while (TRUE) {
					GeeIterator* _tmp9_;
					MusicSmartQuery* q = NULL;
					GeeIterator* _tmp10_;
					gpointer _tmp11_;
					MusicSmartQuery* _tmp12_;
					MusicMedia* _tmp13_;
					_tmp9_ = _q_it;
					if (!gee_iterator_next (_tmp9_)) {
						break;
					}
					_tmp10_ = _q_it;
					_tmp11_ = gee_iterator_get (_tmp10_);
					q = (MusicSmartQuery*) _tmp11_;
					_tmp12_ = q;
					_tmp13_ = m;
					if (music_smart_playlist_media_matches_query (_tmp12_, _tmp13_)) {
						gint _tmp14_;
						_tmp14_ = match_count;
						match_count = _tmp14_ + 1;
					}
					_g_object_unref0 (q);
				}
				_g_object_unref0 (_q_it);
			}
			_tmp18_ = music_smart_playlist_get_conditional (self);
			_tmp19_ = _tmp18_;
			if (_tmp19_ == MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ALL) {
				GeeTreeSet* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				_tmp20_ = self->queries;
				_tmp21_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp20_);
				_tmp22_ = _tmp21_;
				_tmp17_ = match_count == _tmp22_;
			} else {
				_tmp17_ = FALSE;
			}
			if (_tmp17_) {
				_tmp16_ = TRUE;
			} else {
				gboolean _tmp23_ = FALSE;
				MusicSmartPlaylistConditionalType _tmp24_;
				MusicSmartPlaylistConditionalType _tmp25_;
				_tmp24_ = music_smart_playlist_get_conditional (self);
				_tmp25_ = _tmp24_;
				if (_tmp25_ == MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ANY) {
					_tmp23_ = match_count >= 1;
				} else {
					_tmp23_ = FALSE;
				}
				_tmp16_ = _tmp23_;
			}
			if (_tmp16_) {
				MusicMedia* _tmp26_;
				gboolean _tmp27_;
				gboolean _tmp28_;
				_tmp26_ = m;
				_tmp27_ = music_media_get_is_temporary (_tmp26_);
				_tmp28_ = _tmp27_;
				_tmp15_ = !_tmp28_;
			} else {
				_tmp15_ = FALSE;
			}
			if (_tmp15_) {
				GeeArrayList* _tmp29_;
				GeeArrayList* _tmp30_;
				MusicMedia* _tmp31_;
				_tmp29_ = music_playlist_get_medias ((MusicPlaylist*) self);
				_tmp30_ = _tmp29_;
				_tmp31_ = m;
				if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp30_, _tmp31_)) {
					GeeTreeSet* _tmp32_;
					MusicMedia* _tmp33_;
					GeeArrayList* _tmp34_;
					GeeArrayList* _tmp35_;
					MusicMedia* _tmp36_;
					_tmp32_ = _data11_->added;
					_tmp33_ = m;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, _tmp33_);
					_tmp34_ = music_playlist_get_medias ((MusicPlaylist*) self);
					_tmp35_ = _tmp34_;
					_tmp36_ = m;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp35_, _tmp36_);
				}
			} else {
				GeeArrayList* _tmp37_;
				GeeArrayList* _tmp38_;
				MusicMedia* _tmp39_;
				_tmp37_ = music_playlist_get_medias ((MusicPlaylist*) self);
				_tmp38_ = _tmp37_;
				_tmp39_ = m;
				if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp38_, _tmp39_)) {
					GeeArrayList* _tmp40_;
					GeeArrayList* _tmp41_;
					MusicMedia* _tmp42_;
					GeeTreeSet* _tmp43_;
					MusicMedia* _tmp44_;
					_tmp40_ = music_playlist_get_medias ((MusicPlaylist*) self);
					_tmp41_ = _tmp40_;
					_tmp42_ = m;
					gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp41_, _tmp42_);
					_tmp43_ = _data11_->removed;
					_tmp44_ = m;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp43_, _tmp44_);
				}
			}
			_tmp46_ = music_smart_playlist_get_limit (self);
			_tmp47_ = _tmp46_;
			if (_tmp47_) {
				guint _tmp48_;
				guint _tmp49_;
				GeeArrayList* _tmp50_;
				GeeArrayList* _tmp51_;
				gint _tmp52_;
				gint _tmp53_;
				_tmp48_ = music_smart_playlist_get_limit_amount (self);
				_tmp49_ = _tmp48_;
				_tmp50_ = music_playlist_get_medias ((MusicPlaylist*) self);
				_tmp51_ = _tmp50_;
				_tmp52_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp51_);
				_tmp53_ = _tmp52_;
				_tmp45_ = _tmp49_ <= ((guint) _tmp53_);
			} else {
				_tmp45_ = FALSE;
			}
			if (_tmp45_) {
				_g_object_unref0 (m);
				break;
			}
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda11__gsource_func, block11_data_ref (_data11_), block11_data_unref);
	result = NULL;
	block11_data_unref (_data11_);
	_data11_ = NULL;
	return result;
}

static gpointer
___lambda10__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda10_ (self);
	block10_data_unref (self);
	return result;
}

static void
music_smart_playlist_analyse_list (MusicSmartPlaylist* self,
                                   GeeCollection* given_library)
{
	Block10Data* _data10_;
	GeeCollection* _tmp0_;
	GThread* _tmp1_;
	GThread* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (given_library != NULL);
	_data10_ = g_slice_new0 (Block10Data);
	_data10_->_ref_count_ = 1;
	_data10_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (given_library);
	_g_object_unref0 (_data10_->given_library);
	_data10_->given_library = _tmp0_;
	_tmp1_ = g_thread_new (NULL, ___lambda10__gthread_func, block10_data_ref (_data10_));
	_tmp2_ = _tmp1_;
	_g_thread_unref0 (_tmp2_);
	block10_data_unref (_data10_);
	_data10_ = NULL;
}

MusicSmartPlaylistConditionalType
music_smart_playlist_get_conditional (MusicSmartPlaylist* self)
{
	MusicSmartPlaylistClass* _klass_;
	g_return_val_if_fail (self != NULL, 0);
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
	if (_klass_->get_conditional) {
		return _klass_->get_conditional (self);
	}
	return 0;
}

static MusicSmartPlaylistConditionalType
music_smart_playlist_real_get_conditional (MusicSmartPlaylist* base)
{
	MusicSmartPlaylistConditionalType result;
	MusicSmartPlaylist* self;
	MusicSmartPlaylistConditionalType _tmp0_;
	self = base;
	_tmp0_ = self->priv->_conditional;
	result = _tmp0_;
	return result;
}

void
music_smart_playlist_set_conditional (MusicSmartPlaylist* self,
                                      MusicSmartPlaylistConditionalType value)
{
	MusicSmartPlaylistClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
	if (_klass_->set_conditional) {
		_klass_->set_conditional (self, value);
	}
}

static void
music_smart_playlist_real_set_conditional (MusicSmartPlaylist* base,
                                           MusicSmartPlaylistConditionalType value)
{
	MusicSmartPlaylist* self;
	MusicSmartPlaylistConditionalType old_value;
	self = base;
	old_value = music_smart_playlist_real_get_conditional (base);
	if (old_value != value) {
		self->priv->_conditional = value;
		g_object_notify_by_pspec ((GObject *) self, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_CONDITIONAL_PROPERTY]);
	}
}

gint
music_smart_playlist_get_query_count (MusicSmartPlaylist* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_query_count;
	return result;
}

void
music_smart_playlist_set_query_count (MusicSmartPlaylist* self,
                                      gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = music_smart_playlist_get_query_count (self);
	if (old_value != value) {
		self->priv->_query_count = value;
		g_object_notify_by_pspec ((GObject *) self, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_QUERY_COUNT_PROPERTY]);
	}
}

gboolean
music_smart_playlist_get_limit (MusicSmartPlaylist* self)
{
	MusicSmartPlaylistClass* _klass_;
	g_return_val_if_fail (self != NULL, FALSE);
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
	if (_klass_->get_limit) {
		return _klass_->get_limit (self);
	}
	return FALSE;
}

static gboolean
music_smart_playlist_real_get_limit (MusicSmartPlaylist* base)
{
	gboolean result;
	MusicSmartPlaylist* self;
	self = base;
	result = self->priv->_limit;
	return result;
}

void
music_smart_playlist_set_limit (MusicSmartPlaylist* self,
                                gboolean value)
{
	MusicSmartPlaylistClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
	if (_klass_->set_limit) {
		_klass_->set_limit (self, value);
	}
}

static void
music_smart_playlist_real_set_limit (MusicSmartPlaylist* base,
                                     gboolean value)
{
	MusicSmartPlaylist* self;
	gboolean old_value;
	self = base;
	old_value = music_smart_playlist_real_get_limit (base);
	if (old_value != value) {
		self->priv->_limit = value;
		g_object_notify_by_pspec ((GObject *) self, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_LIMIT_PROPERTY]);
	}
}

guint
music_smart_playlist_get_limit_amount (MusicSmartPlaylist* self)
{
	MusicSmartPlaylistClass* _klass_;
	g_return_val_if_fail (self != NULL, 0U);
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
	if (_klass_->get_limit_amount) {
		return _klass_->get_limit_amount (self);
	}
	return 0U;
}

static guint
music_smart_playlist_real_get_limit_amount (MusicSmartPlaylist* base)
{
	guint result;
	MusicSmartPlaylist* self;
	self = base;
	result = self->priv->_limit_amount;
	return result;
}

void
music_smart_playlist_set_limit_amount (MusicSmartPlaylist* self,
                                       guint value)
{
	MusicSmartPlaylistClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = MUSIC_SMART_PLAYLIST_GET_CLASS (self);
	if (_klass_->set_limit_amount) {
		_klass_->set_limit_amount (self, value);
	}
}

static void
music_smart_playlist_real_set_limit_amount (MusicSmartPlaylist* base,
                                            guint value)
{
	MusicSmartPlaylist* self;
	guint old_value;
	self = base;
	old_value = music_smart_playlist_real_get_limit_amount (base);
	if (old_value != value) {
		self->priv->_limit_amount = value;
		g_object_notify_by_pspec ((GObject *) self, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY]);
	}
}

MusicLibrary*
music_smart_playlist_get_library (MusicSmartPlaylist* self)
{
	MusicLibrary* result;
	MusicLibrary* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_library;
	result = _tmp0_;
	return result;
}

void
music_smart_playlist_set_library (MusicSmartPlaylist* self,
                                  MusicLibrary* value)
{
	MusicLibrary* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_smart_playlist_get_library (self);
	if (old_value != value) {
		MusicLibrary* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_library);
		self->priv->_library = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_LIBRARY_PROPERTY]);
	}
}

static void
_music_smart_playlist___lambda12_ (MusicSmartPlaylist* self,
                                   GeeCollection* medias)
{
	g_return_if_fail (medias != NULL);
	music_smart_playlist_analyse_list (self, medias);
}

static void
__music_smart_playlist___lambda12__music_library_media_added (MusicLibrary* _sender,
                                                              GeeCollection* medias,
                                                              gpointer self)
{
	_music_smart_playlist___lambda12_ ((MusicSmartPlaylist*) self, medias);
}

static void
_music_smart_playlist___lambda13_ (MusicSmartPlaylist* self,
                                   GeeCollection* medias)
{
	g_return_if_fail (medias != NULL);
	music_smart_playlist_analyse_list (self, medias);
}

static void
__music_smart_playlist___lambda13__music_library_media_updated (MusicLibrary* _sender,
                                                                GeeCollection* medias,
                                                                gpointer self)
{
	_music_smart_playlist___lambda13_ ((MusicSmartPlaylist*) self, medias);
}

static void
_music_smart_playlist___lambda14_ (MusicSmartPlaylist* self,
                                   GeeCollection* medias)
{
	GeeLinkedList* removed = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp13_;
	g_return_if_fail (medias != NULL);
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	removed = _tmp0_;
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp1_;
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) medias);
		_m_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeArrayList* _tmp5_;
			GeeArrayList* _tmp6_;
			MusicMedia* _tmp7_;
			_tmp2_ = _m_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _m_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			m = (MusicMedia*) _tmp4_;
			_tmp5_ = music_playlist_get_medias ((MusicPlaylist*) self);
			_tmp6_ = _tmp5_;
			_tmp7_ = m;
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp6_, _tmp7_)) {
				GeeArrayList* _tmp8_;
				GeeArrayList* _tmp9_;
				MusicMedia* _tmp10_;
				GeeLinkedList* _tmp11_;
				MusicMedia* _tmp12_;
				_tmp8_ = music_playlist_get_medias ((MusicPlaylist*) self);
				_tmp9_ = _tmp8_;
				_tmp10_ = m;
				gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp9_, _tmp10_);
				_tmp11_ = removed;
				_tmp12_ = m;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
			}
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	_tmp13_ = removed;
	g_signal_emit_by_name ((MusicPlaylist*) self, "media-removed", (GeeCollection*) _tmp13_);
	_g_object_unref0 (removed);
}

static void
__music_smart_playlist___lambda14__music_library_media_removed (MusicLibrary* _sender,
                                                                GeeCollection* medias,
                                                                gpointer self)
{
	_music_smart_playlist___lambda14_ ((MusicSmartPlaylist*) self, medias);
}

static GObject *
music_smart_playlist_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicSmartPlaylist * self;
	GThemedIcon* _tmp0_;
	GeeTreeSet* _tmp1_;
	MusicLibrary* _tmp2_;
	MusicLibrary* _tmp3_;
	MusicLibrary* _tmp4_;
	parent_class = G_OBJECT_CLASS (music_smart_playlist_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist);
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("playlist-automatic");
	_g_object_unref0 (((MusicPlaylist*) self)->icon);
	((MusicPlaylist*) self)->icon = (GIcon*) _tmp0_;
	_tmp1_ = gee_tree_set_new (MUSIC_TYPE_SMART_QUERY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->queries);
	self->queries = _tmp1_;
	_tmp2_ = self->priv->_library;
	g_signal_connect_object (_tmp2_, "media-added", (GCallback) __music_smart_playlist___lambda12__music_library_media_added, self, 0);
	_tmp3_ = self->priv->_library;
	g_signal_connect_object (_tmp3_, "media-updated", (GCallback) __music_smart_playlist___lambda13__music_library_media_updated, self, 0);
	_tmp4_ = self->priv->_library;
	g_signal_connect_object (_tmp4_, "media-removed", (GCallback) __music_smart_playlist___lambda14__music_library_media_removed, self, 0);
	return obj;
}

static void
music_smart_playlist_class_init (MusicSmartPlaylistClass * klass,
                                 gpointer klass_data)
{
	music_smart_playlist_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicSmartPlaylist_private_offset);
	((MusicPlaylistClass *) klass)->add_media = (void (*) (MusicPlaylist*, MusicMedia*)) music_smart_playlist_real_add_media;
	((MusicPlaylistClass *) klass)->add_medias = (void (*) (MusicPlaylist*, GeeCollection*)) music_smart_playlist_real_add_medias;
	((MusicPlaylistClass *) klass)->remove_media = (void (*) (MusicPlaylist*, MusicMedia*)) music_smart_playlist_real_remove_media;
	((MusicPlaylistClass *) klass)->remove_medias = (void (*) (MusicPlaylist*, GeeCollection*)) music_smart_playlist_real_remove_medias;
	((MusicSmartPlaylistClass *) klass)->analyse_all = (void (*) (MusicSmartPlaylist*)) music_smart_playlist_real_analyse_all;
	((MusicSmartPlaylistClass *) klass)->clear_queries = (void (*) (MusicSmartPlaylist*)) music_smart_playlist_real_clear_queries;
	((MusicSmartPlaylistClass *) klass)->get_queries = (GeeCollection* (*) (MusicSmartPlaylist*)) music_smart_playlist_real_get_queries;
	((MusicSmartPlaylistClass *) klass)->add_query = (void (*) (MusicSmartPlaylist*, MusicSmartQuery*)) music_smart_playlist_real_add_query;
	((MusicSmartPlaylistClass *) klass)->add_queries = (void (*) (MusicSmartPlaylist*, GeeCollection*)) music_smart_playlist_real_add_queries;
	((MusicPlaylistClass *) klass)->clear = (void (*) (MusicPlaylist*)) music_smart_playlist_real_clear;
	MUSIC_SMART_PLAYLIST_CLASS (klass)->get_conditional = music_smart_playlist_real_get_conditional;
	MUSIC_SMART_PLAYLIST_CLASS (klass)->set_conditional = music_smart_playlist_real_set_conditional;
	MUSIC_SMART_PLAYLIST_CLASS (klass)->get_limit = music_smart_playlist_real_get_limit;
	MUSIC_SMART_PLAYLIST_CLASS (klass)->set_limit = music_smart_playlist_real_set_limit;
	MUSIC_SMART_PLAYLIST_CLASS (klass)->get_limit_amount = music_smart_playlist_real_get_limit_amount;
	MUSIC_SMART_PLAYLIST_CLASS (klass)->set_limit_amount = music_smart_playlist_real_set_limit_amount;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_smart_playlist_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_smart_playlist_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_smart_playlist_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_smart_playlist_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SMART_PLAYLIST_CONDITIONAL_PROPERTY, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_CONDITIONAL_PROPERTY] = g_param_spec_enum ("conditional", "conditional", "conditional", MUSIC_SMART_PLAYLIST_TYPE_CONDITIONAL_TYPE, MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ALL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SMART_PLAYLIST_QUERY_COUNT_PROPERTY, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_QUERY_COUNT_PROPERTY] = g_param_spec_int ("query-count", "query-count", "query-count", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SMART_PLAYLIST_LIMIT_PROPERTY, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_LIMIT_PROPERTY] = g_param_spec_boolean ("limit", "limit", "limit", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY] = g_param_spec_uint ("limit-amount", "limit-amount", "limit-amount", 0, G_MAXUINT, (guint) 50, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_SMART_PLAYLIST_LIBRARY_PROPERTY, music_smart_playlist_properties[MUSIC_SMART_PLAYLIST_LIBRARY_PROPERTY] = g_param_spec_object ("library", "library", "library", MUSIC_TYPE_LIBRARY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
}

static void
music_smart_playlist_instance_init (MusicSmartPlaylist * self,
                                    gpointer klass)
{
	self->priv = music_smart_playlist_get_instance_private (self);
	self->priv->_conditional = MUSIC_SMART_PLAYLIST_CONDITIONAL_TYPE_ALL;
	self->priv->_query_count = 0;
	self->priv->_limit = FALSE;
	self->priv->_limit_amount = (guint) 50;
}

static void
music_smart_playlist_finalize (GObject * obj)
{
	MusicSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist);
	_g_object_unref0 (self->queries);
	_g_object_unref0 (self->priv->_library);
	G_OBJECT_CLASS (music_smart_playlist_parent_class)->finalize (obj);
}

static GType
music_smart_playlist_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicSmartPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_smart_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicSmartPlaylist), 0, (GInstanceInitFunc) music_smart_playlist_instance_init, NULL };
	GType music_smart_playlist_type_id;
	music_smart_playlist_type_id = g_type_register_static (MUSIC_TYPE_PLAYLIST, "MusicSmartPlaylist", &g_define_type_info, 0);
	MusicSmartPlaylist_private_offset = g_type_add_instance_private (music_smart_playlist_type_id, sizeof (MusicSmartPlaylistPrivate));
	return music_smart_playlist_type_id;
}

GType
music_smart_playlist_get_type (void)
{
	static volatile gsize music_smart_playlist_type_id__volatile = 0;
	if (g_once_init_enter (&music_smart_playlist_type_id__volatile)) {
		GType music_smart_playlist_type_id;
		music_smart_playlist_type_id = music_smart_playlist_get_type_once ();
		g_once_init_leave (&music_smart_playlist_type_id__volatile, music_smart_playlist_type_id);
	}
	return music_smart_playlist_type_id__volatile;
}

static void
_vala_music_smart_playlist_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	MusicSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist);
	switch (property_id) {
		case MUSIC_SMART_PLAYLIST_CONDITIONAL_PROPERTY:
		g_value_set_enum (value, music_smart_playlist_get_conditional (self));
		break;
		case MUSIC_SMART_PLAYLIST_QUERY_COUNT_PROPERTY:
		g_value_set_int (value, music_smart_playlist_get_query_count (self));
		break;
		case MUSIC_SMART_PLAYLIST_LIMIT_PROPERTY:
		g_value_set_boolean (value, music_smart_playlist_get_limit (self));
		break;
		case MUSIC_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY:
		g_value_set_uint (value, music_smart_playlist_get_limit_amount (self));
		break;
		case MUSIC_SMART_PLAYLIST_LIBRARY_PROPERTY:
		g_value_set_object (value, music_smart_playlist_get_library (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_smart_playlist_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	MusicSmartPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_SMART_PLAYLIST, MusicSmartPlaylist);
	switch (property_id) {
		case MUSIC_SMART_PLAYLIST_CONDITIONAL_PROPERTY:
		music_smart_playlist_set_conditional (self, g_value_get_enum (value));
		break;
		case MUSIC_SMART_PLAYLIST_QUERY_COUNT_PROPERTY:
		music_smart_playlist_set_query_count (self, g_value_get_int (value));
		break;
		case MUSIC_SMART_PLAYLIST_LIMIT_PROPERTY:
		music_smart_playlist_set_limit (self, g_value_get_boolean (value));
		break;
		case MUSIC_SMART_PLAYLIST_LIMIT_AMOUNT_PROPERTY:
		music_smart_playlist_set_limit_amount (self, g_value_get_uint (value));
		break;
		case MUSIC_SMART_PLAYLIST_LIBRARY_PROPERTY:
		music_smart_playlist_set_library (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

