/* StaticPlaylist.c generated by valac 0.52.4, the Vala compiler
 * generated from StaticPlaylist.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

enum  {
	MUSIC_STATIC_PLAYLIST_0_PROPERTY,
	MUSIC_STATIC_PLAYLIST_READ_ONLY_PROPERTY,
	MUSIC_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY,
	MUSIC_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY,
	MUSIC_STATIC_PLAYLIST_NUM_PROPERTIES
};
static GParamSpec* music_static_playlist_properties[MUSIC_STATIC_PLAYLIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _MusicStaticPlaylistPrivate {
	gboolean _read_only;
	gboolean _show_badge;
	gboolean _allow_duplicate;
};

static gint MusicStaticPlaylist_private_offset;
static gpointer music_static_playlist_parent_class = NULL;

static void music_static_playlist_real_add_media (MusicPlaylist* base,
                                           MusicMedia* m);
static void music_static_playlist_real_add_medias (MusicPlaylist* base,
                                            GeeCollection* to_add);
static void music_static_playlist_real_remove_media (MusicPlaylist* base,
                                              MusicMedia* to_remove);
static void music_static_playlist_real_remove_medias (MusicPlaylist* base,
                                               GeeCollection* to_remove);
static void music_static_playlist_real_clear (MusicPlaylist* base);
static GObject * music_static_playlist_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void music_static_playlist_finalize (GObject * obj);
static GType music_static_playlist_get_type_once (void);
static void _vala_music_static_playlist_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_music_static_playlist_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

static inline gpointer
music_static_playlist_get_instance_private (MusicStaticPlaylist* self)
{
	return G_STRUCT_MEMBER_P (self, MusicStaticPlaylist_private_offset);
}

MusicStaticPlaylist*
music_static_playlist_construct_with_info (GType object_type,
                                           gint rowid,
                                           const gchar* name)
{
	MusicStaticPlaylist * self = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	self = (MusicStaticPlaylist*) g_object_new (object_type, "rowid", rowid, "name", name, NULL);
	return self;
}

MusicStaticPlaylist*
music_static_playlist_new_with_info (gint rowid,
                                     const gchar* name)
{
	return music_static_playlist_construct_with_info (MUSIC_TYPE_STATIC_PLAYLIST, rowid, name);
}

static void
music_static_playlist_real_add_media (MusicPlaylist* base,
                                      MusicMedia* m)
{
	MusicStaticPlaylist * self;
	GeeLinkedList* added_media = NULL;
	GeeLinkedList* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	self = (MusicStaticPlaylist*) base;
	g_return_if_fail (m != NULL);
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	added_media = _tmp0_;
	_tmp2_ = self->priv->_allow_duplicate;
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		GeeArrayList* _tmp3_;
		GeeArrayList* _tmp4_;
		_tmp3_ = music_playlist_get_medias ((MusicPlaylist*) self);
		_tmp4_ = _tmp3_;
		_tmp1_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp4_, m) == FALSE;
	}
	if (_tmp1_) {
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeLinkedList* _tmp7_;
		GeeLinkedList* _tmp8_;
		_tmp5_ = music_playlist_get_medias ((MusicPlaylist*) self);
		_tmp6_ = _tmp5_;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, m);
		_tmp7_ = added_media;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, m);
		_tmp8_ = added_media;
		g_signal_emit_by_name ((MusicPlaylist*) self, "media-added", (GeeCollection*) _tmp8_);
	}
	g_signal_emit_by_name ((MusicPlaylist*) self, "updated", NULL);
	_g_object_unref0 (added_media);
}

static void
music_static_playlist_real_add_medias (MusicPlaylist* base,
                                       GeeCollection* to_add)
{
	MusicStaticPlaylist * self;
	GeeLinkedList* added_media = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp15_;
	self = (MusicStaticPlaylist*) base;
	g_return_if_fail (to_add != NULL);
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	added_media = _tmp0_;
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp1_;
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) to_add);
		_m_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_;
			_tmp2_ = _m_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _m_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			m = (MusicMedia*) _tmp4_;
			_tmp6_ = self->priv->_allow_duplicate;
			if (_tmp6_) {
				_tmp5_ = TRUE;
			} else {
				GeeArrayList* _tmp7_;
				GeeArrayList* _tmp8_;
				MusicMedia* _tmp9_;
				_tmp7_ = music_playlist_get_medias ((MusicPlaylist*) self);
				_tmp8_ = _tmp7_;
				_tmp9_ = m;
				_tmp5_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp8_, _tmp9_) == FALSE;
			}
			if (_tmp5_) {
				GeeArrayList* _tmp10_;
				GeeArrayList* _tmp11_;
				MusicMedia* _tmp12_;
				GeeLinkedList* _tmp13_;
				MusicMedia* _tmp14_;
				_tmp10_ = music_playlist_get_medias ((MusicPlaylist*) self);
				_tmp11_ = _tmp10_;
				_tmp12_ = m;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
				_tmp13_ = added_media;
				_tmp14_ = m;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
			}
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	g_signal_emit_by_name ((MusicPlaylist*) self, "updated", NULL);
	_tmp15_ = added_media;
	g_signal_emit_by_name ((MusicPlaylist*) self, "media-added", (GeeCollection*) _tmp15_);
	_g_object_unref0 (added_media);
}

static void
music_static_playlist_real_remove_media (MusicPlaylist* base,
                                         MusicMedia* to_remove)
{
	MusicStaticPlaylist * self;
	gboolean _tmp0_ = FALSE;
	self = (MusicStaticPlaylist*) base;
	g_return_if_fail (to_remove != NULL);
	if (to_remove != NULL) {
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
		_tmp1_ = music_playlist_get_medias ((MusicPlaylist*) self);
		_tmp2_ = _tmp1_;
		_tmp0_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp2_, to_remove);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GeeLinkedList* removed_media = NULL;
		GeeLinkedList* _tmp3_;
		GeeLinkedList* _tmp4_;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeLinkedList* _tmp7_;
		_tmp3_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
		removed_media = _tmp3_;
		_tmp4_ = removed_media;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, to_remove);
		_tmp5_ = music_playlist_get_medias ((MusicPlaylist*) self);
		_tmp6_ = _tmp5_;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp6_, to_remove);
		_tmp7_ = removed_media;
		g_signal_emit_by_name ((MusicPlaylist*) self, "media-removed", (GeeCollection*) _tmp7_);
		_g_object_unref0 (removed_media);
	}
	g_signal_emit_by_name ((MusicPlaylist*) self, "updated", NULL);
}

static void
music_static_playlist_real_remove_medias (MusicPlaylist* base,
                                          GeeCollection* to_remove)
{
	MusicStaticPlaylist * self;
	GeeLinkedList* removed_media = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp15_;
	self = (MusicStaticPlaylist*) base;
	g_return_if_fail (to_remove != NULL);
	_tmp0_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	removed_media = _tmp0_;
	{
		GeeIterator* _m_it = NULL;
		GeeIterator* _tmp1_;
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) to_remove);
		_m_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			MusicMedia* m = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			gboolean _tmp5_ = FALSE;
			MusicMedia* _tmp6_;
			_tmp2_ = _m_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _m_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			m = (MusicMedia*) _tmp4_;
			_tmp6_ = m;
			if (_tmp6_ != NULL) {
				GeeArrayList* _tmp7_;
				GeeArrayList* _tmp8_;
				MusicMedia* _tmp9_;
				_tmp7_ = music_playlist_get_medias ((MusicPlaylist*) self);
				_tmp8_ = _tmp7_;
				_tmp9_ = m;
				_tmp5_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp8_, _tmp9_);
			} else {
				_tmp5_ = FALSE;
			}
			if (_tmp5_) {
				GeeLinkedList* _tmp10_;
				MusicMedia* _tmp11_;
				GeeArrayList* _tmp12_;
				GeeArrayList* _tmp13_;
				MusicMedia* _tmp14_;
				_tmp10_ = removed_media;
				_tmp11_ = m;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
				_tmp12_ = music_playlist_get_medias ((MusicPlaylist*) self);
				_tmp13_ = _tmp12_;
				_tmp14_ = m;
				gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp13_, _tmp14_);
			}
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	g_signal_emit_by_name ((MusicPlaylist*) self, "updated", NULL);
	_tmp15_ = removed_media;
	g_signal_emit_by_name ((MusicPlaylist*) self, "media-removed", (GeeCollection*) _tmp15_);
	_g_object_unref0 (removed_media);
}

static void
music_static_playlist_real_clear (MusicPlaylist* base)
{
	MusicStaticPlaylist * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	self = (MusicStaticPlaylist*) base;
	_tmp0_ = music_playlist_get_medias ((MusicPlaylist*) self);
	_tmp1_ = _tmp0_;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
	g_signal_emit_by_name ((MusicPlaylist*) self, "cleared");
	g_signal_emit_by_name ((MusicPlaylist*) self, "updated", NULL);
}

MusicStaticPlaylist*
music_static_playlist_construct (GType object_type)
{
	MusicStaticPlaylist * self = NULL;
	self = (MusicStaticPlaylist*) music_playlist_construct (object_type);
	return self;
}

MusicStaticPlaylist*
music_static_playlist_new (void)
{
	return music_static_playlist_construct (MUSIC_TYPE_STATIC_PLAYLIST);
}

gboolean
music_static_playlist_get_read_only (MusicStaticPlaylist* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_read_only;
	return result;
}

void
music_static_playlist_set_read_only (MusicStaticPlaylist* self,
                                     gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = music_static_playlist_get_read_only (self);
	if (old_value != value) {
		self->priv->_read_only = value;
		g_object_notify_by_pspec ((GObject *) self, music_static_playlist_properties[MUSIC_STATIC_PLAYLIST_READ_ONLY_PROPERTY]);
	}
}

gboolean
music_static_playlist_get_show_badge (MusicStaticPlaylist* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_badge;
	return result;
}

void
music_static_playlist_set_show_badge (MusicStaticPlaylist* self,
                                      gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = music_static_playlist_get_show_badge (self);
	if (old_value != value) {
		self->priv->_show_badge = value;
		g_object_notify_by_pspec ((GObject *) self, music_static_playlist_properties[MUSIC_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY]);
	}
}

gboolean
music_static_playlist_get_allow_duplicate (MusicStaticPlaylist* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_allow_duplicate;
	return result;
}

void
music_static_playlist_set_allow_duplicate (MusicStaticPlaylist* self,
                                           gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = music_static_playlist_get_allow_duplicate (self);
	if (old_value != value) {
		self->priv->_allow_duplicate = value;
		g_object_notify_by_pspec ((GObject *) self, music_static_playlist_properties[MUSIC_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY]);
	}
}

static GObject *
music_static_playlist_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicStaticPlaylist * self;
	GThemedIcon* _tmp0_;
	parent_class = G_OBJECT_CLASS (music_static_playlist_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist);
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("playlist");
	_g_object_unref0 (((MusicPlaylist*) self)->icon);
	((MusicPlaylist*) self)->icon = (GIcon*) _tmp0_;
	return obj;
}

static void
music_static_playlist_class_init (MusicStaticPlaylistClass * klass,
                                  gpointer klass_data)
{
	music_static_playlist_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicStaticPlaylist_private_offset);
	((MusicPlaylistClass *) klass)->add_media = (void (*) (MusicPlaylist*, MusicMedia*)) music_static_playlist_real_add_media;
	((MusicPlaylistClass *) klass)->add_medias = (void (*) (MusicPlaylist*, GeeCollection*)) music_static_playlist_real_add_medias;
	((MusicPlaylistClass *) klass)->remove_media = (void (*) (MusicPlaylist*, MusicMedia*)) music_static_playlist_real_remove_media;
	((MusicPlaylistClass *) klass)->remove_medias = (void (*) (MusicPlaylist*, GeeCollection*)) music_static_playlist_real_remove_medias;
	((MusicPlaylistClass *) klass)->clear = (void (*) (MusicPlaylist*)) music_static_playlist_real_clear;
	G_OBJECT_CLASS (klass)->get_property = _vala_music_static_playlist_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_static_playlist_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_static_playlist_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_static_playlist_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_STATIC_PLAYLIST_READ_ONLY_PROPERTY, music_static_playlist_properties[MUSIC_STATIC_PLAYLIST_READ_ONLY_PROPERTY] = g_param_spec_boolean ("read-only", "read-only", "read-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY, music_static_playlist_properties[MUSIC_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY] = g_param_spec_boolean ("show-badge", "show-badge", "show-badge", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY, music_static_playlist_properties[MUSIC_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY] = g_param_spec_boolean ("allow-duplicate", "allow-duplicate", "allow-duplicate", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
music_static_playlist_instance_init (MusicStaticPlaylist * self,
                                     gpointer klass)
{
	self->priv = music_static_playlist_get_instance_private (self);
	self->priv->_read_only = FALSE;
	self->priv->_show_badge = FALSE;
	self->priv->_allow_duplicate = FALSE;
}

static void
music_static_playlist_finalize (GObject * obj)
{
	MusicStaticPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist);
	G_OBJECT_CLASS (music_static_playlist_parent_class)->finalize (obj);
}

static GType
music_static_playlist_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicStaticPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_static_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicStaticPlaylist), 0, (GInstanceInitFunc) music_static_playlist_instance_init, NULL };
	GType music_static_playlist_type_id;
	music_static_playlist_type_id = g_type_register_static (MUSIC_TYPE_PLAYLIST, "MusicStaticPlaylist", &g_define_type_info, 0);
	MusicStaticPlaylist_private_offset = g_type_add_instance_private (music_static_playlist_type_id, sizeof (MusicStaticPlaylistPrivate));
	return music_static_playlist_type_id;
}

GType
music_static_playlist_get_type (void)
{
	static volatile gsize music_static_playlist_type_id__volatile = 0;
	if (g_once_init_enter (&music_static_playlist_type_id__volatile)) {
		GType music_static_playlist_type_id;
		music_static_playlist_type_id = music_static_playlist_get_type_once ();
		g_once_init_leave (&music_static_playlist_type_id__volatile, music_static_playlist_type_id);
	}
	return music_static_playlist_type_id__volatile;
}

static void
_vala_music_static_playlist_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	MusicStaticPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist);
	switch (property_id) {
		case MUSIC_STATIC_PLAYLIST_READ_ONLY_PROPERTY:
		g_value_set_boolean (value, music_static_playlist_get_read_only (self));
		break;
		case MUSIC_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY:
		g_value_set_boolean (value, music_static_playlist_get_show_badge (self));
		break;
		case MUSIC_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY:
		g_value_set_boolean (value, music_static_playlist_get_allow_duplicate (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_static_playlist_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	MusicStaticPlaylist * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_STATIC_PLAYLIST, MusicStaticPlaylist);
	switch (property_id) {
		case MUSIC_STATIC_PLAYLIST_READ_ONLY_PROPERTY:
		music_static_playlist_set_read_only (self, g_value_get_boolean (value));
		break;
		case MUSIC_STATIC_PLAYLIST_SHOW_BADGE_PROPERTY:
		music_static_playlist_set_show_badge (self, g_value_get_boolean (value));
		break;
		case MUSIC_STATIC_PLAYLIST_ALLOW_DUPLICATE_PROPERTY:
		music_static_playlist_set_allow_duplicate (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

