/* PluginManager.c generated by valac 0.52.4, the Vala compiler
 * generated from PluginManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Zeeshan Ali (Khattak) <zeeshanak@gnome.org> (from Rygel)
 *              Lucas Baudin <xapantu@gmail.com> (from Pantheon Files)
 *              Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <libpeas/peas.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gtk/gtk.h>
#include <libpeas-gtk/peas-gtk.h>

enum  {
	MUSIC_PLUGINS_MANAGER_0_PROPERTY,
	MUSIC_PLUGINS_MANAGER_TOOLBAR_PROPERTY,
	MUSIC_PLUGINS_MANAGER_NOISE_APP_PROPERTY,
	MUSIC_PLUGINS_MANAGER_PLUGIN_IFACE_PROPERTY,
	MUSIC_PLUGINS_MANAGER_CONTEXT_PROPERTY,
	MUSIC_PLUGINS_MANAGER_SIDEBAR_PROPERTY,
	MUSIC_PLUGINS_MANAGER_NUM_PROPERTIES
};
static GParamSpec* music_plugins_manager_properties[MUSIC_PLUGINS_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_PeasPluginInfo_free0(var) ((var == NULL) ? NULL : (var = (_vala_PeasPluginInfo_free (var), NULL)))
enum  {
	MUSIC_PLUGINS_MANAGER_HOOK_MAIN_MENU_SIGNAL,
	MUSIC_PLUGINS_MANAGER_HOOK_TOOLBAR_SIGNAL,
	MUSIC_PLUGINS_MANAGER_HOOK_SET_ARG_SIGNAL,
	MUSIC_PLUGINS_MANAGER_HOOK_NOTEBOOK_BOTTOM_SIGNAL,
	MUSIC_PLUGINS_MANAGER_HOOK_SOURCE_VIEW_SIGNAL,
	MUSIC_PLUGINS_MANAGER_HOOK_NEW_WINDOW_SIGNAL,
	MUSIC_PLUGINS_MANAGER_HOOK_PREFERENCES_WINDOW_SIGNAL,
	MUSIC_PLUGINS_MANAGER_HOOK_TOOLBAR_CONTEXT_MENU_SIGNAL,
	MUSIC_PLUGINS_MANAGER_HOOK_NOTEBOOK_CONTEXT_SIGNAL,
	MUSIC_PLUGINS_MANAGER_HOOK_NOTEBOOK_SIDEBAR_SIGNAL,
	MUSIC_PLUGINS_MANAGER_HOOK_ADDONS_MENU_SIGNAL,
	MUSIC_PLUGINS_MANAGER_NUM_SIGNALS
};
static guint music_plugins_manager_signals[MUSIC_PLUGINS_MANAGER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MusicPluginsManagerPrivate {
	PeasEngine* engine;
	PeasExtensionSet* exts;
	MusicPluginsInterface* _plugin_iface;
};

static gint MusicPluginsManager_private_offset;
static gpointer music_plugins_manager_parent_class = NULL;
static MusicPluginsManager* music_plugins_manager_plugin_manager;
static MusicPluginsManager* music_plugins_manager_plugin_manager = NULL;

static MusicPluginsManager* music_plugins_manager_new (void);
static MusicPluginsManager* music_plugins_manager_construct (GType object_type);
static void music_plugins_manager_set_plugin_iface (MusicPluginsManager* self,
                                             MusicPluginsInterface* value);
void music_plugins_interface_set_set_name (MusicPluginsInterface* self,
                                           const gchar* value);
static PeasPluginInfo* _vala_PeasPluginInfo_copy (PeasPluginInfo* self);
static void _vala_PeasPluginInfo_free (PeasPluginInfo* self);
static void __lambda16_ (MusicPluginsManager* self,
                  PeasPluginInfo* info,
                  GObject* ext);
static void ___lambda16__peas_extension_set_extension_added (PeasExtensionSet* _sender,
                                                      PeasPluginInfo* info,
                                                      GObject* exten,
                                                      gpointer self);
static void music_plugins_manager_on_extension_removed (MusicPluginsManager* self,
                                                 PeasPluginInfo* info,
                                                 GObject* extension);
static void _music_plugins_manager_on_extension_removed_peas_extension_set_extension_removed (PeasExtensionSet* _sender,
                                                                                       PeasPluginInfo* info,
                                                                                       GObject* exten,
                                                                                       gpointer self);
static void music_plugins_manager_on_extension_added (MusicPluginsManager* self,
                                               PeasExtensionSet* set,
                                               PeasPluginInfo* info,
                                               PeasExtension* extension);
static void _music_plugins_manager_on_extension_added_peas_extension_set_foreach_func (PeasExtensionSet* set,
                                                                                PeasPluginInfo* info,
                                                                                PeasExtension* exten,
                                                                                gpointer self);
static void g_parameter_destroy (GParameter * self);
void music_plugins_interface_set_noise_app (MusicPluginsInterface* self,
                                            GtkApplication* value);
void music_plugins_interface_set_toolbar (MusicPluginsInterface* self,
                                          GtkToolbar* value);
void music_plugins_interface_set_context (MusicPluginsInterface* self,
                                          GtkNotebook* value);
void music_plugins_interface_set_sidebar (MusicPluginsInterface* self,
                                          GtkNotebook* value);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void music_plugins_manager_finalize (GObject * obj);
static GType music_plugins_manager_get_type_once (void);
static void _vala_music_plugins_manager_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_music_plugins_manager_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

static inline gpointer
music_plugins_manager_get_instance_private (MusicPluginsManager* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsManager_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

MusicPluginsManager*
music_plugins_manager_get_default (void)
{
	MusicPluginsManager* _tmp0_;
	MusicPluginsManager* _tmp2_;
	MusicPluginsManager* _tmp3_;
	MusicPluginsManager* result = NULL;
	_tmp0_ = music_plugins_manager_plugin_manager;
	if (_tmp0_ == NULL) {
		MusicPluginsManager* _tmp1_;
		_tmp1_ = music_plugins_manager_new ();
		_g_object_unref0 (music_plugins_manager_plugin_manager);
		music_plugins_manager_plugin_manager = _tmp1_;
	}
	_tmp2_ = music_plugins_manager_plugin_manager;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	result = _tmp3_;
	return result;
}

static PeasPluginInfo*
_vala_PeasPluginInfo_copy (PeasPluginInfo* self)
{
	return g_boxed_copy (peas_plugin_info_get_type (), self);
}

static gpointer
__vala_PeasPluginInfo_copy0 (gpointer self)
{
	return self ? _vala_PeasPluginInfo_copy (self) : NULL;
}

static void
_vala_PeasPluginInfo_free (PeasPluginInfo* self)
{
	g_boxed_free (peas_plugin_info_get_type (), self);
}

static void
__lambda16_ (MusicPluginsManager* self,
             PeasPluginInfo* info,
             GObject* ext)
{
	g_return_if_fail (info != NULL);
	g_return_if_fail (ext != NULL);
	peas_activatable_activate (G_TYPE_CHECK_INSTANCE_CAST (ext, peas_activatable_get_type (), PeasActivatable));
}

static void
___lambda16__peas_extension_set_extension_added (PeasExtensionSet* _sender,
                                                 PeasPluginInfo* info,
                                                 GObject* exten,
                                                 gpointer self)
{
	__lambda16_ ((MusicPluginsManager*) self, info, exten);
}

static void
_music_plugins_manager_on_extension_removed_peas_extension_set_extension_removed (PeasExtensionSet* _sender,
                                                                                  PeasPluginInfo* info,
                                                                                  GObject* exten,
                                                                                  gpointer self)
{
	music_plugins_manager_on_extension_removed ((MusicPluginsManager*) self, info, exten);
}

static void
_music_plugins_manager_on_extension_added_peas_extension_set_foreach_func (PeasExtensionSet* set,
                                                                           PeasPluginInfo* info,
                                                                           PeasExtension* exten,
                                                                           gpointer self)
{
	music_plugins_manager_on_extension_added ((MusicPluginsManager*) self, set, info, exten);
}

static void
g_parameter_destroy (GParameter * self)
{
	G_IS_VALUE (&(*self).value) ? (g_value_unset (&(*self).value), NULL) : NULL;
}

static MusicPluginsManager*
music_plugins_manager_construct (GType object_type)
{
	MusicPluginsManager * self = NULL;
	MusicPluginsInterface* _tmp0_;
	MusicPluginsInterface* _tmp1_;
	MusicPluginsInterface* _tmp2_;
	PeasEngine* _tmp3_;
	PeasEngine* _tmp4_;
	PeasEngine* _tmp5_;
	GeeLinkedList* disabled_plugins = NULL;
	GeeLinkedList* _tmp6_;
	MusicSettingsMain* _tmp7_;
	MusicSettingsMain* _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gint _tmp10_ = 0;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar** _tmp12_;
	gint _tmp12__length1;
	PeasEngine* _tmp16_;
	GList* _tmp17_;
	GParameter param = {0};
	MusicPluginsInterface* _tmp24_;
	GValue _tmp25_ = {0};
	PeasEngine* _tmp26_;
	MusicPluginsInterface* _tmp27_;
	PeasExtensionSet* _tmp28_;
	PeasExtensionSet* _tmp29_;
	PeasExtensionSet* _tmp30_;
	PeasExtensionSet* _tmp31_;
	self = (MusicPluginsManager*) g_object_new (object_type, NULL);
	_tmp0_ = music_plugins_interface_new (self);
	_tmp1_ = _tmp0_;
	music_plugins_manager_set_plugin_iface (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = self->priv->_plugin_iface;
	music_plugins_interface_set_set_name (_tmp2_, "noise");
	_tmp3_ = peas_engine_get_default ();
	_tmp4_ = _g_object_ref0 (_tmp3_);
	_g_object_unref0 (self->priv->engine);
	self->priv->engine = _tmp4_;
	_tmp5_ = self->priv->engine;
	peas_engine_add_search_path (_tmp5_, BUILD_PLUGIN_DIR, NULL);
	_tmp6_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	disabled_plugins = _tmp6_;
	_tmp7_ = music_settings_main_get_default ();
	_tmp8_ = _tmp7_;
	_tmp9_ = music_settings_main_get_plugins_disabled (_tmp8_, &_tmp10_);
	_tmp9__length1 = _tmp10_;
	_tmp11_ = _tmp9_;
	_tmp11__length1 = _tmp9__length1;
	_tmp12_ = _tmp11_;
	_tmp12__length1 = _tmp11__length1;
	_g_object_unref0 (_tmp8_);
	{
		gchar** plugin_collection = NULL;
		gint plugin_collection_length1 = 0;
		gint _plugin_collection_size_ = 0;
		gint plugin_it = 0;
		plugin_collection = _tmp12_;
		plugin_collection_length1 = _tmp12__length1;
		for (plugin_it = 0; plugin_it < plugin_collection_length1; plugin_it = plugin_it + 1) {
			gchar* _tmp13_;
			gchar* plugin = NULL;
			_tmp13_ = g_strdup (plugin_collection[plugin_it]);
			plugin = _tmp13_;
			{
				GeeLinkedList* _tmp14_;
				const gchar* _tmp15_;
				_tmp14_ = disabled_plugins;
				_tmp15_ = plugin;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
				_g_free0 (plugin);
			}
		}
	}
	_tmp16_ = self->priv->engine;
	_tmp17_ = peas_engine_get_plugin_list (_tmp16_);
	{
		GList* plugin_collection = NULL;
		GList* plugin_it = NULL;
		plugin_collection = _tmp17_;
		for (plugin_it = plugin_collection; plugin_it != NULL; plugin_it = plugin_it->next) {
			PeasPluginInfo* _tmp18_;
			PeasPluginInfo* plugin = NULL;
			_tmp18_ = __vala_PeasPluginInfo_copy0 ((PeasPluginInfo*) plugin_it->data);
			plugin = _tmp18_;
			{
				GeeLinkedList* _tmp19_;
				PeasPluginInfo* _tmp20_;
				const gchar* _tmp21_;
				_tmp19_ = disabled_plugins;
				_tmp20_ = plugin;
				_tmp21_ = peas_plugin_info_get_module_name (_tmp20_);
				if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp19_, _tmp21_)) {
					PeasEngine* _tmp22_;
					PeasPluginInfo* _tmp23_;
					_tmp22_ = self->priv->engine;
					_tmp23_ = plugin;
					peas_engine_load_plugin (_tmp22_, _tmp23_);
				}
				__vala_PeasPluginInfo_free0 (plugin);
			}
		}
	}
	memset (&param, 0, sizeof (GParameter));
	_tmp24_ = self->priv->_plugin_iface;
	g_value_init (&_tmp25_, MUSIC_PLUGINS_TYPE_INTERFACE);
	g_value_set_object (&_tmp25_, _tmp24_);
	G_IS_VALUE (&param.value) ? (g_value_unset (&param.value), NULL) : NULL;
	param.value = _tmp25_;
	param.name = "object";
	_tmp26_ = self->priv->engine;
	_tmp27_ = self->priv->_plugin_iface;
	_tmp28_ = peas_extension_set_new (_tmp26_, peas_activatable_get_type (), "object", _tmp27_, NULL, NULL);
	_g_object_unref0 (self->priv->exts);
	self->priv->exts = _tmp28_;
	_tmp29_ = self->priv->exts;
	g_signal_connect_object (_tmp29_, "extension-added", (GCallback) ___lambda16__peas_extension_set_extension_added, self, 0);
	_tmp30_ = self->priv->exts;
	g_signal_connect_object (_tmp30_, "extension-removed", (GCallback) _music_plugins_manager_on_extension_removed_peas_extension_set_extension_removed, self, 0);
	_tmp31_ = self->priv->exts;
	peas_extension_set_foreach (_tmp31_, _music_plugins_manager_on_extension_added_peas_extension_set_foreach_func, self);
	g_parameter_destroy (&param);
	_g_object_unref0 (disabled_plugins);
	return self;
}

static MusicPluginsManager*
music_plugins_manager_new (void)
{
	return music_plugins_manager_construct (MUSIC_PLUGINS_TYPE_MANAGER);
}

GtkWidget*
music_plugins_manager_get_view (MusicPluginsManager* self)
{
	PeasGtkPluginManager* view = NULL;
	PeasEngine* _tmp0_;
	PeasGtkPluginManager* _tmp1_;
	GtkBox* bottom_box = NULL;
	GList* _tmp2_;
	GList* _tmp3_;
	gconstpointer _tmp4_;
	GtkWidget* _tmp5_;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GList* _tmp8_;
	GList* _tmp9_;
	gconstpointer _tmp10_;
	GList* _tmp11_;
	GList* _tmp12_;
	gconstpointer _tmp13_;
	GtkWidget* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->engine;
	_tmp1_ = (PeasGtkPluginManager*) peas_gtk_plugin_manager_new (_tmp0_);
	g_object_ref_sink (_tmp1_);
	view = _tmp1_;
	_tmp2_ = gtk_container_get_children ((GtkContainer*) view);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_list_nth_data (_tmp3_, (guint) 1);
	_tmp5_ = (GtkWidget*) _tmp4_;
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, gtk_box_get_type ()) ? ((GtkBox*) _tmp5_) : NULL);
	_tmp7_ = _tmp6_;
	(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_list_free (_tmp3_), NULL));
	bottom_box = _tmp7_;
	_vala_assert (bottom_box != NULL, "bottom_box != null");
	_tmp8_ = gtk_container_get_children ((GtkContainer*) bottom_box);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_list_nth_data (_tmp9_, (guint) 0);
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp10_, TRUE);
	(_tmp9_ == NULL) ? NULL : (_tmp9_ = (g_list_free (_tmp9_), NULL));
	_tmp11_ = gtk_container_get_children ((GtkContainer*) bottom_box);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_list_nth_data (_tmp12_, (guint) 0);
	gtk_widget_set_visible ((GtkWidget*) _tmp13_, FALSE);
	(_tmp12_ == NULL) ? NULL : (_tmp12_ = (g_list_free (_tmp12_), NULL));
	result = (GtkWidget*) view;
	_g_object_unref0 (bottom_box);
	return result;
}

static void
music_plugins_manager_on_extension_added (MusicPluginsManager* self,
                                          PeasExtensionSet* set,
                                          PeasPluginInfo* info,
                                          PeasExtension* extension)
{
	GList* core_list = NULL;
	PeasEngine* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (set != NULL);
	g_return_if_fail (info != NULL);
	g_return_if_fail (extension != NULL);
	_tmp0_ = self->priv->engine;
	_tmp1_ = peas_engine_get_plugin_list (_tmp0_);
	_tmp2_ = g_list_copy (_tmp1_);
	core_list = _tmp2_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				GList* _tmp5_;
				gchar* module = NULL;
				GList* _tmp6_;
				gconstpointer _tmp7_;
				const gchar* _tmp8_;
				gchar* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = core_list;
				if (!(((guint) i) < g_list_length (_tmp5_))) {
					break;
				}
				_tmp6_ = core_list;
				_tmp7_ = g_list_nth_data (_tmp6_, (guint) i);
				_tmp8_ = peas_plugin_info_get_module_name ((PeasPluginInfo*) _tmp7_);
				_tmp9_ = g_strdup (_tmp8_);
				module = _tmp9_;
				_tmp10_ = module;
				_tmp11_ = peas_plugin_info_get_module_name (info);
				if (g_strcmp0 (_tmp10_, _tmp11_) == 0) {
					peas_activatable_activate (G_TYPE_CHECK_INSTANCE_CAST (extension, peas_activatable_get_type (), PeasActivatable));
				} else {
					const gchar* _tmp12_;
					MusicPluginsInterface* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					_tmp12_ = module;
					_tmp13_ = self->priv->_plugin_iface;
					_tmp14_ = music_plugins_interface_get_set_name (_tmp13_);
					_tmp15_ = _tmp14_;
					if (g_strcmp0 (_tmp12_, _tmp15_) == 0) {
						const gchar* _tmp16_;
						_tmp16_ = module;
						g_debug ("PluginManager.vala:110: Loaded %s", _tmp16_);
						peas_activatable_activate (G_TYPE_CHECK_INSTANCE_CAST (extension, peas_activatable_get_type (), PeasActivatable));
					} else {
						peas_activatable_deactivate (G_TYPE_CHECK_INSTANCE_CAST (extension, peas_activatable_get_type (), PeasActivatable));
					}
				}
				_g_free0 (module);
			}
		}
	}
	(core_list == NULL) ? NULL : (core_list = (g_list_free (core_list), NULL));
}

static void
music_plugins_manager_on_extension_removed (MusicPluginsManager* self,
                                            PeasPluginInfo* info,
                                            GObject* extension)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (info != NULL);
	g_return_if_fail (extension != NULL);
	peas_activatable_deactivate (G_TYPE_CHECK_INSTANCE_CAST (extension, peas_activatable_get_type (), PeasActivatable));
}

void
music_plugins_manager_hook_app (MusicPluginsManager* self,
                                GtkApplication* app)
{
	MusicPluginsInterface* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (app != NULL);
	_tmp0_ = self->priv->_plugin_iface;
	music_plugins_interface_set_noise_app (_tmp0_, app);
}

void
music_plugins_manager_hook_example (MusicPluginsManager* self,
                                    const gchar* arg)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (arg != NULL);
}

void
music_plugins_manager_set_toolbar (MusicPluginsManager* self,
                                   GtkToolbar* value)
{
	MusicPluginsInterface* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_plugin_iface;
	music_plugins_interface_set_toolbar (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, music_plugins_manager_properties[MUSIC_PLUGINS_MANAGER_TOOLBAR_PROPERTY]);
}

void
music_plugins_manager_set_noise_app (MusicPluginsManager* self,
                                     GtkApplication* value)
{
	MusicPluginsInterface* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_plugin_iface;
	music_plugins_interface_set_noise_app (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, music_plugins_manager_properties[MUSIC_PLUGINS_MANAGER_NOISE_APP_PROPERTY]);
}

MusicPluginsInterface*
music_plugins_manager_get_plugin_iface (MusicPluginsManager* self)
{
	MusicPluginsInterface* result;
	MusicPluginsInterface* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_plugin_iface;
	result = _tmp0_;
	return result;
}

static void
music_plugins_manager_set_plugin_iface (MusicPluginsManager* self,
                                        MusicPluginsInterface* value)
{
	MusicPluginsInterface* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_plugins_manager_get_plugin_iface (self);
	if (old_value != value) {
		MusicPluginsInterface* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_plugin_iface);
		self->priv->_plugin_iface = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_plugins_manager_properties[MUSIC_PLUGINS_MANAGER_PLUGIN_IFACE_PROPERTY]);
	}
}

void
music_plugins_manager_set_context (MusicPluginsManager* self,
                                   GtkNotebook* value)
{
	MusicPluginsInterface* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_plugin_iface;
	music_plugins_interface_set_context (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, music_plugins_manager_properties[MUSIC_PLUGINS_MANAGER_CONTEXT_PROPERTY]);
}

void
music_plugins_manager_set_sidebar (MusicPluginsManager* self,
                                   GtkNotebook* value)
{
	MusicPluginsInterface* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_plugin_iface;
	music_plugins_interface_set_sidebar (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, music_plugins_manager_properties[MUSIC_PLUGINS_MANAGER_SIDEBAR_PROPERTY]);
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
}

static void
music_plugins_manager_class_init (MusicPluginsManagerClass * klass,
                                  gpointer klass_data)
{
	music_plugins_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicPluginsManager_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_plugins_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_plugins_manager_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_plugins_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLUGINS_MANAGER_TOOLBAR_PROPERTY, music_plugins_manager_properties[MUSIC_PLUGINS_MANAGER_TOOLBAR_PROPERTY] = g_param_spec_object ("toolbar", "toolbar", "toolbar", gtk_toolbar_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLUGINS_MANAGER_NOISE_APP_PROPERTY, music_plugins_manager_properties[MUSIC_PLUGINS_MANAGER_NOISE_APP_PROPERTY] = g_param_spec_object ("noise-app", "noise-app", "noise-app", gtk_application_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLUGINS_MANAGER_PLUGIN_IFACE_PROPERTY, music_plugins_manager_properties[MUSIC_PLUGINS_MANAGER_PLUGIN_IFACE_PROPERTY] = g_param_spec_object ("plugin-iface", "plugin-iface", "plugin-iface", MUSIC_PLUGINS_TYPE_INTERFACE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLUGINS_MANAGER_CONTEXT_PROPERTY, music_plugins_manager_properties[MUSIC_PLUGINS_MANAGER_CONTEXT_PROPERTY] = g_param_spec_object ("context", "context", "context", gtk_notebook_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_PLUGINS_MANAGER_SIDEBAR_PROPERTY, music_plugins_manager_properties[MUSIC_PLUGINS_MANAGER_SIDEBAR_PROPERTY] = g_param_spec_object ("sidebar", "sidebar", "sidebar", gtk_notebook_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	music_plugins_manager_signals[MUSIC_PLUGINS_MANAGER_HOOK_MAIN_MENU_SIGNAL] = g_signal_new ("hook-main-menu", MUSIC_PLUGINS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_menu_get_type ());
	music_plugins_manager_signals[MUSIC_PLUGINS_MANAGER_HOOK_TOOLBAR_SIGNAL] = g_signal_new ("hook-toolbar", MUSIC_PLUGINS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_plugins_manager_signals[MUSIC_PLUGINS_MANAGER_HOOK_SET_ARG_SIGNAL] = g_signal_new ("hook-set-arg", MUSIC_PLUGINS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
	music_plugins_manager_signals[MUSIC_PLUGINS_MANAGER_HOOK_NOTEBOOK_BOTTOM_SIGNAL] = g_signal_new ("hook-notebook-bottom", MUSIC_PLUGINS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_notebook_get_type ());
	music_plugins_manager_signals[MUSIC_PLUGINS_MANAGER_HOOK_SOURCE_VIEW_SIGNAL] = g_signal_new ("hook-source-view", MUSIC_PLUGINS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_text_view_get_type ());
	music_plugins_manager_signals[MUSIC_PLUGINS_MANAGER_HOOK_NEW_WINDOW_SIGNAL] = g_signal_new ("hook-new-window", MUSIC_PLUGINS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_window_get_type ());
	music_plugins_manager_signals[MUSIC_PLUGINS_MANAGER_HOOK_PREFERENCES_WINDOW_SIGNAL] = g_signal_new ("hook-preferences-window", MUSIC_PLUGINS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_window_get_type ());
	music_plugins_manager_signals[MUSIC_PLUGINS_MANAGER_HOOK_TOOLBAR_CONTEXT_MENU_SIGNAL] = g_signal_new ("hook-toolbar-context-menu", MUSIC_PLUGINS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_menu_get_type ());
	music_plugins_manager_signals[MUSIC_PLUGINS_MANAGER_HOOK_NOTEBOOK_CONTEXT_SIGNAL] = g_signal_new ("hook-notebook-context", MUSIC_PLUGINS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_plugins_manager_signals[MUSIC_PLUGINS_MANAGER_HOOK_NOTEBOOK_SIDEBAR_SIGNAL] = g_signal_new ("hook-notebook-sidebar", MUSIC_PLUGINS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	music_plugins_manager_signals[MUSIC_PLUGINS_MANAGER_HOOK_ADDONS_MENU_SIGNAL] = g_signal_new ("hook-addons-menu", MUSIC_PLUGINS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, gtk_menu_get_type ());
}

static void
music_plugins_manager_instance_init (MusicPluginsManager * self,
                                     gpointer klass)
{
	self->priv = music_plugins_manager_get_instance_private (self);
}

static void
music_plugins_manager_finalize (GObject * obj)
{
	MusicPluginsManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_MANAGER, MusicPluginsManager);
	_g_object_unref0 (self->priv->engine);
	_g_object_unref0 (self->priv->exts);
	_g_object_unref0 (self->priv->_plugin_iface);
	G_OBJECT_CLASS (music_plugins_manager_parent_class)->finalize (obj);
}

static GType
music_plugins_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsManager), 0, (GInstanceInitFunc) music_plugins_manager_instance_init, NULL };
	GType music_plugins_manager_type_id;
	music_plugins_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicPluginsManager", &g_define_type_info, 0);
	MusicPluginsManager_private_offset = g_type_add_instance_private (music_plugins_manager_type_id, sizeof (MusicPluginsManagerPrivate));
	return music_plugins_manager_type_id;
}

GType
music_plugins_manager_get_type (void)
{
	static volatile gsize music_plugins_manager_type_id__volatile = 0;
	if (g_once_init_enter (&music_plugins_manager_type_id__volatile)) {
		GType music_plugins_manager_type_id;
		music_plugins_manager_type_id = music_plugins_manager_get_type_once ();
		g_once_init_leave (&music_plugins_manager_type_id__volatile, music_plugins_manager_type_id);
	}
	return music_plugins_manager_type_id__volatile;
}

static void
_vala_music_plugins_manager_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	MusicPluginsManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_PLUGINS_TYPE_MANAGER, MusicPluginsManager);
	switch (property_id) {
		case MUSIC_PLUGINS_MANAGER_PLUGIN_IFACE_PROPERTY:
		g_value_set_object (value, music_plugins_manager_get_plugin_iface (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_plugins_manager_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	MusicPluginsManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_PLUGINS_TYPE_MANAGER, MusicPluginsManager);
	switch (property_id) {
		case MUSIC_PLUGINS_MANAGER_TOOLBAR_PROPERTY:
		music_plugins_manager_set_toolbar (self, g_value_get_object (value));
		break;
		case MUSIC_PLUGINS_MANAGER_NOISE_APP_PROPERTY:
		music_plugins_manager_set_noise_app (self, g_value_get_object (value));
		break;
		case MUSIC_PLUGINS_MANAGER_PLUGIN_IFACE_PROPERTY:
		music_plugins_manager_set_plugin_iface (self, g_value_get_object (value));
		break;
		case MUSIC_PLUGINS_MANAGER_CONTEXT_PROPERTY:
		music_plugins_manager_set_context (self, g_value_get_object (value));
		break;
		case MUSIC_PLUGINS_MANAGER_SIDEBAR_PROPERTY:
		music_plugins_manager_set_sidebar (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

