/* CompareFunctionHolder.c generated by valac 0.52.4, the Vala compiler
 * generated from CompareFunctionHolder.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 *              Scott Ringwelski <sgringwe@mtu.edu>
 */

#include "io.elementary.music-core.h"
#include <glib.h>

#define _g_free0(var) (var = (g_free (var), NULL))

inline gint
music_compare_titles (MusicMedia* a,
                      MusicMedia* b)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint result = 0;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp0_ = music_media_get_display_title (a);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_media_get_display_title (b);
	_tmp3_ = _tmp2_;
	_tmp4_ = music_string_compare (_tmp1_, _tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	result = _tmp4_;
	return result;
}

inline gint
music_compare_genres (MusicMedia* a,
                      MusicMedia* b)
{
	gint order = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint result = 0;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp0_ = music_media_get_display_genre (a);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_media_get_display_genre (b);
	_tmp3_ = _tmp2_;
	_tmp4_ = music_string_compare (_tmp1_, _tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	order = _tmp4_;
	if (order == 0) {
		order = music_compare_album_artists (a, b);
	}
	result = order;
	return result;
}

inline gint
music_compare_artists (MusicMedia* a,
                       MusicMedia* b)
{
	gint order = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint result = 0;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp0_ = music_media_get_display_artist (a);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_media_get_display_artist (b);
	_tmp3_ = _tmp2_;
	_tmp4_ = music_string_compare (_tmp1_, _tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	order = _tmp4_;
	if (order == 0) {
		guint _tmp5_;
		guint _tmp6_;
		guint _tmp7_;
		guint _tmp8_;
		_tmp5_ = music_media_get_year (a);
		_tmp6_ = _tmp5_;
		_tmp7_ = music_media_get_year (b);
		_tmp8_ = _tmp7_;
		order = music_compare_standard_unsigned (_tmp6_, _tmp8_);
	}
	if (order == 0) {
		order = music_compare_albums (a, b);
	}
	result = order;
	return result;
}

inline gint
music_compare_album_artists (MusicMedia* a,
                             MusicMedia* b)
{
	gint order = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint result = 0;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp0_ = music_media_get_display_album_artist (a, TRUE);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_media_get_display_album_artist (b, TRUE);
	_tmp3_ = _tmp2_;
	_tmp4_ = music_string_compare (_tmp1_, _tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	order = _tmp4_;
	if (order == 0) {
		order = music_compare_albums (a, b);
	}
	result = order;
	return result;
}

inline gint
music_compare_albums (MusicMedia* a,
                      MusicMedia* b)
{
	gint order = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint result = 0;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp0_ = music_media_get_display_album (a);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_media_get_display_album (b);
	_tmp3_ = _tmp2_;
	_tmp4_ = music_string_compare (_tmp1_, _tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	order = _tmp4_;
	if (order == 0) {
		guint _tmp5_;
		guint _tmp6_;
		guint _tmp7_;
		guint _tmp8_;
		_tmp5_ = music_media_get_album_number (a);
		_tmp6_ = _tmp5_;
		_tmp7_ = music_media_get_album_number (b);
		_tmp8_ = _tmp7_;
		order = music_compare_standard_unsigned (_tmp6_, _tmp8_);
	}
	if (order == 0) {
		guint _tmp9_;
		guint _tmp10_;
		guint _tmp11_;
		guint _tmp12_;
		_tmp9_ = music_media_get_track (a);
		_tmp10_ = _tmp9_;
		_tmp11_ = music_media_get_track (b);
		_tmp12_ = _tmp11_;
		order = music_compare_standard_unsigned (_tmp10_, _tmp12_);
	}
	result = order;
	return result;
}

inline gint
music_compare_standard (gint a,
                        gint b)
{
	gint result = 0;
	result = ((gint) (a > b)) - ((gint) (a < b));
	return result;
}

inline gint
music_compare_standard_unsigned (guint a,
                                 guint b)
{
	gint result = 0;
	result = ((gint) (a > b)) - ((gint) (a < b));
	return result;
}

inline gint
music_compare_standard_64 (gint64 a,
                           gint64 b)
{
	gint result = 0;
	result = ((gint) (a > b)) - ((gint) (a < b));
	return result;
}

