/* FileUtils.c generated by valac 0.52.4, the Vala compiler
 * generated from FileUtils.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 *              Scott Ringwelski <sgringwe@mtu.edu>
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "io.elementary.music-core.h"
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

#define MUSIC_FILE_UTILS_APP_NAME "noise"
GFile* music_file_utils_get_cache_directory (void);
static gchar** _vala_array_dup2 (gchar** self,
                          gint length);
static gchar** _vala_array_dup3 (gchar** self,
                          gint length);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

extern const gchar* MUSIC_MEDIA_CONTENT_TYPES[50];

GFile*
music_file_utils_get_data_directory (void)
{
	gchar* data_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* dir_path = NULL;
	gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* result = NULL;
	_tmp0_ = g_get_user_data_dir ();
	_tmp1_ = g_strdup (_tmp0_);
	data_dir = _tmp1_;
	_tmp2_ = g_build_path (G_DIR_SEPARATOR_S, data_dir, MUSIC_FILE_UTILS_APP_NAME, NULL);
	dir_path = _tmp2_;
	_tmp3_ = g_file_new_for_path (dir_path);
	result = _tmp3_;
	_g_free0 (dir_path);
	_g_free0 (data_dir);
	return result;
}

GFile*
music_file_utils_get_cache_directory (void)
{
	gchar* data_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* dir_path = NULL;
	gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* result = NULL;
	_tmp0_ = g_get_user_cache_dir ();
	_tmp1_ = g_strdup (_tmp0_);
	data_dir = _tmp1_;
	_tmp2_ = g_build_path (G_DIR_SEPARATOR_S, data_dir, MUSIC_FILE_UTILS_APP_NAME, NULL);
	dir_path = _tmp2_;
	_tmp3_ = g_file_new_for_path (dir_path);
	result = _tmp3_;
	_g_free0 (dir_path);
	_g_free0 (data_dir);
	return result;
}

guint64
music_file_utils_get_size (GFile* file,
                           GCancellable* cancellable)
{
	guint64 size = 0ULL;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
	g_return_val_if_fail (file != NULL, 0ULL);
	size = (guint64) 0;
	{
		GFileInfo* info = NULL;
		GFileInfo* _tmp0_;
		_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_SIZE, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
		info = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		size = g_file_info_get_attribute_uint64 (info, G_FILE_ATTRIBUTE_STANDARD_SIZE);
		_g_object_unref0 (info);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GError* _tmp3_;
		const gchar* _tmp4_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = g_file_get_uri (file);
		_tmp2_ = _tmp1_;
		_tmp3_ = err;
		_tmp4_ = _tmp3_->message;
		g_warning ("FileUtils.vala:54: Could not get size of '%s': %s", _tmp2_, _tmp4_);
		_g_free0 (_tmp2_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		guint64 _tmp5_ = 0ULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp5_;
	}
	result = size;
	return result;
}

/**
     * Queries whether a content type equals or is a subtype of any other type in
     * an array of content types.
     *
     * @param file_content_type Content type of the file to compare.
     * @param content_types A string array containing the expected content types to compare against.
     * @return whether file_content_type is considered valid.
     */
static gchar**
_vala_array_dup2 (gchar** self,
                  gint length)
{
	if (length >= 0) {
		gchar** result;
		gint i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static gchar**
_vala_array_dup3 (gchar** self,
                  gint length)
{
	if (length >= 0) {
		gchar** result;
		gint i;
		result = g_new0 (gchar*, length + 1);
		for (i = 0; i < length; i++) {
			gchar* _tmp0_;
			_tmp0_ = g_strdup (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

gboolean
music_file_utils_is_valid_content_type (const gchar* file_content_type,
                                        gchar** content_types,
                                        gint content_types_length1)
{
	gchar** considered_content_type = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint considered_content_type_length1;
	gint _considered_content_type_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gboolean result = FALSE;
	g_return_val_if_fail (file_content_type != NULL, FALSE);
	_tmp0_ = (content_types != NULL) ? _vala_array_dup2 (content_types, content_types_length1) : content_types;
	_tmp0__length1 = content_types_length1;
	considered_content_type = _tmp0_;
	considered_content_type_length1 = _tmp0__length1;
	_considered_content_type_size_ = considered_content_type_length1;
	if (content_types == NULL) {
		gchar** _tmp1_;
		gint _tmp1__length1;
		_tmp1_ = _vala_array_dup3 (MUSIC_MEDIA_CONTENT_TYPES, G_N_ELEMENTS (MUSIC_MEDIA_CONTENT_TYPES));
		_tmp1__length1 = G_N_ELEMENTS (MUSIC_MEDIA_CONTENT_TYPES);
		considered_content_type = (_vala_array_free (considered_content_type, considered_content_type_length1, (GDestroyNotify) g_free), NULL);
		considered_content_type = _tmp1_;
		considered_content_type_length1 = _tmp1__length1;
		_considered_content_type_size_ = considered_content_type_length1;
	}
	_tmp2_ = considered_content_type;
	_tmp2__length1 = considered_content_type_length1;
	{
		gchar** content_type_collection = NULL;
		gint content_type_collection_length1 = 0;
		gint _content_type_collection_size_ = 0;
		gint content_type_it = 0;
		content_type_collection = _tmp2_;
		content_type_collection_length1 = _tmp2__length1;
		for (content_type_it = 0; content_type_it < content_type_collection_length1; content_type_it = content_type_it + 1) {
			gchar* _tmp3_;
			gchar* content_type = NULL;
			_tmp3_ = g_strdup (content_type_collection[content_type_it]);
			content_type = _tmp3_;
			{
				const gchar* _tmp4_;
				_tmp4_ = content_type;
				if (g_content_type_equals (file_content_type, _tmp4_)) {
					result = TRUE;
					_g_free0 (content_type);
					considered_content_type = (_vala_array_free (considered_content_type, considered_content_type_length1, (GDestroyNotify) g_free), NULL);
					return result;
				}
				_g_free0 (content_type);
			}
		}
	}
	result = FALSE;
	considered_content_type = (_vala_array_free (considered_content_type, considered_content_type_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

gint
music_file_utils_count_music_files (GFile* music_folder,
                                    GeeCollection* files)
{
	GFileInfo* file_info = NULL;
	gint index = 0;
	GError* _inner_error0_ = NULL;
	gint result = 0;
	g_return_val_if_fail (music_folder != NULL, 0);
	g_return_val_if_fail (files != NULL, 0);
	file_info = NULL;
	index = 0;
	{
		GFileEnumerator* enumerator = NULL;
		GFileEnumerator* _tmp0_;
		_tmp0_ = g_file_enumerate_children (music_folder, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, 0, NULL, &_inner_error0_);
		enumerator = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		while (TRUE) {
			GFileInfo* _tmp1_ = NULL;
			GFileEnumerator* _tmp2_;
			GFileInfo* _tmp3_;
			GFileInfo* _tmp4_;
			GFileInfo* _tmp5_;
			GFile* file = NULL;
			GFileInfo* _tmp6_;
			const gchar* _tmp7_;
			GFile* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GFileInfo* _tmp10_;
			_tmp2_ = enumerator;
			_tmp3_ = g_file_enumerator_next_file (_tmp2_, NULL, &_inner_error0_);
			_tmp1_ = _tmp3_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (enumerator);
				goto __catch0_g_error;
			}
			_tmp4_ = _tmp1_;
			_tmp1_ = NULL;
			_g_object_unref0 (file_info);
			file_info = _tmp4_;
			_tmp5_ = file_info;
			if (!(_tmp5_ != NULL)) {
				_g_object_unref0 (_tmp1_);
				break;
			}
			_tmp6_ = file_info;
			_tmp7_ = g_file_info_get_name (_tmp6_);
			_tmp8_ = g_file_get_child (music_folder, _tmp7_);
			file = _tmp8_;
			_tmp10_ = file_info;
			if (g_file_info_get_file_type (_tmp10_) == G_FILE_TYPE_REGULAR) {
				GFileInfo* _tmp11_;
				const gchar* _tmp12_;
				_tmp11_ = file_info;
				_tmp12_ = g_file_info_get_content_type (_tmp11_);
				_tmp9_ = music_file_utils_is_valid_content_type (_tmp12_, NULL, (gint) 0);
			} else {
				_tmp9_ = FALSE;
			}
			if (_tmp9_) {
				gint _tmp13_;
				GFile* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				_tmp13_ = index;
				index = _tmp13_ + 1;
				_tmp14_ = file;
				_tmp15_ = g_file_get_uri (_tmp14_);
				_tmp16_ = _tmp15_;
				gee_collection_add (files, _tmp16_);
				_g_free0 (_tmp16_);
			} else {
				GFileInfo* _tmp17_;
				_tmp17_ = file_info;
				if (g_file_info_get_file_type (_tmp17_) == G_FILE_TYPE_DIRECTORY) {
					GFile* _tmp18_;
					_tmp18_ = file;
					index += music_file_utils_count_music_files (_tmp18_, files);
				}
			}
			_g_object_unref0 (file);
			_g_object_unref0 (_tmp1_);
		}
		_g_object_unref0 (enumerator);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp19_;
		const gchar* _tmp20_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp19_ = err;
		_tmp20_ = _tmp19_->message;
		g_warning ("FileUtils.vala:100: Could not pre-scan music folder. Progress percenta" \
"ge may be off: %s\n", _tmp20_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp21_ = -1;
		_g_object_unref0 (file_info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp21_;
	}
	result = index;
	_g_object_unref0 (file_info);
	return result;
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

GFile*
music_file_utils_get_new_destination (MusicMedia* s)
{
	GFile* dest = NULL;
	GError* _inner_error0_ = NULL;
	GFile* result = NULL;
	g_return_val_if_fail (s != NULL, NULL);
	{
		GFile* original = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		gchar* ext = NULL;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gboolean _tmp9_;
		MusicSettingsMain* main_settings = NULL;
		MusicSettingsMain* _tmp23_;
		gchar* path = NULL;
		MusicSettingsMain* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		gboolean _tmp28_ = FALSE;
		const gchar* _tmp29_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		const gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		const gchar* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		const gchar* _tmp57_;
		guint _tmp58_;
		guint _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		MusicSettingsMain* _tmp63_;
		const gchar* _tmp64_;
		const gchar* _tmp65_;
		const gchar* _tmp66_;
		const gchar* _tmp67_;
		gchar* _tmp68_;
		gchar* _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
		GFile* _tmp72_;
		GFile* _tmp73_;
		gchar* _tmp74_;
		gchar* _tmp75_;
		GFile* _tmp76_;
		gchar* _tmp77_;
		gchar* _tmp78_;
		gboolean _tmp79_;
		GFile* _tmp80_;
		GFile* _tmp98_;
		GFile* _tmp99_;
		GFile* _tmp100_;
		gboolean _tmp101_;
		_tmp0_ = music_media_get_uri (s);
		_tmp1_ = _tmp0_;
		_tmp2_ = _tmp1_;
		_tmp3_ = g_file_new_for_uri (_tmp2_);
		_tmp4_ = _tmp3_;
		_g_free0 (_tmp2_);
		original = _tmp4_;
		_tmp5_ = g_strdup ("");
		ext = _tmp5_;
		_tmp6_ = music_media_get_uri (s);
		_tmp7_ = _tmp6_;
		_tmp8_ = _tmp7_;
		_tmp9_ = g_str_has_prefix (_tmp8_, "cdda://");
		_g_free0 (_tmp8_);
		if (_tmp9_) {
			gchar* _tmp10_;
			_tmp10_ = g_strdup (".mp3");
			_g_free0 (ext);
			ext = _tmp10_;
		} else {
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			gchar* _tmp22_;
			_tmp11_ = music_media_get_uri (s);
			_tmp12_ = _tmp11_;
			_tmp13_ = _tmp12_;
			_tmp14_ = music_media_get_uri (s);
			_tmp15_ = _tmp14_;
			_tmp16_ = _tmp15_;
			_tmp17_ = music_media_get_uri (s);
			_tmp18_ = _tmp17_;
			_tmp19_ = _tmp18_;
			_tmp20_ = strlen (_tmp19_);
			_tmp21_ = _tmp20_;
			_tmp22_ = string_slice (_tmp13_, (glong) string_last_index_of (_tmp16_, ".", 0), (glong) _tmp21_);
			_g_free0 (ext);
			ext = _tmp22_;
			_g_free0 (_tmp19_);
			_g_free0 (_tmp16_);
			_g_free0 (_tmp13_);
		}
		_tmp23_ = music_settings_main_get_default ();
		main_settings = _tmp23_;
		_tmp24_ = main_settings;
		_tmp25_ = music_settings_main_get_path_string (_tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = g_strdup (_tmp26_);
		path = _tmp27_;
		_tmp29_ = path;
		if (g_strcmp0 (_tmp29_, "") == 0) {
			_tmp28_ = TRUE;
		} else {
			const gchar* _tmp30_;
			_tmp30_ = path;
			_tmp28_ = _tmp30_ == NULL;
		}
		if (_tmp28_) {
			gchar* _tmp31_;
			MusicSettingsMain* _tmp32_;
			_tmp31_ = g_strdup ("$ALBUM_ARTIST/$ALBUM/$TRACK - $TITLE");
			_g_free0 (path);
			path = _tmp31_;
			_tmp32_ = main_settings;
			music_settings_main_set_path_string (_tmp32_, "$ALBUM_ARTIST/$ALBUM/$TRACK - $TITLE");
		}
		_tmp33_ = path;
		_tmp34_ = music_media_get_display_album_artist (s, TRUE);
		_tmp35_ = _tmp34_;
		_tmp36_ = string_replace (_tmp35_, "/", "_");
		_tmp37_ = _tmp36_;
		_tmp38_ = string_replace (_tmp33_, "$ALBUM_ARTIST", _tmp37_);
		_g_free0 (path);
		path = _tmp38_;
		_g_free0 (_tmp37_);
		_g_free0 (_tmp35_);
		_tmp39_ = path;
		_tmp40_ = music_media_get_display_artist (s);
		_tmp41_ = _tmp40_;
		_tmp42_ = string_replace (_tmp41_, "/", "_");
		_tmp43_ = _tmp42_;
		_tmp44_ = string_replace (_tmp39_, "$ARTIST", _tmp43_);
		_g_free0 (path);
		path = _tmp44_;
		_g_free0 (_tmp43_);
		_g_free0 (_tmp41_);
		_tmp45_ = path;
		_tmp46_ = music_media_get_display_album (s);
		_tmp47_ = _tmp46_;
		_tmp48_ = string_replace (_tmp47_, "/", "_");
		_tmp49_ = _tmp48_;
		_tmp50_ = string_replace (_tmp45_, "$ALBUM", _tmp49_);
		_g_free0 (path);
		path = _tmp50_;
		_g_free0 (_tmp49_);
		_g_free0 (_tmp47_);
		_tmp51_ = path;
		_tmp52_ = music_media_get_display_title (s);
		_tmp53_ = _tmp52_;
		_tmp54_ = string_replace (_tmp53_, "/", "_");
		_tmp55_ = _tmp54_;
		_tmp56_ = string_replace (_tmp51_, "$TITLE", _tmp55_);
		_g_free0 (path);
		path = _tmp56_;
		_g_free0 (_tmp55_);
		_g_free0 (_tmp53_);
		_tmp57_ = path;
		_tmp58_ = music_media_get_track (s);
		_tmp59_ = _tmp58_;
		_tmp60_ = g_strdup_printf ("%u", _tmp59_);
		_tmp61_ = _tmp60_;
		_tmp62_ = string_replace (_tmp57_, "$TRACK", _tmp61_);
		_g_free0 (path);
		path = _tmp62_;
		_g_free0 (_tmp61_);
		_tmp63_ = main_settings;
		_tmp64_ = music_settings_main_get_music_folder (_tmp63_);
		_tmp65_ = _tmp64_;
		_tmp66_ = path;
		_tmp67_ = ext;
		_tmp68_ = g_strconcat (_tmp66_, _tmp67_, NULL);
		_tmp69_ = _tmp68_;
		_tmp70_ = g_build_path ("/", _tmp65_, _tmp69_, NULL);
		_tmp71_ = _tmp70_;
		_tmp72_ = g_file_new_for_path (_tmp71_);
		_g_object_unref0 (dest);
		dest = _tmp72_;
		_g_free0 (_tmp71_);
		_g_free0 (_tmp69_);
		_tmp73_ = original;
		_tmp74_ = g_file_get_path (_tmp73_);
		_tmp75_ = _tmp74_;
		_tmp76_ = dest;
		_tmp77_ = g_file_get_path (_tmp76_);
		_tmp78_ = _tmp77_;
		_tmp79_ = string_contains (_tmp75_, _tmp78_);
		_g_free0 (_tmp78_);
		_g_free0 (_tmp75_);
		if (_tmp79_) {
			g_debug ("FileUtils.vala:136: File is already in correct location\n");
			result = NULL;
			_g_free0 (path);
			_g_object_unref0 (main_settings);
			_g_free0 (ext);
			_g_object_unref0 (original);
			_g_object_unref0 (dest);
			return result;
		}
		_tmp80_ = dest;
		if (g_file_query_exists (_tmp80_, NULL)) {
			gint number = 0;
			number = 2;
			while (TRUE) {
				MusicSettingsMain* _tmp81_;
				const gchar* _tmp82_;
				const gchar* _tmp83_;
				const gchar* _tmp84_;
				gchar* _tmp85_;
				gchar* _tmp86_;
				gchar* _tmp87_;
				gchar* _tmp88_;
				const gchar* _tmp89_;
				gchar* _tmp90_;
				gchar* _tmp91_;
				gchar* _tmp92_;
				gchar* _tmp93_;
				GFile* _tmp94_;
				GFile* _tmp95_;
				gboolean _tmp96_;
				gint _tmp97_;
				_tmp81_ = main_settings;
				_tmp82_ = music_settings_main_get_music_folder (_tmp81_);
				_tmp83_ = _tmp82_;
				_tmp84_ = path;
				_tmp85_ = g_strdup_printf (_ (" (%d)"), number);
				_tmp86_ = _tmp85_;
				_tmp87_ = g_strconcat (_tmp84_, _tmp86_, NULL);
				_tmp88_ = _tmp87_;
				_tmp89_ = ext;
				_tmp90_ = g_strconcat (_tmp88_, _tmp89_, NULL);
				_tmp91_ = _tmp90_;
				_tmp92_ = g_build_path ("/", _tmp83_, _tmp91_, NULL);
				_tmp93_ = _tmp92_;
				_tmp94_ = g_file_new_for_path (_tmp93_);
				_g_object_unref0 (dest);
				dest = _tmp94_;
				_tmp95_ = dest;
				_tmp96_ = !g_file_query_exists (_tmp95_, NULL);
				_g_free0 (_tmp93_);
				_g_free0 (_tmp91_);
				_g_free0 (_tmp88_);
				_g_free0 (_tmp86_);
				if (_tmp96_) {
					break;
				}
				_tmp97_ = number;
				number = _tmp97_ + 1;
			}
		}
		_tmp98_ = dest;
		_tmp99_ = g_file_get_parent (_tmp98_);
		_tmp100_ = _tmp99_;
		_tmp101_ = !g_file_query_exists (_tmp100_, NULL);
		_g_object_unref0 (_tmp100_);
		if (_tmp101_) {
			GFile* _tmp102_;
			GFile* _tmp103_;
			GFile* _tmp104_;
			_tmp102_ = dest;
			_tmp103_ = g_file_get_parent (_tmp102_);
			_tmp104_ = _tmp103_;
			g_file_make_directory_with_parents (_tmp104_, NULL, &_inner_error0_);
			_g_object_unref0 (_tmp104_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_free0 (path);
				_g_object_unref0 (main_settings);
				_g_free0 (ext);
				_g_object_unref0 (original);
				goto __catch0_g_error;
			}
		}
		_g_free0 (path);
		_g_object_unref0 (main_settings);
		_g_free0 (ext);
		_g_object_unref0 (original);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp105_;
		const gchar* _tmp106_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp105_ = err;
		_tmp106_ = _tmp105_->message;
		g_debug ("FileUtils.vala:152: Could not find new destination!: %s\n", _tmp106_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (dest);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = dest;
	return result;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

