/* Icon.c generated by valac 0.52.4, the Vala compiler
 * generated from Icon.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

enum  {
	MUSIC_ICON_0_PROPERTY,
	MUSIC_ICON_NAME_PROPERTY,
	MUSIC_ICON_GICON_PROPERTY,
	MUSIC_ICON_NUM_PROPERTIES
};
static GParamSpec* music_icon_properties[MUSIC_ICON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MusicIconPrivate {
	gchar* _name;
	GIcon* _gicon;
};

static gint MusicIcon_private_offset;
static gpointer music_icon_parent_class = NULL;
static GtkIconTheme* music_icon__theme;
static GtkIconTheme* music_icon__theme = NULL;

static void music_icon_set_name (MusicIcon* self,
                          const gchar* value);
static void music_icon_set_gicon (MusicIcon* self,
                           GIcon* value);
static GtkIconInfo* music_icon_get_icon_info (MusicIcon* self,
                                       gint size);
static GtkIconTheme* music_icon_get_theme (void);
static void music_icon_finalize (GObject * obj);
static GType music_icon_get_type_once (void);
static void _vala_music_icon_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_music_icon_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);

static inline gpointer
music_icon_get_instance_private (MusicIcon* self)
{
	return G_STRUCT_MEMBER_P (self, MusicIcon_private_offset);
}

/**
     * Creates a new icon object.
     *
     * @param name The icon name (without filename extension), to be loaded from
     * the available icon themes.
     */
MusicIcon*
music_icon_construct (GType object_type,
                      const gchar* name)
{
	MusicIcon * self = NULL;
	const gchar* _tmp0_;
	GThemedIcon* _tmp1_;
	GThemedIcon* _tmp2_;
	g_return_val_if_fail (name != NULL, NULL);
	self = (MusicIcon*) g_object_new (object_type, NULL);
	music_icon_set_name (self, name);
	_tmp0_ = self->priv->_name;
	_tmp1_ = (GThemedIcon*) g_themed_icon_new (_tmp0_);
	_tmp2_ = _tmp1_;
	music_icon_set_gicon (self, (GIcon*) _tmp2_);
	_g_object_unref0 (_tmp2_);
	return self;
}

MusicIcon*
music_icon_new (const gchar* name)
{
	return music_icon_construct (MUSIC_TYPE_ICON, name);
}

static GtkIconInfo*
music_icon_get_icon_info (MusicIcon* self,
                          gint size)
{
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
	GIcon* _tmp2_;
	GtkIconInfo* _tmp3_;
	GtkIconInfo* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_icon_get_theme ();
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->_gicon;
	_tmp3_ = gtk_icon_theme_lookup_by_gicon (_tmp1_, _tmp2_, size, GTK_ICON_LOOKUP_USE_BUILTIN);
	result = _tmp3_;
	return result;
}

/**
     * Returns a file representing the icon in the filesystem.
     * @param size Icon size to query.
     * @return A {@link GLib.File} representing the icon, or //null// if none is found.
     */
GFile*
music_icon_get_file (MusicIcon* self,
                     gint size)
{
	GtkIconInfo* info = NULL;
	GtkIconInfo* _tmp0_;
	GFile* _tmp1_ = NULL;
	GtkIconInfo* _tmp2_;
	GFile* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = music_icon_get_icon_info (self, size);
	info = _tmp0_;
	_tmp2_ = info;
	if (_tmp2_ != NULL) {
		GtkIconInfo* _tmp3_;
		const gchar* _tmp4_;
		GFile* _tmp5_;
		_tmp3_ = info;
		_tmp4_ = gtk_icon_info_get_filename (_tmp3_);
		_tmp5_ = g_file_new_for_path (_tmp4_);
		_g_object_unref0 (_tmp1_);
		_tmp1_ = _tmp5_;
	} else {
		_g_object_unref0 (_tmp1_);
		_tmp1_ = NULL;
	}
	result = _tmp1_;
	_g_object_unref0 (info);
	return result;
}

/**
     * Creates a new {@link Gdk.Pixbuf} from the icon at the specified icon size.
     *
     * @param size The pixbuf's icon size.
     * @param style_context The style context used to render the icon, or null to use none.
     * @return a newly-created Gdk.Pixbuf displaying the icon (or a "missing-image" icon)
     */
GdkPixbuf*
music_icon_render (MusicIcon* self,
                   GtkIconSize size,
                   GtkStyleContext* style_context)
{
	gint width = 0;
	gint height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint pixel_size = 0;
	GdkPixbuf* rv = NULL;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	gtk_icon_size_lookup (size, &_tmp0_, &_tmp1_);
	width = _tmp0_;
	height = _tmp1_;
	pixel_size = MAX (width, height);
	rv = NULL;
	{
		GtkIconInfo* icon_info = NULL;
		GtkIconInfo* _tmp2_;
		GtkIconInfo* _tmp3_;
		GdkPixbuf* _tmp12_;
		_tmp2_ = music_icon_get_icon_info (self, pixel_size);
		icon_info = _tmp2_;
		_tmp3_ = icon_info;
		if (_tmp3_ != NULL) {
			if (style_context != NULL) {
				GdkPixbuf* _tmp4_ = NULL;
				GtkIconInfo* _tmp5_;
				GdkPixbuf* _tmp6_;
				GdkPixbuf* _tmp7_;
				_tmp5_ = icon_info;
				_tmp6_ = gtk_icon_info_load_symbolic_for_context (_tmp5_, style_context, NULL, &_inner_error0_);
				_tmp4_ = _tmp6_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (icon_info);
					goto __catch0_g_error;
				}
				_tmp7_ = _tmp4_;
				_tmp4_ = NULL;
				_g_object_unref0 (rv);
				rv = _tmp7_;
				_g_object_unref0 (_tmp4_);
			} else {
				GdkPixbuf* _tmp8_ = NULL;
				GtkIconInfo* _tmp9_;
				GdkPixbuf* _tmp10_;
				GdkPixbuf* _tmp11_;
				_tmp9_ = icon_info;
				_tmp10_ = gtk_icon_info_load_icon (_tmp9_, &_inner_error0_);
				_tmp8_ = _tmp10_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (icon_info);
					goto __catch0_g_error;
				}
				_tmp11_ = _tmp8_;
				_tmp8_ = NULL;
				_g_object_unref0 (rv);
				rv = _tmp11_;
				_g_object_unref0 (_tmp8_);
			}
		}
		_tmp12_ = rv;
		if (_tmp12_ == NULL) {
			const gchar* _tmp13_;
			GdkPixbuf* _tmp14_ = NULL;
			GtkIconTheme* _tmp15_;
			GtkIconTheme* _tmp16_;
			GdkPixbuf* _tmp17_;
			GdkPixbuf* _tmp18_;
			_tmp13_ = self->priv->_name;
			g_warning ("Icon.vala:103: Icon not found: %s", _tmp13_);
			_tmp15_ = music_icon_get_theme ();
			_tmp16_ = _tmp15_;
			_tmp17_ = gtk_icon_theme_load_icon (_tmp16_, "image-missing", pixel_size, GTK_ICON_LOOKUP_GENERIC_FALLBACK, &_inner_error0_);
			_tmp14_ = _tmp17_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (icon_info);
				goto __catch0_g_error;
			}
			_tmp18_ = _tmp14_;
			_tmp14_ = NULL;
			_g_object_unref0 (rv);
			rv = _tmp18_;
			_g_object_unref0 (_tmp14_);
		}
		_g_object_unref0 (icon_info);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp19_;
		GError* _tmp20_;
		const gchar* _tmp21_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp19_ = self->priv->_name;
		_tmp20_ = err;
		_tmp21_ = _tmp20_->message;
		g_warning ("Icon.vala:107: Could not load icon [%s]: %s", _tmp19_, _tmp21_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (rv);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = rv;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GtkIconTheme*
music_icon_get_theme (void)
{
	GtkIconTheme* result;
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp3_;
	_tmp0_ = music_icon__theme;
	if (_tmp0_ == NULL) {
		GtkIconTheme* _tmp1_;
		GtkIconTheme* _tmp2_;
		_tmp1_ = gtk_icon_theme_get_default ();
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_g_object_unref0 (music_icon__theme);
		music_icon__theme = _tmp2_;
	}
	_tmp3_ = music_icon__theme;
	result = _tmp3_;
	return result;
}

const gchar*
music_icon_get_name (MusicIcon* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}

static void
music_icon_set_name (MusicIcon* self,
                     const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_icon_get_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_name);
		self->priv->_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_icon_properties[MUSIC_ICON_NAME_PROPERTY]);
	}
}

GIcon*
music_icon_get_gicon (MusicIcon* self)
{
	GIcon* result;
	GIcon* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_gicon;
	result = _tmp0_;
	return result;
}

static void
music_icon_set_gicon (MusicIcon* self,
                      GIcon* value)
{
	GIcon* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_icon_get_gicon (self);
	if (old_value != value) {
		GIcon* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_gicon);
		self->priv->_gicon = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_icon_properties[MUSIC_ICON_GICON_PROPERTY]);
	}
}

static void
music_icon_class_init (MusicIconClass * klass,
                       gpointer klass_data)
{
	music_icon_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicIcon_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_icon_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_icon_set_property;
	G_OBJECT_CLASS (klass)->finalize = music_icon_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_ICON_NAME_PROPERTY, music_icon_properties[MUSIC_ICON_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_ICON_GICON_PROPERTY, music_icon_properties[MUSIC_ICON_GICON_PROPERTY] = g_param_spec_object ("gicon", "gicon", "gicon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
music_icon_instance_init (MusicIcon * self,
                          gpointer klass)
{
	self->priv = music_icon_get_instance_private (self);
}

static void
music_icon_finalize (GObject * obj)
{
	MusicIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_ICON, MusicIcon);
	_g_free0 (self->priv->_name);
	_g_object_unref0 (self->priv->_gicon);
	G_OBJECT_CLASS (music_icon_parent_class)->finalize (obj);
}

/**
 * An Icon Object
 *
 * Icon objects point to icon files or generic icon names. The API provides convenience
 * methods for rendering the icon to a {@link Gdk.Pixbuf} image or {@link Gtk.Image} widgets.
 *
 * The icon is searched in the available icon themes.
 */
static GType
music_icon_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicIcon), 0, (GInstanceInitFunc) music_icon_instance_init, NULL };
	GType music_icon_type_id;
	music_icon_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicIcon", &g_define_type_info, 0);
	MusicIcon_private_offset = g_type_add_instance_private (music_icon_type_id, sizeof (MusicIconPrivate));
	return music_icon_type_id;
}

GType
music_icon_get_type (void)
{
	static volatile gsize music_icon_type_id__volatile = 0;
	if (g_once_init_enter (&music_icon_type_id__volatile)) {
		GType music_icon_type_id;
		music_icon_type_id = music_icon_get_type_once ();
		g_once_init_leave (&music_icon_type_id__volatile, music_icon_type_id);
	}
	return music_icon_type_id__volatile;
}

static void
_vala_music_icon_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	MusicIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_ICON, MusicIcon);
	switch (property_id) {
		case MUSIC_ICON_NAME_PROPERTY:
		g_value_set_string (value, music_icon_get_name (self));
		break;
		case MUSIC_ICON_GICON_PROPERTY:
		g_value_set_object (value, music_icon_get_gicon (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_icon_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	MusicIcon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_ICON, MusicIcon);
	switch (property_id) {
		case MUSIC_ICON_NAME_PROPERTY:
		music_icon_set_name (self, g_value_get_string (value));
		break;
		case MUSIC_ICON_GICON_PROPERTY:
		music_icon_set_gicon (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

