/* PlaylistsUtils.c generated by valac 0.52.4, the Vala compiler
 * generated from PlaylistsUtils.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

gboolean music_playlists_utils_save_playlist_pls (MusicPlaylist* p,
                                                  const gchar* folder_uri);
gboolean music_playlists_utils_parse_paths_from_m3u (const gchar* uri,
                                                     GeeLinkedList* * locals);
gboolean music_playlists_utils_parse_paths_from_pls (const gchar* uri,
                                                     GeeLinkedList* * locals,
                                                     gchar* * title);
void music_playlists_utils_parse_index_and_value (const gchar* prefix,
                                                  const gchar* line,
                                                  GeeHashMap* * map);
GeeCollection* music_playlists_utils_convert_paths_to_uris (GeeCollection* paths);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

gboolean
music_playlists_utils_save_playlist_m3u (MusicPlaylist* p,
                                         const gchar* folder_uri,
                                         const gchar* without_path)
{
	gboolean rv = FALSE;
	gchar* to_save = NULL;
	gchar* _tmp0_;
	GFile* dest = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (p != NULL, FALSE);
	g_return_val_if_fail (folder_uri != NULL, FALSE);
	g_return_val_if_fail (without_path != NULL, FALSE);
	rv = FALSE;
	_tmp0_ = music_playlists_utils_get_playlist_m3u_file (p, without_path);
	to_save = _tmp0_;
	_tmp1_ = g_strconcat (folder_uri, "/", NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = music_playlist_get_name (p);
	_tmp4_ = _tmp3_;
	_tmp5_ = string_replace (_tmp4_, "/", "_");
	_tmp6_ = _tmp5_;
	_tmp7_ = g_strconcat (_tmp2_, _tmp6_, NULL);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strconcat (_tmp8_, ".m3u", NULL);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_file_new_for_uri (_tmp10_);
	_tmp12_ = _tmp11_;
	_g_free0 (_tmp10_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp2_);
	dest = _tmp12_;
	{
		GFile* _tmp13_;
		GFileOutputStream* file_stream = NULL;
		GFile* _tmp32_;
		GFileOutputStream* _tmp33_;
		GDataOutputStream* data_stream = NULL;
		GFileOutputStream* _tmp34_;
		GDataOutputStream* _tmp35_;
		GDataOutputStream* _tmp36_;
		const gchar* _tmp37_;
		_tmp13_ = dest;
		if (g_file_query_exists (_tmp13_, NULL)) {
			gint i = 0;
			i = 2;
			while (TRUE) {
				gchar* _tmp14_;
				gchar* _tmp15_;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				GFile* _tmp28_;
				GFile* _tmp29_;
				gboolean _tmp30_;
				gint _tmp31_;
				_tmp14_ = g_strconcat (folder_uri, "/", NULL);
				_tmp15_ = _tmp14_;
				_tmp16_ = music_playlist_get_name (p);
				_tmp17_ = _tmp16_;
				_tmp18_ = string_replace (_tmp17_, "/", "_");
				_tmp19_ = _tmp18_;
				_tmp20_ = g_strconcat (_tmp15_, _tmp19_, NULL);
				_tmp21_ = _tmp20_;
				_tmp22_ = g_strdup_printf ("(%d)", i);
				_tmp23_ = _tmp22_;
				_tmp24_ = g_strconcat (_tmp21_, _tmp23_, NULL);
				_tmp25_ = _tmp24_;
				_tmp26_ = g_strconcat (_tmp25_, ".m3u", NULL);
				_tmp27_ = _tmp26_;
				_tmp28_ = g_file_new_for_uri (_tmp27_);
				_g_object_unref0 (dest);
				dest = _tmp28_;
				_tmp29_ = dest;
				_tmp30_ = !g_file_query_exists (_tmp29_, NULL);
				_g_free0 (_tmp27_);
				_g_free0 (_tmp25_);
				_g_free0 (_tmp23_);
				_g_free0 (_tmp21_);
				_g_free0 (_tmp19_);
				_g_free0 (_tmp15_);
				if (_tmp30_) {
					break;
				}
				_tmp31_ = i;
				i = _tmp31_ + 1;
			}
		}
		_tmp32_ = dest;
		_tmp33_ = g_file_create (_tmp32_, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
		file_stream = _tmp33_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp34_ = file_stream;
		_tmp35_ = g_data_output_stream_new ((GOutputStream*) _tmp34_);
		data_stream = _tmp35_;
		_tmp36_ = data_stream;
		_tmp37_ = to_save;
		g_data_output_stream_put_string (_tmp36_, _tmp37_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (data_stream);
			_g_object_unref0 (file_stream);
			goto __catch0_g_error;
		}
		rv = TRUE;
		_g_object_unref0 (data_stream);
		_g_object_unref0 (file_stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		GFile* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		GError* _tmp43_;
		const gchar* _tmp44_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp38_ = music_playlist_get_name (p);
		_tmp39_ = _tmp38_;
		_tmp40_ = dest;
		_tmp41_ = g_file_get_path (_tmp40_);
		_tmp42_ = _tmp41_;
		_tmp43_ = err;
		_tmp44_ = _tmp43_->message;
		g_warning ("PlaylistsUtils.vala:53: Could not save playlist %s to m3u file %s: %s\n", _tmp39_, _tmp42_, _tmp44_);
		_g_free0 (_tmp42_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp45_ = FALSE;
		_g_object_unref0 (dest);
		_g_free0 (to_save);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp45_;
	}
	result = rv;
	_g_object_unref0 (dest);
	_g_free0 (to_save);
	return result;
}

gchar*
music_playlists_utils_get_playlist_m3u_file (MusicPlaylist* p,
                                             const gchar* without_path)
{
	gchar* to_save = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (p != NULL, NULL);
	g_return_val_if_fail (without_path != NULL, NULL);
	_tmp0_ = g_strdup ("#EXTM3U");
	to_save = _tmp0_;
	{
		GeeIterator* _s_it = NULL;
		GeeIterator* _tmp1_;
		_tmp1_ = music_playlist_iterator (p);
		_s_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			MusicMedia* s = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			MusicMedia* _tmp5_;
			const gchar* _tmp6_;
			MusicMedia* _tmp7_;
			guint _tmp8_;
			guint _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			MusicMedia* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			MusicMedia* _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			MusicMedia* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			GFile* _tmp34_;
			GFile* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			const gchar* _tmp41_;
			gchar* _tmp42_;
			_tmp2_ = _s_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _s_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			s = (MusicMedia*) _tmp4_;
			_tmp5_ = s;
			if (_tmp5_ == NULL) {
				_g_object_unref0 (s);
				continue;
			}
			_tmp6_ = to_save;
			_tmp7_ = s;
			_tmp8_ = music_media_get_length (_tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = g_strdup_printf ("%u", _tmp9_);
			_tmp11_ = _tmp10_;
			_tmp12_ = g_strconcat ("\n\n#EXTINF:", _tmp11_, NULL);
			_tmp13_ = _tmp12_;
			_tmp14_ = g_strconcat (_tmp13_, ", ", NULL);
			_tmp15_ = _tmp14_;
			_tmp16_ = s;
			_tmp17_ = music_media_get_artist (_tmp16_);
			_tmp18_ = _tmp17_;
			_tmp19_ = g_strconcat (_tmp15_, _tmp18_, NULL);
			_tmp20_ = _tmp19_;
			_tmp21_ = g_strconcat (_tmp20_, " - ", NULL);
			_tmp22_ = _tmp21_;
			_tmp23_ = s;
			_tmp24_ = music_media_get_title (_tmp23_);
			_tmp25_ = _tmp24_;
			_tmp26_ = g_strconcat (_tmp22_, _tmp25_, NULL);
			_tmp27_ = _tmp26_;
			_tmp28_ = g_strconcat (_tmp27_, "\n", NULL);
			_tmp29_ = _tmp28_;
			_tmp30_ = s;
			_tmp31_ = music_media_get_uri (_tmp30_);
			_tmp32_ = _tmp31_;
			_tmp33_ = _tmp32_;
			_tmp34_ = g_file_new_for_uri (_tmp33_);
			_tmp35_ = _tmp34_;
			_tmp36_ = g_file_get_path (_tmp35_);
			_tmp37_ = _tmp36_;
			_tmp38_ = g_strconcat (_tmp29_, _tmp37_, NULL);
			_tmp39_ = _tmp38_;
			_tmp40_ = g_strconcat (_tmp6_, _tmp39_, NULL);
			_g_free0 (to_save);
			to_save = _tmp40_;
			_g_free0 (_tmp39_);
			_g_free0 (_tmp37_);
			_g_object_unref0 (_tmp35_);
			_g_free0 (_tmp33_);
			_g_free0 (_tmp29_);
			_g_free0 (_tmp27_);
			_g_free0 (_tmp22_);
			_g_free0 (_tmp20_);
			_g_free0 (_tmp15_);
			_g_free0 (_tmp13_);
			_g_free0 (_tmp11_);
			_tmp41_ = to_save;
			_tmp42_ = string_replace (_tmp41_, without_path, "");
			_g_free0 (to_save);
			to_save = _tmp42_;
			_g_object_unref0 (s);
		}
		_g_object_unref0 (_s_it);
	}
	result = to_save;
	return result;
}

gboolean
music_playlists_utils_save_playlist_pls (MusicPlaylist* p,
                                         const gchar* folder_uri)
{
	gboolean rv = FALSE;
	gchar* to_save = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gchar* _tmp6_;
	gint index = 0;
	GFile* dest = NULL;
	gchar* _tmp37_;
	gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	GFile* _tmp47_;
	GFile* _tmp48_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (p != NULL, FALSE);
	g_return_val_if_fail (folder_uri != NULL, FALSE);
	rv = FALSE;
	_tmp0_ = music_playlist_get_name (p);
	_tmp1_ = _tmp0_;
	_tmp2_ = music_playlist_get_medias (p);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strdup_printf ("[playlist]\nX-GNOME-Title=%s\nNumberOfEntries=%d\nVersion=2", _tmp1_, _tmp5_);
	to_save = _tmp6_;
	index = 1;
	{
		GeeIterator* _s_it = NULL;
		GeeIterator* _tmp7_;
		_tmp7_ = music_playlist_iterator (p);
		_s_it = _tmp7_;
		while (TRUE) {
			GeeIterator* _tmp8_;
			MusicMedia* s = NULL;
			GeeIterator* _tmp9_;
			gpointer _tmp10_;
			MusicMedia* _tmp11_;
			const gchar* _tmp12_;
			MusicMedia* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			const gchar* _tmp22_;
			MusicMedia* _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			const gchar* _tmp29_;
			MusicMedia* _tmp30_;
			guint _tmp31_;
			guint _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gint _tmp36_;
			_tmp8_ = _s_it;
			if (!gee_iterator_next (_tmp8_)) {
				break;
			}
			_tmp9_ = _s_it;
			_tmp10_ = gee_iterator_get (_tmp9_);
			s = (MusicMedia*) _tmp10_;
			_tmp11_ = s;
			if (_tmp11_ == NULL) {
				_g_object_unref0 (s);
				continue;
			}
			_tmp12_ = to_save;
			_tmp13_ = s;
			_tmp14_ = music_media_get_uri (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = _tmp15_;
			_tmp17_ = string_replace (_tmp16_, folder_uri, "");
			_tmp18_ = _tmp17_;
			_tmp19_ = g_strdup_printf ("\n\nFile%d=%s", index, _tmp18_);
			_tmp20_ = _tmp19_;
			_tmp21_ = g_strconcat (_tmp12_, _tmp20_, NULL);
			_g_free0 (to_save);
			to_save = _tmp21_;
			_g_free0 (_tmp20_);
			_g_free0 (_tmp18_);
			_g_free0 (_tmp16_);
			_tmp22_ = to_save;
			_tmp23_ = s;
			_tmp24_ = music_media_get_title (_tmp23_);
			_tmp25_ = _tmp24_;
			_tmp26_ = g_strdup_printf ("\nTitle%d=%s", index, _tmp25_);
			_tmp27_ = _tmp26_;
			_tmp28_ = g_strconcat (_tmp22_, _tmp27_, NULL);
			_g_free0 (to_save);
			to_save = _tmp28_;
			_g_free0 (_tmp27_);
			_tmp29_ = to_save;
			_tmp30_ = s;
			_tmp31_ = music_media_get_length (_tmp30_);
			_tmp32_ = _tmp31_;
			_tmp33_ = g_strdup_printf ("\nLength%d=%u", index, _tmp32_);
			_tmp34_ = _tmp33_;
			_tmp35_ = g_strconcat (_tmp29_, _tmp34_, NULL);
			_g_free0 (to_save);
			to_save = _tmp35_;
			_g_free0 (_tmp34_);
			index = index + 1;
			_tmp36_ = index;
			_g_object_unref0 (s);
		}
		_g_object_unref0 (_s_it);
	}
	_tmp37_ = g_strconcat (folder_uri, "/", NULL);
	_tmp38_ = _tmp37_;
	_tmp39_ = music_playlist_get_name (p);
	_tmp40_ = _tmp39_;
	_tmp41_ = string_replace (_tmp40_, "/", "_");
	_tmp42_ = _tmp41_;
	_tmp43_ = g_strconcat (_tmp38_, _tmp42_, NULL);
	_tmp44_ = _tmp43_;
	_tmp45_ = g_strconcat (_tmp44_, ".pls", NULL);
	_tmp46_ = _tmp45_;
	_tmp47_ = g_file_new_for_uri (_tmp46_);
	_tmp48_ = _tmp47_;
	_g_free0 (_tmp46_);
	_g_free0 (_tmp44_);
	_g_free0 (_tmp42_);
	_g_free0 (_tmp38_);
	dest = _tmp48_;
	{
		gint extra = 0;
		GFile* _tmp49_;
		GFileOutputStream* file_stream = NULL;
		GFile* _tmp66_;
		GFileOutputStream* _tmp67_;
		GDataOutputStream* data_stream = NULL;
		GFileOutputStream* _tmp68_;
		GDataOutputStream* _tmp69_;
		GDataOutputStream* _tmp70_;
		const gchar* _tmp71_;
		extra = 2;
		_tmp49_ = dest;
		if (g_file_query_exists (_tmp49_, NULL) == TRUE) {
			while (TRUE) {
				gchar* _tmp50_;
				gchar* _tmp51_;
				const gchar* _tmp52_;
				const gchar* _tmp53_;
				gchar* _tmp54_;
				gchar* _tmp55_;
				gchar* _tmp56_;
				gchar* _tmp57_;
				gchar* _tmp58_;
				gchar* _tmp59_;
				gchar* _tmp60_;
				gchar* _tmp61_;
				GFile* _tmp62_;
				GFile* _tmp63_;
				gboolean _tmp64_;
				gint _tmp65_;
				_tmp50_ = g_strconcat (folder_uri, "/", NULL);
				_tmp51_ = _tmp50_;
				_tmp52_ = music_playlist_get_name (p);
				_tmp53_ = _tmp52_;
				_tmp54_ = string_replace (_tmp53_, "/", "_");
				_tmp55_ = _tmp54_;
				_tmp56_ = g_strdup_printf (_ ("%s (%d)"), _tmp55_, extra);
				_tmp57_ = _tmp56_;
				_tmp58_ = g_strconcat (_tmp51_, _tmp57_, NULL);
				_tmp59_ = _tmp58_;
				_tmp60_ = g_strconcat (_tmp59_, ".pls", NULL);
				_tmp61_ = _tmp60_;
				_tmp62_ = g_file_new_for_uri (_tmp61_);
				_g_object_unref0 (dest);
				dest = _tmp62_;
				_tmp63_ = dest;
				_tmp64_ = !g_file_query_exists (_tmp63_, NULL);
				_g_free0 (_tmp61_);
				_g_free0 (_tmp59_);
				_g_free0 (_tmp57_);
				_g_free0 (_tmp55_);
				_g_free0 (_tmp51_);
				if (_tmp64_) {
					break;
				}
				_tmp65_ = extra;
				extra = _tmp65_ + 1;
			}
		}
		_tmp66_ = dest;
		_tmp67_ = g_file_create (_tmp66_, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
		file_stream = _tmp67_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp68_ = file_stream;
		_tmp69_ = g_data_output_stream_new ((GOutputStream*) _tmp68_);
		data_stream = _tmp69_;
		_tmp70_ = data_stream;
		_tmp71_ = to_save;
		g_data_output_stream_put_string (_tmp70_, _tmp71_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (data_stream);
			_g_object_unref0 (file_stream);
			goto __catch0_g_error;
		}
		rv = TRUE;
		_g_object_unref0 (data_stream);
		_g_object_unref0 (file_stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp72_;
		const gchar* _tmp73_;
		GFile* _tmp74_;
		gchar* _tmp75_;
		gchar* _tmp76_;
		GError* _tmp77_;
		const gchar* _tmp78_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp72_ = music_playlist_get_name (p);
		_tmp73_ = _tmp72_;
		_tmp74_ = dest;
		_tmp75_ = g_file_get_path (_tmp74_);
		_tmp76_ = _tmp75_;
		_tmp77_ = err;
		_tmp78_ = _tmp77_->message;
		g_warning ("PlaylistsUtils.vala:108: Could not save playlist %s to pls file %s: %s" \
"\n", _tmp73_, _tmp76_, _tmp78_);
		_g_free0 (_tmp76_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp79_ = FALSE;
		_g_object_unref0 (dest);
		_g_free0 (to_save);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp79_;
	}
	result = rv;
	_g_object_unref0 (dest);
	_g_free0 (to_save);
	return result;
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

gboolean
music_playlists_utils_parse_paths_from_m3u (const gchar* uri,
                                            GeeLinkedList* * locals)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (uri != NULL, FALSE);
	g_return_val_if_fail (*locals != NULL, FALSE);
	_tmp0_ = g_file_new_for_uri (uri);
	file = _tmp0_;
	_tmp1_ = file;
	if (!g_file_query_exists (_tmp1_, NULL)) {
		g_critical ("PlaylistsUtils.vala:122: The imported playlist doesn't exist !");
		result = FALSE;
		_g_object_unref0 (file);
		return result;
	}
	{
		gchar* line = NULL;
		gchar* previous_line = NULL;
		gchar* _tmp2_;
		GFileInputStream* _tmp3_ = NULL;
		GFile* _tmp4_;
		GFileInputStream* _tmp5_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp6_;
		_tmp2_ = g_strdup ("");
		previous_line = _tmp2_;
		_tmp4_ = file;
		_tmp5_ = g_file_read (_tmp4_, NULL, &_inner_error0_);
		_tmp3_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (previous_line);
			_g_free0 (line);
			goto __catch0_g_error;
		}
		_tmp6_ = g_data_input_stream_new ((GInputStream*) _tmp3_);
		dis = _tmp6_;
		while (TRUE) {
			gchar* _tmp7_ = NULL;
			GDataInputStream* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			const gchar* _tmp11_;
			gboolean _tmp12_ = FALSE;
			const gchar* _tmp13_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			_tmp8_ = dis;
			_tmp9_ = g_data_input_stream_read_line (_tmp8_, NULL, NULL, &_inner_error0_);
			_tmp7_ = _tmp9_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (dis);
				_g_object_unref0 (_tmp3_);
				_g_free0 (previous_line);
				_g_free0 (line);
				goto __catch0_g_error;
			}
			_tmp10_ = _tmp7_;
			_tmp7_ = NULL;
			_g_free0 (line);
			line = _tmp10_;
			_tmp11_ = line;
			if (!(_tmp11_ != NULL)) {
				_g_free0 (_tmp7_);
				break;
			}
			_tmp13_ = line;
			if (string_get (_tmp13_, (glong) 0) != '#') {
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				_tmp14_ = line;
				_tmp15_ = string_replace (_tmp14_, " ", "");
				_tmp16_ = _tmp15_;
				_tmp17_ = strlen (_tmp16_);
				_tmp18_ = _tmp17_;
				_tmp12_ = _tmp18_ > 0;
				_g_free0 (_tmp16_);
			} else {
				_tmp12_ = FALSE;
			}
			if (_tmp12_) {
				const gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				const gchar* _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
				_tmp19_ = line;
				_tmp20_ = g_strconcat ("file://", _tmp19_, NULL);
				_tmp21_ = _tmp20_;
				g_warning ("PlaylistsUtils.vala:133: %s", _tmp21_);
				_g_free0 (_tmp21_);
				_tmp22_ = line;
				_tmp23_ = g_strconcat ("file://", _tmp22_, NULL);
				_tmp24_ = _tmp23_;
				gee_abstract_collection_add ((GeeAbstractCollection*) (*locals), _tmp24_);
				_g_free0 (_tmp24_);
			}
			_tmp25_ = line;
			_tmp26_ = g_strdup (_tmp25_);
			_g_free0 (previous_line);
			previous_line = _tmp26_;
			_g_free0 (_tmp7_);
		}
		_g_object_unref0 (dis);
		_g_object_unref0 (_tmp3_);
		_g_free0 (previous_line);
		_g_free0 (line);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp27_ = err;
		_tmp28_ = _tmp27_->message;
		g_warning ("PlaylistsUtils.vala:141: Could not load m3u file at %s: %s\n", uri, _tmp28_);
		result = FALSE;
		_g_error_free0 (err);
		_g_object_unref0 (file);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp29_ = FALSE;
		_g_object_unref0 (file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp29_;
	}
	result = TRUE;
	_g_object_unref0 (file);
	return result;
}

gboolean
music_playlists_utils_parse_paths_from_pls (const gchar* uri,
                                            GeeLinkedList* * locals,
                                            gchar* * title)
{
	GeeHashMap* files = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* titles = NULL;
	GeeHashMap* _tmp1_;
	GeeHashMap* lengths = NULL;
	GeeHashMap* _tmp2_;
	GFile* file = NULL;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GeeHashMap* _tmp30_;
	GeeCollection* _tmp31_;
	GeeCollection* _tmp32_;
	GeeCollection* _tmp33_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (uri != NULL, FALSE);
	g_return_val_if_fail (*locals != NULL, FALSE);
	g_return_val_if_fail (*title != NULL, FALSE);
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	files = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	titles = _tmp1_;
	_tmp2_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	lengths = _tmp2_;
	_tmp3_ = g_file_new_for_uri (uri);
	file = _tmp3_;
	_tmp4_ = file;
	if (!g_file_query_exists (_tmp4_, NULL)) {
		result = FALSE;
		_g_object_unref0 (file);
		_g_object_unref0 (lengths);
		_g_object_unref0 (titles);
		_g_object_unref0 (files);
		return result;
	}
	{
		gchar* line = NULL;
		GFileInputStream* _tmp5_ = NULL;
		GFile* _tmp6_;
		GFileInputStream* _tmp7_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp8_;
		_tmp6_ = file;
		_tmp7_ = g_file_read (_tmp6_, NULL, &_inner_error0_);
		_tmp5_ = _tmp7_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (line);
			goto __catch0_g_error;
		}
		_tmp8_ = g_data_input_stream_new ((GInputStream*) _tmp5_);
		dis = _tmp8_;
		while (TRUE) {
			gchar* _tmp9_ = NULL;
			GDataInputStream* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			_tmp10_ = dis;
			_tmp11_ = g_data_input_stream_read_line (_tmp10_, NULL, NULL, &_inner_error0_);
			_tmp9_ = _tmp11_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (dis);
				_g_object_unref0 (_tmp5_);
				_g_free0 (line);
				goto __catch0_g_error;
			}
			_tmp12_ = _tmp9_;
			_tmp9_ = NULL;
			_g_free0 (line);
			line = _tmp12_;
			_tmp13_ = line;
			if (!(_tmp13_ != NULL)) {
				_g_free0 (_tmp9_);
				break;
			}
			_tmp14_ = line;
			if (g_str_has_prefix (_tmp14_, "File")) {
				const gchar* _tmp15_;
				_tmp15_ = line;
				music_playlists_utils_parse_index_and_value ("File", _tmp15_, &files);
			} else {
				const gchar* _tmp16_;
				_tmp16_ = line;
				if (g_str_has_prefix (_tmp16_, "X-GNOME-Title")) {
					gchar** parts = NULL;
					const gchar* _tmp17_;
					gchar** _tmp18_;
					gchar** _tmp19_;
					gint parts_length1;
					gint _parts_size_;
					gchar** _tmp20_;
					gint _tmp20__length1;
					const gchar* _tmp21_;
					gchar* _tmp22_;
					_tmp17_ = line;
					_tmp19_ = _tmp18_ = g_strsplit (_tmp17_, "=", 2);
					parts = _tmp19_;
					parts_length1 = _vala_array_length (_tmp18_);
					_parts_size_ = parts_length1;
					_tmp20_ = parts;
					_tmp20__length1 = parts_length1;
					_tmp21_ = _tmp20_[1];
					_tmp22_ = g_strdup (_tmp21_);
					_g_free0 (*title);
					*title = _tmp22_;
					parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
				} else {
					const gchar* _tmp23_;
					_tmp23_ = line;
					if (g_str_has_prefix (_tmp23_, "Title")) {
						const gchar* _tmp24_;
						_tmp24_ = line;
						music_playlists_utils_parse_index_and_value ("Title", _tmp24_, &titles);
					} else {
						const gchar* _tmp25_;
						_tmp25_ = line;
						if (g_str_has_prefix (_tmp25_, "Length")) {
							const gchar* _tmp26_;
							_tmp26_ = line;
							music_playlists_utils_parse_index_and_value ("Length", _tmp26_, &lengths);
						}
					}
				}
			}
			_g_free0 (_tmp9_);
		}
		_g_object_unref0 (dis);
		_g_object_unref0 (_tmp5_);
		_g_free0 (line);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp27_ = err;
		_tmp28_ = _tmp27_->message;
		g_warning ("PlaylistsUtils.vala:175: Could not load m3u file at %s: %s\n", uri, _tmp28_);
		result = FALSE;
		_g_error_free0 (err);
		_g_object_unref0 (file);
		_g_object_unref0 (lengths);
		_g_object_unref0 (titles);
		_g_object_unref0 (files);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp29_ = FALSE;
		_g_object_unref0 (file);
		_g_object_unref0 (lengths);
		_g_object_unref0 (titles);
		_g_object_unref0 (files);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp29_;
	}
	_tmp30_ = files;
	_tmp31_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp30_);
	_tmp32_ = _tmp31_;
	_tmp33_ = _tmp32_;
	gee_collection_add_all ((GeeCollection*) (*locals), _tmp33_);
	_g_object_unref0 (_tmp33_);
	result = TRUE;
	_g_object_unref0 (file);
	_g_object_unref0 (lengths);
	_g_object_unref0 (titles);
	_g_object_unref0 (files);
	return result;
}

void
music_playlists_utils_parse_index_and_value (const gchar* prefix,
                                             const gchar* line,
                                             GeeHashMap* * map)
{
	gint index = 0;
	gchar* val = NULL;
	gchar** parts = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint parts_length1;
	gint _parts_size_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	g_return_if_fail (prefix != NULL);
	g_return_if_fail (line != NULL);
	g_return_if_fail (*map != NULL);
	_tmp1_ = _tmp0_ = g_strsplit (line, "=", 2);
	parts = _tmp1_;
	parts_length1 = _vala_array_length (_tmp0_);
	_parts_size_ = parts_length1;
	_tmp2_ = parts[0];
	_tmp3_ = string_replace (_tmp2_, prefix, "");
	_tmp4_ = _tmp3_;
	index = atoi (_tmp4_);
	_g_free0 (_tmp4_);
	_tmp5_ = parts[1];
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 (val);
	val = _tmp6_;
	gee_abstract_map_set ((GeeAbstractMap*) (*map), (gpointer) ((gintptr) index), val);
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (val);
}

GeeCollection*
music_playlists_utils_convert_paths_to_uris (GeeCollection* paths)
{
	GeeTreeSet* uris = NULL;
	GeeTreeSet* _tmp0_;
	GeeCollection* result = NULL;
	g_return_val_if_fail (paths != NULL, NULL);
	_tmp0_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	uris = _tmp0_;
	{
		GeeIterator* _path_it = NULL;
		GeeIterator* _tmp1_;
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) paths);
		_path_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			gchar* path = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeTreeSet* _tmp5_;
			const gchar* _tmp6_;
			GFile* _tmp7_;
			GFile* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			_tmp2_ = _path_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _path_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			path = (gchar*) _tmp4_;
			_tmp5_ = uris;
			_tmp6_ = path;
			_tmp7_ = g_file_new_for_path (_tmp6_);
			_tmp8_ = _tmp7_;
			_tmp9_ = g_file_get_uri (_tmp8_);
			_tmp10_ = _tmp9_;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp10_);
			_g_free0 (_tmp10_);
			_g_object_unref0 (_tmp8_);
			_g_free0 (path);
		}
		_g_object_unref0 (_path_it);
	}
	result = (GeeCollection*) uris;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
music_playlists_utils_import_from_playlist_file_info (GeeHashMap* playlists,
                                                      MusicLibrary* library)
{
	g_return_if_fail (playlists != NULL);
	g_return_if_fail (library != NULL);
	{
		GeeIterator* _values_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
		_tmp0_ = gee_abstract_map_get_values ((GeeAbstractMap*) playlists);
		_tmp1_ = _tmp0_;
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_values_it = _tmp4_;
		while (TRUE) {
			GeeIterator* _tmp5_;
			GeeLinkedList* values = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GeeLinkedList* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			_tmp5_ = _values_it;
			if (!gee_iterator_next (_tmp5_)) {
				break;
			}
			_tmp6_ = _values_it;
			_tmp7_ = gee_iterator_get (_tmp6_);
			values = (GeeLinkedList*) _tmp7_;
			_tmp8_ = values;
			_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
			_tmp10_ = _tmp9_;
			if (_tmp10_ > 0) {
				GeeLinkedList* _tmp11_;
				gpointer _tmp12_;
				gchar* _tmp13_;
				gboolean _tmp14_;
				_tmp11_ = values;
				_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, 0);
				_tmp13_ = (gchar*) _tmp12_;
				_tmp14_ = g_str_has_prefix (_tmp13_, "/");
				_g_free0 (_tmp13_);
				if (_tmp14_) {
					GeeLinkedList* _tmp15_;
					GeeCollection* _tmp16_;
					GeeCollection* _tmp17_;
					_tmp15_ = values;
					_tmp16_ = music_playlists_utils_convert_paths_to_uris ((GeeCollection*) _tmp15_);
					_tmp17_ = _tmp16_;
					music_library_add_files_to_library (library, _tmp17_);
					_g_object_unref0 (_tmp17_);
				} else {
					GeeLinkedList* _tmp18_;
					_tmp18_ = values;
					music_library_add_files_to_library (library, (GeeCollection*) _tmp18_);
				}
			}
			_g_object_unref0 (values);
		}
		_g_object_unref0 (_values_it);
	}
	{
		GeeIterator* _playlist_it = NULL;
		GeeSet* _tmp19_;
		GeeSet* _tmp20_;
		GeeSet* _tmp21_;
		GeeIterator* _tmp22_;
		GeeIterator* _tmp23_;
		_tmp19_ = gee_abstract_map_get_entries ((GeeAbstractMap*) playlists);
		_tmp20_ = _tmp19_;
		_tmp21_ = _tmp20_;
		_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
		_tmp23_ = _tmp22_;
		_g_object_unref0 (_tmp21_);
		_playlist_it = _tmp23_;
		while (TRUE) {
			GeeIterator* _tmp24_;
			GeeMapEntry* playlist = NULL;
			GeeIterator* _tmp25_;
			gpointer _tmp26_;
			MusicStaticPlaylist* new_playlist = NULL;
			MusicStaticPlaylist* _tmp27_;
			MusicStaticPlaylist* _tmp28_;
			GeeMapEntry* _tmp29_;
			gconstpointer _tmp30_;
			gconstpointer _tmp31_;
			GeeLinkedList* medias_to_use = NULL;
			GeeMapEntry* _tmp32_;
			gconstpointer _tmp33_;
			gconstpointer _tmp34_;
			GeeLinkedList* _tmp35_;
			GeeLinkedList* to_add = NULL;
			GeeLinkedList* _tmp36_;
			MusicStaticPlaylist* _tmp60_;
			GeeLinkedList* _tmp61_;
			MusicStaticPlaylist* _tmp62_;
			_tmp24_ = _playlist_it;
			if (!gee_iterator_next (_tmp24_)) {
				break;
			}
			_tmp25_ = _playlist_it;
			_tmp26_ = gee_iterator_get (_tmp25_);
			playlist = (GeeMapEntry*) _tmp26_;
			_tmp27_ = music_static_playlist_new ();
			new_playlist = _tmp27_;
			_tmp28_ = new_playlist;
			_tmp29_ = playlist;
			_tmp30_ = gee_map_entry_get_key (_tmp29_);
			_tmp31_ = _tmp30_;
			music_playlist_set_name ((MusicPlaylist*) _tmp28_, (const gchar*) _tmp31_);
			_tmp32_ = playlist;
			_tmp33_ = gee_map_entry_get_value (_tmp32_);
			_tmp34_ = _tmp33_;
			_tmp35_ = _g_object_ref0 ((GeeLinkedList*) _tmp34_);
			medias_to_use = _tmp35_;
			_tmp36_ = gee_linked_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
			to_add = _tmp36_;
			{
				GeeIterator* _media_it = NULL;
				GeeCollection* _tmp37_;
				GeeCollection* _tmp38_;
				GeeIterator* _tmp39_;
				GeeIterator* _tmp40_;
				_tmp37_ = music_library_get_medias (library);
				_tmp38_ = _tmp37_;
				_tmp39_ = gee_iterable_iterator ((GeeIterable*) _tmp38_);
				_tmp40_ = _tmp39_;
				_g_object_unref0 (_tmp38_);
				_media_it = _tmp40_;
				while (TRUE) {
					GeeIterator* _tmp41_;
					MusicMedia* media = NULL;
					GeeIterator* _tmp42_;
					gpointer _tmp43_;
					gboolean _tmp44_ = FALSE;
					GeeLinkedList* _tmp45_;
					MusicMedia* _tmp46_;
					GFile* _tmp47_;
					GFile* _tmp48_;
					gchar* _tmp49_;
					gchar* _tmp50_;
					gboolean _tmp51_;
					_tmp41_ = _media_it;
					if (!gee_iterator_next (_tmp41_)) {
						break;
					}
					_tmp42_ = _media_it;
					_tmp43_ = gee_iterator_get (_tmp42_);
					media = (MusicMedia*) _tmp43_;
					_tmp45_ = medias_to_use;
					_tmp46_ = media;
					_tmp47_ = music_media_get_file (_tmp46_);
					_tmp48_ = _tmp47_;
					_tmp49_ = g_file_get_path (_tmp48_);
					_tmp50_ = _tmp49_;
					_tmp51_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp45_, _tmp50_);
					_g_free0 (_tmp50_);
					if (_tmp51_) {
						_tmp44_ = TRUE;
					} else {
						GeeLinkedList* _tmp52_;
						MusicMedia* _tmp53_;
						GFile* _tmp54_;
						GFile* _tmp55_;
						gchar* _tmp56_;
						gchar* _tmp57_;
						_tmp52_ = medias_to_use;
						_tmp53_ = media;
						_tmp54_ = music_media_get_file (_tmp53_);
						_tmp55_ = _tmp54_;
						_tmp56_ = g_file_get_uri (_tmp55_);
						_tmp57_ = _tmp56_;
						_tmp44_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp52_, _tmp57_);
						_g_free0 (_tmp57_);
					}
					if (_tmp44_) {
						GeeLinkedList* _tmp58_;
						MusicMedia* _tmp59_;
						_tmp58_ = to_add;
						_tmp59_ = media;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp58_, _tmp59_);
					}
					_g_object_unref0 (media);
				}
				_g_object_unref0 (_media_it);
			}
			_tmp60_ = new_playlist;
			_tmp61_ = to_add;
			music_playlist_add_medias ((MusicPlaylist*) _tmp60_, (GeeCollection*) _tmp61_);
			_tmp62_ = new_playlist;
			music_library_add_playlist (library, _tmp62_);
			_g_object_unref0 (to_add);
			_g_object_unref0 (medias_to_use);
			_g_object_unref0 (new_playlist);
			_g_object_unref0 (playlist);
		}
		_g_object_unref0 (_playlist_it);
	}
}

gchar*
music_playlists_utils_get_new_playlist_name (GeeCollection* playlists,
                                             const gchar* name)
{
	gchar* base_name = NULL;
	gboolean is_fine = FALSE;
	gint index = 0;
	gchar* new_name = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (playlists != NULL, NULL);
	if (name == NULL) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (_ ("New playlist"));
		_g_free0 (base_name);
		base_name = _tmp0_;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup (name);
		_g_free0 (base_name);
		base_name = _tmp1_;
	}
	is_fine = TRUE;
	index = 2;
	_tmp2_ = base_name;
	_tmp3_ = g_strdup (_tmp2_);
	new_name = _tmp3_;
	while (TRUE) {
		gboolean found = FALSE;
		if (!is_fine) {
			break;
		}
		found = FALSE;
		{
			GeeIterator* _p_it = NULL;
			GeeIterator* _tmp4_;
			_tmp4_ = gee_iterable_iterator ((GeeIterable*) playlists);
			_p_it = _tmp4_;
			while (TRUE) {
				GeeIterator* _tmp5_;
				MusicPlaylist* p = NULL;
				GeeIterator* _tmp6_;
				gpointer _tmp7_;
				MusicPlaylist* _tmp8_;
				const gchar* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				_tmp5_ = _p_it;
				if (!gee_iterator_next (_tmp5_)) {
					break;
				}
				_tmp6_ = _p_it;
				_tmp7_ = gee_iterator_get (_tmp6_);
				p = (MusicPlaylist*) _tmp7_;
				_tmp8_ = p;
				_tmp9_ = music_playlist_get_name (_tmp8_);
				_tmp10_ = _tmp9_;
				_tmp11_ = new_name;
				if (g_strcmp0 (_tmp10_, _tmp11_) == 0) {
					const gchar* _tmp12_;
					gchar* _tmp13_;
					gint _tmp14_;
					_tmp12_ = base_name;
					_tmp13_ = g_strdup_printf (_ ("%s (%i)"), _tmp12_, index);
					_g_free0 (new_name);
					new_name = _tmp13_;
					_tmp14_ = index;
					index = _tmp14_ + 1;
					found = TRUE;
					_g_object_unref0 (p);
					break;
				}
				_g_object_unref0 (p);
			}
			_g_object_unref0 (_p_it);
		}
		if (found == FALSE) {
			is_fine = FALSE;
		}
	}
	result = new_name;
	_g_free0 (base_name);
	return result;
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}

void
music_playlists_utils_export_playlist (MusicPlaylist* p)
{
	GtkFileFilter* m3u_filter = NULL;
	GtkFileFilter* _tmp0_;
	GtkFileFilter* _tmp1_;
	GtkFileFilter* _tmp2_;
	GtkFileFilter* pls_filter = NULL;
	GtkFileFilter* _tmp3_;
	GtkFileFilter* _tmp4_;
	GtkFileFilter* _tmp5_;
	GtkFileChooserNative* file_chooser = NULL;
	GtkFileChooserNative* _tmp6_;
	GtkFileChooserNative* _tmp7_;
	GtkFileChooserNative* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GtkFileChooserNative* _tmp13_;
	GtkFileFilter* _tmp14_;
	GtkFileFilter* _tmp15_;
	GtkFileChooserNative* _tmp16_;
	GtkFileFilter* _tmp17_;
	GtkFileFilter* _tmp18_;
	MusicSettingsMain* main_settings = NULL;
	MusicSettingsMain* _tmp19_;
	MusicSettingsMain* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	GFile* _tmp23_;
	GFile* _tmp24_;
	gboolean _tmp25_;
	gchar* file = NULL;
	gchar* _tmp32_;
	gchar* name = NULL;
	gchar* _tmp33_;
	gchar* extension = NULL;
	gchar* _tmp34_;
	GtkFileChooserNative* _tmp35_;
	GtkFileChooserNative* _tmp64_;
	gchar* original_name = NULL;
	const gchar* _tmp65_;
	const gchar* _tmp66_;
	gchar* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp80_;
	g_return_if_fail (p != NULL);
	if (p == NULL) {
		return;
	}
	_tmp0_ = gtk_file_filter_new ();
	g_object_ref_sink (_tmp0_);
	m3u_filter = _tmp0_;
	_tmp1_ = m3u_filter;
	gtk_file_filter_add_pattern (_tmp1_, "*.m3u");
	_tmp2_ = m3u_filter;
	gtk_file_filter_set_name (_tmp2_, _ ("MPEG Version 3.0 Extended (*.m3u)"));
	_tmp3_ = gtk_file_filter_new ();
	g_object_ref_sink (_tmp3_);
	pls_filter = _tmp3_;
	_tmp4_ = pls_filter;
	gtk_file_filter_add_pattern (_tmp4_, "*.pls");
	_tmp5_ = pls_filter;
	gtk_file_filter_set_name (_tmp5_, _ ("Shoutcast Playlist Version 2.0 (*.pls)"));
	_tmp6_ = gtk_file_chooser_native_new (_ ("Export Playlist"), NULL, GTK_FILE_CHOOSER_ACTION_SAVE, _ ("Save"), _ ("Cancel"));
	file_chooser = _tmp6_;
	_tmp7_ = file_chooser;
	gtk_file_chooser_set_do_overwrite_confirmation ((GtkFileChooser*) _tmp7_, TRUE);
	_tmp8_ = file_chooser;
	_tmp9_ = music_playlist_get_name (p);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_strconcat (_tmp10_, ".m3u", NULL);
	_tmp12_ = _tmp11_;
	gtk_file_chooser_set_current_name ((GtkFileChooser*) _tmp8_, _tmp12_);
	_g_free0 (_tmp12_);
	_tmp13_ = file_chooser;
	_tmp14_ = m3u_filter;
	_tmp15_ = _g_object_ref0 (_tmp14_);
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp13_, _tmp15_);
	_tmp16_ = file_chooser;
	_tmp17_ = pls_filter;
	_tmp18_ = _g_object_ref0 (_tmp17_);
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp16_, _tmp18_);
	_tmp19_ = music_settings_main_get_default ();
	main_settings = _tmp19_;
	_tmp20_ = main_settings;
	_tmp21_ = music_settings_main_get_music_folder (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = g_file_new_for_path (_tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = g_file_query_exists (_tmp24_, NULL);
	_g_object_unref0 (_tmp24_);
	if (_tmp25_) {
		GtkFileChooserNative* _tmp26_;
		MusicSettingsMain* _tmp27_;
		const gchar* _tmp28_;
		const gchar* _tmp29_;
		_tmp26_ = file_chooser;
		_tmp27_ = main_settings;
		_tmp28_ = music_settings_main_get_music_folder (_tmp27_);
		_tmp29_ = _tmp28_;
		gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp26_, _tmp29_);
	} else {
		GtkFileChooserNative* _tmp30_;
		const gchar* _tmp31_;
		_tmp30_ = file_chooser;
		_tmp31_ = g_get_home_dir ();
		gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp30_, _tmp31_);
	}
	_tmp32_ = g_strdup ("");
	file = _tmp32_;
	_tmp33_ = g_strdup ("");
	name = _tmp33_;
	_tmp34_ = g_strdup ("");
	extension = _tmp34_;
	_tmp35_ = file_chooser;
	if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp35_) == ((gint) GTK_RESPONSE_ACCEPT)) {
		GtkFileChooserNative* _tmp36_;
		gchar* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		const gchar* _tmp40_;
		gint _tmp41_;
		gint _tmp42_;
		gchar* _tmp43_;
		gboolean _tmp44_ = FALSE;
		const gchar* _tmp45_;
		gint _tmp46_;
		gint _tmp47_;
		const gchar* _tmp58_;
		const gchar* _tmp59_;
		const gchar* _tmp60_;
		gchar* _tmp61_;
		const gchar* _tmp62_;
		const gchar* _tmp63_;
		_tmp36_ = file_chooser;
		_tmp37_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp36_);
		_g_free0 (file);
		file = _tmp37_;
		_tmp38_ = file;
		_tmp39_ = file;
		_tmp40_ = file;
		_tmp41_ = strlen (_tmp40_);
		_tmp42_ = _tmp41_;
		_tmp43_ = string_slice (_tmp38_, (glong) string_last_index_of (_tmp39_, ".", 0), (glong) _tmp42_);
		_g_free0 (extension);
		extension = _tmp43_;
		_tmp45_ = extension;
		_tmp46_ = strlen (_tmp45_);
		_tmp47_ = _tmp46_;
		if (_tmp47_ == 0) {
			_tmp44_ = TRUE;
		} else {
			const gchar* _tmp48_;
			_tmp48_ = extension;
			_tmp44_ = string_get (_tmp48_, (glong) 0) != '.';
		}
		if (_tmp44_) {
			const gchar* _tmp49_ = NULL;
			GtkFileChooserNative* _tmp50_;
			GtkFileFilter* _tmp51_;
			GtkFileFilter* _tmp52_;
			GtkFileFilter* _tmp53_;
			gchar* _tmp54_;
			const gchar* _tmp55_;
			const gchar* _tmp56_;
			gchar* _tmp57_;
			_tmp50_ = file_chooser;
			_tmp51_ = gtk_file_chooser_get_filter ((GtkFileChooser*) _tmp50_);
			_tmp52_ = _tmp51_;
			_tmp53_ = m3u_filter;
			if (_tmp52_ == _tmp53_) {
				_tmp49_ = ".m3u";
			} else {
				_tmp49_ = ".pls";
			}
			_tmp54_ = g_strdup (_tmp49_);
			_g_free0 (extension);
			extension = _tmp54_;
			_tmp55_ = file;
			_tmp56_ = extension;
			_tmp57_ = g_strconcat (_tmp55_, _tmp56_, NULL);
			_g_free0 (file);
			file = _tmp57_;
		}
		_tmp58_ = file;
		_tmp59_ = file;
		_tmp60_ = file;
		_tmp61_ = string_slice (_tmp58_, (glong) (string_last_index_of (_tmp59_, "/", 0) + 1), (glong) string_last_index_of (_tmp60_, ".", 0));
		_g_free0 (name);
		name = _tmp61_;
		_tmp62_ = name;
		_tmp63_ = extension;
		g_message ("PlaylistsUtils.vala:304: name is %s extension is %s\n", _tmp62_, _tmp63_);
	}
	_tmp64_ = file_chooser;
	gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp64_);
	_tmp65_ = music_playlist_get_name (p);
	_tmp66_ = _tmp65_;
	_tmp67_ = g_strdup (_tmp66_);
	original_name = _tmp67_;
	_tmp68_ = file;
	if (g_strcmp0 (_tmp68_, "") != 0) {
		GFile* f = NULL;
		const gchar* _tmp69_;
		GFile* _tmp70_;
		gchar* folder = NULL;
		GFile* _tmp71_;
		GFile* _tmp72_;
		GFile* _tmp73_;
		gchar* _tmp74_;
		gchar* _tmp75_;
		const gchar* _tmp76_;
		const gchar* _tmp77_;
		_tmp69_ = file;
		_tmp70_ = g_file_new_for_path (_tmp69_);
		f = _tmp70_;
		_tmp71_ = f;
		_tmp72_ = g_file_get_parent (_tmp71_);
		_tmp73_ = _tmp72_;
		_tmp74_ = g_file_get_uri (_tmp73_);
		_tmp75_ = _tmp74_;
		_g_object_unref0 (_tmp73_);
		folder = _tmp75_;
		_tmp76_ = name;
		music_playlist_set_name (p, _tmp76_);
		_tmp77_ = file;
		if (g_str_has_suffix (_tmp77_, ".m3u")) {
			const gchar* _tmp78_;
			_tmp78_ = folder;
			music_playlists_utils_save_playlist_m3u (p, _tmp78_, "");
		} else {
			const gchar* _tmp79_;
			_tmp79_ = folder;
			music_playlists_utils_save_playlist_pls (p, _tmp79_);
		}
		_g_free0 (folder);
		_g_object_unref0 (f);
	}
	_tmp80_ = original_name;
	music_playlist_set_name (p, _tmp80_);
	_g_free0 (original_name);
	_g_free0 (extension);
	_g_free0 (name);
	_g_free0 (file);
	_g_object_unref0 (main_settings);
	_g_object_unref0 (file_chooser);
	_g_object_unref0 (pls_filter);
	_g_object_unref0 (m3u_filter);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
}

GeeHashMap*
music_playlists_utils_get_playlists_to_import (const gchar* set_title,
                                               GError** error)
{
	gchar* title = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GtkFileFilter* m3u_filter = NULL;
	GtkFileFilter* _tmp3_;
	GtkFileFilter* _tmp4_;
	GtkFileFilter* _tmp5_;
	GtkFileFilter* pls_filter = NULL;
	GtkFileFilter* _tmp6_;
	GtkFileFilter* _tmp7_;
	GtkFileFilter* _tmp8_;
	GtkFileChooserNative* file_chooser = NULL;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GtkFileChooserNative* _tmp12_;
	GtkFileChooserNative* _tmp13_;
	GtkFileChooserNative* _tmp14_;
	GtkFileChooserNative* _tmp15_;
	GtkFileFilter* _tmp16_;
	GtkFileFilter* _tmp17_;
	GtkFileChooserNative* _tmp18_;
	GtkFileFilter* _tmp19_;
	GtkFileFilter* _tmp20_;
	GSList* files = NULL;
	GtkFileChooserNative* _tmp21_;
	GtkFileChooserNative* _tmp24_;
	GeeHashMap* playlists = NULL;
	GeeHashMap* _tmp25_;
	gboolean success = FALSE;
	GSList* _tmp26_;
	GError* _inner_error0_ = NULL;
	GeeHashMap* result = NULL;
	_tmp0_ = g_strdup (set_title);
	title = _tmp0_;
	if (set_title == NULL) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = g_strcmp0 (set_title, "") == 0;
	}
	if (_tmp1_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (_ ("Playlist"));
		_g_free0 (title);
		title = _tmp2_;
	}
	_tmp3_ = gtk_file_filter_new ();
	g_object_ref_sink (_tmp3_);
	m3u_filter = _tmp3_;
	_tmp4_ = m3u_filter;
	gtk_file_filter_add_pattern (_tmp4_, "*.m3u");
	_tmp5_ = m3u_filter;
	gtk_file_filter_set_name (_tmp5_, _ ("MPEG Version 3.0 Extended (*.m3u)"));
	_tmp6_ = gtk_file_filter_new ();
	g_object_ref_sink (_tmp6_);
	pls_filter = _tmp6_;
	_tmp7_ = pls_filter;
	gtk_file_filter_add_pattern (_tmp7_, "*.pls");
	_tmp8_ = pls_filter;
	gtk_file_filter_set_name (_tmp8_, _ ("Shoutcast Playlist Version 2.0 (*.pls)"));
	_tmp9_ = title;
	_tmp10_ = g_strdup_printf (_ ("Import %s"), _tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = gtk_file_chooser_native_new (_tmp11_, NULL, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("Open"), _ ("Cancel"));
	_tmp13_ = _tmp12_;
	_g_free0 (_tmp11_);
	file_chooser = _tmp13_;
	_tmp14_ = file_chooser;
	gtk_file_chooser_set_select_multiple ((GtkFileChooser*) _tmp14_, TRUE);
	_tmp15_ = file_chooser;
	_tmp16_ = m3u_filter;
	_tmp17_ = _g_object_ref0 (_tmp16_);
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp15_, _tmp17_);
	_tmp18_ = file_chooser;
	_tmp19_ = pls_filter;
	_tmp20_ = _g_object_ref0 (_tmp19_);
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp18_, _tmp20_);
	files = NULL;
	_tmp21_ = file_chooser;
	if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp21_) == ((gint) GTK_RESPONSE_ACCEPT)) {
		GtkFileChooserNative* _tmp22_;
		GSList* _tmp23_;
		_tmp22_ = file_chooser;
		_tmp23_ = gtk_file_chooser_get_filenames ((GtkFileChooser*) _tmp22_);
		(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
		files = _tmp23_;
	}
	_tmp24_ = file_chooser;
	gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp24_);
	_tmp25_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_LINKED_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	playlists = _tmp25_;
	success = FALSE;
	_tmp26_ = files;
	{
		GSList* file_collection = NULL;
		GSList* file_it = NULL;
		file_collection = _tmp26_;
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
			gchar* _tmp27_;
			gchar* file = NULL;
			_tmp27_ = g_strdup ((const gchar*) file_it->data);
			file = _tmp27_;
			{
				const gchar* _tmp28_;
				_tmp28_ = file;
				if (g_strcmp0 (_tmp28_, "") != 0) {
					gchar* name = NULL;
					const gchar* _tmp29_;
					GFile* _tmp30_;
					GFile* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					GeeLinkedList* paths = NULL;
					GeeLinkedList* _tmp34_;
					const gchar* _tmp35_;
					GeeHashMap* _tmp50_;
					const gchar* _tmp51_;
					GeeLinkedList* _tmp52_;
					_tmp29_ = file;
					_tmp30_ = g_file_new_for_path (_tmp29_);
					_tmp31_ = _tmp30_;
					_tmp32_ = g_file_get_basename (_tmp31_);
					_tmp33_ = _tmp32_;
					_g_object_unref0 (_tmp31_);
					name = _tmp33_;
					_tmp34_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
					paths = _tmp34_;
					_tmp35_ = file;
					if (g_str_has_suffix (_tmp35_, ".m3u")) {
						const gchar* _tmp36_;
						gchar* _tmp37_;
						const gchar* _tmp38_;
						gchar* _tmp39_;
						gchar* _tmp40_;
						gboolean _tmp41_;
						_tmp36_ = name;
						_tmp37_ = string_replace (_tmp36_, ".m3u", "");
						_g_free0 (name);
						name = _tmp37_;
						_tmp38_ = file;
						_tmp39_ = g_strconcat ("file://", _tmp38_, NULL);
						_tmp40_ = _tmp39_;
						_tmp41_ = music_playlists_utils_parse_paths_from_m3u (_tmp40_, &paths);
						success = _tmp41_;
						_g_free0 (_tmp40_);
					} else {
						const gchar* _tmp42_;
						_tmp42_ = file;
						if (g_str_has_suffix (_tmp42_, ".pls")) {
							const gchar* _tmp43_;
							gchar* _tmp44_;
							const gchar* _tmp45_;
							gchar* _tmp46_;
							gchar* _tmp47_;
							gboolean _tmp48_;
							_tmp43_ = name;
							_tmp44_ = string_replace (_tmp43_, ".pls", "");
							_g_free0 (name);
							name = _tmp44_;
							_tmp45_ = file;
							_tmp46_ = g_strconcat ("file://", _tmp45_, NULL);
							_tmp47_ = _tmp46_;
							_tmp48_ = music_playlists_utils_parse_paths_from_pls (_tmp47_, &paths, &name);
							success = _tmp48_;
							_g_free0 (_tmp47_);
						} else {
							GError* _tmp49_;
							success = FALSE;
							_tmp49_ = g_error_new (g_quark_from_string ("not-recognized"), 1, "%s", _ ("Unrecognized playlist file. Import failed."));
							_inner_error0_ = _tmp49_;
							g_propagate_error (error, _inner_error0_);
							_g_object_unref0 (paths);
							_g_free0 (name);
							_g_free0 (file);
							_g_object_unref0 (playlists);
							(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
							_g_object_unref0 (file_chooser);
							_g_object_unref0 (pls_filter);
							_g_object_unref0 (m3u_filter);
							_g_free0 (title);
							return NULL;
						}
					}
					_tmp50_ = playlists;
					_tmp51_ = name;
					_tmp52_ = paths;
					gee_abstract_map_set ((GeeAbstractMap*) _tmp50_, _tmp51_, _tmp52_);
					_g_object_unref0 (paths);
					_g_free0 (name);
				}
				_g_free0 (file);
			}
		}
	}
	result = playlists;
	(files == NULL) ? NULL : (files = (_g_slist_free__g_free0_ (files), NULL));
	_g_object_unref0 (file_chooser);
	_g_object_unref0 (pls_filter);
	_g_object_unref0 (m3u_filter);
	_g_free0 (title);
	return result;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

