/* Search.c generated by valac 0.52.4, the Vala compiler
 * generated from Search.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include "io.elementary.music-core.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

gchar* music_search_get_valid_search_string (const gchar* s);
gchar* music_string_canonicalize_for_search (const gchar* str);
guint* music_search_get_rating_from_string (const gchar* rating_string);
static gboolean _uint_equal (const guint * s1,
                      const guint * s2);
static guint* _uint_dup (guint* self);

void
music_search_search_in_media_list (GeeCollection* to_search,
                                   GeeCollection* * results,
                                   const gchar* album_artist,
                                   const gchar* album,
                                   const gchar* genre,
                                   const gchar* grouping,
                                   const gchar* composer,
                                   gint year,
                                   gint rating,
                                   GCancellable* cancellable)
{
	GeeCollection* _vala_results = NULL;
	GeeTreeSet* _tmp0_;
	g_return_if_fail (to_search != NULL);
	g_return_if_fail (album_artist != NULL);
	g_return_if_fail (album != NULL);
	g_return_if_fail (genre != NULL);
	g_return_if_fail (grouping != NULL);
	g_return_if_fail (composer != NULL);
	_tmp0_ = gee_tree_set_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (_vala_results);
	_vala_results = (GeeCollection*) _tmp0_;
	{
		GeeIterator* _media_it = NULL;
		GeeIterator* _tmp1_;
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) to_search);
		_media_it = _tmp1_;
		while (TRUE) {
			GeeIterator* _tmp2_;
			MusicMedia* media = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			gboolean _tmp5_ = FALSE;
			MusicMedia* _tmp6_;
			_tmp2_ = _media_it;
			if (!gee_iterator_next (_tmp2_)) {
				break;
			}
			_tmp3_ = _media_it;
			_tmp4_ = gee_iterator_get (_tmp3_);
			media = (MusicMedia*) _tmp4_;
			if (cancellable != NULL) {
				_tmp5_ = g_cancellable_is_cancelled (cancellable);
			} else {
				_tmp5_ = FALSE;
			}
			if (_tmp5_) {
				_g_object_unref0 (media);
				break;
			}
			_tmp6_ = media;
			if (music_search_match_fields_to_media (_tmp6_, album_artist, album, genre, grouping, composer, year, rating)) {
				GeeCollection* _tmp7_;
				MusicMedia* _tmp8_;
				_tmp7_ = _vala_results;
				_tmp8_ = media;
				gee_collection_add (_tmp7_, _tmp8_);
			}
			_g_object_unref0 (media);
		}
		_g_object_unref0 (_media_it);
	}
	if (results) {
		*results = _vala_results;
	} else {
		_g_object_unref0 (_vala_results);
	}
}

inline gboolean
music_search_match_fields_to_media (MusicMedia* media,
                                    const gchar* album_artist,
                                    const gchar* album,
                                    const gchar* genre,
                                    const gchar* grouping,
                                    const gchar* composer,
                                    gint year,
                                    gint rating)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (media != NULL, FALSE);
	g_return_val_if_fail (album_artist != NULL, FALSE);
	g_return_val_if_fail (album != NULL, FALSE);
	g_return_val_if_fail (genre != NULL, FALSE);
	g_return_val_if_fail (grouping != NULL, FALSE);
	g_return_val_if_fail (composer != NULL, FALSE);
	if (rating == -1) {
		_tmp6_ = TRUE;
	} else {
		guint _tmp7_;
		guint _tmp8_;
		_tmp7_ = music_media_get_rating (media);
		_tmp8_ = _tmp7_;
		_tmp6_ = _tmp8_ == ((guint) rating);
	}
	if (_tmp6_) {
		gboolean _tmp9_ = FALSE;
		if (year == -1) {
			_tmp9_ = TRUE;
		} else {
			guint _tmp10_;
			guint _tmp11_;
			_tmp10_ = music_media_get_year (media);
			_tmp11_ = _tmp10_;
			_tmp9_ = _tmp11_ == ((guint) year);
		}
		_tmp5_ = _tmp9_;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		gboolean _tmp12_ = FALSE;
		if (music_string_is_empty (genre, FALSE)) {
			_tmp12_ = TRUE;
		} else {
			gchar* _tmp13_;
			gchar* _tmp14_;
			_tmp13_ = music_media_get_display_genre (media);
			_tmp14_ = _tmp13_;
			_tmp12_ = g_strcmp0 (_tmp14_, genre) == 0;
			_g_free0 (_tmp14_);
		}
		_tmp4_ = _tmp12_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		gboolean _tmp15_ = FALSE;
		if (music_string_is_empty (album_artist, FALSE)) {
			_tmp15_ = TRUE;
		} else {
			gchar* _tmp16_;
			gchar* _tmp17_;
			_tmp16_ = music_media_get_display_album_artist (media, TRUE);
			_tmp17_ = _tmp16_;
			_tmp15_ = g_strcmp0 (_tmp17_, album_artist) == 0;
			_g_free0 (_tmp17_);
		}
		_tmp3_ = _tmp15_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		gboolean _tmp18_ = FALSE;
		if (music_string_is_empty (album, FALSE)) {
			_tmp18_ = TRUE;
		} else {
			gchar* _tmp19_;
			gchar* _tmp20_;
			_tmp19_ = music_media_get_display_album (media);
			_tmp20_ = _tmp19_;
			_tmp18_ = g_strcmp0 (_tmp20_, album) == 0;
			_g_free0 (_tmp20_);
		}
		_tmp2_ = _tmp18_;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		gboolean _tmp21_ = FALSE;
		if (music_string_is_empty (grouping, FALSE)) {
			_tmp21_ = TRUE;
		} else {
			const gchar* _tmp22_;
			const gchar* _tmp23_;
			_tmp22_ = music_media_get_grouping (media);
			_tmp23_ = _tmp22_;
			_tmp21_ = g_strcmp0 (_tmp23_, grouping) == 0;
		}
		_tmp1_ = _tmp21_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gboolean _tmp24_ = FALSE;
		if (music_string_is_empty (composer, FALSE)) {
			_tmp24_ = TRUE;
		} else {
			gchar* _tmp25_;
			gchar* _tmp26_;
			_tmp25_ = music_media_get_display_composer (media);
			_tmp26_ = _tmp25_;
			_tmp24_ = g_strcmp0 (_tmp26_, composer) == 0;
			_g_free0 (_tmp26_);
		}
		_tmp0_ = _tmp24_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

inline gchar*
music_search_get_valid_search_string (const gchar* s)
{
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (s != NULL, NULL);
	_tmp0_ = music_string_canonicalize_for_search (s);
	result = _tmp0_;
	return result;
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
	if (_vala_c != ((gunichar) 0)) {
		gchar* _tmp0_;
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
		*index = (gint) (_tmp0_ - ((gchar*) self));
		result = TRUE;
		if (c) {
			*c = _vala_c;
		}
		return result;
	} else {
		result = FALSE;
		if (c) {
			*c = _vala_c;
		}
		return result;
	}
}

static gboolean
_uint_equal (const guint * s1,
             const guint * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	return (*s1) == (*s2);
}

static guint*
_uint_dup (guint* self)
{
	guint* dup;
	dup = g_new0 (guint, 1);
	memcpy (dup, self, sizeof (guint));
	return dup;
}

static gpointer
__uint_dup0 (gpointer self)
{
	return self ? _uint_dup (self) : NULL;
}

inline guint*
music_search_get_rating_from_string (const gchar* rating_string)
{
	gint i = 0;
	gunichar c = 0U;
	guint rating = 0U;
	guint* _tmp8_;
	guint* _tmp9_;
	guint _tmp10_;
	guint* result = NULL;
	g_return_val_if_fail (rating_string != NULL, NULL);
	i = 0;
	{
		gboolean _tmp0_ = FALSE;
		rating = (guint) 0;
		_tmp0_ = TRUE;
		while (TRUE) {
			gunichar _tmp2_ = 0U;
			gboolean _tmp3_;
			if (!_tmp0_) {
				guint _tmp1_;
				_tmp1_ = rating;
				rating = _tmp1_ + 1;
			}
			_tmp0_ = FALSE;
			_tmp3_ = string_get_next_char (rating_string, &i, &_tmp2_);
			c = _tmp2_;
			if (!_tmp3_) {
				break;
			}
			if (c != ((gunichar) '*')) {
				guint* _tmp4_;
				guint _tmp5_;
				result = NULL;
				_tmp4_ = result;
				_tmp5_ = (guint) 0;
				_vala_warn_if_fail (_uint_equal (_tmp4_, &_tmp5_) != TRUE, "result != 0");
				return result;
			}
		}
	}
	if (rating == ((guint) 0)) {
		guint* _tmp6_;
		guint _tmp7_;
		result = NULL;
		_tmp6_ = result;
		_tmp7_ = (guint) 0;
		_vala_warn_if_fail (_uint_equal (_tmp6_, &_tmp7_) != TRUE, "result != 0");
		return result;
	}
	_tmp8_ = __uint_dup0 (&rating);
	result = _tmp8_;
	_tmp9_ = result;
	_tmp10_ = (guint) 0;
	_vala_warn_if_fail (_uint_equal (_tmp9_, &_tmp10_) != TRUE, "result != 0");
	return result;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

inline gboolean
music_search_match_string_to_media (MusicMedia* m,
                                    const gchar* search)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	guint _tmp9_;
	guint _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gboolean _tmp13_;
	gboolean result = FALSE;
	g_return_val_if_fail (m != NULL, FALSE);
	g_return_val_if_fail (search != NULL, FALSE);
	_tmp9_ = music_media_get_year (m);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_strdup_printf ("%u", _tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_strcmp0 (search, _tmp12_) == 0;
	_g_free0 (_tmp12_);
	if (_tmp13_) {
		_tmp8_ = TRUE;
	} else {
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		_tmp14_ = music_media_get_display_title (m);
		_tmp15_ = _tmp14_;
		_tmp16_ = music_search_get_valid_search_string (_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp8_ = string_contains (_tmp17_, search);
		_g_free0 (_tmp17_);
		_g_free0 (_tmp15_);
	}
	if (_tmp8_) {
		_tmp7_ = TRUE;
	} else {
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		_tmp18_ = music_media_get_album (m);
		_tmp19_ = _tmp18_;
		_tmp20_ = music_search_get_valid_search_string (_tmp19_);
		_tmp21_ = _tmp20_;
		_tmp7_ = string_contains (_tmp21_, search);
		_g_free0 (_tmp21_);
	}
	if (_tmp7_) {
		_tmp6_ = TRUE;
	} else {
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		_tmp22_ = music_media_get_artist (m);
		_tmp23_ = _tmp22_;
		_tmp24_ = music_search_get_valid_search_string (_tmp23_);
		_tmp25_ = _tmp24_;
		_tmp6_ = string_contains (_tmp25_, search);
		_g_free0 (_tmp25_);
	}
	if (_tmp6_) {
		_tmp5_ = TRUE;
	} else {
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		_tmp26_ = music_media_get_album_artist (m);
		_tmp27_ = _tmp26_;
		_tmp28_ = music_search_get_valid_search_string (_tmp27_);
		_tmp29_ = _tmp28_;
		_tmp5_ = string_contains (_tmp29_, search);
		_g_free0 (_tmp29_);
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		_tmp30_ = music_media_get_genre (m);
		_tmp31_ = _tmp30_;
		_tmp32_ = music_search_get_valid_search_string (_tmp31_);
		_tmp33_ = _tmp32_;
		_tmp4_ = string_contains (_tmp33_, search);
		_g_free0 (_tmp33_);
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp34_;
		const gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		_tmp34_ = music_media_get_composer (m);
		_tmp35_ = _tmp34_;
		_tmp36_ = music_search_get_valid_search_string (_tmp35_);
		_tmp37_ = _tmp36_;
		_tmp3_ = string_contains (_tmp37_, search);
		_g_free0 (_tmp37_);
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		_tmp38_ = music_media_get_grouping (m);
		_tmp39_ = _tmp38_;
		_tmp40_ = music_search_get_valid_search_string (_tmp39_);
		_tmp41_ = _tmp40_;
		_tmp2_ = string_contains (_tmp41_, search);
		_g_free0 (_tmp41_);
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp42_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		_tmp42_ = music_media_get_comment (m);
		_tmp43_ = _tmp42_;
		_tmp44_ = music_search_get_valid_search_string (_tmp43_);
		_tmp45_ = _tmp44_;
		_tmp1_ = string_contains (_tmp45_, search);
		_g_free0 (_tmp45_);
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp46_;
		const gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		_tmp46_ = music_media_get_lyrics (m);
		_tmp47_ = _tmp46_;
		_tmp48_ = music_search_get_valid_search_string (_tmp47_);
		_tmp49_ = _tmp48_;
		_tmp0_ = string_contains (_tmp49_, search);
		_g_free0 (_tmp49_);
	}
	result = _tmp0_;
	return result;
}

