/* TimeUtils.c generated by valac 0.52.4, the Vala compiler
 * generated from TimeUtils.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include "io.elementary.music-core.h"
#include <glib.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define MUSIC_TIME_UTILS_SEC_INV ((guint64) 1)

/**
     * Returns a formatted date and time string.
     */
static gchar*
g_time_format (struct tm *self,
               const gchar* format)
{
	gchar* buffer = NULL;
	gchar* _tmp0_;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* _tmp1_;
	gchar* result = NULL;
	g_return_val_if_fail (format != NULL, NULL);
	_tmp0_ = g_new0 (gchar, 64);
	buffer = _tmp0_;
	buffer_length1 = 64;
	_buffer_size_ = buffer_length1;
	strftime (buffer, (gint) buffer_length1, format, &(*self));
	_tmp1_ = g_strdup ((const gchar*) buffer);
	result = _tmp1_;
	buffer = (g_free (buffer), NULL);
	return result;
}

inline gchar*
music_time_utils_pretty_timestamp_from_time (struct tm* dt)
{
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (dt != NULL, NULL);
	_tmp0_ = g_time_format (dt, _ ("%m/%e/%Y %l:%M %p"));
	result = _tmp0_;
	return result;
}

/**
     * Convert from nanoseconds (10E-9) to miliseconds (10E-3);
     *
     * This is used extensively because {@link Music.Media} stores
     * miliseconds, while GStreamer uses nanoseconds.
     *
     * The method does its best to avoid losing precision.
     */
inline guint
music_time_utils_nanoseconds_to_miliseconds (guint64 nanoseconds)
{
	guint result = 0U;
	result = (guint) ((nanoseconds * MUSIC_TIME_UTILS_MILI_INV) / MUSIC_TIME_UTILS_NANO_INV);
	return result;
}

inline guint
music_time_utils_nanoseconds_to_seconds (guint64 nanoseconds)
{
	guint result = 0U;
	result = (guint) ((nanoseconds * MUSIC_TIME_UTILS_SEC_INV) / MUSIC_TIME_UTILS_NANO_INV);
	return result;
}

inline guint64
music_time_utils_seconds_to_nanoseconds (guint64 seconds)
{
	guint64 result = 0ULL;
	result = (guint64) ((seconds * MUSIC_TIME_UTILS_NANO_INV) / MUSIC_TIME_UTILS_SEC_INV);
	return result;
}

